/*************************************************************
 * HSYCO MANAGER, version 3.7.0 Build 0124
 *  (c) 2010-2017 HSYCO S.r.l.
 *
 *  For information, see the Home Systems Consulting web site:
 *  http://www.homesystemsconsulting.com/
 *
*************************************************************/



//--------------------------------------------------------------------------------------------------------------------------
// Common Code -------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
function isNumeric(n) {
  return !isNaN(parseFloat(n)) && isFinite(n);
}
String.prototype.trim = function () {
    //return this.replace(/^\s*/, "").replace(/\s*$/, "");
	var	str = this.replace(/^\s\s*/, ''),
		ws = /\s/,
		i = str.length;
	while (ws.test(str.charAt(--i)));
	return str.slice(0, i + 1);
}
if (typeof String.prototype.startsWith != "function") {
	String.prototype.startsWith = function (str){
		return this.slice(0, str.length) == str;
	};
}
if (typeof String.prototype.endsWith != "function") {
	String.prototype.endsWith = function (str){
		return this.slice(-str.length) == str;
	};
}
Number.prototype.mod = function (n) { // useful for ciclying 0-->n
	return ((this%n)+n)%n;
}
Number.prototype.next = function (b) { // n: base
	return (this+1).mod(b);
}
Number.prototype.previous = function (b) {
	return (this-1).mod(b);
}
// array is array is array.
if (!Array.prototype.isArray) {
	Array.prototype.isArray = function (vArg) {
	    return Object.prototype.toString.call(vArg) === "[object Array]";
	}
}
// return an array with unique elements
Array.prototype.unique = function () {
	var a = [];
	var l = this.length;
	for (var i=0; i<l; i++) {
	  for (var j=i+1; j<l; j++) {
	    if (this[i] === this[j])
	      j = ++i; //skip
	  }
	  a.push(this[i]);
	}
	return a;
};
// get last element
Array.prototype.last = function () {
	if (!this.length) return null;
	return this[this.length-1];
}
// clone array
Array.prototype.clone = function () {
	return this.slice(0);
}
// intersection of two arrays
Array.prototype.intersect = function (arr) {
	var a = [];
	var l = this.length;
	for (var i=0; i<l; i++) {
		if (arr.indexOf(this[i]) != -1) {
			a.push(this[i]);
		}
	}
	return a;
}
// same
Array.prototype.same = function (arr) {
	if (this.length != arr.length) return false;
	for (var i=0; i<this.length; i++) {
		if (this[i] != null && arr[i] != null && // not null
			typeof this[i] === "object" && typeof arr[i] === "object" && // both objs
			this[i].isArray && arr[i].isArray) { // arrays
			if (!this[i].same(arr[i]))
				return false;
		} else if (this[i] != arr[i]) {
			return false;
		}
	}
	return true;
}
// search
if (!Array.prototype.indexOf) {
  Array.prototype.indexOf = function (searchElement, fromIndex) {
    "use strict";
    if (this == null) {
      throw new TypeError();
    }
    var t = Object(this);
    var len = t.length >>> 0;

    if (len === 0) {
      return -1;
    }
    var n = 0;
    if (arguments.length > 1) {
      n = Number(arguments[1]);
      if (n != n) { // shortcut for verifying if it's NaN
        n = 0;
      } else if (n != 0 && n != Infinity && n != -Infinity) {
        n = (n > 0 || -1) * Math.floor(Math.abs(n));
      }
    }
    if (n >= len) {
      return -1;
    }
    var k = n >= 0 ? n : Math.max(len - Math.abs(n), 0);
    for (; k < len; k++) {
      if (k in t && t[k] === searchElement) {
        return k;
      }
    }
    return -1;
  }
}

// remove empty elements
Array.prototype.clean = function (deleteValue) {
	for (var i = 0; i < this.length; i++) {
		if (this[i] == deleteValue) {
			this.splice(i, 1);
			i--;
		}
	}
	return this;
};

Number.prototype.clamp = function(min, max) {
  return Math.min(Math.max(this, min), max);
};


Math.clamp = function(number, min, max) {
  return Math.max(min, Math.min(number, max));
};

// add event cross browser
window.addEvent = function (event, target, method) {
	if (target.addEventListener) {
		target.addEventListener(event, method, false);
	} else if (target.attachEvent) {
		target.attachEvent("on" + event, method);
	} else {
		target["on" + event] = method;
	}
}
window.removeEvent = function (event, target, method) {
	if (target.removeEventListener) {
		target.removeEventListener(event, method, false);
	} else if (target.attachEvent) {
		target.detachEvent("on" + event, method);
	} else {
		target["on" + event] = null;
	}
}

// JSON
var JSON = JSON || {};
JSON.parse = JSON.parse || function (str) {
	if (str === "") str = '""';
	eval("var p=" + str + ";");
	return p;
};


// colors
function increase_brightness(str, percent){
    var r,g,b, a,hex;

    str = str.trim();

    if (str.indexOf("rgb") == 0) {
        var l = str.indexOf("("); // rgba( or rgb(
        var rgb = str.split(/[,\(\)]/);
        r = parseInt(rgb[1]);
        g = parseInt(rgb[2]);
        b = parseInt(rgb[3]);
        a = rgb.length>5 ? parseInt(a[4]) : null;
    } else {
        // strip the leading # if it's there
        hex = str.replace(/^\s*#|\s*$/g, '');

        // convert 3 char codes --> 6, e.g. `E0F` --> `EE00FF`
        if (hex.length == 3) {
            hex = hex.replace(/(.)/g, '$1$1');
        }

        r = parseInt(hex.substr(0, 2), 16),
        g = parseInt(hex.substr(2, 2), 16),
        b = parseInt(hex.substr(4, 2), 16);
    }

    var d = (r+g+b)/3;
    if (Math.abs(r-d)<20 && Math.abs(g-d)<20 && Math.abs(b-d)<20) {
        // crack it up
        percent *= 1.5;
    }

    /*
    r = Math.round(r + (256 - r) * percent / 100);
    g = Math.round(g + (256 - g) * percent / 100);
    b = Math.round(b + (256 - b) * percent / 100);
    */

    r += Math.round(255 * (percent / 100));
    g += Math.round(255 * (percent / 100));
    b += Math.round(255 * (percent / 100));

    r = Math.clamp(r,0,255);
    g = Math.clamp(g,0,255);
    b = Math.clamp(b,0,255);

    if (!hex) {
        if (a === null)
            return "rgb("+r+","+g+","+b+")";
        else
            return "rgba("+r+","+g+","+b+","+a+")";
    } else {
        r = r.toString(16);
        g = g.toString(16);
        b = b.toString(16);
        if (r.length < 2) r = "0"+r;
        if (g.length < 2) g = "0"+g;
        if (b.length < 2) b = "0"+b;
        return '#' + r + g + b;
    }
}

// Converts from degrees to radians.
Math.radians = function(degrees) {
  return degrees * Math.PI / 180;
};

// Converts from radians to degrees.
Math.degrees = function(radians) {
  return radians * 180 / Math.PI;
};


// https://developer.mozilla.org/en/docs/Web/SVG/Tutorial/Paths
// http://scaledinnovation.com/analytics/splines/aboutSplines.html
function getBezierControlPoints(x0,y0,x1,y1,x2,y2,t){
	var d01=Math.sqrt(Math.pow(x1-x0,2)+Math.pow(y1-y0,2));
	var d12=Math.sqrt(Math.pow(x2-x1,2)+Math.pow(y2-y1,2));
    if (d01 == 0 && d12 == 0)
        return [x1,y1,x1,y1];
	var fa=t*d01/(d01+d12);   // scaling factor for triangle Ta
	var fb=t*d12/(d01+d12);   // ditto for Tb, simplifies to fb=t-fa
	var p1x=x1-fa*(x2-x0);    // x2-x0 is the width of triangle T
	var p1y=y1-fa*(y2-y0);    // y2-y0 is the height of T
	var p2x=x1+fb*(x2-x0);
	var p2y=y1+fb*(y2-y0);
	return [p1x,p1y,p2x,p2y];
}



window.onload = onLoadInit;
window.onresize = onResize;
window.onorientationchange = onOrientationChange;
window.onbeforeunload = onBeforeUnload;

var browser; // browser supported browser
var animations; // manages the animations (fade in/out..)
var login; // login object
var parser; // parser object
var files; // files object
var timestampChecker; // timestamp checker
var manager; // manager general object
var project; // currently edited project
var dictionary; // project dictionary, objects, project attributes..

// apps: configuration
var clientApplication;
// apps: development
var projectEditor;
var fileManager;
var statusBrowser;
// apps: system
var logViewer;
var systemMonitor;

var focusedElement; // currently focused element

var buttonColorRegExp = "nope";

// text
var text = {
	"selectNewValue":"new value..",
	"color_":"default",
	"color_b":"blue",
	"color_r":"red",
	"color_g":"green",
	"color_y":"yellow",
	"color_gr":"gray",
	"color_glass":"glass"
}

//--------------------------------------------------------------------------------------------------------------------------
// Generic Editor Functions ------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------

// on Load Init
function onLoadInit() {
	manager = new Manager();

	var req = new XMLReq();
	req.onLoaded = onLoaded;
	req.onAuthenticate = onAuth;
	req.onNoAccess = onNoAccess;
	req.retryOnErrorDelay = 500;
	req.open("/x/getstate?0");

	// on getstate loaded
	function onLoaded() {
		manager.state = this.getResponseJSON();

		// disable auto correct
		var el = document.getElementsByTagName("input");
		for (var i=0; el[i]; i++) {
			el[i].setAttribute("autocorrect","off");
		}

		// manager
		var locked = (manager.state && manager.state.hsycostate && manager.state.hsycostate.ui && manager.state.hsycostate.ui["manager.lock"] == "true");
		if (locked) {
			//manager.showErrorPopup("Locked");
			document.getElementById("lock").style.display = "inline";
			kill();
		} else {
			manager.start();
			onResize(); // layout
		}
/*/
console.log("REMOVE ME. AUTOPILOT TO EDITOR");
manager.switchApp("fm");
fileManager.currentFile = "events.txt";
fileManager.openEditor();
/**/
	}

	function onNoAccess() {
		manager.showErrorPopup("No access");
		onResize();
	}
	function onAuth() {
		showPin(true); // true: goto login page
		onResize();
	}

	function kill() {
		timestampChecker.stop();
		window.Manager = window.manager = null;
	}
} // onLoadInit()

// focus element
function focusElement(e) {
	focusedElement = e;
	if (e.focus) e.focus();
} // focus()

// focus input
function focusMe(e) {
	focusedElement = e;
} // focusMe()

// blur input
function blurMe(e) {
	focusedElement = null;
} // blurMe()

// lose focus
function loseFocus() {
	if (focusedElement) {
		try {
			focusedElement.blur();
		} catch (e) {}
		focusedElement = null;
		if (window.focus) window.focus();
	}
} // loseFocus()

function onResize() {
	// get viewport size
	var viewportWidth;
	var viewportHeight;

	if (window.innerWidth) {
		viewportWidth = window.innerWidth;
		viewportHeight = window.innerHeight;
	} else if (document.documentElement && document.documentElement.clientWidth) {
		viewportWidth = document.documentElement.clientWidth;
		viewportHeight = document.documentElement.clientHeight;
	} else if (document.body.clientWidth) {
		viewportWidth = document.body.clientWidth;
		viewportHeight = document.body.clientHeight;
	} else {
		viewportWidth = 0;
		viewportHeight = 0;
	}

	manager.adjustLayout(viewportWidth,viewportHeight);
} // onResize()

function onOrientationChange() {
	var o = window.orientation?window.orientation:0;
	manager.adjustOrientation(o);
	//o = (window.orientation == 90 || window.orientation == -90) ? "landscape" : "portrait";

	onResize();
} // onOrientationChange()

function onBeforeUnload(evt) {
	var res;
	if (!manager.reloading) { // automatically reloading?
		// check (regardless of which app is open)
		if (fileManager.editorOpen && fileManager.editorChanged)
			res = "If you exit now, you will lose the Text Editor's changes.";
		else if (fileManager.uploading)
			res = "If you exit now, the current upload will be canceled.";
		else if (projectEditor.projectModified) // project modified?
			res = "If you exit now, you will lose the Project Editor's changes.";
	}
	// res?
	if (res) {
		if (typeof evt == 'undefined') evt = window.event;
		if (evt) evt.returnValue = res;
	} else {
		timestampChecker.stop(); // no "server connection lost" popup
		manager.showBlack(); // show black
	}
	return res;
} // onBeforeUnload()

// show login popup or goto login page
function showPin(lock) {
	if (lock)
		manager.gotoLoginPage();
	else
		manager.showLoginPopup();
}

//--------------------------------------------------------------------------------------------------------------------------
// Manager -----------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------

// Manager class
function Manager() {
	var NOTICE_WAIT = 5000;

	this.viewportWidth = 0;
	this.viewportHeight = 0;

	var popupAreaContentsE = document.getElementById("popupAreaContents");
	var popupFrameE = document.getElementById("popupFrame");
	var popupBgE = document.getElementById("popupBg");

	this.cPopup = null; // current popup
	this.popupStack = []; // popup stack

	// toolbar popups
	var cToolbarPopup = ""; // current popup open
	var toolbarPopupPEEditE = document.getElementById("pe_editPopup");
	var toolbarPopupPEWarningsE = document.getElementById("pe_warningsPopup");
	var toolbarPopupFMEditE = document.getElementById("fm_editPopup");
	var toolbarPopupFMWarningsE = document.getElementById("fm_warningsPopup");
	var toolbarArrowE = document.getElementById("toolbarArrow");

	// app popup buttons
	var appContentE;
	var appBtsE = [];
	var appBackBtE;

	// temp area, we render stuff here to get the size (getDivSize)
	this.tempAreaE = document.getElementById("tempArea");

	var noticeTimeout = 0;
	var noticeStatus = 0;

	this.cApp = ""; // current application

	this.reloading = false; // manually reloading (so we don't fire the onBeforeUnload)

	var apps

	var self = this;

	// quick apps panel
	var quickAppsPanel = {
		e:document.getElementById("quickAppsPanel"),
		buttonsE:[], // buttons elements
		buttonsIds:[], // app ids,
		fixedAppsIds:["pe","fm","lv"], // fixed apps, will always be visible
		cId:-1, // current highlighted app index (-1 also means the panel is not visible)
	}

	// init Manager
	function init() {
		// browser
		browser = new Browser();
		// supported?
		if (browser.browser == "Explorer" && browser.version<9) {
			alert("Sorry, Internet Explorer version "+browser.version+" is not supported.");
		}
		// animations
		animations = new Animations();
		// login
		login = new Login();
		login.onLogin = function () {timestampChecker.start(); manager.focus(); manager.showAppsPopup()}; // on login successful
		// files
		files = new Files();
		// parser
		parser = new Parser();
		// timestamp checker
		timestampChecker = new TimestampChecker();

		// client application: settings, admin, wiring
		clientApplication = new ClientApplication();

		// project editor parts
		projectEditor = new ProjectEditor();
		// file manager parts
		fileManager = new FileManager();
		// status browser
		statusBrowser = new StatusBrowser();

		// log viewer
		logViewer = new LogViewer();
		// system monitor
		systemMonitor = new SystemMonitor();

		apps = {
			"pe": projectEditor,
			"fm": fileManager,
			"sb": statusBrowser,
			"lv": logViewer,
			"sm": systemMonitor,
		}

		// apps panel
		initAppsPopup();

		// quick apps
		initQuickAppsPanel();

		// button, focus, img events
		browser.initEvents(document);
	} // init()

	// start
	this.start = function () {
		// apps popup
		self.showAppsPopup(false);
		timestampChecker.start();
		self.onTopoUpdate(); // topo embedded
		self.onConfigUpdate(); // config embedded
		self.focus();
	} // start()

	// focus, restore key events
	this.focus = function () {
		document.onkeydown = this.onKeyDown;
		document.onkeyup = this.onKeyUp;
		if (window.focus) window.focus();
		this.deselect();
	} // focus()

	// deselect all
	this.deselect = function () {
		try {
			if (document.selection)
				document.selection.empty();
			else if (window.getSelection)
				window.getSelection().removeAllRanges();
			if (document.blur)
				document.blur();
		} catch (err) {}
	} // deselect()

	// reload
	this.reload = function () {
		this.reloading = true;
		location.reload();
	} // reload()

	// goto login page
	this.gotoLoginPage = function () {
		var url = window.location.href;
		if (url.indexOf("/pin.") != -1) { // old format
			url = url.replace("/pin.", "/login.")
		} else { // new format
			var u = url.split("?");
			u[0] += ".login";
			url = u.join("?");
		}
		window.location.replace(url);
	}

	// back to referrer
	this.backToReferrer = function () {
		window.location.replace(browser.referrer);
	} // backToReferrer()

	// on topo update
	this.onTopoUpdate = function () {
		projectEditor.onTopoUpdate();
		updateAppsPopup();
	} // onTopoUpdate()

	// on config update
	this.onConfigUpdate = function () {
		projectEditor.onConfigUpdate();
		updateAppsPopup();
	} // onConfigUpdate()

	// key down
	this.onKeyDown = function (e) {
		if (!e) var e = window.event;
		// code
		var code;
		if (e.keyCode) code = e.keyCode;
		else if (e.which) code = e.which;
		// target
		var t;
		if (e.target) t = e.target;
		else if (e.srcElement) t = e.srcElement;
		if (t.nodeType == 3) // defeat Safari bug
			t = t.parentNode;

		// backspace. prevent only when focused element is not password, text or file
		if ((code == 8) && !(t && t.tagName && (t.type && /(password)|(text)|(file)/.test(t.type.toLowerCase())) || t.tagName.toLowerCase() == 'textarea')) {
			try { e.preventDefault(); } catch(err) {}
			//return false;
		}

		// ctrl shift, show quick apps panel
		if (code == 16 && e.ctrlKey) {
			self.showQuickAppsPanel();
			return false;
		}

		// esc
		if (manager.cPopup && manager.cPopup.closeBt && code == 27) {
			manager.closePopup();
			browser.preventDefault(e);
			return;
		}

		if (self.cApp && apps[self.cApp].onKeyDown) {
            apps[self.cApp].onKeyDown(e, code, t);
		} else {
			// ctrl/cmd s. not allowed
			if (code == 83 && (e.ctrlKey || e.metaKey)){
				browser.preventDefault(e);
				return;
			}
		}

		//this.showNotice("keydown "+code+" "+e.ctrlKey,10000);
	}; // onKeyDown()

	// key up
	this.onKeyUp = function (e) {
		if (!e) var e = window.event;
		// code
		var code;
		if (e.keyCode) code = e.keyCode;
		else if (e.which) code = e.which;
		// target
		var t;
		if (e.target) t = e.target;
		else if (e.srcElement) t = e.srcElement;
		if (t.nodeType == 3) // defeat Safari bug
			t = t.parentNode;

		// deselect?
		//if (!focusedElement) self.deselect();

		// ctrl shift released?
		if (!e.ctrlKey && self.hideQuickAppsPanel()) return; // close quick apps panel?

        if (self.cApp && apps[self.cApp].onKeyUp)
            apps[self.cApp].onKeyUp(e, code, t);
	} // onKeyUp()

	// format file size. maximum 5 characters (including dot)
	this.formatFS = function (e) {
		if (e == undefined) return "";
		var cl = 5; // max char length
		var v = e;
		var s = v+"";
		var sa = s.split(".");
		// get rid of decimals?
		if (sa[0].length>=cl && sa[1]) { // integer part length >= cl
			v = Math.round(v);
			s = v+"";
		}
		// add k/M/G/T?
		var m = "";
		// always add K
		v = v/1000;
		m = "K";
		s = v+"";
		if (s.length>cl && v>1000) {
			v = v/1000;
			m = "M";
			s = v+"";
			if (s.length>cl && v>1000) {
				v = v/1000;
				m = "G";
				s = v+"";
				if (s.length>cl && v>1000) {
					v = v/1000;
					m = "T";
					s = v+"";
				}
			}
			}
		// still to long?
		var p = s.indexOf(".");
		if (p >-1) {
			sa = s.split(".");
			// get rid of decimals?
			if (sa[0].length>=cl && sa[1]) { // integer part length >= cl
				v = Math.round(v);
			} else {
				var d = 3-sa[0].length; // allowed decimals: 0,1,2. sa[0].lenght: 1,2,3
				var u = (d==0)?1:(d==1)?10:100;
				v = Math.round(v*u)/u;
			}
			s = v+"";
		}
		return s+" "+m+"B";
	} // formatFS()

	// render a div and get size
	this.getDivSize = function (d) {
		var cd = d.cloneNode(true);
		this.tempAreaE.style.position = "absolute";
		this.tempAreaE.style.display = "inline";
		this.tempAreaE.appendChild(cd);
		// get size
		var w = cd.offsetWidth;
		var h = cd.offsetHeight;
		this.tempAreaE.innerHTML = "";
		this.tempAreaE.style.display = "none";
		return {w:w, h:h};
	} // getDivSize()

	// get app object given the id
	function getApp(id) {
		switch (id) {
		case "se":
		case "ad":
		case "we":
		case "ku":
		case "bu":
		case "hu":
		case "mu":
			return clientApplication;
		}
		return apps[id];
	}

	// switch app
	this.switchApp = function (app) {
		if (app == this.cApp) {
			this.closePopup();
			return;
		}

		timestampChecker.stop(); // started on app start function

		this.closeToolbarPopup();
		this.closePopups();

		this.cApp = app;

		switch(app) {
		case "":
			this.hideOtherApps(app);
			break;
		case "pe":
			this.hideOtherApps(app);
			files.load("www"); // load www
			this.showLoadingPopup();
			break;
		default: // default behaviour
			getApp(app).start(app); // app is only needed for clientApplication
		}

		// update quick apps panel, add current? not currently visible and not a fixed one
		if (quickAppsPanel.buttonsIds.indexOf(this.cApp)==-1 && quickAppsPanel.fixedAppsIds.indexOf(this.cApp)==-1) {
			// can have 2 additional apps
			if (quickAppsPanel.buttonsIds.length<5) {
				quickAppsPanel.buttonsIds.push(this.cApp);
			} else {
				// replace older one
				for (var i=quickAppsPanel.buttonsIds.length-1; i>=0; i--) {
					// not a fixed one?
					if (quickAppsPanel.fixedAppsIds.indexOf(quickAppsPanel.buttonsIds[i]) == -1) {
						// replace it
						quickAppsPanel.buttonsIds[i] = this.cApp;
						break;
					}
				}
			}
		}
		// next based on current app
		for (var i=0; i<quickAppsPanel.buttonsIds.length; i++) {
			if (quickAppsPanel.buttonsIds[i] == this.cApp) {
				quickAppsPanel.buttonsIds.splice(0,0,quickAppsPanel.buttonsIds.splice(i,1)[0]); // move the element to the first position
				break;
			}
		}
	} // switchApp()

	// hide the other apps, (this app)
	this.hideOtherApps = function (app) {
		if (clientApplication.open &&
			(app != "se") &&
			(app != "ad") &&
			(app != "we") &&
			(app != "ku") &&
			(app != "bu") &&
			(app != "hu") &&
			(app != "mu"))
			clientApplication.hide();

		if (projectEditor.open && app != "pe") projectEditor.hide();
		if (fileManager.open && app != "fm") fileManager.hide();
		if (statusBrowser.open && app != "sb") statusBrowser.hide();

		if (logViewer.open && app != "lv") logViewer.hide();
		if (systemMonitor.open && app != "sm") systemMonitor.hide();
	} // hideOtherApps()

	// restart server
	this.restartServer = function (confirm) {
		if (!confirm) {
			this.openPopup("restart", true);
		} else {
			this.closePopup();
			this.openPopup("waitrestart", false);
			files.load("restart");
		}
	} // restartServer()

	// --------------------------------------------------------------------------------------------------------------------------
	// Layout -------------------------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	// adjust manager layout. viewport size
	this.adjustLayout = function (vw,vh) {
		if (vw && vh) {
			this.viewportWidth = vw;
			this.viewportHeight = vh;
		}

		// app specific adjust layout
		switch (this.cApp) {
		case "se":
		case "ad":
		case "ku":
		case "bu":
		case "hu":
		case "mu":
		case "we":
			clientApplication.adjustLayout(); break;

		case "pe": projectEditor.adjustLayout(); break;
		case "fm": fileManager.adjustLayout(); break;
		case "sb": statusBrowser.adjustLayout(); break;

		case "lv": logViewer.adjustLayout(); break;
		case "sm": systemMonitor.adjustLayout(); break;
		}

		this.adjustPopup();
		this.adjustToolbar();
		this.adjustPanels();
	} // adjustLayout()

	// adjust the orientation
	this.adjustOrientation = function (o) {
		this.closeToolbarPopup();
	} // adjustOrientation()

	// adjust toolbar
	this.adjustToolbar = function () {
		var	vw = this.viewportWidth;
		var	vh = this.viewportHeight;

		// tool bar size
		var tbW = (this.cApp=="pe")?201:0; // left one
		var tbH = 36; // top one

		// editable area size
		var eW = vw - tbW;
		var eH = vh - tbH;

		// fix toolbar header max width. do it here because we call it from adjustLayout and updateToolbarTitle
		var t = document.getElementById("pe_toolbarHeader");
		t.style.maxWidth = (this.cApp == "pe")?((vw-460)+"px"):"";
		var tbts = ["Warnings","Tools","Save"];
		for (var i=0; i<tbts.length; i++) { // remove labels from buttons?
			browser.miniButton(document.getElementById("pe_toolbar"+tbts[i]+"Bt"), (vw-t.offsetWidth<620));
		}

		// fm
		var t = document.getElementById("fm_toolbarHeader");
		var tbts = ["Tools","Save"];
		for (var i=0; i<tbts.length; i++) { // remove labels from buttons?
			browser.miniButton(document.getElementById("fm_toolbar"+tbts[i]+"Bt"), (vw-t.offsetWidth<390));
		}

		// panel and arrow pos, better fixed position???
		switch (cToolbarPopup) {
		case "pe_edit":
			toolbarArrowE.style.left = Math.round(document.getElementById("pe_toolbarToolsBt").offsetLeft+document.getElementById("pe_toolbarToolsBt").offsetWidth/2+192)+"px"; // 192 = 200 (left panel) - 16/2 (arrow width)
			break;
		case "pe_warnings":
			toolbarPopupPEWarningsE.style.left = Math.round(document.getElementById("pe_toolbarWarningsBt").offsetLeft+document.getElementById("pe_toolbarWarningsBt").offsetWidth/2+100)+"px"; // 100 = 200 (left panel) - 200/2 (panel width)
			toolbarArrowE.style.left = Math.round(document.getElementById("pe_toolbarWarningsBt").offsetLeft+document.getElementById("pe_toolbarWarningsBt").offsetWidth/2+192)+"px";
			break;
		case "fm_edit":
			var ebt = document.getElementById("fm_toolbarToolsBt");
			toolbarArrowE.style.left = Math.round(ebt.offsetLeft+ebt.offsetWidth/2-8+tbW)+"px"; // (16/2) arrow width
			break;
		case "fm_warnings":
			toolbarPopupFMWarningsE.style.left = Math.round(document.getElementById("fm_toolbarWarningsBt").offsetLeft+document.getElementById("fm_toolbarWarningsBt").offsetWidth/2-100)+"px";  // -100 = - 200/2 (panel width)
			toolbarArrowE.style.left = Math.round(document.getElementById("fm_toolbarWarningsBt").offsetLeft+document.getElementById("fm_toolbarWarningsBt").offsetWidth/2-8)+"px";  // -8 = - (16/2) arrow width
			break;
		}
	} // adjustToolbar()

	// adjust popup if visible
	this.adjustPopup = function () {
		if (!this.viewportWidth || !this.viewportHeight) return;

		vw = this.viewportWidth;
		vh = this.viewportHeight;

		// popup
		popupBgE.style.width = vw+"px";
		popupBgE.style.height = vh+"px";

		if (!this.cPopup) return;

		var pw = this.cPopup.contentE.offsetWidth;
		var ph = this.cPopup.contentE.offsetHeight;

		var so = 7; // shadow offset;

		popupFrameE.style.width = pw+"px";
		popupFrameE.style.height = ph+"px";

		this.cPopup.contentE.style.left =
		popupFrameE.style.left = Math.round(vw/2-pw/2)+"px";

		var t = Math.round(vh/2-ph/2);
		if (t>300) t = 300; // max 300 from top

		this.cPopup.contentE.style.top =
		popupFrameE.style.top = t+"px";
	} // adjustPopup()

	// adjust panels
	this.adjustPanels = function () {
		if (!this.viewportWidth || !this.viewportHeight) return;

		vw = this.viewportWidth;
		vh = this.viewportHeight;

		// quick apps panel
		var pw = quickAppsPanel.e.offsetWidth;
		var ph = quickAppsPanel.e.offsetHeight;

		quickAppsPanel.e.style.left = Math.round(vw/2-pw/2)+"px";

		var t = Math.round(vh/2-ph/2);
		if (t>300) t = 300; // max 300 from top
		t += 5; // +5 so it's slightly below the popups

		quickAppsPanel.e.style.top = t+"px";
	} // adjustPanels()

	// --------------------------------------------------------------------------------------------------------------------------
	// Popup Functions ----------------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	// id of content (div: "popup-"+id), close button visible?, onClose function, clear (shadow background not visible)
	this.openPopup = function (contentId, closeBt, f, clear) {
		// is there an open popup?
		if (this.cPopup) {
			// same?
			if (this.cPopup.id == contentId)
				return;
			// hide
			this.cPopup.contentE.style.display = "none";
			this.popupStack.push(this.cPopup);
		}

		if (fileManager.editorOpen && fileManager.editor.completer)
			fileManager.editor.completer.detach();

		loseFocus();

		// popup stack
		this.cPopup = {id:contentId, closeBt:closeBt, onClose:f};
		this.cPopup.contentE = document.getElementById("popup-"+contentId);
		this.cPopup.data = getPopupData(this.cPopup.contentE);

		if (!clear)
			popupAreaContentsE.style.display = "block";
		showPopup(); // show current popup
	} // openPopup()

	// show current popup. used only by open and close popup
	function showPopup() {
		self.cPopup.contentE.style.display = "block";
		popupFrameE.style.display = "inline";
		self.adjustPopup();
		for (var id in self.cPopup.data.input) {
			focusElement(self.cPopup.data.input[id]);
			break;
		}
		self.cPopup.data.div["closeBt"].style.display = self.cPopup.closeBt?"inline":"none";
	} // showPopup()

	// show black, lock screen (when leaving page)
	this.showBlack = function () {
		this.closePopups();
		popupAreaContentsE.style.display = "block";
		popupFrameE.style.display = "none";
	} // showBlack()

	// close popup. keep data?
	this.closePopup = function (keep) {
		if (!this.cPopup) return; // nothing to close
		loseFocus();

		var c = this.cPopup; // save it, so we null cPopup
		this.cPopup = null;

		if (!keep) {
			for (var n in c.data.input) c.data.input[n].value = "";
			for (var n in c.data.select) c.data.select[n].selectedIndex = 0;
		}
		// hide
		c.contentE.style.display = "none";

		// onclose
		if (c.onClose)
			c.onClose();

		// other popups?
		if (this.popupStack.length) {
			this.cPopup = this.popupStack.pop();
			showPopup();
		} else {
			popupAreaContentsE.style.display = "none";
			// focus, restore events..
			switch (this.cApp) {
			case "se":
			case "ad":
			case "we":
			case "bu":
			case "hu":
			case "mu":
			case "ku":
				clientApplication.focus(); break;

			case "pe": projectEditor.focus(); break;
			case "fm": fileManager.focus(); break;
			case "sb": statusBrowser.focus(); break;

			case "lv": logViewer.focus(); break;
			case "sm": systemMonitor.focus(); break;
			}
		}
	} // closePopup()

	// close all popups
	this.closePopups = function () {
		while (this.cPopup)
			this.closePopup();
	} // close all

	function getPopupData(e) {
		var res = {};

		// divs for quick access by name
		res.div = {};
		res.input = {};
		res.select = {};

		// get divs
		var divs,i;
		divs = e.getElementsByTagName("div");
		for (i=0; i<divs.length; i++)
			res.div[divs[i].getAttribute("name")] = divs[i];
		divs = e.getElementsByTagName("input");
		for (i=0; i<divs.length; i++) {
			var n = divs[i].getAttribute("name");
			var k = "";
			while (res.input[n+k]) k += "x"; // for radio buttons m,mx,mxx,mxxx..
			res.input[n+k] = divs[i];
		}
		divs = e.getElementsByTagName("select");
		for (i=0; i<divs.length; i++) res.select[divs[i].getAttribute("name")] = divs[i];

		return res;
	} // getPopupData()



	// init apps popup
	function initAppsPopup() {
		var e = document.getElementById("popup-appswitch");

		var d,n;
		for (var i = 0; (d = e.getElementsByTagName("div")[i]); i++) {
			n = d.getAttribute("name");
			if (!n) continue;
			switch (n) {
				case "content": appContentE = d; break;
				case "seAppBt": appBtsE["se"] = d; break;
				case "adAppBt": appBtsE["ad"] = d; break;
				case "weAppBt": appBtsE["we"] = d; break;
				case "peAppBt": appBtsE["pe"] = d; break;
				case "fmAppBt": appBtsE["fm"] = d; break;
				case "sbAppBt": appBtsE["sb"] = d; break;
				case "lvAppBt": appBtsE["lv"] = d; break;
				case "smAppBt": appBtsE["sm"] = d; break;
				case "kuAppBt": appBtsE["ku"] = d; break;
				case "buAppBt": appBtsE["bu"] = d; break;
				case "huAppBt": appBtsE["hu"] = d; break;
				case "muAppBt": appBtsE["mu"] = d; break;
				case "sep1": 	appBtsE["-1"] = d; break;
				case "sep2": 	appBtsE["-2"] = d; break;
				case "sep3": 	appBtsE["-3"] = d; break;
				case "backBt":	appBackBtE = d; break;
			}
		}

		// back button if previous was hsyco client
		appBackBtE.style.display = browser.referrer?"inline":"none";

		// updateAppsPopup(); called by onTopoUpdate
	} // initAppsPopup()

	// update apps popup
	function updateAppsPopup() {
		var e = document.getElementById("popup-appswitch");

		// detect ioservers
		var k = false, // knx?
			b = false, // bacnet?
			h = false; // heos?
			m = false; // modbus?
		var aid = ["we"]; // additional ids

/* --DEVSTART-- */
/*
JSONConfig.hsycoconfig.ioservers = [
//	{type:"knx"},
//	{type:"bacnet"},
//	{type:"heos"},
	{type:"modbustcp"},
	{type:"modbusrtu"}
];
*/
/* --DEVEND-- */

		if (JSONConfig && JSONConfig.hsycoconfig && JSONConfig.hsycoconfig.ioservers)
		for (var n in JSONConfig.hsycoconfig.ioservers) {
			switch (JSONConfig.hsycoconfig.ioservers[n].type) {
			case "knx":		k = true; aid.push("ku"); break;
			case "bacnet":	b = true; aid.push("bu"); break;
			case "heos":	h = true; aid.push("hu"); break;
			case "modbustcp":
			case "modbusrtu":
							if (!m) aid.push("mu");
							m = true; break;
			}
		}

		var width;
		var ids;

		if (aid.length>1) { // 4 cols
			e.style.width = "490px";
			ids = ["se","ad","sm","fm","-1",
			       "pe","lv","sb"];
			for (var i=0; i<aid.length; i++) {
				if ((aid.length<4 && i == 0)||
					(aid.length>3 && i == 1))
					ids.push("-2"); // divider
				ids.push(aid[i]);
			}
			ids.push("-3"); // last divider
		} else { // 3 cols
			e.style.width = "370px";
			ids = ["se","ad","we","-1",
			       "pe","fm","sb","-2",
			       "lv","sm","-3"];
		}

		// update divs
		while (appContentE.childNodes.length)
			appContentE.removeChild(appContentE.childNodes[0]); // empty it, we saved the divs

		for (var i=0; i<ids.length; i++)
			if (ids[i])
				appContentE.appendChild(appBtsE[ids[i]]);
	}

	// show app switch popup
	this.showAppsPopup = function (closeBt) {
		this.closePopups(); // close all popups
		this.openPopup('appswitch',closeBt);
		this.adjustPopup(); // adjust because we've changed the size
	} // showAppsPopup()

	// show error popup
	this.showErrorPopup = function (e) {
		this.openPopup('error',false);
		this.cPopup.data.div["e"].innerHTML = e;
		this.adjustPopup(); // adjust because we've changed the size
	} // showErrorPopup()

	// show loading popup
	this.showLoadingPopup = function () {
		this.openPopup('loading',false);
		this.adjustPopup(); // adjust because we've changed the size
	} // showLoadingPopup()

	// show saving popup
	this.showSavingPopup = function () {
		this.openPopup('saving',false);
		this.adjustPopup(); // adjust because we've changed the size
	} // showSavingPopup()

	// show login popup
	this.showLoginPopup = function () {
		if (!self.cPopup || self.cPopup.id != "login") {
			self.closePopups(); // close all popups and notice
			self.clearNotice();
			self.switchApp("");
			self.openPopup("login", false);
			login.start();
		}
	} // showLoginPopup()

	// --------------------------------------------------------------------------------------------------------------------------
	// Panel Functions ----------------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	// init quick app panel
	function initQuickAppsPanel() {
		quickAppsPanel.e = document.getElementById("quickAppsPanel");
		var d = quickAppsPanel.e.getElementsByTagName("div");
		var n = "";
		for (var i=0; i<d.length; i++) {
			if (d[i].className == "quickAppsButton") {
				n = d[i].getAttribute("name");
				quickAppsPanel.buttonsE[n] = d[i];
			}
		}
		quickAppsPanel.buttonsIds = quickAppsPanel.fixedAppsIds.clone(); // initially visible apps
		updateQuickAppsPanel(); // empty it, we saved the divs
	} // initQuickAppsPanel()

	// show quick app switch panel
	this.showQuickAppsPanel = function () {
		// check if can open (no blocking popups). appswitch is closed even if blocking (when opening the manager)
		if (this.cPopup) {
			if (!this.cPopup.closeBt || this.cPopup.id == "appswitch") return;
		}

		if (fileManager.editorOpen && fileManager.editor.completer)
			fileManager.editor.completer.detach();

		if (quickAppsPanel.cId != -1) { // already visible?
			// next
			quickAppsPanel.cId = quickAppsPanel.cId.next(quickAppsPanel.buttonsIds.length);
		} else {
			quickAppsPanel.cId = this.cApp?1:0; // first
			quickAppsPanel.e.style.display = "inline";
		}
		// update
		updateQuickAppsPanel();
	} // showQuickAppsPanel

	// update quick apps panel
	function updateQuickAppsPanel() {
		while (quickAppsPanel.e.childNodes.length)
			quickAppsPanel.e.removeChild(quickAppsPanel.e.childNodes[0]); // empty it, we saved the divs
		if (quickAppsPanel.cId != -1) {
			var e;
			for (var i=0; i<quickAppsPanel.buttonsIds.length; i++) {
				e = quickAppsPanel.buttonsE[quickAppsPanel.buttonsIds[i]];
				quickAppsPanel.e.appendChild(e);
				e.style.opacity = (i == quickAppsPanel.cId)?"1":"0.5";
			}
			self.adjustPanels(); // adjust position
		}
	} // updateQuickAppsPanel()

	// hide quick app switch panel. if cancel, don't switch. returns true or false
	this.hideQuickAppsPanel = function (cancel) {
		if (quickAppsPanel.cId == -1) return false; // already hidden

		if (!cancel)
			this.switchApp(quickAppsPanel.buttonsIds[quickAppsPanel.cId]);

		quickAppsPanel.cId = -1; // reset
		quickAppsPanel.e.style.display = "none";
		// update
		updateQuickAppsPanel();
		return true;
	} // hideQuickAppsPanel

	// --------------------------------------------------------------------------------------------------------------------------
	// Toolbar popups Functions -------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	// show toolbar popup. panel id, show (true, false, null:toggle). if panel id is "", all are hidden
	this.showToolbarPopup = function (p,show) {
		if (p == "")
			show = true;
		else if (show == null)
			show = (cToolbarPopup != p);

		if (!show && cToolbarPopup != p) // hide: already hidden?
			return;
		else if (!show && cToolbarPopup == p) // p becomes the only panel to show, or ""
			p = "";

		// optimization: nothing to change?
		if (cToolbarPopup == p) return;

		toolbarPopupPEEditE.style.display = (p == "pe_edit")?"inline":"none";
		toolbarPopupPEWarningsE.style.display = (p == "pe_warnings")?"inline":"none";

		toolbarPopupFMEditE.style.display = (p == "fm_edit")?"inline":"none";
		toolbarPopupFMWarningsE.style.display = (p == "fm_warnings")?"inline":"none";

		cToolbarPopup = p;

		toolbarArrowE.style.display = (p)?"inline":"none";
		this.adjustToolbar();
	} // showToolbarPopup()

	// close current toolbar popup (if any)
	this.closeToolbarPopup = function () {
		this.showToolbarPopup("");
	} // closeToolbarPopup()

	// --------------------------------------------------------------------------------------------------------------------------
	// Notice Functions ----------------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	// show notice panel
	this.showNotice = function (txt, ms) {
		clearTimeout(noticeTimeout);
		document.getElementById("notice").innerHTML = txt;
		document.getElementById("noticePanel").style.display = "inline";
		if (noticeStatus == 0)
			animations.fadeAnimation(document.getElementById("noticePanel"), {fadeInTime:300});
		noticeStatus = 1; // showing
		if (ms == null)
			ms = NOTICE_WAIT;
		if (ms)
			noticeTimeout = setTimeout(function() {manager.clearNotice()}, ms); // specifying directly the function gave closeNow values
	} // showNotice()

	// clear notice panel
	this.clearNotice = function (closeNow) {
		clearTimeout(noticeTimeout);
		noticeStatus = 0; // not showing
		if (closeNow == true) {
			document.getElementById("notice").innerHTML = "";
			document.getElementById("noticePanel").style.display = "none";
		} else {
			animations.fadeAnimation(document.getElementById("noticePanel"), {fadeOutTime:1500});
		}
	} // clearNotice()

	init();
} // Manager class

//--------------------------------------------------------------------------------------------------------------------------
// Files -------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------

function Files() {
	var req = new XMLReq();

	// name and type of resource currently loading
	this.resID = "";
	this.resType = "";

	var self = this;

	// init
	function init() {
		req.onLoaded = onResourceLoaded;
		req.onError = onResourceError;
		req.onAuthenticate = showPin;
		req.onNoAccess = function () {manager.showErrorPopup("No access");};
	} // init()

	// encode file name
	this.encodeFileName = function (n) {
		if (n=="") n=".";
		n = encodeURIComponent(n);
		return n.replace(/\*/g,"%2A"); //.replace(/\./g,"%2E");
	} // encodeFileName()

	// save a project
	this.saveProject = function (name, content) {
		var file = this.encodeFileName("www/"+name+"/index.hsm");
		var ts = "."+(new Date()).getTime();
		var url = "/x/files?u"+ts;
		url += "*"+file+"*"+encodeURI(content).replace(/#/g,"%23").replace(/\+/g,"%2B");
		this.resType = "saveproj";
		this.resID = name;
		req.open(url,10); // default 10 msec timeout
	} // saveProject()

	// duplicate a project
	this.duplicateProject = function (name, newName) {
		var ts = "."+(new Date()).getTime();
		url = "/x/files?dup"+ts+"*"+this.encodeFileName("www/"+name)+"*"+this.encodeFileName("www/"+newName);
		this.resType = "dupproj";
		this.resID = name;
		req.open(url,10); // default 10 msec timeout
	} // saveProject()

	// save editor file
	this.saveEditorFile = function (file, content) {
		var ts = "."+(new Date()).getTime();
		var url = "/x/files?u"+ts;
		url += "*"+this.encodeFileName(file)+"*"+encodeURI(content).replace(/#/g,"%23").replace(/\+/g,"%2B");
		this.resType = "saveeditor";
		this.resID = file;
		req.open(url,10); // default 10 msec timeout
	} // save()

	// load a file. type, value, wait msec?
	this.load = function (type, value, msec) {
		if (!msec) msec = 10; // default 10 msec timeout
		var url = "";
		var ts = "."+(new Date()).getTime();
		switch (type) {
		// file manager
		case "list":
			url = "/x/files?ls"+ts;
			url += "*"+this.encodeFileName(value)+"*1";
			break;
		case "reqfile":
			url = "/x/files?ts"+ts;
			url += "*"+this.encodeFileName(value);
			break;
		case "openfile":
			url = "/x/files?o"+ts;
			url += "*"+this.encodeFileName(value);
			break;
		case "newfolder":
			url = "/x/files?md"+ts;
			url += "*"+this.encodeFileName(value);
			break;
		case "deletefile":
			url = "/x/files?dr"+ts;
			for (var i=0; i<value.length; i++)
				url += "*"+this.encodeFileName(value[i]);
			break;
		case "duplicatefile":
			url = "/x/files?dup"+ts;
			for (var i=0; i<value.length; i++)
				url += "*"+this.encodeFileName(value[i]);
			break;
		case "renamefile":
			url = "/x/files?r"+ts;
			url += "*"+this.encodeFileName(value[0])+"*"+this.encodeFileName(value[1]);
			break;
		case "movefiles":
			url = "/x/files?mv"+ts;
			for (var i=0; i<value.length; i++)
				url += "*"+this.encodeFileName(value[i]);
			break;
		case "movefilesoverwrite":
			url = "/x/files?mvo"+ts;
			for (var i=0; i<value.length; i++)
				url += "*"+this.encodeFileName(value[i]);
			break;
		case "copyfiles":
			url = "/x/files?cp"+ts;
			for (var i=0; i<value.length; i++)
				url += "*"+this.encodeFileName(value[i]);
			break;
		case "copyfilesoverwrite":
			url = "/x/files?cpo"+ts;
			for (var i=0; i<value.length; i++)
				url += "*"+this.encodeFileName(value[i]);
			break;
		case "gettextpreview":
			url = "/x/files?o"+ts;
			url += "*"+this.encodeFileName(value)+"*9";
			break;
		// project editor
		case "www":
			url = "/x/files?ls"+ts;
			url += "*www*2";
			break;
		case "topo":
			url = "topo.txt"+ts;
			break;
		case "config":
			url = "config.txt"+ts;
			break;
		case "reqproject":
			url = "/x/files?ts"+ts;
			url += "*"+this.encodeFileName("www/"+value+"/index.hsm");
			break;
		case "project":
			url = "/x/files?o"+ts;
			url += "*"+this.encodeFileName("www/"+value+"/index.hsm");
			break;
		case "dictionary":
			url = "/x/getdictionary?"+this.encodeFileName(value)+ts;
			break;
		case "include":
			value = project.includesNeeded[0].file;
			url = "/x/files?o"+ts;
			url += "*"+this.encodeFileName("www/"+project.name+"/"+value+".hsm");
			break;
		case "logout":
			url = "/x/logout?logout"+ts;
			break;
		case "lock":
			url = "/x/logout?reset"+ts;
			break;
		case "restart":
			url = "/x/kill"+ts;
			break;
		// system monitor
		case "systemstatus":
			url = "/x/getsystemstatus"+ts;
			break;
		}

		this.resType = type;
		this.resID = value;

		req.open(url,msec);
	} // load()

	// delete a file
	this.del = function (name) {
		var ts = "."+(new Date()).getTime();
		var url = "/x/files?dr"+ts;
		url += "*"+this.encodeFileName(name);
		this.resType = "delproj";
		this.resID = name;
		req.open(url);
	} // del()

	// on resource loaded event
	function onResourceLoaded() {
		var w = 100; // wait before next request (prevents hanging?)
	    switch(self.resType) {
	    // file manager
	    case "list":
			fileManager.onList(this.getResponseJSON());
	    	break;
	    case "reqfile":
	    	fileManager.editorTs = this.getResponseText()*1;
	    	self.load("openfile",self.resID,w);
	    	break;
		case "openfile":
			fileManager.updateEditor(this.getResponseText().substr(8)); // remove Content:
			break;
		case "newfolder":
			manager.closePopup();
			var name = self.resID.split("/").pop();
			if (this.getResponseText() == "ack")
				manager.showNotice("new folder (<b>"+name+"</b>) created");
			else
				manager.showNotice("error creating new folder");
			var o = fileManager.popupMode?fileManager.popupData:fileManager;
			fileManager.browseTo(o.currentPath);
			break;
		case "deletefile":
			manager.closePopup();
			var n = self.resID.length;
			var fs = "file"+(self.resID.length>1?"s":""); // file string
			if (this.getResponseText() == "ack")
				manager.showNotice(n+" "+fs+" deleted");
			else
				manager.showNotice("error deleting "+fs);
			var o = fileManager.popupMode?fileManager.popupData:fileManager;
			fileManager.browseTo(o.currentPath);
			break;
		case "renamefile":
			var name = self.resID[0].split("/").pop();
			if (this.getResponseText() == "ack")
				manager.showNotice("<b>"+name+"</b> renamed");
			else
				manager.showNotice("error renaming <b>"+name+"</b>");
			var o = fileManager.popupMode?fileManager.popupData:fileManager;
			fileManager.selectItem(-1);
			fileManager.browseTo(o.currentPath);
			break;

		case "duplicatefile":
			var name = self.resID[0].split("/").pop();
			if (this.getResponseText() == "ack")
				manager.showNotice("<b>"+name+"</b> duplicated");
			else
				manager.showNotice("error duplicating <b>"+name+"</b>");
			var o = fileManager.popupMode?fileManager.popupData:fileManager;
			fileManager.selectItem(-1);
			fileManager.browseTo(o.currentPath);
			break;

		case "movefiles":
		case "movefilesoverwrite":
		case "copyfiles":
		case "copyfilesoverwrite":
			var n = self.resID.length-1; // last param is target folder
			var fs = "file"+(n>1?"s":""); // file string
			var m = (self.resType == "movefiles" || self.resType == "movefilesoverwrite");
			var as1 = m?"moved":"copied"; // action string 1
			var as2 = m?"moving":"copying"; // 2

			switch (this.getResponseText()) {
			case "ack":			manager.showNotice(n+" "+fs+" "+as1+" to <b>"+self.resID.last())+"</b>"; break; // mv, mvo
			case "error":		manager.showNotice("error "+as2+" "+fs); break; // mv, mvo
			case "error:size":	manager.showNotice("error "+as2+" "+fs+": total size exceeds the limit"); break; // mv, mvo
			case "error:same":	manager.showNotice("error "+as2+" "+fs+": source and destination folders are the same"); break;
			case "error:exists":
				manager.openPopup("overwritefiles",true);
				break;  // mv
			}
			break;

	    case "saveeditor":
			manager.closePopup();
			fileManager.onEditorSaved(this.getResponseText());
	    	break;
		case "gettextpreview":
			fileManager.updateTextPreview(this.getResponseText().substr(8)); // remove Content:
			break;
	    // project editor
	    case "www":
	    	projectEditor.onList(this.getResponseJSON());
	    	break;
	    case "lan":
	    	projectEditor.onCustomLanguageUpdate(this.getResponseText().substr(8)); // remove Content:
	    	break;
	    case "topo":
	    	JSONTopo = this.getResponseJSON();
	    	self.load("config",w);
	    	break;
	    case "config":
			JSONConfig = this.getResponseJSON();
			self.load("dictionary", "blue",w);
			break;
	    case "reqproject":
	    	project = new Project();
	    	project.timestamp = this.getResponseText()*1;
	    	self.load("project",self.resID,w);
	    	break;
	    case "project":
	    	project.name = self.resID;
	    	project.src = this.getResponseText().substr(8); // remove Content:
	    	project.skin = self.getSkin(project.src);
	    	if (dictionary && project.skin == dictionary.skin) { // parse now
		    	parser.parseProject();
				if (project.includesNeeded.length)
					self.load("include",w);
				else
					projectEditor.onProjectLoaded();
	    	} else {
	    		self.load("dictionary",project.skin,w);
	    	}
			break;
	    case "dictionary":
	    	// manage error
	    	if (this.getResponseText() == "error") {
	    		manager.showErrorPopup("There was an error while loading the skin ("+self.resID+")");
	    	} else {
		    	dictionary = new Dictionary(this.getResponseXML());
	    	}
	    	if (project)
	    		project.selectDictionary();
	    	if (project && project.src)
	    		parser.parseProject();
			if (project && project.includesNeeded.length)
				self.load("include",w);
			else
				projectEditor.onProjectLoaded();
	    	break;
	    case "include":
	    	// manage error
	    	if (this.getResponseText() == "error") {
	    		break;
	    	} else {
				parser.parseInclude(self.resID,this.getResponseText().substr(8)); // remove Content:
				// redraw all includes
				for (var i=0; i<project.includesNeeded[0].objs.length; i++) {
					project.includesNeeded[0].objs[i].fitSize(true); // does redraw too
					var c = project.includesNeeded[0].objs[i].parentObj;
					while (!c.isPage) {
						c.fitSize();
						c = c.parentObj;
					}
				}
	    	}
			project.includesNeeded.splice(0,1);
			if (project.includesNeeded.length)
				self.load("include",w);
			else
				projectEditor.onProjectLoaded();
			break;
	    case "saveproj":
	    	projectEditor.onProjectSaved(this.getResponseText(),self.resID);
	    	break;
	    case "delproj":
	    	projectEditor.onProjectDeleted(this.getResponseText(),self.resID);
	    	break;
	    case "dupproj":
	    	files.saveProject(project.name,projectEditor.generateIndex());
	    	break;
	    case "logout": // server replies with "logout", "lock"
	    case "lock":
	    	manager.reload();
	    	break;
		case "restart":
	    	if (this.getResponseText() == "ack") {
	    		timestampChecker.waitRestart("");
	    	}
			break;
		// system monitor
		case "systemstatus":
			systemMonitor.onUpdate(this.getResponseJSON());
			break;
	    }
	} // onResourceLoaded()

	// error
	function onResourceError(errCode) {
	    // close popups?
	    if (manager.cPopup && (manager.cPopup.id == "saving" || manager.cPopup.id == "loading"))
	    	manager.closePopup();
		// error
		manager.clearNotice();
	    switch(files.resType) {
	    case "logout":
	    case "lock":
	    	// logout will raise an error, do nothing
	    	break;
	    case "saveproj":
	    case "saveeditor":
	    	manager.showErrorPopup("Error saving <b>"+files.resID+"</b> ("+errCode+")");
	    	break;
	    case "delproj":
	    	manager.showErrorPopup("Error deleting <b>"+files.resID+"</b> ("+errCode+")");
	    	break;
		// system monitor
		case "systemstatus":
			// do nothing
			// systemMonitor.onError();
			break;
	    case "www":
	    	manager.switchApp("");
	    	manager.showAppsPopup(); // project editor is hidden
	    default:
	    	var str = "Error loading "+files.resType;
	    	if (files.resID) str += ", "+files.resID;
	    	str += " ("+errCode+")";
			manager.showErrorPopup(str);
			break;
	    }
	} // onResourceError()

	// get skin from source
	this.getSkin = function (txt) {
		var p = txt.indexOf("(#skin ");
		var b = p+7;
		var e = txt.indexOf(")",b);
		// TODO:errors
		return txt.substr(b,e-b);
	} // getSkin

	init();
} // Files()

//--------------------------------------------------------------------------------------------------------------------------
// System Monitor ----------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------

// system monitor
function SystemMonitor() {
	var started = false; // if already started, will just switch
	var intervalID; // update interval id

	var toolbarE = document.getElementById("sm_toolbar");
	var frameE = document.getElementById("sm_frame");
	var errorE = document.getElementById("sm_error");

	// sizes for adjustLayout
	var fw,fh,ew,eh;

	this.e = document.getElementById("systemMonitor");

	var fields = {}; // fields by name

	var self = this;

	// init
	function init() {
	} // init()

	// start
	this.start = function () {
		manager.hideOtherApps("sm");

		this.e.style.display = "inline";

		// fields
		var d,n;
		for (var i = 0; (d = frameE.getElementsByTagName("div")[i]); i++) {
			n = d.getAttribute("name");
			if (n) fields[n] = d;
		}

		// mode
		toolbarE.style.display = "inline";

		intervalID = setInterval(update, 10000);
		update(); // update now

		if (!started) {
			started = true;
			fw = frameE.offsetWidth;
			fh = frameE.offsetHeight;
			ew = errorE.offsetWidth;
			eh = errorE.offsetHeight;
			errorE.style.display = "none";
		}

		this.adjustLayout();

		this.focus();
		this.open = true;

		timestampChecker.start(); // no additional files to check here
	} // start()

	// hide (switching to another app)
	this.hide = function () {
		timestampChecker.stop(); // pause

		clearInterval(intervalID);

		this.e.style.display = "none";

		manager.focus();

		this.open = false;
	} // hide()

	// focus, restore key events
	this.focus = function () {
		if (window.focus) window.focus();
		manager.deselect();
	} // focus()

	// adjust layout. viewport size
	this.adjustLayout = function () {
		if (!manager.viewportWidth || !manager.viewportHeight) return;

		var	vw = manager.viewportWidth;
		var	vh = manager.viewportHeight;

		// tool bar size
		var tbW = 0; // left one
		var tbH = 36; // top one

		// editable area size
		var eW = vw - tbW;
		var eH = vh - tbH;

		toolbarE.style.left = (tbW-1)+"px"; // +1, attach it to the iconPanel
		toolbarE.style.width = (eW+1)+"px";

		frameE.style.left = Math.round((eW-fw)/2)+"px";
		frameE.style.top = (tbH+Math.round((eH-fh)/2))+"px";

		errorE.style.left = Math.round((eW-ew)/2)+"px";
		errorE.style.top = (tbH+Math.round((eH-eh)/2))+"px";
	} // adjustLayout()

	// new request
	function update() {
		files.load("systemstatus");
	}

	// update
	this.onUpdate = function (data) {
		if (data && data.systemstatus && data.systemstatus["disk.free.percent"]!=null) { // disk.free.percent is the first
			frameE.style.display = "inline";
			errorE.style.display = "none";
			for (var i in data.systemstatus) {
				if (fields[i])
					fields[i].innerHTML = data.systemstatus[i];
			}
			if (data.systemstatus["disk.errors"] && data.systemstatus["disk.errors"] != "null") {
				fields["disk.errors.label"].style.visibility = "";
				fields["disk.errors.value"].innerHTML = data.systemstatus["disk.errors"];
			} else {
				fields["disk.errors.label"].style.visibility = "hidden";
				fields["disk.errors.value"].innerHTML = "&nbsp;";
			}
			fields["messages"].style.display = data.systemstatus["messages"]?"inline":"none";
		} else {
			frameE.style.display = "none";
			errorE.style.display = "inline";
		}
	} // onUpdate()

	// init
	init();
} // SystemMonitor()

//--------------------------------------------------------------------------------------------------------------------------
// Timestamp Checker -------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------

// checks timestamp of file while working on them, so we know when they're changed
function TimestampChecker() {
	// file timestamp change checker
	var tsCheckReq = new XMLReq();

	// loader
	var loaderReq = new XMLReq();
	var resID = ""; // requested resource

	var runTs = 0; // run ts
	var jarTs = 0; // jar timestamp
	var topoTs = 0; // system topo timestamp
	var iniTs = 0; // ini timestamp

	var iniChanged = false;
	var jarChanged = false;

	var restartState = ""; // server restart state. wo: wait for the server to go offline. wr: wait for server to go online again

	var state = {}; // current state: what we're checking

	var nopolling = false; // no polling mode on iOS
	var justFailed = false; // last request failed? don't wait...
	var failCount = 0; // so we check with a lower delay based on number of failures

	var self = this;

	// init
	function init() {
		// timestamp check
		tsCheckReq.onLoaded = onCheck;
		tsCheckReq.onAuthenticate = onCheckAuthenticate;
		tsCheckReq.onNoAccess = onCheckNoAccess;
		tsCheckReq.onError = onError;
		tsCheckReq.maxWaitingTime = 15000; // in 15 sec the server should reply
		// loader
		loaderReq.onLoaded = onResourceLoaded;
		loaderReq.onAuthenticate = showPin;
		loaderReq.onNoAccess = function () {manager.showErrorPopup("No access");};

		// no polling
		nopolling = browser.iOS;
	} // init()

	// get current state, determines what we're checking
	function getState() {
		if (manager.cApp == "fm") {
			var o = fileManager.popupMode?fileManager.popupData:fileManager;
			if (fileManager.editorOpen)
				return {mode:"fme", req:fileManager.currentFile}; // edit
			else
				return {mode:"fmf", req:o.currentPath}; // folder
		} else if (manager.cApp == "pe") {
			if (manager.cPopup) {
				if (manager.cPopup.id == "choosefile")
					return {mode:"pef", req:fileManager.popupData.currentPath}; // choose file
			} else if (project && project.name) {
				return {mode:"pep", req:"www/"+project.name+"/index.hsm", reqLan:"www/"+project.name+"/text_"+project.language+".txt"}; // project
			} else if (projectEditor.projects) {
				return {mode:"pew", req:""}; // www
			}
		}
		return "";
	} // getState()

	// start checking, depending on current mode
	this.start = function () {
		tsCheckReq.stop(); // reset?

		var ts = "."+(new Date()).getTime();
		var url = "/x/files?ts"+ts;

		// runts
		url += "*runts*"+(nopolling || justFailed?0:runTs); // no polling: if at least one ts is negative, the server will reply right away

		// jar
		url += "*"+files.encodeFileName("hsyco.jar")+"*"+jarTs;

		// system topo
		url += "*"+files.encodeFileName("systemtopo.txt")+"*"+topoTs;

		// ini
		url += "*"+files.encodeFileName("hsyco.ini")+"*"+iniTs;

		// get state
		state = getState();
		// set file check. project: www, current hsc. file manager: folder, current text file
		switch (state.mode) {
		case "fme":	// file manager, editor
			url += "*"+files.encodeFileName(state.req)+"*"+fileManager.editorTs;
			break;
		case "fmf": // file manager, folder
			var o = fileManager.popupMode?fileManager.popupData:fileManager;
			url += "*"+files.encodeFileName(state.req)+"*"+o.folderTs;
			break;
		case "pef": // project editor, choose file
			url += "*"+files.encodeFileName(state.req)+"*"+fileManager.popupData.folderTs;
			break;
		case "pep": // project editor, project
			url += "*"+files.encodeFileName(state.req)+"*"+project.timestamp;
			url += "*"+files.encodeFileName(state.reqLan)+"*"+project.customLanTimestamp;
			// go on
		case "pew": // www
			url += "*"+files.encodeFileName("www")+"*"+projectEditor.folderTs;
			if (projectEditor.projects) {
				for (var i=0; i<projectEditor.projects.length; i++)
					url += "*"+files.encodeFileName("www/"+projectEditor.projects[i])+"*"+projectEditor.projectsTs[i];
			}
			break;
		}


		var wt = 100;
		if (nopolling && !justFailed) wt = 1000; // no polling gets the answer right away, so wait 1sec between requests
		if (failCount>2) wt = (failCount<30)?failCount*100:3000; // wait between 100-2500ms
		tsCheckReq.open(url, wt);
		justFailed = false; // reset
	} // start()

	// stop timestamp check
	this.stop = function () {
		tsCheckReq.stop();
		loaderReq.stop(); // will abort any request
	} // stop()

	// timestamp check
	function onCheck() {
		// reset failcount
		failCount = 0;
		// restarted?
		if (restartState == "wr") {
			restartState = "";
			manager.showNotice("server restarted");
			// connected, remove popup?
			if (manager.cPopup && manager.cPopup.id == "waitrestart")
				manager.closePopup();
		}
		// connected, remove popup?
		if (manager.cPopup && manager.cPopup.id == "connecting")
			manager.closePopup();

		var ts = this.getResponseText().split(",");

		// runts
		if (runTs == 0) { // first time
			runTs = ts[0];
		} else if (runTs != ts[0]) {
			runTs = ts[0]; // update anyway
			// connected, remove popup?
			if (manager.cPopup && (manager.cPopup.id == "waitrestart" || manager.cPopup.id == "connecting"))
				manager.closePopup();
			// clean variables
			statusBrowser.onRestart();
			snippetDataManager.onRestart();
			if (jarChanged) {
				// reload page
				manager.reload();
			} else if (iniChanged) {
				iniChanged = false;
				// reload config
				resID = "config";
				var t = "."+(new Date()).getTime();
				var url = "/x/getconfig?"+t;
				loaderReq.open(url, 100);
				return; // one thing at a time
			}
		}

		// jar
		if (jarTs == 0) { // first time
			jarTs = ts[1];
		} else if (jarTs != ts[1]) {
			jarTs = ts[1]; // update anyway
	    	manager.showNotice("hsyco.jar updated");
	    	jarChanged = true;
		}

		// system topo
		if (topoTs == 0) { // first time
			topoTs = ts[2];
		} else if (topoTs != ts[2]) {
			topoTs = ts[2]; // update anyway
			resID = "topo";
			var t = "."+(new Date()).getTime();
			var url = "/x/gettopo?"+t;
			loaderReq.open(url, 100);
			return; // one thing at a time
		}

		// ini
		if (iniTs == 0) { // first time
			iniTs = ts[3];
		} else if (iniTs != ts[3]) {
			iniTs = ts[3]; // update anyway
	    	manager.showNotice("hsyco.ini updated");
	    	iniChanged = true;
		}

		// check mode, still the same?
		var k = 4;
		var s = getState();
		if (s.mode == state.mode && s.req == state.req) {
			switch (s.mode) {
			case "fme":	// file manager, editor
				var r = new RegExp("^logs/[^/]+/[^\.]+\.log$"); // check that it's not a log file
				if (fileManager.editorTs != ts[k] && !r.test(state.req)) {
					fileManager.editorTs = ts[k]; // update anyway
					manager.openPopup("filerefresh", true, function(){timestampChecker.start()});
					return; // don't restart timestampChecker, wait for popup
				}
				break;
			case "fmf":
			case "pef":
				var o = fileManager.popupMode?fileManager.popupData:fileManager;
				if (o.folderTs != ts[k]) {
					o.folderTs = ts[k]; // update anyway
					// reload folder
					resID = "list";
					var t = "."+(new Date()).getTime();
					var url = "/x/files?ls"+t+"*"+files.encodeFileName(o.currentPath)+"*1";
					loaderReq.open(url, 100);
					return; // don't restart timestampChecker until done
				}
				break;
			case "pep":
				if (project.timestamp != ts[k]) {
					if (ts[k] == 0) { // deleted?
						projectEditor.onProjectDeleted("ack","www/"+project.name);
					} else {
						project.timestamp = ts[k]; // update anyway
						manager.openPopup("filerefresh", true, function(){timestampChecker.start()});
					}
					return; // don't restart timestampChecker, wait for popup
				}
				k++;
				if (project.customLanTimestamp != ts[k]) {
					project.customLanTimestamp = ts[k];
					if (ts[k] == 0) { // deleted?
						projectEditor.onCustomLanguageUpdate("");
					} else {
						// reload lan
						resID = "lan";
						var t = "."+(new Date()).getTime();
						var url = "/x/files?o"+t+"*"+files.encodeFileName("www/"+project.name+"/text_"+project.language+".txt");

						loaderReq.open(url, 100);
						return; // don't restart timestampChecker until done
					}
				}
				k++;
				// go on
			case "pew":
				var r = false; // reload
				if (projectEditor.folderTs != ts[k]) {
					projectEditor.folderTs = ts[k]; // update
					r = true;
				}
				k++;
				if (projectEditor.projects) {
					for (var i=0; i<projectEditor.projects.length; i++) {
						if (projectEditor.projectsTs[i] != ts[k]) {
							projectEditor.projectsTs[i] = ts[k];
							r = true;
						}
						k++;
					}
				}
				if (r) {
					// reload www
					resID = "www";
					var t = "."+(new Date()).getTime();
					var url = "/x/files?ls"+t+"*www*2";
					loaderReq.open(url, 100);
					return; // don't restart timestampChecker until done
				}
				break;
			}
		}
		self.start(); // check again
	} // onCheck()

	// on check authenticate
	function onCheckAuthenticate(lock) {
		self.stop();
		showPin(lock);
	} // onCheckAuthenticate()

	// on check no access
	function onCheckNoAccess() {
		self.stop();
		manager.showErrorPopup("No access");
	} // onCheckNoAccess()

	// on error
	function onError() {
		// error because it's restarting?
		if (restartState == "wo") {
			restartState = "wr"; // wait restart
			manager.openPopup("waitrestart", false);
		} else {
			justFailed = true;
			manager.openPopup("connecting", false);
		}
		failCount++;
		self.start();
	} // onError()

	// wait server restart. mode, what to do when it's restarted
	this.waitRestart = function () {
		restartState = "wo";
	} // waitRestart()

	// on refresh, when clicking yes on the filerefresh popup
	this.onRefresh = function () {
		manager.closePopup();
		switch (manager.cApp) {
		case "fm":
			fileManager.openEditor(); // refresh
			break;
		case "pe":
			projectEditor.loadProject(project.name);
			break;
		}
	} // onRefresh()

	// on resource loaded
	function onResourceLoaded() {
		switch (resID) {
	    // project editor
	    case "www":
	    	projectEditor.onList(this.getResponseJSON());
	    	break;
	    case "lan":
	    	projectEditor.onCustomLanguageUpdate(this.getResponseText());
	    	break;
	    // file manager
	    case "list":
	    	fileManager.refreshFolder(this.getResponseText());
	    	break;
	    // topo
	    case "topo":
			JSONTopo = this.getResponseJSON(); // database
			manager.onTopoUpdate();
	    	manager.showNotice("systemtopo updated");
	    	break;
	    // config
	    case "config":
			JSONConfig = this.getResponseJSON(); // database
			// load state also, for timers
			resID = "state";
			var url = "/x/getstate?0";
			loaderReq.open(url, 100);
	    	break;
	    // state
	    case "state":
			JSONState = this.getResponseJSON(); // database
	    	manager.onConfigUpdate();
	    	manager.showNotice("config updated");
	    	break;
		}
		self.start(); // restart
	} // onResourceLoaded()

	init();
} // TimestampChecker Class

//--------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
// LogViewer ---------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------

// LogViewer class
function LogViewer() {
	var started = false; // if already started, will just switch
	this.open = false; // currently open. set by start, hide
	var mode = "app"; // app mode or preview mode

	var req = new XMLReq();
	var timeout; // repeat timeout

	var logTargetE; // log target
	var logLines = 0; // how many lines
	var logLastReq = 0; // time stamp
	var logLastClear = 0; // last time stamp cleared, so we restart from there

	// type, id and value of resource currently loading
	var resType = "";
	var resID = "";
	var resValue = "";

	var paused = false;

	var lineBuffer = [];
	var filterBuffer = [];

	this.e = document.getElementById("logViewer");

	var toolbarE = document.getElementById("lv_toolbar");

	var logPanelE = document.getElementById("lv_logPanel");
	var topPanelE = document.getElementById("lv_topPanel");
	var logContainerE = document.getElementById("lv_container");
	var logE = document.getElementById("lv_log");

	var filterE = document.getElementById("lv_filter");
	var filterFieldE = document.getElementById("lv_filterField");

	var filter = ""; // current filter string
	var filterData = []; // array data from filter string
	var filterMode = true; // include
	var filterModeBtE = document.getElementById("lv_filterModeBt");

	var verboseMode = false;
	var eventsMode = false;
	var userMode = false;

	var pauseBtE = document.getElementById("lv_pauseBt");
	var clearBtE = document.getElementById("lv_clearBt");
	var verboseModeBtE = document.getElementById("lv_verboseModeBt");
	var eventsModeBtE = document.getElementById("lv_eventsModeBt");
	var userModeBtE = document.getElementById("lv_userModeBt");

	// panel shape, for preview mode
	this.panelShape = {x:0,y:0,width:0,height:0};

	var self = this;

	// init
	function init() {
		req.onLoaded = onResourceLoaded;
		req.onAuthenticate = showPin;
		req.onNoAccess = function () {manager.showErrorPopup("No access");};
		req.onError = onResourceError; // it never fires???????????????????????????
		req.retryOnErrorDelay = 1000;
	} // init()

	// start
	this.start = function () {
		manager.hideOtherApps("lv");

		this.e.style.display = "inline";

		// mode
		mode = "app";
		toolbarE.style.display = "inline";

		this.adjustLayout();

		started = true;

    	if (paused) this.togglePause(true);

		// log preview
		this.startLog(logE,1000);
		logContainerE.scrollTop = logContainerE.scrollHeight; // scroll to bottom

		this.focus();
		this.open = true;

		timestampChecker.start(); // no additional files to check here
	} // start()

	// start in preview mode. lines
	this.startPreview = function (n) {
		this.e.style.display = "inline";

		// mode
		mode = "pre";
		toolbarE.style.display = "none";

		this.adjustLayout();

		// log preview
		this.startLog(logE,n);
		logContainerE.scrollTop = logContainerE.scrollHeight; // scroll to bottom
	} // startPreview()

	// stop preview, hide panel
	this.stopPreview = function () {
		this.e.style.display = "none"; // hide
		this.stopLog();
	} // stopPreview()

	// clear log
	this.clear = function () {
		lineBuffer = [];
		logLastClear = logLastReq;
		// check filter
		if (filter) {
			filterBuffer = [];
		}
		this.updateLog();
	} // clear()

	// set panel shape, for preview mode
	this.setPanelShape = function (x,y,width,height) {
		this.panelShape.x = x;
		this.panelShape.y = y;
		this.panelShape.width = width;
		this.panelShape.height = height;
	} // setPanelShape()

	// hide (switching to another app)
	this.hide = function () {
		timestampChecker.stop(); // pause

		this.e.style.display = "none";
		this.stopLog();

		manager.focus();

		this.open = false;
	} // hide()

	// focus, restore key events
	this.focus = function () {
		if (window.focus) window.focus();
		manager.deselect();
	} // focus()

	// adjust layout. viewport size
	this.adjustLayout = function () {
		if (!manager.viewportWidth || !manager.viewportHeight) return;

		var	vw = manager.viewportWidth;
		var	vh = manager.viewportHeight;

		// tool bar size
		var tbW = 0; // left one
		var tbH = 36; // top one

		// editable area size
		var eW = vw - tbW;
		var eH = vh - tbH;

		toolbarE.style.left = (tbW-1)+"px"; // +1, attach it to the iconPanel
		toolbarE.style.width = (eW+1)+"px";

		// panel
		if (mode == "app") {
			var pd = 7; // panel distance from border
			var bs = 1; // border size
			var pl = pd; // panel left
			var pt = tbH+pd; // panel top
			var pw = vw-pd*2-bs*2; // full content width
			var ph = vh-tbH-pd*2-bs*2;
		} else {
			var pl = this.panelShape.x; // panel left
			var pt = this.panelShape.y; // panel top
			var bs = 1; // border size
			var pw = this.panelShape.width-bs*2; // full content width
			var ph = this.panelShape.height-bs*2;
		}

		var bh = 45; // bottom bar

		topPanelE.style.height = (ph-bh)+"px";

		logPanelE.style.left = (pl)+"px";
		logPanelE.style.top = (pt)+"px";
		logPanelE.style.width = (pw)+"px";
		logPanelE.style.height = (ph)+"px";

		logContainerE.style.height = (ph-bh)+"px";

		browser.miniButton(pauseBtE, (pw<550));
		browser.miniButton(clearBtE, (pw<550));
		browser.miniButton(verboseModeBtE, (pw<700));
		browser.miniButton(eventsModeBtE, (pw<700));
		browser.miniButton(userModeBtE, (pw<700));
		browser.miniButton(filterModeBtE, (pw<550));

		var fw = (pw<450)?pw-200:250;
		filterFieldE.style.width = fw + "px";
		filterE.style.width = (fw-40) + "px"; // leave space for the x
	} // adjustLayout()

	// repeat
	this.repeat = function (ms) {
		timeout = setTimeout(doRepeat, ms);
	}

	function doRepeat() {
		self.load(resType, resID, resValue);
	}

	// load a file
	this.load = function (type, id, value) {
		if (timeout) {
			clearTimeout(timeout);
			timeout = null;
		}

		// /x/getlog? now also returns the current status of log modes, as "mode":{"verbose":[0 | 1],"events":[0 | 1],"user":[0 | 1]}
		// /x/setlog?[verbose | events | user]*[0 | 1] temporarily sets log levels; after approx. 60 seconds of inactivity on /x/getlog, logs
		var url = "";
		switch (type) {
		case "get":
			var url = "/x/getlog?"+logLines+"*"+logLastReq;
			break;
		case "set":
			var url = "/x/setlog?"+id+"*"+(value?1:0);
			break;
		}

		resType = type;
		resID = id;
		resValue = value;

	    req.open(url,10);
	} // load()

	// on resource loaded event
	function onResourceLoaded() {
		if (timeout) {
			clearTimeout(timeout);
			timeout = null;
		}

		if (!logTargetE) return; // nothing to do

	    switch(resType) {
	    case "get":
	    	if (paused) return; // paused
	    	var data = this.getResponseJSON();
	    	if (data && data.log.timestamp) {
	    		logLastReq = data.log.timestamp;
	    		self.updateLog(data);
	    	}
	    	self.repeat(250);
	    	break;
	    case "set":
	    	if (paused) self.togglePause(true);
	    	self.load("get");
	    	break;
	    }
	} // onResourceLoaded()

	// on resource error
	function onResourceError() {
		if (timeout) {
			clearTimeout(timeout);
			timeout = null;
		}

		if (!logTargetE) return; // nothing to do

    	// error
    	manager.clearNotice();
	    switch(resType) {
	    case "get":
	    	this.repeat(3000);
	    	break;
	    case "set":
	    	this.repeat(3000);
	    	break;
	    }
	} // onResourceError()

	// lines, div, resume? (when pausing)
	this.startLog = function (e,n,resume) {
		logTargetE = e;
		logLines = n;
		if (!resume)
			logLastReq = logLastClear;
		this.load("get");
	} // startLog()

	// update preview
	this.updateLog = function (data) {
		if (!logTargetE) return;

		// levels mode
		if (data && data.mode) {
			var v = (data.mode.verbose == 1);
			if (verboseMode != v) {
				verboseMode = v;
				verboseModeBtE.getElementsByTagName("img")[0].style.display = v?"inline":"none";
				verboseModeBtE.getElementsByTagName("img")[1].style.display = v?"none":"inline";
			}
			v = (data.mode.events == 1);
			if (eventsMode != v) {
				eventsMode = v;
				eventsModeBtE.getElementsByTagName("img")[0].style.display = v?"inline":"none";
				eventsModeBtE.getElementsByTagName("img")[1].style.display = v?"none":"inline";
			}
			v = (data.mode.user == 1);
			if (userMode != v) {
				userMode = v;
				userModeBtE.getElementsByTagName("img")[0].style.display = v?"inline":"none";
				userModeBtE.getElementsByTagName("img")[1].style.display = v?"none":"inline";
			}
		}

		var i;
		var dl = 0; // lines added to buffer
		var df = 0; // lines added to filter buffer
		var txt = "";
		var htxt = "";
		if (data && data.log && data.log.lines && data.log.lines.length) {
			txt = "";
			for (i=data.log.lines.length-1; i>=0; i--) {
				txt = decodeURIComponent(data.log.lines[i]);
				htxt = txt.replace(/\&/g,'&'+'amp;').replace(/</g,'&'+'lt;').replace(/>/g,'&'+'gt;').replace(/\'/g,'&'+'apos;').replace(/\"/g,'&'+'quot;');
				htxt = "<span style='color:#5f7f5f'>"+htxt.substr(0,23)+"</span>"+htxt.substr(23);
				txt = txt.substr(26); // remove datetime

				lineBuffer.push([txt,htxt]); // array 0:decoded text, 1:html text ready to be added
				dl++;
				// check filter
				if (filterCheck(txt)) {
					filterBuffer.push([txt,htxt]);
					df++;
				}
			}
		}

		if (lineBuffer.length>logLines)
			lineBuffer = lineBuffer.slice(-logLines);
		if (filterBuffer.length>logLines)
			filterBuffer = filterBuffer.slice(-logLines);

		var e = logTargetE.parentNode;
		var h = e.scrollHeight-e.offsetHeight; // scroll height
		var d = (e.scrollTop == h); // down? keep it down

		// update, add all lines
		var html = "";
		if (!filter) {
			for (i=0; i<lineBuffer.length; i++) html +=  lineBuffer[i][1]+"<br>"; // 1:html text
		} else {
			for (i=0; i<filterBuffer.length; i++) html +=  filterBuffer[i][1]+"<br>";
		}
		logTargetE.innerHTML = html;
		var st = e.scrollTop; // save scroll top

		// get new lines height
		var hd = 0;
		if (data && data.log && data.log && data.log.lines && data.log.lines.length) {
			var div = document.createElement('div');
			div.style.fontFamily = "Monaco";
			div.style.fontSize = "12px";
			div.style.width = logTargetE.offsetWidth+"px";
			div.style.wordWrap = "break-word";

			html = "";
			if (!filter) {
				for (i=lineBuffer.length-dl; i<lineBuffer.length; i++) html +=  lineBuffer[i][1]+"<br>";
			} else {
				for (i=filterBuffer.length-df; i<filterBuffer.length; i++) html +=  filterBuffer[i][1]+"<br>";
			}
			div.innerHTML = html;
			hd = manager.getDivSize(div).h; // to keep scrolling fixed;
		}

		if (d) {
			st = e.scrollHeight-e.offsetHeight;
		} else {
			if ((!filter && lineBuffer.length == logLines)&&
				(filter && filterBuffer.length == logLines)) { // keep the scrolling fixed
				st -= hd;
				if (st<0) st = 0;
			}
		}
		// restore
		e.scrollTop = st;
	} // updateLog()

	this.stopLog = function () {
		if (timeout) {
			clearTimeout(timeout);
			timeout = null;
		}
		if (logTargetE) {
			logTargetE.innerHTML = "";
			logTargetE = null;
		}
		// clean buffers
		lineBuffer = [];
		filterBuffer = [];
		req.stop();
	} // stopLog()

	// check text line using filter. returns true/false
	function filterCheck(txt) {
		if (!filter) return true; // no filter
		var f = false;
		var t = txt.toLowerCase();
		// or
		for (var i=0; i<filterData.length; i++) {
			if (t.indexOf(filterData[i])!=-1) { // found
				f = true;
				break;
			}
		}
		if (!filterMode) f = !f;
		return f;
	} // filterCheck()

	// update filter
	this.updateFilter = function (v) {
		if (v == null)
			v = filterE.value;
		else
			filterE.value = v;
		if (filter != v) {
			filter = v;
			// get filter data
			filterData = v.trim().toLowerCase().split(" ");
			// rebuild filtered lines buffer
			filterBuffer = [];
			for (i=0; i<lineBuffer.length; i++) {
				if (filterCheck(lineBuffer[i][0])) {
					filterBuffer.push([lineBuffer[i][0],lineBuffer[i][1]]);
				}
			}
			this.updateLog();
		}
	} // updateFilter()

	// toggle pause. reset? (change just the buttons)
	this.togglePause = function (reset) {
		if (reset)
			paused = false;
		else
			paused = !paused;
		pauseBtE.getElementsByTagName("img")[0].src = paused?"/manager/pic/bticonpause.png":"/manager/pic/loaderg.gif";
		pauseBtE.getElementsByTagName("span")[0].innerHTML = paused?"resume":"pause";

		logE.className = (paused)?"paused":"";

		if (!reset) {
			if (paused)
				req.stop();
			else
				this.startLog(logTargetE,logLines,true);
		}
	} // togglePause()

	// toggle filter mode
	this.toggleFilter = function () {
		filterMode = !filterMode;
		filterModeBtE.getElementsByTagName("img")[0].src = "/manager/pic/bticonsearch"+(filterMode?"":"o")+".png";
		filterModeBtE.getElementsByTagName("span")[0].innerHTML = filterMode?"search:":"exclude:";
		filter = ""; // force update
		this.updateFilter();
	} // toggleFilter()

	// toggle level
	this.toggleLevel = function (l) {
		switch(l) {
		case "verbose":
			this.load("set",l,!verboseMode);
			break;
		case "events":
			this.load("set",l,!eventsMode);
			break;
		case "user":
			this.load("set",l,!userMode);
			break;
		}
	} // toggleLevel()

	init();
} // LogViewer Class



//--------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
// Client Application ------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------

// Client Application class
function ClientApplication() {
	var started = false; // if already started, will just switch
	this.open = false; // currently open. set by start, hide

	this.e = document.getElementById("clientApplication");

	var toolbarE = document.getElementById("ca_toolbar");
	var titlesE;

	var clientContainerE = document.getElementById("client_container");
	var clientFrameE;
	var clientFrameSrc = ""; // so we set it only when it changes

	var self = this;

	// init
	function init() {
		titlesE = [];
		var n,d;
		for (var i=0; i<toolbarE.childNodes.length; i++) {
			d = toolbarE.childNodes[i];
			n = d.getAttribute?d.getAttribute("name"):null;
			switch (n) {
			case "title_se": titlesE["se"] = d; break;
			case "title_ad": titlesE["ad"] = d; break;
			case "title_we": titlesE["we"] = d; break;
			case "title_ku": titlesE["ku"] = d; break;
			case "title_bu": titlesE["bu"] = d; break;
			case "title_hu": titlesE["hu"] = d; break;
			case "title_mu": titlesE["mu"] = d; break;
			}
		}
	} // init()

	// start
	this.start = function (id) {
		manager.hideOtherApps(id);

		this.e.style.display = "inline";

		// mode
		toolbarE.style.display = "inline";

		if (!started) {
			started = true;
		}

		titlesE["se"].style.display = (id == "se")?"":"none";
		titlesE["ad"].style.display = (id == "ad")?"":"none";
		titlesE["we"].style.display = (id == "we")?"":"none";
		titlesE["ku"].style.display = (id == "ku")?"":"none";
		titlesE["bu"].style.display = (id == "bu")?"":"none";
		titlesE["hu"].style.display = (id == "hu")?"":"none";
		titlesE["mu"].style.display = (id == "mu")?"":"none";

		var src = getFrameSrc(id);
		if (clientFrameSrc == src) {
			// resume the client
			try {
				clientFrameE.contentWindow.client.resume();
			} catch (err) {
				clientFrameSrc = ""; // need to reload it
			}
		}
		if (clientFrameSrc != src) {
			clientFrameSrc = src;
			clientContainerE.innerHTML = '<iframe id="myframe" src="'+src+'" onload="window.frameOnLoad(this)"></iframe>';
			clientFrameE = clientContainerE.childNodes[0];
		}

		// this doesn't work. it's embarassing. remove it.
		window.frameOnLoad = function (e) {
			var ancestor = document.getElementById("client_container").childNodes[0],
				descendents = ancestor.getElementsByTagName('*');
		    // gets all descendent of ancestor

			var i, e, d;
			for (i = 0; i < descendents.length; ++i) {
			    e = descendents[i];
			    if (e.scrollTop || e.scrollTop === 0) {
			    	e.scrollTop = e.scrollHeight;
			    }
			}
		}

		this.adjustLayout(); // adjust only after creating the iframe
		this.open = true;

		timestampChecker.start(); // no additional files to check here
	} // start()

	function getFrameSrc(id) {
		var url = document.location.href.replace("http://","").replace("https://","");
		var key = "";
		if (url.indexOf("manager/pin")!=-1) {
			var l = url.split(".");
			key = l.pop();
		} else {
			var l = url.split("/");
			key = l[1];
		}
		switch (id) {
		case "se": return "/"+key+"/manager_settings?nobg&noconnectionlostpopup";
		case "ad": return "/"+key+"/admin?nobg&noconnectionlostpopup";
		case "we": return "/"+key+"/wiring?nobg&noconnectionlostpopup&kiosk=strict";
		case "ku": return "/"+key+"/knxutil?nobg&noconnectionlostpopup";
		case "bu": return "/"+key+"/bacnetutil?nobg&noconnectionlostpopup";
		case "hu": return "/"+key+"/heosutil?nobg&noconnectionlostpopup";
		case "mu": return "/"+key+"/modbusutil?nobg&noconnectionlostpopup";
		}
	}

	// hide (switching to another app)
	this.hide = function () {
		this.e.style.display = "none";

		// stop the client
		try {
			clientFrameE.contentWindow.client.stop();
		} catch (err) {
			// not yet loaded? force reload next time
			clientFrameSrc = "";
			clientContainerE.innerHTML = "";
		}

		manager.focus();

		this.open = false;
	} // hide()

	// focus, restore key events
	this.focus = function () {
		if (window.focus) window.focus();
		manager.deselect();
	} // focus()

	// adjust project editor layout. viewport size
	this.adjustLayout = function () {
		if (!manager.viewportWidth || !manager.viewportHeight) return;

		var	vw = manager.viewportWidth;
		var	vh = manager.viewportHeight;

		// tool bar size
		var tbW = 0; // left one
		var tbH = 36; // top one

		// editable area size
		var eW = vw - tbW;
		var eH = vh - tbH;

		toolbarE.style.left = (tbW-1)+"px"; // +1, attach it to the iconPanel
		toolbarE.style.width = (eW+1)+"px";

		// adjust client frame position, height, based on toolbar
		clientFrameE.style.top = tbH+"px";
		clientFrameE.style.height = (vh-tbH)+"px";
	} // adjustLayout()

	init();
} // Client Application Class

/*/
function delme(s) {
	var d = document.getElementById("delmeArea");
	d.innerHTML=s+"<br>"+d.innerHTML;
}
/**/



// Warning class
function Warning() {
	// types
	this.TYPE_NAME_NOT_VALID = 1; // currently not used
	this.TYPE_MISSING_HEADER = 2;
	this.TYPE_MISSING_ID = 3;
	this.TYPE_ID_SAME_AS_PROJECT = 4;
	this.TYPE_ID_NOT_VALID = 5;
	this.TYPE_MISSING_ATTRIBUTE = 6;
	this.TYPE_WRONG_ATTRIBUTE_VALUE = 7;
	this.TYPE_IMG_NOT_VALID = 8;
	this.TYPE_ATTRLIST_NOT_VALID = 9;

	this.type = 0;
	this.obj = null;
	this.attr = 0;
} // Warning Class

//--------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
// ProjectEditor -----------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------

// project editor class
function ProjectEditor() {
	var started = false; // if already started, will just switch
	this.open = false; // currently open. set by start, hide

	this.projects = null; // array of projects that can be loaded
	this.projectsTs = null; // array of project timestamps (folders)
	this.folderTs = 0; // www timestamp

	this.jarSkins = [];
	this.skins = []; // updated on www along with projects
	var skinCSSURL = ""; // current skin CSS URL
	var skinCSSUpdateTimeout;

	this.toLoad = ""; // project to load when projectEditor starts (when opening from fileManager)
	var toLoadNext = ""; // project to load if loading confirmed (when current project wasn't saved)

	this.stdLan = {};

	var attrPanelFieldsSrc = []; // stores the attribute panel fields html
	var attrPanelFields = []; // current attribute panel fields (div, inputs, selects)

	var activeObj;
	var draggedObj;
	var cycleObjs; // objects under the mousedown

	// multiple object selection
	var selMode; // null, key, bt
	var selObjs = []; // selected objects if in select mode
	var selObjsAdd = []; // objects about to be added to selObjs

	var activePage;
	var activeContainer = null; // current container, page or container

	// copied objects, page
	var copiedObjs = [];
	var copiedPage;

	var snapEnabled = true;
	var snapCoords = {x:[], y:[]};

	var selectedPanel = "";
	var sourcePopupOpen = false;

	// selected index for quick reference (up down on the list)
	var selectedPageI = 0;

	// next, previous object for quick reference (hotkeys)
	var prevSelObj = null;
	var nextSelObj = null;

	// warnings
	var warnings = null;
	var warningsLimit = 100;
	var attributeWarningTimeout = {timeout:null, obj:null, attr:null}; // check attribute warnings on timeout

	// undo
	var undoStates = [];
	var undoLimit = 100;

	// source or hsm
	var hscMode = false; // false source, true HSC

	// current project modified since last save or load?
	this.projectModified = false;

	// www list (two levels)
	var www;

	// drag
	var downX; // save down x,y to vary the behaviour
	var downY;
	var downDx = 0; // distance from clicked area to obj origin
	var downDy = 0;
	var downDr = 0; // distance from clicked cell to obj origin cell
	var downDc = 0;
	var lastX; // save last x/y since onTouchEnd doesn't have them
	var lastY;
	var moving = false;
	var movingPoint = false;
	var resizing = false;
	var selecting = false;
	var skipClickUpEvent = false; // if clicked on a button

	// popup link, object's attribute element linked to current popup
	var popupLink;

	// elements
	this.e = document.getElementById("projectEditor");

	var toolbarE = document.getElementById("pe_toolbar");

	var objsPanel = new ProjectEditorPanel("objs");
	var pagesPanel = new ProjectEditorPanel("pages");
	var projectPanel = new ProjectEditorPanel("project");

	var editorE = document.getElementById("pe_editorArea");
	var contentE = document.getElementById("pe_contentArea");
	var helpersE = document.getElementById("pe_helpersArea");
	var clickE = document.getElementById("pe_clickArea");

	var helpersContentE = document.getElementById("pe_helpersContent");
	var helpersBg = "";

	var selectedFrameE = document.getElementById("pe_selectedFrame");
	var selectedFramesE = document.getElementById("pe_selectedFrames"); // selection frames are contained here
	var selectedLabelE =  document.getElementById("pe_selectedLabel");
	var selectedRemoveBtE = document.getElementById("pe_selectedRemoveBt");
	var selectedResizeBtE =  document.getElementById("pe_selectedResizeBt");
	var selectedOpenBtE = document.getElementById("pe_selectedOpenBt");
	var selectedStartPointBtE = document.getElementById("pe_selectedStartPointBt");
	var selectedEndPointBtE = document.getElementById("pe_selectedEndPointBt");

	var selectRectE = document.getElementById("pe_selectRect"); // selection rect when selMode is on

	var xSnapE = document.getElementById("pe_xSnap");
	var ySnapE = document.getElementById("pe_ySnap");

	var containerFrameE = document.getElementById("pe_containerFrame");
	var containerFrameCloseBtE = document.getElementById("pe_containerFrameCloseBt");

	var bgE = document.getElementById("pe_bgArea");
	var bgPageE = document.getElementById("pe_bgAreaPage");
	var bgPopupE = document.getElementById("pe_bgAreaPopup");
	var bgWatchE = document.getElementById("pe_bgAreaWatch");

	this.pageContentE = document.getElementById("pe_pageContent");

	// list panels
	this.projectStyleListPanel = new ListPanel(document.getElementById("projectStyleListPanel"),"=","; ");
	this.uiSetListPanel =  new ListPanel(document.getElementById("uiSetListPanel"),"=","; ");
	this.cssListPanel =  new ListPanel(document.getElementById("cssListPanel"),":","; ");
	this.chartAttributesListPanel =  new ListPanel(document.getElementById("chartAttributesListPanel"),"=","; ");
	this.dataLoggerAttributesListPanel =  new ListPanel(document.getElementById("dataLoggerAttributesListPanel"),"=","; ");
	this.gesturesListPanel =  new ListPanel(document.getElementById("gesturesListPanel"),"=","; ");
	this.scopeListPanel =  new ListPanel(document.getElementById("scopeListPanel"),"",","); // no assigner, just list

	var foo = this;

	/*
	// debug, grid all objs in curr container
	this.alignObjs = function(w,h) {
		console.log("aligning "+activeContainer.objs.length+" objs")
		var c = Math.ceil(Math.sqrt(activeContainer.objs.length));

		for (var i=0; i<activeContainer.objs.length; i++) {
			var o = activeContainer.objs[i];
			var x = i%c;
			var y = Math.floor(i/c);
			o.x = Math.round(w/c*x);
			o.y = Math.round(h/c*y);
			o.updatePos(); // update position, checkPos, redraw or set coordinates
		}
	}
	*/

	// init
	function init() {
		var a = (JSONConfig && JSONConfig.hsycoconfig && JSONConfig.hsycoconfig.skins?JSONConfig.hsycoconfig.skins:[]);
		foo.jarSkins = [];
		for (var i=0; i<a.length; i++)
    		if (a[i] != "manager" && a[i] != "tech") // reserved skins
    			foo.jarSkins.push(a[i]);

		foo.loadAttrFields();

		var v = { // sorted by importance
				"body-background-color":{type:"cssColor",values:["red","#FF0000"]},
				"pages-background-color":{type:"cssColor",values:["transparent","green","#00FF00","rgba(255,255,0,0.5)"]},
				"pages-shadow":{values:["none","0 0 0 3px yellow","0 0 1px 1px rgba(0,0,0,0.5)"]},
				"header-background-color":{type:"cssColor",values:["transparent","blue","#0000FF","rgba(0,0,255,0.5)"]},
				"footer-background-color":{type:"cssColor",values:["transparent","blue","#0000FF","rgba(0,0,255,0.5)"]},
				"popup-background-color":{type:"cssColor",values:["transparent","purple","#FF00FF","rgba(255,0,255,0.5)"]},
				"popup-shadow":{values:["none","0 0 0 3px yellow"]},
				"scrollbar-width":{type:"cssSize"},
				"scrollbar-thumb-color":{type:"cssColor"}
		};
		foo.projectStyleListPanel.setValues(v);

		var v = { // sorted by importance
				"background":{},
				"border":{values:["1px solid red"]},
				"color":{type:"cssColor",values:["black","blue","gray","green","red","white","yellow"]},
				"font-family":{values:["Verdana, Arial, Helvetica, sans-serif","Georgia, Times New Roman, Times, serif","Courier New, Courier, monospace","Arial, Helvetica, sans-serif","Tahoma, Geneva, sans-serif","Trebuchet MS, Arial, Helvetica, sans-serif","Arial Black, Gadget, sans-serif","Times New Roman, Times, serif","Palatino Linotype, Book Antiqua, Palatino, serif","Lucida Sans Unicode, Lucida Grande, sans-serif","MS Serif, New York, serif","Lucida Console, Monaco, monospace"]},
				"font-size":{type:"cssSize"},
				"font-style":{values:["normal","italic","oblique"]},
				"font-weight":{values:["normal","bold","bolder"]},
				"text-align":{values:["left","right","center","justify"]},
				"text-overflow":{values:["","clip","ellipsis"]},
				"white-space":{values:["normal","nowrap"]},
				"width":{type:"cssSize"},
				"height":{type:"cssSize"},
				"left":{type:"cssPosition"},
				"top":{type:"cssPosition"},
				"overflow":{values:["hidden","scroll","auto"]}
		};
		foo.cssListPanel.setValues(v);

		v = { // sorted by importance
				"swipeup":{},
				"swipedown":{},
				"swipeleft":{},
				"swiperight":{values:["","off","user"]},
				"pinchin":{values:["","off","user"]},
				"pinchout":{values:["","off","user"]}
		};
		foo.gesturesListPanel.setValues(v);

		v = { // alphabetical order
				"axiscolor":{type:"cssColor"},
				"axislabels":{},
				"axisoffset":{},
				"barborder":{values:["true","false"]},
				"bgcolor":{type:"cssColor"},
				"drawaxis":{values:["true","false"]},
				"type":{values:["bars","gauge","points","line","spline"]},
				"labelcolor":{type:"cssColor"},
				"notches":{type:"integer"},
				"notchcolor":{type:"cssColor"},
				"offset[n]":{type:"float"},
				"orientation":{values:["vertical","horizontal"]},
				"origin":{type:"number"},
				"pointsize":{type:"integer"},
				"spacing":{type:"float"},
				"spacing[n]":{type:"float"},
				"stroke":{},
				"stroke[n]":{},
				"thresholds":{},
				"thresholdcolor":{type:"cssColor"},
				"thresholdcolors":{},
				"value":{},
				"value[n]":{},
				"values":{},
				"values[n]":{},
				"valuecolor":{type:"cssColor"},
				"valuecolor[n]":{type:"cssColor"},
				"valuecolors":{},
				"valuecolors[n]":{},
				"valuelabeltype":{values:["inside","outside","popup"]},
				"valuelabelcolor":{type:"cssColor"},
				"valuelabels":{},
				"valuelabels[n]":{},
				"valuerange":{values:["0,100"]},
		};
		foo.chartAttributesListPanel.setValues(v);

		v = { // sorted by importance
				"avgvalues":{values:["true","false"]},
				"axiscolor":{type:"cssColor"},
				"controls":{values:["tabs","toolbar","none"]},
				"drawaxis":{values:["true","false"]},
				"byminute":{values:["true","false"]},
				"byhour":{values:["true","false"]},
				"byday":{values:["true","false"]},
				"bymonth":{values:["true","false"]},
				"browserdate":{},
				"browserscale":{values:["year","month","day","hour"]},
				"download":{values:["true","false"]},
				"group":{},
				"hd":{values:["true","false","toggle"]},
				"labelcolor":{type:"cssColor"},
				"legend":{values:["true","false","min,avg,max"]},
				"list":{},
				"mode":{values:["live","browser"]},
				"maxvalues":{values:["true","false"]},
				"minvalues":{values:["true","false"]},
				"multichart":{values:["true","false"]},
				"multirange":{values:["true","false"]},
				"names":{},
				"notchcolor":{type:"cssColor"},
				"notches":{type:"integer"},
				"panel":{values:["true","false"]},
				"pastperiod":{values:["true","false"]},
				"pastvaluecolor":{}, // a || a,b,c
				"pielegendposition":{values:["top","right"]},
				"presentvaluecolor":{}, // a || a,b,c
				"rangegroups":{},
				"scale":{values:["year","month","day","hour"]},
				"valuecolor[n]":{type:"cssColor"},
				"slot":{},
				"thresholds":{},
				"thresholdcolor":{type:"cssColor"},
				"thresholdcolors":{},
				"totals":{values:["true","false"]},
				"type":{values:["bars","points","line","spline","pie"]},
				"valuelabelcolor":{type:"cssColor"},
				"valuelabeltype":{values:["inside","outside","popup"]}
		};
		foo.dataLoggerAttributesListPanel.setValues(v);

		if (browser.touchEventsSupported) {
			clickE.ontouchend = onTouchEnd;
			clickE.ontouchstart = onTouchStart;
			clickE.ontouchmove = onTouchMove;
		} else {
			clickE.onmousemove = onMouseMove;
			clickE.onmousedown = onMouseDown;
			clickE.onmouseup = onMouseUp;
		}

		selMode = "meh"; // force update
		foo.toggleSelMode(""); // off by default
	} // init()

	// start
	this.start = function () {
		manager.hideOtherApps("pe");

		// clear timeout
		if (attributeWarningTimeout.timeout) {
			this.clearAttributeWarningTimeout();
		}

		if (!started) {
			started = true;

			this.initProjectAddPanel();
			this.initProjectEditPanel();
			this.initProjectListPanel();
			this.refreshProjectAddPanel();
			this.refreshProjectEditPanel();

			this.onPanelSelect('m');
			this.selectTab("project","list");
			browser.enableButton(document.getElementById("pe_toolbarToolsBt"),false);
			browser.enableButton(document.getElementById("pe_toolbarSaveBt"),false);
			browser.enableButton(document.getElementById("pe_toolbarOpenBt"),false);
		} else if (project) {
			bgE.style.display = "inline";
			contentE.style.display = "inline";
			helpersE.style.display = "inline";
			timestampChecker.start(); // restart
		}

		this.e.style.display = "inline";
		this.adjustLayout();
		updateToolbarTitle();

		// load on start?
		if (this.toLoad) {
			this.loadProject(this.toLoad);
			this.toLoad = "";
		} else {
			// loading popup?
			if (manager.cPopup && manager.cPopup.id == "loading")
				manager.closePopup();
			timestampChecker.start(); // done loading
		}

		this.focus();
		this.open = true;
	} // start()

	// hide
	this.hide = function () {
		timestampChecker.stop(); // pause

		this.e.style.display = "none";

		bgE.style.display = "none";
		contentE.style.display = "none";
		helpersE.style.display = "none";

		manager.focus();

		// select mode? selMode: null, key, bt
		if (selMode == "key")
			foo.toggleSelMode("");

		this.open = false;
	} // hide()

	// focus, restore key events
	this.focus = function () {
		if (window.focus) window.focus();
		manager.deselect();
	} // focus()

	// clear (before loading or deleting a project, switching to another app)
	function clear() {
		activeObj = null;
		draggedObj = null;
		cycleObjs = [];
		activePage = null;
		activeContainer = null;
		selectedPageI = 0;
		prevSelObj = null;
		nextSelObj = null;
	} // clear()

	// getter
	this.getActiveObj = function () {
		return activeObj;
	} // getActiveObj()
	this.getActiveContainer = function () {
		return activeContainer;
	}; // getActiveContainer()

	// load a project
	this.loadProject = function (name) {
		if (sourcePopupOpen)
			this.showSourcePopup(false);
		// clear timeout
		this.clearAttributeWarningTimeout();
		manager.closeToolbarPopup();
		toLoadNext = name;
		if (this.projectModified) // project modified?
			manager.openPopup("confirmloadproject", true);
		else
			this.confirmProjectLoad();
	}; // loadProject()

	// confirm load project
	this.confirmProjectLoad = function () {
		manager.closePopups();
		manager.showLoadingPopup();
		files.load("reqproject", toLoadNext); // reqfile, we get the timestamp first
		toLoadNext = "";
	}; // confirmProjectLoad()

	// on project loaded
	this.onProjectLoaded = function () {
		// clear timeout
		this.clearAttributeWarningTimeout();

		// any watch data?
		this.parseWatchData();

		// add pages
		if (project.status=="new") {
			if (!project.orientationMode) {
				this.addPage("menu");
			} else {
				var p = this.addPage("menu");
				p.orientation = "landscape";
				p = this.addPage("menu");
				p.orientation = "portrait";
			}
			project.updateSize();
		}

		this.initProjectAddPanel();
		this.initProjectEditPanel();
		this.initProjectListPanel();
		this.refreshProjectAddPanel(); // skins
		this.refreshProjectEditPanel();

		this.initPagesAddPanel();
		this.initPagesEditPanel();
		this.initPagesListPanel();
		this.initObjsAddPanel();

		// reset project modified
		this.projectModified = false;

		selectPage(project.pages[0]);
		this.onPanelSelect(project.status=="new"?'o':'p');
		this.selectTab("objs",(project.pages[0].objs.length)?"list":"add");
		browser.enableButton(document.getElementById("pe_toolbarToolsBt"),true);
		browser.enableButton(document.getElementById("pe_toolbarSaveBt"),true);
		browser.enableButton(document.getElementById("pe_toolbarOpenBt"),true);
		document.getElementById("preloadDiv").innerHTML = "";

		if (project.background)
			bgPageE.style.backgroundImage = "url('/img/"+project.background+"')";
		bgPageE.style.backgroundPosition = "0px "+(project.kiosk?"0px":"20px");

		// reset undo states
		undoStates = [];
		browser.enableButton(document.getElementById("undoButton"),false);
		updateObjToolButtons();

		this.adjustLayout();
		this.checkWarnings();

		updateSkinCSS();

		// loading popup?
		if (manager.cPopup && manager.cPopup.id == "loading")
			manager.closePopup();

		timestampChecker.start();

		// save it
		if (project.status=="new") {
			this.saveProject(true);
		}
		project.status = "ready";

		if (window.focus) window.focus();
	}; // onProjectLoaded()

	function updateSkinCSS() {
		// clear timeout
		clearTimeout(skinCSSUpdateTimeout);
		skinCSSUpdateTimeout = null;
		// url
		var url = "/x/getstylecss?skin="+project.skin;
		if (project.style) {
			var a = foo.projectStyleListPanel.stringToArray(project.style);
			for (var i=0; i<a.length; i++) {
				url += "&"+encodeURIComponent("style:"+a[i][0]).replace(/\./g,"%2E");
				url += "="+encodeURIComponent(a[i][1]).replace(/\./g,"%2E");
			}
			//url += "&"+project.style.replace(/;/g,"&");
		}
		if (url != skinCSSURL) {
			skinCSSURL = url;
			document.getElementById("projectcss").href = url;
		}
	} // updateSkinCSS()

	// on list (www)
	this.onList = function (data) {
		www = data; // store

    	this.projects = []; // reset
    	this.projectsTs = [];

    	this.skins = this.jarSkins.clone();

    	this.folderTs = www[4]; // www timestamp

    	var n;
    	for (var i=0; i<www[2].length; i++) {
    		n = www[2][i][0];
    		if (n == "manager" || n == "tech") continue;
    		for (var k=0; k<www[2][i][2].length; k++) {
    			if (www[2][i][2][k][0] == "index.hsm") { // it's a project, save name and ts
    				this.projects.push(n);
    				this.projectsTs.push(www[2][i][4]);
    				break;
    			} else if (www[2][i][2][k][0] == "main.hsc") { // it's a skin, save name
    				this.skins.push(n);
    			}
    		}
    	}

    	this.skins = this.skins.unique().sort();

    	// first time?
		if (!this.open) {
			this.start();
		} else {
			this.initProjectListPanel();
			this.refreshProjectAddPanel(); // skins
			this.refreshProjectEditPanel();
		}
	} // onList()

	// on topo update
	this.onTopoUpdate = function () {
		if (project) {
			// if something is selected, refresh the edit page
			if (activeObj)
				this.refreshObjsEditPanel();
			// reset all
			project.reset();
		}
	} // onTopoUpdate()

	// on config update
	this.onConfigUpdate = function () {
		// if something is selected, refresh the edit page
		if (project) {
			if (activeObj)
				this.refreshObjsEditPanel();
			this.initObjsAddPanel();
		}
	} // onConfigUpdate()

	// on custom language update
	this.onCustomLanguageUpdate = function (txt) {
		project.customLan = {};
		// parse langauge
		if (txt) {
			var lines = txt.split("\n");
			for (var i=0; i<lines.length; i++) {
				var a = lines[i].split("=");
				if (a.length == 2)
					project.customLan[a[0].trim()] = a[1].trim();
			}
		}
		// reset all
		project.redraw();
	}; // this.onCustomLanguageUpdate()

	//generate index.hsm
	this.generateIndex = function (hsm) {
		var txt = "";

		this.genWatchData();

		// meta
		if (!hsm) {
			txt += "(#skin "+project.skin+")\n";
			txt += "(#language "+project.language+")\n";
			txt += "(#size "+project.width+"x"+project.height;
			if (project.orientationMode)
				txt += "; "+project.width2+"x"+project.height2;
			txt += ")\n";
			if (project.scale)
				txt += "(#scale "+project.scale+")\n";

			if (project.kiosk) {
				txt += "(#kiosk "+project.kiosk+")\n";
			}

			if (!project.deviceImage) {
				txt += "(#deviceimage disable)\n";
			}

			if (project.locked) {
				txt += "(#locked true)\n";
			}

			if (project.cameraList)
				txt += "(#cameralist "+project.cameraList+")\n";
			if (project.cameraGridList)
				txt += "(#cameragridlist "+project.cameraGridList+")\n";
			if (project.cameraOverlay)
				txt += "(#cameraoverlay "+project.cameraOverlay+")\n";

			if (project.scope)
				txt += "(#scope "+project.scope+")\n";

			if (project.style)
				txt += "(#style "+project.style+")\n";

			if (project.uiset)
				txt += "(#uiset "+project.uiset.replace(/"/g, '\\"')+")\n"; // escape "

			txt += "\n";
			txt += "(header "+project.header+")\n";

			if (project.background) {
				txt += "(background!"+project.name+".background "+project.background+")\n";
			}
		}

		for (i=0; i<project.pages.length; i++) {
			if (project.pages[i].obj.watch)
				continue; // skip watch page: it goes in uiset
			txt += "\n";// add empty row
			txt += project.pages[i].getHSMSrc(hsm);
		}
		return txt;
	}; // generateIndex

	// new project
	this.newProject = function () {
		if (window.focus) window.focus();

		// get values and check them
		var name = projectPanel.addFields[0].input['v'].value;

		var skin = projectPanel.addFields[1].select['s'].value;
		var lan = projectPanel.addFields[2].select['s'].value;
		var header = projectPanel.addFields[3].input['v'].value;

		// header same as name
		if (!header) header = name;

		var orm = projectPanel.addFields[4].input['orientationenabled'].checked; // orientation mode?

		if (!orm) {
			var w = projectPanel.addFields[4].input['w'].value;
			var h = projectPanel.addFields[4].input['h'].value;
		} else {
			var wl = projectPanel.addFields[4].input['wl'].value;
			var hl = projectPanel.addFields[4].input['hl'].value;
			var wp = projectPanel.addFields[4].input['wp'].value;
			var hp = projectPanel.addFields[4].input['hp'].value;
		}

		// generate cam list, cam grid
		var camList = "";
		var camOverlay = "";
		var camGridList = "";
		var c = document.getElementById("cameraValues");
		if (JSONConfig && JSONConfig.hsycoconfig) {
			var e,el,ei;
			// ids
			var ai = JSONConfig.hsycoconfig.cameraids;
			for (var i=0; i<ai.length; i++) if (ai[i]!=-1) {
				if (camList) camList += ',';
				camList += '"'+ai[i]+'"';
			}
			ai = JSONConfig.hsycoconfig.cameragrids;
			for (var i=0; i<ai.length; i++) {
				if (camGridList) camGridList += ',';
				camGridList += '"grid '+(i+1)+'"';
			}
		}

		// various checks
		// TODO: check name, if it exists..
		var ok = true;
		if (!name || name.indexOf("manager") == 0 || name.search(/^([0-9a-zA-Z\_-]+)$/) != 0) {
			var wf = projectPanel.addFields[0].div["t"];
			this.showAttrTitleIcon(wf,"bticonwarning.png");
			ok = false;
		}
		if ((!orm && (!w || !h || !parseInt(w) || !parseInt(h))) ||
			(orm && (!wl || !hl || !wp || !hp || !parseInt(wl) || !parseInt(hl) || !parseInt(wp) || !parseInt(hp)))) {
			var wf = projectPanel.addFields[4].div["t"];
			this.showAttrTitleIcon(wf,"bticonwarning.png");
			ok = false;
		}
		if (!ok) return; // missing params

		// ok, create it
		this.clearAttributeWarningTimeout();
		manager.closeToolbarPopup();
		manager.showLoadingPopup();

		project = new Project();

		project.status = "new"; // new one, so we know onProjectLoaded
		project.name = name;
		project.timestamp = 0; // same ts as a file that doesn't exist

		project.skin = skin;
		project.language = lan;
		project.header = header;

		project.orientationMode = orm;

		if (!orm) {
			project.width = parseInt(w);
			project.height = parseInt(h);
		} else {
			project.width = parseInt(wl);
			project.height = parseInt(hl);
			project.width2 = parseInt(wp);
			project.height2 = parseInt(hp);
		}

		project.cameraList = camList;
		project.cameraOverlay = camOverlay;
		project.cameraGridList = camGridList;

		// load dictionary and skin or start
		if (!dictionary || project.skin != dictionary.skin) {
			files.load("dictionary", project.skin);
			updateSkinCSS();
		} else {
			this.onProjectLoaded();
		}
	}; // newProject()

	// parse watch data, from uiset to page
	this.parseWatchData = function () {
		var uiset = project.uiset;
		if (!uiset) return;
		var arr = ListPanel.prototype.stringToArray(uiset,"=",";");
		var t, watchData;
		for (t=0; t<arr.length; t++) {
			if (arr[t][0] == "app_watch") {
				watchData = arr[t][1];
				arr.splice(t,1);
			}
		}
		if (watchData == null) return;

		var json;
		try {
			json = JSON.parse("["+watchData+"]");
		} catch (err) {
			manager.showNotice("error parsing watch data");
			return;
		}

		// remove from project uiset
		project.uiset = ListPanel.prototype.arrayToString(arr,"=",";");

		for (t=0; t<project.pages.length; t++) {
			if (project.pages[t].obj.watch) {
				if (activePage == project.pages[t])
					selectPage(null);
				project.delPage(project.pages[t]);
			}
		}
		var p = this.addPage("_watch_page");
		var obj;
		var a,v,n;
		for (var i=0; i<json.length; i++) {
			obj = dictionary.getObjInstance("_watch_"+json[i].type);
			if (obj) {
				// backward compatibility. action contained a url
				if (json[i].action && ["url","device","user"].indexOf(json[i].action) == -1) {
					json[i].url = json[i].action;
					json[i].action = "url";
				}
				// address and no action? action = "url"
				else if (json[i].address && !json[i].action) {
					json[i].action = "device";
				}
				// assign id
				if (json[i].id) {
					obj.id = json[i].id;
				}
				// assign attrValues
				for (t=0; t<obj.obj.attributes.length; t++) {
					a = obj.obj.attributes[t];
					n = a.name.toLowerCase();
					v = json[i][n];
					if (v !== null) {
						obj.attrValues[t] = v;
					}
				}
				p.addObj(obj);
				obj.redraw();
			}
		}
		this.updateWatchObjs();
	};

	// generate watch data, from page to uiset
	this.genWatchData = function () {
		// get watch data
		var watchData,json,page,obj,i,t;
		for (i=0; i<project.pages.length; i++) {
			page = project.pages[i];
			if (page.obj.watch) {
				watchData = "";
				for (var o=0; o<page.objs.length; o++) {
					obj = page.objs[o];
					watchData += watchData ? ",":"";
					json = {type:obj.obj.id.substr(7)}; // remove _watch_
					if (obj.id) {
						json.id = obj.id;
					}
					for (var a=0; a<obj.attrValues.length; a++) {
						if (obj.attrValues[a]) {
							json[obj.obj.attributes[a].name.toLowerCase()] = obj.attrValues[a];
						}
					}
					watchData += JSON.stringify(json);
				}
				if (watchData) {
					var uiset = project.uiset;
					var arr = [];
					if (uiset) {
						arr = ListPanel.prototype.stringToArray(uiset,"=",";");
						for (t=0; t<arr.length; t++) {
							// remove
							if (arr[t][0] == "app_watch") {
								arr.splice(t,1);
								break;
							}
						}
					}
					// readd
					arr.push(["app_watch",watchData]);
					project.uiset = ListPanel.prototype.arrayToString(arr,"=",";");
				}
			}
		}
	};

	// update watch page objects (coordinates)
	this.updateWatchObjs = function () {
		// get watch data
		var page,obj,i,t;
		var y = 0;
		for (i=0; i<project.pages.length; i++) {
			page = project.pages[i];
			if (page.obj.watch) {
				for (var o=0; o<page.objs.length; o++) {
					obj = page.objs[o];
					obj.setPosition(0,y);
					obj.updatePos();
					obj.width = obj.obj.width;
					obj.height = obj.obj.height;
					y += obj.height + 4;
				}
				page.height = y + 4;
				this.adjustLayout();
			}
		}
	};

	// save project. confirm (skip warning check)
	this.saveProject = function (confirm) {
		if (!project) return;
		if (window.focus) window.focus();
		loseFocus();
		this.checkWarnings();
		if (!confirm && warnings.length) {
			manager.openPopup("saveerror", true);
		} else {
			if (confirm) manager.closePopup(); // confirm: save anyway popup was open
			manager.showNotice("saving project..",0);
			timestampChecker.stop();
			files.saveProject(project.name,this.generateIndex());
		}
	};

	// on project saved
	this.onProjectSaved = function (r,n) {
		// duplicating?
		var dup = project.name != n;
		if (r != "error") {
			manager.showNotice("project <b>"+n+"</b> saved");
			if (!dup) // if duplicating, it's different
				project.timestamp = r*1; // timestamp refreshed
			// add to projects
			for (var i=0; i<this.projects.length; i++) {
				if (this.projects[i] == n) {
					i = -1;
					break;
				}
			}
			if (i!=-1) {
				// insert in order
				for (i=0; i<this.projects.length; i++) {
					if (this.projects[i]>n) {
						this.projects.splice(i,0,n);
						this.projectsTs.splice(i,0,0); // ts
						break;
					}
				}
				this.initProjectListPanel();
			}
		} else {
			manager.showNotice("error saving project <b>"+n+"</b>");
			if (dup) // duplicating? abort
				manager.closePopups();
		}
		// duplicating, clone whole directory
		if (dup) {
			files.duplicateProject(n,project.name);
		} else {
			var c = true; // create it?
			// img already exists?
	    	for (var i=0; i<www[2].length; i++) {
	    		if (www[2][i][0] == project.name) {
	    			for (var t=0; t<www[2][i][2].length; t++) { // subfolders
	    				if (www[2][i][2][t][0] == "img") {
	    					c = false;
	    					break;
	    				}
	    			}
	    			break;
	    		}
	    	}
    		// create the img folder also
	    	if (c)
	    		files.load("newfolder","www/"+project.name+"/img");
			// restart check
			timestampChecker.start();
		}
		// project modified?
		this.projectModified = false;
		updateToolbarTitle();
	} // onProjectSaved()

	// delete project. confirm (skip popup)
	this.delProject = function (confirm) {
		if (!project) return;
		window.focus();
		if (!confirm) {
			manager.openPopup("deleteproject", true);
		} else {
			manager.closePopup(); // confirm: save anyway popup was open
			this.clearAttributeWarningTimeout();
			var name = project.name;
			project = null;
			clear();
			timestampChecker.stop();
			manager.closeToolbarPopup();
			manager.showLoadingPopup();
			files.del("www/"+name);
		}
	} // delProject()

	// on project deleted
	this.onProjectDeleted = function (r,n) {
		// project modified?
		this.projectModified = false;
		if (r != "error") {
	    	manager.showNotice("project <b>"+n.substr(4)+"</b> deleted");
			// remove from projects
			var name = n.substr(4);
			for (var i=0; i<this.projects.length; i++) {
				if (this.projects[i] == name) {
					this.projects.splice(i,1);
					this.projectsTs.splice(i,1);
					break;
				}
			}
			// project is not null if the file was deleted from outside the PE. called from timestampchecker
			if (project) {
				this.projectModified = true;
			} else {
				started = false; // force restart.. no project anymore
				foo.start();
			}
		} else {
			manager.showNotice("error deleting project <b>"+n+"</b>");
		}
		updateToolbarTitle();
	}; // onProjectDeleted()

	// update toolbar title
	var _toolbarTitle; // cache
	function updateToolbarTitle() {
		var t = document.getElementById("pe_toolbarHeader");
		var txt = "";
		var fun = "";
		if (project) {
			fun = 'data-onclick="projectEditor.onToolbarSelect(\'project\')"';
			if (foo.projectModified) txt += "*";
			txt += " <span class='mTextButton "+((activePage || activeObj)?"checked":"selected")+"' "+fun+">"+project.name+"</span>";
		}
		if (activePage) {
			txt += " <img src='/manager/pic/arrow-r.png'> ";
			fun = 'data-onclick="projectEditor.onToolbarSelect(\'page\')"';
			var n = activePage.obj.id;
			if (n.substr(0,7) == "_watch_") n = "watch "+n.substr(7);
			if (n == "menu" || n == "overlay" || n == "watch page") {
				txt += " <span class='mTextButton "+((activeObj || activeContainer!=activePage)?"checked":"selected")+"' "+fun+">"+n+"</span>";
			} else {
				txt += " <span class='mTextButton "+((activeObj || activeContainer!=foo.activePage)?"checked":"selected")+"' "+fun+">"+activePage.attrValues[0]+"</span>";
			}
			if (activeObj || activeContainer != activePage) {
				var a = [];
				var c = activeObj || activeContainer;
				do {
					a.push(c);
					c = (c.parentObj && !c.parentObj.isPage)?c.parentObj:null;
				} while (c);
				var k = 0; // object index. if 0, obj. otherwise number of containers to close
				for (var i=a.length-1; i>=0; i--) {
					txt += " <img src='/manager/pic/arrow-r.png'> ";
					if (i==0 && selObjs.length>1) {
						txt += " <span class='mTextButton selected'>selection ["+selObjs.length+"]</span>";
					} else {
						k = (!activeObj)?i+1:i;
						fun = 'data-onclick="projectEditor.onToolbarSelect('+k+')"';
						n = a[i].obj.id;
						if (n.substr(0,7) == "_watch_") n = "watch "+n.substr(7);
						txt += " <span class='mTextButton "+((i==0)?"selected":"checked")+"' "+fun+">"+n+"</span>";
					}
				}
			}
		}
		if (_toolbarTitle != txt) {
			t.innerHTML = txt;
			_toolbarTitle = txt;
			browser.initEvents(t);
			manager.adjustToolbar();
		}
	} // updateToolbarTitle()

	// used to get common coordinates and detect overlaps
	function getFrameBtPos(e) {
		var x = e.offsetLeft + e.parentNode.offsetLeft;
		var y = e.offsetTop + e.parentNode.offsetTop;
		return {x:x, y:y};
	} // getFrameBtPos()

	// used to check if buttons overlap
	function btOverlap(a,b,s) {
		return (a.x < b.x+s && a.x+s > b.x &&
				a.y < b.y+s && a.y+s > b.y);
	} // btOverlap()

	// update selected frame
	this.updateSelectedFrame = function () {
		selectedFrameE.style.display = "none"; // always hide it, we update it while hidden to speed it up
		// reset close container display
		containerFrameCloseBtE.style.display = "";
		// html
		var sel = selecting?getUnionSelObjs():selObjs;
		if (selectedFramesE.childNodes.length != sel.length) {
			var h = "";
			for (var i=0; i<sel.length; i++)
				h += '<div class="selectedFrame"><div class="frameBg"></div><div class="frameBorder"></div><div class="frameBorderOver"></div></div>';
			selectedFramesE.innerHTML = h;
		}
		// multiple objects
		if (selObjs.length > 1 || selMode) { // no buttons when more objects are selected or in selMode
			var x,y,w,h;
			selectedFrameE.style.left = "0px";
			selectedFrameE.style.top = "0px";

			var b = 0; // 4
			var rb = 1;

			var o;
			for (var i=0; i<sel.length; i++) {
				o = sel[i];
				x = o.x;
				y = o.y;
				w = o.width;
				h = o.height;
				if (o.obj.deltaWidth)
					w += o.obj.deltaWidth;
				if (o.obj.deltaHeight)
					h += o.obj.deltaHeight;
				// single frames
				selectedFramesE.childNodes[i].style.left = (x - b)+"px";
				selectedFramesE.childNodes[i].style.top = (y - b)+"px";
				selectedFramesE.childNodes[i].style.width = (w+b-rb*2)+"px";
				selectedFramesE.childNodes[i].style.height = (h+b-rb*2)+"px";
			}

			// position label
			selectedLabelE.style.display = "none";

			// buttons
			selectedRemoveBtE.style.display = "none";
			selectedResizeBtE.style.display = "none";
			selectedOpenBtE.style.display = "none";
			selectedStartPointBtE.style.display = "none";
			selectedEndPointBtE.style.display = "none";

			// grid. TODO: not here?
			var b = 'url("/manager/pic/grid0.png")';
			if (helpersBg != b) {
				helpersBg = b;
				helpersContentE.style.backgroundImage = b;
			}
			selectedFrameE.style.display = "inline";
		}
		// single object
		else if (activeObj) {
			var w = activeObj.width?activeObj.width:activePage.width;
			var h = activeObj.height?activeObj.height:activePage.height;

			if (activeObj.obj.deltaWidth)
				w += activeObj.obj.deltaWidth;
			if (activeObj.obj.deltaHeight)
				h += activeObj.obj.deltaHeight;

			var b = 0; // 4
			var rb = 1;

			if (activeObj.x!=null) {
				selectedFrameE.style.left = (activeObj.x - b)+"px";
				selectedFrameE.style.top = (activeObj.y - b)+"px";
			} else {
				selectedFrameE.style.left = "0px";
				selectedFrameE.style.top = "0px";
			}
			selectedFrameE.style.width = (w+b-rb*2)+"px";
			selectedFrameE.style.height = (h+b-rb*2)+"px";
			selectedFramesE.childNodes[0].style.left = "0px";
			selectedFramesE.childNodes[0].style.top = "0px";
			selectedFramesE.childNodes[0].style.width = "100%";
			selectedFramesE.childNodes[0].style.height = "100%";

			// position label
			selectedLabelE.style.display = "none"; // hide it first, optimization
			if (!activeObj.isInclude && activeObj.x!=null &&
				activeObj.obj.id != "line" && !activeObj.obj.watch) { // show
				var txt = (activeObj.posMode == "xy")?
					"x&nbsp;"+activeObj.x+"<br>y&nbsp;"+activeObj.y:
					"r&nbsp;"+activeObj.r+"<br>c&nbsp;"+activeObj.c;
				selectedLabelE.innerHTML = txt;
				selectedLabelE.style.right = (w+b-rb*2)+"px";
				selectedLabelE.style.display = "inline";
			}


			// grid. TODO: not here?
			var b = (activeObj.posMode == "rc")?'url("/manager/pic/grid'+activeObj.obj.grid+'.png")':'url("/manager/pic/grid0.png")';
			if (helpersBg != b) {
				helpersBg = b;
				helpersContentE.style.backgroundImage = b;
			}

			// show now, we need it to get coords
			selectedFrameE.style.display = "inline";

			// show buttons? show all to get coords, then hide them
			selectedRemoveBtE.style.display = "";
			selectedResizeBtE.style.display = "";
			selectedOpenBtE.style.display = "";
			selectedStartPointBtE.style.display = "";
			selectedEndPointBtE.style.display = "";
			var dv = (!activeObj.isInclude);
			var rv = (activeObj.obj.minWidth != null);
			var ov = (activeObj.obj.id == "container");
			var sv = (activeObj.startPoint);
			var ev = (activeObj.endPoint);
			// check if any button overlaps container close bt
			if (!activeContainer.isPage) {
				var bs = 30; // button size
				// grab positions relative to same div
				var ccp = getFrameBtPos(containerFrameCloseBtE);
				// position label
				var lov = btOverlap(ccp, getFrameBtPos(selectedLabelE), bs);
				// delete
				var dov = btOverlap(ccp, getFrameBtPos(selectedRemoveBtE), bs);
				// resize
				var rov = (rv)?btOverlap(ccp, getFrameBtPos(selectedResizeBtE), bs):false;
				// open
				var oov = (ov)?btOverlap(ccp, getFrameBtPos(selectedOpenBtE), bs):false;
				// close visible?
				containerFrameCloseBtE.style.display = (lov || dov || rov || oov)?"none":"";
			}
			// buttons visible
			selectedRemoveBtE.style.display = dv?"":"none";
			selectedResizeBtE.style.display = rv?"":"none";
			selectedOpenBtE.style.display = ov?"":"none";
			selectedStartPointBtE.style.display = sv?"":"none";
			selectedEndPointBtE.style.display = ev?"":"none";

			if (sv) {
				selectedStartPointBtE.style.left = (sv[0]-10)+"px";
				selectedStartPointBtE.style.top = (sv[1]-10)+"px";
			}
			if (ev) {
				selectedEndPointBtE.style.left = (ev[0]-10)+"px";
				selectedEndPointBtE.style.top = (ev[1]-10)+"px";
			}
		} else {
			xSnapE.style.display = "none";
			ySnapE.style.display = "none";

			// grid
			if (helpersBg != "") {
				helpersBg = "";
				helpersContentE.style.backgroundImage = "";
			}
		}

	} // updateSelectedFrame()

	// load copied objects
	function loadCopiedObjs() {
		if (localStorage && localStorage.copiedObjs && dictionary) {
			copiedObjs = [];
			var a = JSON.parse(localStorage.copiedObjs);
			for (var i=0; i<a.length; i++) {
				var o = dictionary.getObjInstance(a[i].type);
				o.fromJSON(a[i],true); // redraw all
				copiedObjs.push(o);
			}
		}
	}
	function saveCopiedObjs() {
		if (localStorage) {
			var a = [];
			for (var i=0; i<copiedObjs.length; i++) {
				var s = copiedObjs[i].toJSON(true); // true:also children
				a[i] = s;
			}
			localStorage.copiedObjs = JSON.stringify(a);
		}
	}

	// copy selected objects
	this.copySelObjs = function () {
		if (!selObjs.length) return;
		copiedObjs = [];
		for (var i=0; i<selObjs.length; i++)
			copiedObjs.push(selObjs[i].cloneObj());
		saveCopiedObjs();
		//browser.enableButton(document.getElementById("pasteButton"),(copiedObjs));
		// notice
		if (selObjs.length == 1) {
			var n = activeObj.obj.id;
			if (n.substr(0,7) == "_watch_") n = "watch "+n.substr(7);
			manager.showNotice("<b>"+n+"</b> copied");
		} else {
			manager.showNotice("<b>"+selObjs.length+"</b> objects copied");
		}
	} // copySelObjs()

	// cut selected objects
	this.cutSelObjs = function () {
		if (!selObjs.length) return;
		copiedObjs = [];
		var u = []; // array for undo state
		for (var i=0; i<selObjs.length; i++) {
			copiedObjs.push(selObjs[i].cloneObj());
			u.push(selObjs[i]);
		}
		addUndoState("obj_del", u); // before deleting, add undo
		// copied from delSelObjs
		for (var i=0; i<selObjs.length; i++) {
			if (selObjs[i].isInclude) continue; // include can't be cut
			selObjs[i].parentObj.removeObj(selObjs[i]);
			selObjs[i].div.parentNode.removeChild(selObjs[i].div);
		}
		saveCopiedObjs();
		selectNone();
		this.updateWatchObjs();
		//browser.enableButton(document.getElementById("pasteButton"),(copiedObjs));
		// notice
		if (copiedObjs.length == 1) {
			var n = copiedObjs[0].obj.id;
			if (n.substr(0,7) == "_watch_") n = "watch "+n.substr(7);
			manager.showNotice("<b>"+n+"</b> cut");
		} else {
			manager.showNotice("<b>"+copiedObjs.length+"</b> objects cut");
		}
	} // cutSelObjs()

	// past copied objects
	this.pasteObjs = function () {
		loadCopiedObjs(); // make sure
		if (!copiedObjs.length) return;
		// copied from onObjsAddSelect()
		if (copiedObjs.length > 1) { // select mode, so selectObj will select multiple
			selectNone();
			this.toggleSelMode("key");
		}
		var u = []; // array for undo state
		var fits = true;
		for (var i=0; i<copiedObjs.length; i++) {
			var oi = copiedObjs[i];
			copiedObjs[i] = oi.cloneObj(); // in case we want to paste it again

			if (activeContainer.isPage)
				this.pageContentE.appendChild(oi.div);
			else
				activeContainer.div.childNodes[2].appendChild(oi.div);

			if (oi.obj.id == "background") {
				activeContainer.addObj(oi,0);
				activeContainer.redraw();
			} else {
				activeContainer.addObj(oi);
				oi.fixPos();
				oi.redraw();
			}

			selectObj(oi);
			this.checkObjectWarnings(oi);
			u.push(oi);

			// fits?
			if (oi.checkPos())
				fits = false;
		}
		this.updateWatchObjs();
		// check positions
		addUndoState("obj_new", u);
		if (copiedObjs.length > 1) {
			this.toggleSelMode("");
		}

		this.updateWatchObjs(); // do it again
		this.initObjsListPanel();

		//browser.enableButton(document.getElementById("pasteButton"),(copiedObjs));
		// notice
		if (selObjs.length == 1) {
			var n = activeObj.obj.id;
			if (n.substr(0,7) == "_watch_") n = "watch "+n.substr(7);
			manager.showNotice("<b>"+n+"</b> pasted");
		} else {
			manager.showNotice("<b>"+selObjs.length+"</b> objects pasted");
		}
	} // pasteObjs()

	// delete selected objects
	this.delSelObjs = function () {
		if (!selObjs.length) return;
		if (selObjs.length == 1) {
			var n = activeObj.obj.id;
			if (n.substr(0,7) == "_watch_") n = "watch "+n.substr(7);
			manager.showNotice("<b>"+n+"</b> deleted");
		} else {
			manager.showNotice("<b>"+selObjs.length+"</b> objects deleted");
		}
		var u = []; // array for undo state
		for (var i=0; i<selObjs.length; i++) {
			u.push(selObjs[i]);
		}
		addUndoState("obj_del", u); // before deleting, add undo
		for (var i=0; i<selObjs.length; i++) {
			if (selObjs[i].isInclude) continue; // include can't be cut
			selObjs[i].parentObj.removeObj(selObjs[i]); // remove from container
			selObjs[i].div.parentNode.removeChild(selObjs[i].div); // remove from parent node
		}

		selectNone();
		this.updateWatchObjs();
		this.initObjsListPanel();
		this.checkWarnings();
	} // delSelObjs()

	// clone selected objects
	this.cloneSelObjs = function () {
		if (!selObjs.length) return;
		var objs = selObjs;
		selectNone();
		var c = objs[0].parentObj; // always a single container?
		if (objs.length > 1) { // select mode, so selectObj will select multiple
			this.toggleSelMode("key");
		}
		var u = []; // array for undo state
		for (var t=0; t<objs.length; t++) {
			var oi = objs[t].cloneObj(c);

			// slightly move it?
			if (oi.posMode == "rc") {
				oi.r++;
			} else {
				oi.x += 5;
				oi.y += 5;
			}
			oi.checkPos();
			oi.redraw();

			for (var i=0; i<c.objs.length; i++) {
				if (c.objs[i] == objs[t])
					break;
				else if (i == c.objs.length-1)
					return; // not found
			}
			c.objs.splice(i+1,0,oi);

			selectObj(oi); // add to selection
			u.push(oi);
		}
		c.redraw();
		if (objs.length > 1) {
			this.toggleSelMode("");
		}

		this.updateWatchObjs();
		this.updateSelectedFrame();
		this.initObjsListPanel();
		this.checkWarnings();
		addUndoState("obj_new", u);

		if (objs.length == 1) {
			var n = activeObj.obj.id;
			if (n.substr(0,7) == "_watch_") n = "watch "+n.substr(7);
			manager.showNotice("<b>"+n+"</b> duplicated");
		} else {
			manager.showNotice("<b>"+selObjs.length+"</b> objects duplicated");
		}
	} // cloneSelObjs()

	// select no object
	function selectNone() {
		loseFocus();
		activeObj =
		draggedObj =
		prevSelObj = null;
		cycleObjs = [];
		selObjs = [];
		foo.refreshObjsListPanel();
		foo.initObjsEditPanel();
		foo.updateSelectedFrame();
		if (snapEnabled)
			updateSnapPositions();
		objsPanel.title.innerHTML = "Objects";
		updateToolbarTitle();
		updateObjToolButtons();
	} // selectNone()

	// select obj. just refresh selection? called by mouseup when selecting multiple
	function selectObj(obj,refresh) {
		loseFocus();
		if (!selMode || !selObjs.length || refresh) {
			activeObj = obj;
			if (!refresh) // change selObjs?
				selObjs = [activeObj];
		} else {
			// already in? remove
			for (var i=0; i<selObjs.length; i++) {
				if (selObjs[i] == obj) {
					selObjs.splice(i,1);
					if (!selObjs.length) {
						selectNone();
						return;
					}
					if (activeObj == obj) // was the activeObj?
						activeObj = selObjs[0];
					obj = null; // so we don't add it
					break;
				}
			}
			// add (if it wasn't removed)
			if (obj)
				selObjs.push(obj);
		}
		var id = activeObj.obj.id;
		if (activeObj.obj.watch)
			id = "watch "+id.substr(7);
		objsPanel.title.innerHTML = "Objects: "+(selObjs.length==1?id:selObjs.length+" selected");
		foo.refreshObjsListPanel();
		foo.initObjsEditPanel();
		foo.updateSelectedFrame();
		if (snapEnabled)
			updateSnapPositions();
		updateToolbarTitle();
		if (selectedPanel != 'o') {
			foo.onPanelSelect('o');
			foo.selectTab("objs","edit");
		}
		updateObjToolButtons();
	} // selectObj()

	// toggle selection mode. mode:null (toggle "bt"/null), "key", "" (null)
	this.toggleSelMode = function (mode) {
		var v = selMode;
		if (mode)
			selMode = mode;
		else if (mode === "")
			selMode = null;
		else
			selMode = selMode?null:"bt"; // toggle
		// changed?
		if (v != selMode) {
			selectRectE.style.display = "none";
			// frame
			foo.updateSelectedFrame();
			// button
			document.getElementById("selectButtonPe").getElementsByTagName("img")[0].style.display = selMode?"inline":"none";
			document.getElementById("selectButtonPe").getElementsByTagName("img")[1].style.display = selMode?"none":"inline";
		}
	} // toggleSelMode()

	// get union selection (selObjs U selObjsAdd)
	function getUnionSelObjs() {
		var arr = selObjs.clone();
		for (var i=0; i<selObjsAdd.length; i++) {
			if (arr.indexOf(selObjsAdd[i]) == -1)
				arr.push(selObjsAdd[i]);
		}
		return arr;
	} // getUnionSelObjs()

	// update tool buttons related to objects
	function updateObjToolButtons() {
		browser.enableButton(document.getElementById("moveUpButton"),selObjs.length);
		browser.enableButton(document.getElementById("moveDownButton"),selObjs.length);
		browser.enableButton(document.getElementById("hideButton"),selObjs.length);
	}

	// move selected objects on z. d:1 forward, -1: backward
	this.moveZ = function (d) {
		if (!selObjs.length) return;
		if (selObjs[0].obj.watch) {
			if (d == 1) d = -1;
			else if (d == -1) d = 1;
		}
		var c = selObjs[0].parentObj; // take the first container (move only inside one container)
		if (selObjs.length == 1) {
			if (c.moveObj(selObjs[0],d)) {
				c.redraw();
				addUndoState("obj_move", selObjs[0], d);
			}
		} else {
			var i;
			var f = d==1?c.objs.length-1:0;
			var t = d==1?-1:c.objs.length;
			var o;
			for (i=f; i!=t; i-=d) {
				if ((selObjs.indexOf(c.objs[i]) != -1) && // selected?
					((d == 1 && i+1 < c.objs.length)||(d == -1 && i > 0)) && // inside array's limits?
					(selObjs.indexOf(c.objs[i+d]) == -1)) { // moving to an empty position?
					o = c.objs[i];
					if (c.moveObj(o,d))
						addUndoState("obj_move", o, d); // add single move
				}
			}
			c.redraw();
		}
		if (selObjs[0].obj.watch) {
			this.updateWatchObjs();
			this.updateSelectedFrame();
		}
		this.refreshObjsListPanel();
		this.focusObjsListPanel();
		this.selectTab("objs", "list");
	} // moveZ()

	// move selected objects, direction 1 up, 2 right, 3 down, 4 left. pixel amount
	function moveSelObjs(d,a) {
		if (!selObjs.length) return;
		if (!a) a = 1;
		var uo = []; // objects, for undo state
		var us = []; // snapshots, for undo state
		// if moving when multi selected, switch all to xy
		if (selObjs.length>1) {
			for (var i=0; i<selObjs.length; i++) {
				if (selObjs[i].posMode == "rc") {
					selObjs[i].posMode = "xy";
					selObjs[i].updateXY(); // no params: uses r,c
				}
			}
		}
		for (i=0; i<selObjs.length; i++) {
			if (selObjs[i].isInclude) continue; // include can't be moved
			uo.push(selObjs[i]);
			us.push(selObjs[i].toJSON());
			if (selObjs[i].posMode == "xy") {
				switch(d) {
				case 1: selObjs[i].y-=a; break;
				case 2: selObjs[i].x+=a; break;
				case 3: selObjs[i].y+=a; break;
				case 4: selObjs[i].x-=a; break;
				}
			} else {
				switch(d) {
				case 1: selObjs[i].r-=a; break;
				case 2: selObjs[i].c+=a; break;
				case 3: selObjs[i].r+=a; break;
				case 4: selObjs[i].c-=a; break;
				}
				selObjs[i].updateXY();
			}
			selObjs[i].fixPos();
			selObjs[i].updatePos();
		}
		if (uo.length) {
			addUndoState("attr_update",uo,us);
			foo.updateSelectedFrame();
			foo.refreshObjsEditPanel("pos");
		}
	} // moveActiveObj()

	// open container. container default do activeObj (called with null from open container button)
	this.openContainer = function (container) {
		if (!container) container = activeObj;
		activeContainer = container;

		// update container absolute position
		container.ax = container.parentObj.ax + container.x;
		container.ay = container.parentObj.ay + container.y;

		container.showBorder("open");

		containerFrameE.style.display = "inline";
		containerFrameE.style.width = (container.width-2)+"px";
		containerFrameE.style.height = (container.height-2)+"px";
		containerFrameCloseBtE.style.top = (container.height)+"px"; // visibility on updateSelectedFrame

		// hide next objects (they're over the container)
		var h = false;
		for (var i=0; i<container.parentObj.objs.length; i++) {
			if (h)
				container.parentObj.objs[i].div.style.display = "none";
			else if (container.parentObj.objs[i] == container)
				h = true;
		}

		// container? show border
		for (i=0; i<container.objs.length; i++)
			if (container.objs[i].isContainer && !container.objs[i].isInclude)
				container.objs[i].showBorder("visible");

		// deselect
		selectNone();
		this.adjustLayout();

		this.initObjsListPanel();
	} // openContainer()

	// close container
	this.closeContainer = function () {
		var o = activeContainer;
		// fit size
		o.fitSize();

		for (var i=0; i<o.objs.length; i++) {
			// container? hide border
			if (o.objs[i].isContainer && !o.objs[i].isInclude)
				o.objs[i].showBorder("none")
		}
		// show next objects
		var s = false;
		for (var i=0; i<o.parentObj.objs.length; i++) {
			if (s && o.parentObj.objs[i].visible)
				o.parentObj.objs[i].div.style.display = "";
			else if (o.parentObj.objs[i] == o)
				s = true;
		}

		o.showBorder("visible");

		var p = o.parentObj;
		if (p.isPage) {
			activeContainer = p;
			containerFrameE.style.display = "none";
			this.adjustLayout();
		} else {
			this.openContainer(p);
		}

		this.initObjsListPanel();

		// select the object
		selectObj(o);
	} // closeContainer()

	// close all containers
	this.closeAllContainers = function () {
		while (activeContainer && !activeContainer.isPage)
			this.closeContainer();
	} // closeAllContainers()

	// navigate to container (or page)
	this.navigateToContainer = function (c) {
		if (c == activeContainer) return; // already there
		// close containers
		while (activeContainer && activeContainer!=c && !activeContainer.isPage)
			this.closeContainer();
		// open containers
		var a = []; // containers
		while (!c.isPage) {
			a.push(c); // push container
			c = c.parentObj;
		}
		// change page?
		if (c != activePage) selectPage(c);
		// open containers
		while (a.length)
			this.openContainer(a.pop());
	} // navigateToContainer()

	// fit size to content. used just for popups
	this.fitPopupSize = function () {
		if (!activePage || activePage.obj.id!="popup") return;

		var snapshot = activePage.toJSON();

		// get size based on content
		var s = activePage.getContentSize();
		if (s.w<activePage.obj.minWidth)
			s.w = activePage.obj.minWidth;
		if (s.h<activePage.obj.minHeight)
			s.h = activePage.obj.minHeight;

		// reset popup position, size
		activePage.width = s.w + 4;
		activePage.height = s.h + 20;
		activePage.redraw();
		selectNone();
		this.adjustLayout();
		this.refreshPagesEditPanel();

		// undo state. type, objs, previous snapshots
		addUndoState("attr_update",[activePage],[snapshot]);

		loseFocus();
	} // fitSize()

	// setOrientationEnabled
	this.setOrientationEnabled = function (e,event) {
		loseFocus();

		// event target
		var evt = window.event || event;

		// find parent
		var p = e;
		while (p.className.substr(0,4)!="attr") p = p.parentNode;

		// is it an add attribute?
		var addAttr = (p.className.indexOf("add")!=-1);

		// get attr
		var i = parseInt(p.getAttribute("name").substr(1));
		var obj = project;
		var a = (addAttr)?projectPanel.addFields[i]:projectPanel.editFields[i];

		a.div["od"].style.display = e.checked?"none":"inline";
		a.div["oe"].style.display = e.checked?"inline":"none";

		if (e.checked) {
			if (a.input["wl"].value == "") a.input["wl"].value = a.input["w"].value;
			if (a.input["hl"].value == "") a.input["hl"].value = a.input["h"].value;
		} else {
			if (a.input["w"].value == "") a.input["w"].value = a.input["wl"].value;
			if (a.input["h"].value == "") a.input["h"].value = a.input["hl"].value;
		}

		if (project.orientationMode != e.checked) // is this right???
			this.updateAttr(e,event);
		this.initPagesEditPanel();
		this.initPagesListPanel();
	} // setOrientationEnabled()

	// set activeObj size original
	this.setActiveObjSizeOriginal = function () {
		if (!activeObj) return;

		var snapshot = activeObj.toJSON();

		// camera objects
		if (activeObj.obj.id == "camera" ||
			activeObj.obj.id == "camerapanel" ||
			activeObj.obj.id == "cameraimage") {

			if (!activeObj.attrValues[0]) return; // no id

			for (var i=0; i<JSONConfig.hsycoconfig.cameraids.length; i++) {
				if (JSONConfig.hsycoconfig.camerasizes[i] && JSONConfig.hsycoconfig.cameraids[i] == activeObj.attrValues[0]) {
					var w = parseInt(JSONConfig.hsycoconfig.camerasizes[i][0]);
					var h = parseInt(JSONConfig.hsycoconfig.camerasizes[i][1]);
					if (w && h) {
						activeObj.width = w;
						activeObj.height = h;
						activeObj.updateSizeAttributes();
						activeObj.redraw();
						foo.updateSelectedFrame();
						foo.refreshObjsEditPanel("width");
						foo.refreshObjsEditPanel("height");
					}
					break; // done
				}
			}
		}
		// image objects
		else if (activeObj.obj.id == "image" ||
				 activeObj.obj.id == "imagelink" ||
				 activeObj.obj.id == "userimage" ||
				 activeObj.obj.id == "buttonimage" ||
				 activeObj.obj.id == "selector" ||
				 activeObj.obj.id == "submitimage") {

			var img = activeObj.div.getElementsByTagName("img");
			var src;
			if (img[0]) {
				src = activeObj.div.getElementsByTagName("img")[0].src
			} else {
				img = activeObj.div.getElementsByTagName("div");
				for (var i=0; i<img.length; i++) {
					if (img[i].style.backgroundImage) {
						src = img[i].style.backgroundImage.replace('url("','').replace('")','');
						break;
					}
				}
			}
			if (!src) return; // no src

			var img = new Image();
			img.src = src;
			// use onload event to set size
			img.onload = function () {
				if (img.width > 0 && img.height > 0) {
					activeObj.width = img.width;
					activeObj.height = img.height;

					activeObj.updateSizeAttributes();
					activeObj.redraw();
					foo.updateSelectedFrame();
					foo.refreshObjsEditPanel("width");
					foo.refreshObjsEditPanel("height");
					delete img;
				}
			}
		}

		// fix ratio
		if (activeObj.fixedRatio)
			activeObj.fixedRatio = activeObj.width/activeObj.height;


		// undo state. type, objs, previous snapshot
		addUndoState("attr_update",[activeObj],[snapshot]);

		loseFocus();
	} // setActiveObjSizeOriginal()

	// active obj size fixed
	this.setActiveObjSizeFixed = function (e,event) {
		loseFocus();
		if (!activeObj) return;

		var snapshot = activeObj.toJSON();

		delete activeObj.fixedRatio;
		if (!e.checked) return;

		var w,h;

		var ow = activeObj.width;
		var oh = activeObj.height;

		// camera objects
		if (activeObj.obj.id == "camera" ||
			activeObj.obj.id == "camerapanel" ||
			activeObj.obj.id == "cameraimage") {

			for (var i=0; i<JSONConfig.hsycoconfig.cameraids.length; i++) {
				if (JSONConfig.hsycoconfig.camerasizes[i] && JSONConfig.hsycoconfig.cameraids[i] == activeObj.attrValues[0]) {
					ow = JSONConfig.hsycoconfig.camerasizes[i][0];
					oh = JSONConfig.hsycoconfig.camerasizes[i][1];
					break;
				}
			}
		}
		// image objects
		else if (activeObj.obj.id == "image" ||
				 activeObj.obj.id == "imagelink" ||
				 activeObj.obj.id == "userimage") {

			var img = activeObj.div.getElementsByTagName("img");
			var src;
			if (img[0]) {
				src = activeObj.div.getElementsByTagName("img")[0].src
			} else {
				img = activeObj.div.getElementsByTagName("div");
				for (var i=0; i<img.length; i++) {
					if (img[i].style.backgroundImage) {
						src = img[i].style.backgroundImage.replace('url("','').replace('")','');
						break;
					}
				}
			}
			if (!src) return; // no src

			var img = new Image();
			img.src = src;

			if (img.src && img.width > 0 && img.height > 0) {
				ow = img.width;
				oh = img.height;
			}
		}

		if (ow && oh) {
			activeObj.fixedRatio = ow/oh;
			//activeObj.width = w;
			activeObj.height = parseInt(activeObj.width/activeObj.fixedRatio);
			activeObj.updateSizeAttributes();
			activeObj.redraw();
			this.updateSelectedFrame();
			this.refreshObjsEditPanel("width");
			this.refreshObjsEditPanel("height");
		} else {
			e.checked = false;
		}

		// undo state. type, objs, previous snapshots
		addUndoState("attr_update",[activeObj],[snapshot]);
	} // setActiveObjSizeFixed()

	// default project sizes
	this.setProjectSizeDefault = function (t) {
		loseFocus();

		// find parent
		var p = browser.getLastButton();
		while (p.className.substr(0,4)!="attr") p = p.parentNode;

		// is it an add attribute?
		var addAttr = (p.className.indexOf("add")!=-1);

		var i = parseInt(p.getAttribute("name").substr(1));
		var a = (addAttr)?projectPanel.addFields[i]:projectPanel.editFields[i];

		switch (t) {
		case "iPhone":
			a.input["w"].value = "320";
			a.input["h"].value = "416";
			a.input["wl"].value = "480";
			a.input["hl"].value = "268";
			a.input["wp"].value = "320";
			a.input["hp"].value = "416";
			break;
		case "iPad":
			a.input["w"].value = "980";
			a.input["h"].value = "640";
			a.input["wl"].value = "980";
			a.input["hl"].value = "640";
			a.input["wp"].value = "720";
			a.input["hp"].value = "890";
			break;
		case "default":
			a.input["w"].value = "890";
			a.input["h"].value = "640";
			a.input["wl"].value = "890";
			a.input["hl"].value = "640";
			a.input["wp"].value = "640";
			a.input["hp"].value = "890";
			break;
		}

		this.updateAttr(browser.getLastButton());
	} // setProjectSizeDefault()

	// show/hide active object
	this.showActiveObj = function (show) {
		if (!activeObj) return;
		if (show == null)
			show = !activeObj.visible;
		activeObj.visible = show;
		activeObj.div.style.display = (show)?"":"none";

		if (!show) // hiding?
			selectNone();

		// update the frame
		foo.updateSelectedFrame();
	} // showActiveObj()

	// show/hide sel objs
	this.showSelObjs = function (show) {
		if (!selObjs.length) return;
		if (show == null)
			show = !selObjs[0].visible;
		for (var i=0; i<selObjs.length; i++) {
			selObjs[i].visible = show;
			selObjs[i].div.style.display = (show)?"":"none";
		}
		if (!show) // hiding?
			selectNone();

		// update the frame
		foo.updateSelectedFrame();
	} // showActiveObj()

	// unhide all
	this.unhideAll = function (container) {
		if (container == null)
			container = activePage;
		for (var i=0; i<container.objs.length; i++) {
			container.objs[i].visible = true;
			container.objs[i].div.style.display = "";
			if (container.objs[i].isContainer && !container.objs[i].isInclude)
				this.unhideAll(container.objs[i]);
		}
	} // unhideAll()

	// update snap positions
	function updateSnapPositions() {
		snapCoords.x = [];
		snapCoords.y = [];

		if (!activeObj) return;

		// page
		snapCoords.x.push({x:0, o:activeContainer});
		snapCoords.x.push({x:activeContainer.width, o:activeContainer});
		snapCoords.y.push({y:0, o:activeContainer});
		snapCoords.y.push({y:activeContainer.height, o:activeContainer});

		// objs
		var v,k,x1,x2,y1,y2,t,o;
		for (var i=0; i<activeContainer.objs.length; i++) {
			o = activeContainer.objs[i];
			if (o.visible && o != activeObj && (selObjs.length == 1 || selObjs.indexOf(o) == -1)) {
				x1 = o.x;
				y1 = o.y;
				snapCoords.x.push({x: x1, o:o});
				snapCoords.y.push({y: y1, o:o});

				if (o.obj.id == "line") {
					if (o.startPoint) {
						x1 = o.x + o.startPoint[0];
						y1 = o.y + o.startPoint[1];
						snapCoords.x.push({x: x1, o:o, sp:true});
						snapCoords.y.push({y: y1, o:o, sp:true});
					}
					if (o.endPoint) {
						x1 = o.x + o.endPoint[0];
						y1 = o.y + o.endPoint[1];
						snapCoords.x.push({x: x1, o:o, ep:true});
						snapCoords.y.push({y: y1, o:o, ep:true});
					}

				} else {
					if (o.width) {
						var x2 = x1 +  o.width;
						if (o.obj.deltaWidth)
						x2 += o.obj.deltaWidth;
						snapCoords.x.push({x: x2, o:o});
					}
					if (o.height) {
						var y2 = y1 +  o.height;
						if (o.obj.deltaHeight)
						y2 += o.obj.deltaHeight;
						snapCoords.y.push({y: y2, o:o});
					}
				}
			}
		}
	} // updateSnapPositions()

	// enable/disable object snap
	this.setSnap = function (e) {
		snapEnabled = !snapEnabled;
		document.getElementById("snapButton").getElementsByTagName("img")[0].style.display = snapEnabled?"inline":"none";
		document.getElementById("snapButton").getElementsByTagName("img")[1].style.display = snapEnabled?"none":"inline";
		if (snapEnabled) {
			updateSnapPositions();
		} else {
			xSnapE.style.display = "none";
			ySnapE.style.display = "none";
		}
	} // setSnap()

	// get nearest snap
	this.getSnap = function (x,y,a) {
		var d = 0;
		var r = {};
		if (x != null)
		for (var i=0; i<snapCoords.x.length; i++) {
			d = Math.abs(x-snapCoords.x[i].x);
			if (d<a) {
				r.x = snapCoords.x[i].x;
				r.ox = snapCoords.x[i].o;
				break;
			}
		}
		if (y != null)
		for (var i=0; i<snapCoords.y.length; i++) {
			d = Math.abs(y-snapCoords.y[i].y);
			if (d<a) {
				r.y = snapCoords.y[i].y;
				r.oy = snapCoords.y[i].o;
				break;
			}
		}
		return r;
	} // getSnap()

	// show an icon on attribute title div, then fade it
	this.showAttrTitleIcon = function (div, icon) {
		var d = div.getElementsByTagName("img");
		if (!d || d.length==0) // not added yet
			div.innerHTML += "<img src='/manager/pic/"+icon+"'>";
		animations.fadeAnimation(div.childNodes[1], {fadeInTime:300, idleTime:2000, fadeOutTime:1000});
	} // showAttrTitleIcon()

	// redraw page (when duplicating menu)
	this.redrawPage = function (obj) {
		if (obj.isContainer)
			for (var i=0; i<obj.objs.length; i++)
				this.redrawPage(obj.objs[i]);
		obj.redraw();
	} // redrawPage

	// redraw all pages
	this.redrawPages = function () {
		for (var i=0; i<project.pages.length; i++)
			this.redrawPage(project.pages[i]);

		selectPage(activePage);
	} // redrawPages()

	// --------------------------------------------------------------------------------------------------------------------------
	// Warnings -----------------------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	// add warning
	this.addWarning = function (obj,attr,type,s) {
		if (warnings.length>=warningsLimit) return;

		var w = new Warning();
		w.obj = obj;
		w.attr = attr;
		w.type = w["TYPE_"+type]; // TODO: at the moment I'm using [] to access a "constant"

		// check if already there before adding
		for (var i=0; i<warnings.length; i++) {
			if (warnings[i].obj == obj &&
				warnings[i].attr == attr) { // just one warning per attribute
				if (warnings[i].type == type) // it's already there, return
					return;
				// different
				warnings.splice(i,1);
				break;
			}
		}
		warnings.push(w);
		if (!s)
			this.showWarnings(); // update panel
		// add object warning
		if (!obj.warnings) obj.warnings = {};
		obj.warnings[attr] = w; // just one warning per attribute

		return w;
	} // add warning

	// del warning
	this.delWarning = function (obj,attr,s) {
		// warnings
		var f = false; // found
		for (var i=0; i<warnings.length; i++) {
			if (warnings[i].obj == obj &&
				warnings[i].attr == attr) { // just one warning per attribute
				warnings.splice(i,1);
				f = true;
				break;
			}
		}
		if (!f) return; // nothing to delete
		if (!s)
			this.showWarnings(); // update panel
		// object warning
		if (!obj.warnings) return;
		var c = 0;
		for (var a in obj.warnings) {
			if (obj.warnings[a] && obj.warnings[a].attr == attr)
				obj.warnings[a] = null;
			if (obj.warnings[a]) c++;
		}
		if (!c) obj.warnings = null; // delete warnings array?
	} // del warning

	// check a single attribute and return a warning or none. obj, attr index, silent (don't update panel)
	this.checkAttributeWarning = function (obj,attr,s) {
		var w; // warning

		// check on timeout?
		if (attributeWarningTimeout.timeout &&
			attributeWarningTimeout.obj == obj &&
			attributeWarningTimeout.attr == attr) {
			this.clearAttributeWarningTimeout();
		}

		// project?
		if (obj == project) {
			switch (attr) {
			case "header":
				if (!project.header)
					w = this.addWarning(project,"header","MISSING_HEADER",s);
				break;
			case "style":
				if (project.style && project.style.indexOf('"')!=-1)
					w = this.addWarning(project,attr,"ATTRLIST_NOT_VALID",s);
				break;
			}
		}
		// object
		else {
			var a = obj.obj.attributes[attr]; // attribute
			var v = obj.attrValues[attr]; // attr value

			if (a) { // !a: no attribute (orientation, locations on page: no warnings on these fields anyway)
				// missing value?
				if (v == null || v == "" || v == undefined) {
					if (warnings.length<warningsLimit && !a.optional && !a.empty && (!a.values || a.values.indexOf("")==-1))
						w = this.addWarning(obj,attr,"MISSING_ATTRIBUTE",s);
				} else {
					// check type
					if (a.type == "img" && v.search(/^[$;\/0-9a-z\._-]*$/)!=0) {
						w = this.addWarning(obj,attr,"IMG_NOT_VALID",s);
					} else if (a.type == "pageid") {
						if (v == project.name) {
							w = this.addWarning(obj,attr,"ID_SAME_AS_PROJECT",s);
						} else if (v.search(/^((\$[0-9a-zA-Z\._-]+!?)|([0-9a-zA-Z\._-]+))$/)!=0) {
							w = this.addWarning(obj,attr,"ID_NOT_VALID",s);
						}
					} else if (a.type == "chartattributes") {
						if (v.indexOf('"')!=-1)
							w = this.addWarning(obj,attr,"ATTRLIST_NOT_VALID",s);
					}
				}
			} else if (attr == "id") {
				if (obj.id == "" && obj.obj.iId == "required") {
					w = this.addWarning(obj,attr,"MISSING_ID",s);
				} else if (obj.id) {
					if (obj.id == project.name) {
						w = this.addWarning(obj,"id","ID_SAME_AS_PROJECT",s);
					} else if (obj.id.search(/^(\$?([0-9a-zA-Z\._-]+)!?)$/)!=0) { // can start with $, can end with !
						w = this.addWarning(obj,"id","ID_NOT_VALID",s);
					}
				}
			}
		}

		// remove?
		if (!w)
			this.delWarning(obj,attr,s);

		return w;
	} // checkObjectWarnings()

	// check attribute on timeout (when modifying an attribute)
	this.checkAttributeWarningOnTimeout = function (obj,attr) {
		// there's already a timeout
		if (attributeWarningTimeout.timeout) {
			this.clearAttributeWarningTimeout();
			if (attributeWarningTimeout.obj != obj || attributeWarningTimeout.attr != attr)
				this.onCheckAttributeWarning(); // do it now
		}
		attributeWarningTimeout.timeout = setTimeout(this.onCheckAttributeWarning, 2000);
		attributeWarningTimeout.obj = obj;
		attributeWarningTimeout.attr = attr;

		document.getElementById("pe_warningsLoading").style.display = "inline";
	} // checkAttributeWarningOnTimeout()

	// fired by timeout
	this.onCheckAttributeWarning = function () {
		projectEditor.checkAttributeWarning(attributeWarningTimeout.obj,
										   attributeWarningTimeout.attr);

		document.getElementById("pe_warningsLoading").style.display = "none";
	} // onCheckAttributeWarning()

	this.clearAttributeWarningTimeout = function () {
		if (attributeWarningTimeout.timeout) {
			clearTimeout(attributeWarningTimeout.timeout);
			attributeWarningTimeout.timeout = null;
		}
	}

	// check a single object and returns warnings. obj, recursive, silent
	this.checkObjectWarnings = function (obj,r,s) {
		var i; // for
		var a; // attribute
		var v; // attr value
		var w; // warning

		// check id
		if (!obj.isPage && obj.obj.iId) {
			this.checkAttributeWarning(obj,"id",s);
		}

		for (i=0; i<obj.obj.attributes.length; i++) {
			this.checkAttributeWarning(obj,i,s);
			if (warnings.length>=warningsLimit) break;
		}

		// contained objects?
		if (r && obj.isContainer) {
			for (i=0; i<obj.objs.length; i++) {
				this.checkObjectWarnings(obj.objs[i],r,s);
				if (warnings.length>=warningsLimit) break;
			}
		}
	} // checkObjectWarnings()

	// check all warnings, update warning panel
	this.checkWarnings = function () {
		warnings = [];
		var w;

		// project
		this.checkAttributeWarning(project,"header",true);
		this.checkAttributeWarning(project,"style",true);
		this.checkAttributeWarning(project,"uiset",true);

		// pages
		for (var i=0; i<project.pages.length; i++) {
			this.checkObjectWarnings(project.pages[i],true,true);
			if (warnings.length>=warningsLimit) break;
		}

		this.showWarnings();
	} // checkWarnings()

	/* TODO: sort warnings
	// warnings sort function
	warningsSort = function (a,b) {
		if (a.obj == project) return true;
		if (b.obj == project) return false;

		if (a.obj.isContainer && !b.obj.isContainer) return true;
		if (b.obj.isContainer && !a.obj.isContainer) return false;

		// both objects
	} // warningsSort()
	*/

	this.openProjectLink = function () {
		var url = document.location.href;
		url = url.replace(/manager(\/.*)?/,project.name);
		window.open(url,"_blank");
	}

	// show warnings
	this.showWarnings = function () {
		var wE = document.getElementById("pe_warnings");
		var bE = document.getElementById("pe_toolbarWarningsBt");
		var lE = document.getElementById("pe_warningsLoading");

		// update warnings, button
		if (warnings.length) {
			// sort warnings
			//warnings.sort(warningsSort);

			bE.style.display = "inline";
			bE.getElementsByTagName("span")[0].innerHTML = warnings.length;

			wE.innerHTML = "";
			var html = "";
			var w; // warning
			var wt = ""; // warning text
			var fun = ""; // functions
			for (var i=0; i<warnings.length && i<warningsLimit-1; i++) {
				w = warnings[i];
				switch (w.type) {
				case w.TYPE_NAME_NOT_VALID: wt = "Project's name can only contain letters, numbers and \"-\" or \"_\""; break;
				case w.TYPE_MISSING_HEADER: wt = "Project's <b>header</b> is missing"; break;
				case w.TYPE_MISSING_ID: wt = "Object's ID is missing on <b>"+w.obj.obj.id+"</b>"; break;
				case w.TYPE_ID_SAME_AS_PROJECT: wt = "ID can't be the same as the project's name"; break;
				case w.TYPE_ID_NOT_VALID: wt = "ID can only contain letters, numbers and \"-\", \"_\" or \".\""; break;
				case w.TYPE_MISSING_ATTRIBUTE: wt = "<b>"+w.obj.obj.attributes[w.attr].name+"</b> is missing on <b>"+w.obj.obj.id+"</b>"; break;
				case w.TYPE_WRONG_ATTRIBUTE_VALUE: wt = "Object's attribute value not valid"; break;
				case w.TYPE_IMG_NOT_VALID: wt = "Image filename must be in small caps and can only contain letters, numbers and \"-\", \"_\" or \".\""; break;
				case w.TYPE_ATTRLIST_NOT_VALID: wt = "Attribute value not valid, can't contain \""; break;
				}
				fun = 'data-onclick="projectEditor.onWarningSelect('+i+')"';
				html += "<div class='mLineButton' "+fun+">"+wt+"</div>";
			}
			wE.innerHTML = html;
			browser.initEvents(wE);
		} else {
			bE.style.display = "none";
			manager.showToolbarPopup("pe_warnings",false);

			// contents
			wE.innerHTML = "";
		}

		lE.style.display = "none";
	} // showWarnings()

	// on warning select
	this.onWarningSelect = function (i) {
		var w = warnings[i];
		var wf = null; // warning title field
		var i = null; // attribute field index

		// set i (0:id), don't break
		if (w.type == w.TYPE_MISSING_ID ||
			w.type == w.TYPE_ID_SAME_AS_PROJECT ||
			w.type == w.TYPE_ID_NOT_VALID)
			i = 0;

		// project, page, obj
		if (w.obj == project) {
			selectNone();
			this.onPanelSelect('m');
			this.selectTab("project","edit");
			// search i
			for (var f=0; f<projectPanel.editFields.length; f++) {
				if (projectPanel.editFields[f].link == w.attr) {
					i=f;
					break;
				}
			}
			focusElement(projectPanel.editFields[i].input["v"]);
			wf = projectPanel.editFields[i].div["t"];
		} else if (w.obj.isPage) { // page
			selectNone();
			this.navigateToContainer(w.obj);
			this.onPanelSelect('p');
			this.selectTab("pages","edit");
			if (i==null) i = w.attr+1; // first is page type
			for (var f in pagesPanel.editFields[i].input) { // get the first input field
				if (pagesPanel.editFields[i].input[f].focus)
					focusElement(pagesPanel.editFields[i].input[f]);
				break;
			}
			wf = pagesPanel.editFields[i].div["t"];
		} else { // obj
			selectNone();
			this.navigateToContainer(w.obj.parentObj);
			selectObj(w.obj);
			this.onPanelSelect('o');
			this.selectTab("objs","edit");
			if (i==null) i = (w.obj.obj.iId)?w.attr+1:w.attr; // i already set by ID_SAME_AS_PROJECT
			for (var f in attrPanelFields[i].input) { // get the first input field
				if (attrPanelFields[i].input[f].focus)
					focusElement(attrPanelFields[i].input[f]);
				break;
			}
			wf = attrPanelFields[i].div["t"];
		}

		// warning icon
		if (wf) {
			if (wf.scrollIntoView)
				wf.scrollIntoView();
			this.showAttrTitleIcon(wf,"bticonwarning.png");
		}
	} // onWarningSelect()

	// --------------------------------------------------------------------------------------------------------------------------
	// Undo ---------------------------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	// add undo state. type of state, obj(s), value (previous snapshots, move direction..)
	function addUndoState(type,o,v) {
		var p = undoStates.last();

		switch (type) {
		case "attr_update": // v is array of previous snapshots, o multi
			// previous state had same objects? just update
			var psame = (p && type == p.type && o.same(p.o));
			if  (psame)
				v = p.p; // old values are now the stored ones

			// compare values before adding
			var same = true; // attribute values on all objects are the same as previously saved?
			var snapshot,i,k;
			var n = []; // new snapshot array
			for (var t=0; t<o.length; t++) {
				snapshot = o[t].toJSON();
				n.push(snapshot);
				if (same) for (i in snapshot) { // check if something changed?
					if (i == "attrValues") {
						for (k=0; k<snapshot.attrValues.length; k++) {
							if (snapshot.attrValues[k]!=v[t].attrValues[k]) {
								same = false;
								break;
							}
						}
					} else if (snapshot[i]!=v[t][i]) same = false;
					if (!same) break;
				}
			}

			if (same) {
				// same values? nothing to save
				if (psame) undoStates.pop(); // new value is same as old one, remove undo state
			} else if (psame) {
				// update previous undo state instead of adding?
				p.n = n; // new values
			} else {
				// add. type, objects, previous snapshots, new snapshots
				undoStates.push({ type:type, o:o, p:v, n:n });
			}
			break;
		case "obj_new":  // v is null, o multi
		case "page_new": // v is null, o single
			// add. type, object
			undoStates.push({ type:type, o:o });
			break;
		case "obj_del": // v is null, o multi
			// get order
			var p = [];
			var k; // obj index
			var c = o[0].parentObj; // single container
			for (var i=0; i<o.length; i++) {
				k = c.objs.indexOf(o[i]);
				p.push(k); // save index
			}
			undoStates.push({ type:type, o:o, p:p, c:c });
			break;
		case "page_del": // v is null, o single
			// get order
			var p = 0;
			for (var i=0; i<project.pages.length; i++) {
				if (project.pages[i] == o) {
					p = i;
					break;
				}
			}
			undoStates.push({ type:type, o:o, p:p });
			break;
		case "obj_move": // v is direction, o single
			// changing z-order
			// previous is same object? update
			var psame = (p && o == p.o && type == p.type);
			if  (psame) {
				p.d += v;
				if (p.d == 0) undoStates.pop();
			} else {
				undoStates.push({ type:type, o:o, d:v });
			}
			break;
		}
		// too many?
		if (undoStates.length>undoLimit)
			undoStates.splice(0,1);
		// undo button enabled?
		browser.enableButton(document.getElementById("undoButton"),(undoStates.length>0));
		// project modified?
		foo.projectModified = true;
		updateToolbarTitle();
	} // addUndoState()

	// undo
	this.undo = function () {
		if (!undoStates.length) return;
		loseFocus();

		var u = undoStates.pop();
		switch (u.type) {
		case "attr_update": // multiple objs
			selectNone();
			if (u.o.length > 1) { // select mode, so selectObj will select multiple
				this.toggleSelMode("key");
			}

			var o,m;
			var fa = []; // fields array if single object, to show icons on restored fields
			for (var t=0; t<u.o.length;t++) {
				o = u.o[t];
				m = o.fromJSON(u.p[t]); // store modified attributes

				if (o == project) {
					this.closeAllContainers();
					project.updateSize();
					activePage.redraw();
					projectEditor.adjustLayout();
					this.initProjectEditPanel();
					this.onPanelSelect('m');
					this.selectTab("project","edit");
					// modified fields' title divs
					for (var i=0; i<m.length; i++)
						if (projectPanel.editFields[m[i]])
							fa.push(projectPanel.editFields[m[i]].div["t"]);
				} else if (o.isPage) {
					selectPage(o);
					this.onPanelSelect('p')
					this.selectTab("pages","edit");
					this.initPagesListPanel();
					// modified fields' title divs
					for (var i=0; i<m.length; i++)
						if (pagesPanel.editFields[m[i]])
							fa.push(pagesPanel.editFields[m[i]].div["t"]);
				} else {
					o.redraw();
					this.navigateToContainer(o.parentObj);
					selectObj(o);
					if (!activeObj.visible)
						this.showActiveObj(true);
					// modified fields' title divs
					if (u.o.length == 1)
						for (var i=0; i<m.length; i++)
							if (attrPanelFields[m[i]] && attrPanelFields[m[i]].title) // attrField has no title if repeated (height)
								fa.push(attrPanelFields[m[i]].div["t"]);
				}
			}
			if (u.o.length > 1) {
				this.toggleSelMode("");
			}

			// show icon
			for (var i=0; i<fa.length; i++) {
				this.showAttrTitleIcon(fa[i],"bticonundo.png");
			}
			break;
		case "obj_new": // multiple objs
			for (var i=0; i<u.o.length; i++) {
				this.navigateToContainer(u.o[i].parentObj);
				selectObj(u.o[i]);
				this.delSelObjs(); // delete it
			}
			break;
		case "obj_del": // multiple objs
			selectNone();
			if (u.o.length > 1) { // select mode, so selectObj will select multiple
				this.toggleSelMode("key");
			}
			this.navigateToContainer(u.c);
			// readd based on position
			var i,m,mI;
			var c = 0; // objects added
			while (c < u.o.length) {
				i = 0;
				m = 7777777777;
				mI = 0;
				for (i=0; i< u.p.length; i++) {
					if (u.p[i] < m) {
						mI = i;
						m = u.p[i];
					}
				}
				activeContainer.addObj(u.o[mI],u.p[mI]);
				selectObj(u.o[mI]);
				u.p[mI] = 7777777777; // out of the equation
				c++;
			}
			if (u.o.length > 1) {
				this.toggleSelMode("");
			}
			activeContainer.redraw();
			this.showSelObjs(true); // make sure they're visible
			this.updateWatchObjs();
			this.initObjsListPanel();
			this.checkWarnings();
			break;
		case "page_new": // single obj
			selectPage(u.o,true);	// true: check container
			this.delActivePage(); // delete it
			this.onPanelSelect('p')
			this.selectTab("pages","list");
			break;
		case "page_del": // single obj
			this.closeAllContainers();
			project.addPage(u.o, u.p);
			this.initPagesListPanel();
			selectPage(u.o);
			this.checkWarnings();
			break;
		case "obj_move": // single obj
			selectObj(u.o);
			if (!activeObj.visible)
				this.showActiveObj(true);
			var c = activeObj.parentObj;
			this.navigateToContainer(c);
			d = (u.d>0)?-1:1;
			while (u.d!=0) {
				u.d += d;
				c.moveObj(activeObj,d);
			}
			c.redraw();
			this.refreshObjsListPanel();
			break;
		}

		manager.showNotice("undo");

		// check warnings every time we undo
		this.checkWarnings();
		// undo button enabled?
		browser.enableButton(document.getElementById("undoButton"),(undoStates.length>0));
	} // undo()

	// --------------------------------------------------------------------------------------------------------------------------
	// Panel Functions ----------------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	// select a pane
	this.selectTab = function (panel,pane) {
		var panel;
		switch (panel) {
		case "project":	projectPanel.selectTab(pane); break;
		case "pages":	pagesPanel.selectTab(pane); break;
		case "objs":	objsPanel.selectTab(pane); break;
		}
	} // selectTab()

	// show source popup
	this.showSourcePopup = function (show) {
		var div = document.getElementById("pe_sourcePanel");
		// show
		if (show == null) {
			show = !sourcePopupOpen;
			manager.closeToolbarPopup();
		}
		sourcePopupOpen = show;
		div.style.display = (show)?"inline":"none";
		editorE.style.display = (!show)?"inline":"none";
		// refresh
		div = document.getElementById("pe_sourcePanelText");
		if (show && project)
			div.value = this.generateIndex(hscMode);
	} // showSourcePopup()

	// open camera values popup
	this.openCameraValuesPopup = function (id,e) {
		if (e)
			popupLink = e;

		// find parent
		var p = browser.getLastButton();
		while (p.className.substr(0,4)!="attr") p = p.parentNode;

		// is it an add attribute?
		var addAttr = (p.className.indexOf("add")!=-1);

		manager.openPopup("cameravalues",true);
		// use name to remember if add or edit
		manager.cPopup.contentE.setAttribute("name",id+" "+(addAttr?"add":"edit"));

		// popup title
		switch(id) {
		case "list":	manager.cPopup.contentE.getElementsByTagName("span")[0].innerHTML = "Camera List"; break;
		case "overlay":	manager.cPopup.contentE.getElementsByTagName("span")[0].innerHTML = "Camera Overlay"; break;
		case "grid":	manager.cPopup.contentE.getElementsByTagName("span")[0].innerHTML = "Camera Grid Headers"; break;
		case "ids":		manager.cPopup.contentE.getElementsByTagName("span")[0].innerHTML = "Camera List"; break;
		}

		var c = document.getElementById("cameraValues");
		if (!JSONConfig || !JSONConfig.hsycoconfig ||
			(id != "grid" && (!JSONConfig.hsycoconfig.cameraids || !JSONConfig.hsycoconfig.cameraids.length)) ||
			(id == "grid" && (!JSONConfig.hsycoconfig.cameragrids || !JSONConfig.hsycoconfig.cameragrids.length))) {
			var err = (id!="grid")?"No cameras found":"No camera grids found"
			c.innerHTML = "<div style='margin:5px'>"+err+"</div>";
		} else {
			var e,el,ei;
			// ids
			var ai = (id!="grid")?JSONConfig.hsycoconfig.cameraids:JSONConfig.hsycoconfig.cameragrids;
			var ac = p.getElementsByTagName("input")[0].value.split(",");
			c.innerHTML = ""; // clean
			for (var i=0; i<ai.length; i++) {
				e = document.createElement('div');
				if (id != "ids") {
					e.innerHTML = attrPanelFieldsSrc["cameravalue"]+"";
					e.className = "attr cameravalue";
					e.setAttribute('name','o'+i);
					e.style.clear = "both";
					el = e.childNodes[0].getElementsByTagName("div")[0];
					ei = e.childNodes[0].getElementsByTagName("input")[0];
					el.innerHTML = (id!="grid")?ai[i]:"grid "+(i+1);
					if (ac && ac[i])
						ei.value = ac[i].replace( /["]/g , "");
					el.style.color = (ei.value)?"black":"#aaa";
				} else {
					e.innerHTML = attrPanelFieldsSrc["cameravalueid"]+"";
					e.className = "attr cameravalueid";
					e.style.clear = "both";
					e.setAttribute('name','o'+i);
					ei = e.childNodes[0].getElementsByTagName("input")[0];
					el = e.childNodes[0].getElementsByTagName("label")[0];
					el.innerHTML = (id!="grid")?ai[i]:"grid "+(i+1);
					ai[i] = ai[i].replace( /["]/g , "");
					ei.value = ai[i];
					if (ac && (ac.length>1 || ac[0] != "")) {
						for (var k=0; k<ac.length; k++) {
							if (ac[k].replace( /["]/g , "") == ai[i]) {
								ei.checked = true;
								break;
							}
						}
					} else ei.checked = true; // if it's empty, all are checked
				}
				c.appendChild(e);
			}
			browser.initEvents(c); // labels
		}

		manager.adjustLayout();
	} // openCameraValuesPopup(any)()

	// confirm camera values popup
	this.confirmCameraValuesPopup = function (e) {
		// add?
		var p = manager.cPopup.contentE.getAttribute("name").split(" ");

		// get values
		var c = document.getElementById("cameraValues");
		var v = "";
		var k = "";
		var empty = true;
		var e;
		for (var i=0; i<c.childNodes.length; i++) {
			e = c.childNodes[i].getElementsByTagName("input");
			if (e && e.length) {
				if (p[0]!="ids") { // not camerapanel ids
					v += (v?',':'');
					k = e[0].value.replace(/"/g,"");
					v += '"'+k+'"';
				} else {
					if (e[0].checked) {
						v += (v?',':'');
						k = (e[0].checked)?e[0].value.replace(/"/g,""):"";
						v += k;
					}
				}
				if (k) empty = false;
			}
		}
		if (empty) v = "";

		if (p[0]=="ids") { // camerapanel ids
			var e = popupLink;
			e.parentNode.getElementsByTagName("input")[0].value = v;
			this.updateAttr(e);
		} else {
			// get snapshot before updating (for undo)
			var snapshot = project.toJSON();

			switch (p[0]) {
			case "list":	project.cameraList = v; break;
			case "overlay":	project.cameraOverlay = v; break;
			case "grid":	project.cameraGridList = v; break;
			}
			this.refreshProjectEditPanel();
			// undo state. type, objs, previous snapshots
			addUndoState("attr_update",[project],[snapshot]);
		}

		manager.closePopup();
	} // confirmCameraValuesPopup()

	// open choose file popup
	this.openChooseFilePopup = function (t,e) {
		if (e) popupLink = e;
		fileManager.openChooseFilePopup(onChooseFile,t);
	} // openChooseFilePopup()

	// confirm choose file popup
	function onChooseFile(v) {
		var e = popupLink;
		// set value
		e.parentNode.getElementsByTagName("input")[0].value = v;
		// updateAttr
		foo.updateAttr(e);
	} // onChooseFile()

	// open project style popup
	this.openProjectStylePopup = function (e) {
		popupLink = e;
		foo.projectStyleListPanel.fromString(e.parentNode.getElementsByTagName("input")[0].value);
		manager.openPopup("projectstyle", true);
	} // openProjectStylePopup()

	// confirm css popup
	this.confirmProjectStylePopup = function () {
		var e = popupLink;
		// set value. first input. remove root
		e.parentNode.getElementsByTagName("input")[0].value = foo.projectStyleListPanel.toString();
		// updateAttr
		this.updateAttr(e);
		manager.closePopup();
	} // confirmProjectStylePopup()

	// open chart attributes popup
	this.openUISetPopup = function (e) {
		popupLink = e;
		foo.uiSetListPanel.fromString(e.parentNode.getElementsByTagName("input")[0].value)
		manager.openPopup("uiset", true);
	} // openUISetPopup()

	// confirm chart attributes popup
	this.confirmUISetPopup = function () {
		var e = popupLink;
		// set value. first input. remove root
		e.parentNode.getElementsByTagName("input")[0].value = foo.uiSetListPanel.toString();
		// updateAttr
		this.updateAttr(e);
		this.parseWatchData();
		manager.closePopup();
	} // confirmUISetPopup()

	// open css popup
	this.openCSSPopup = function (e) {
		popupLink = e;
		foo.cssListPanel.fromString(e.parentNode.getElementsByTagName("input")[0].value);
		manager.openPopup("css", true);
	} // openCSSPopup()

	// confirm css popup
	this.confirmCSSPopup = function () {
		var e = popupLink;
		// set value. first input. remove root
		e.parentNode.getElementsByTagName("input")[0].value = foo.cssListPanel.toString();
		// updateAttr
		this.updateAttr(e);
		manager.closePopup();
	} // confirmCSSPopup()

	// open gestures popup
	this.openGesturesPopup = function (e) {
		popupLink = e;
		foo.gesturesListPanel.fromString(e.parentNode.getElementsByTagName("input")[0].value);
		manager.openPopup("gestures", true);
	} // openGesturesPopup()

	// confirm gestures popup
	this.confirmGesturesPopup = function () {
		var e = popupLink;
		// set value. first input. remove root
		e.parentNode.getElementsByTagName("input")[0].value = foo.gesturesListPanel.toString();
		// updateAttr
		this.updateAttr(e);
		manager.closePopup();
	} // confirmGesturesPopup()

	// open scope popup
	this.openScopePopup = function (e) {
		popupLink = e;
		foo.scopeListPanel.fromString(e.parentNode.getElementsByTagName("input")[0].value);
		manager.openPopup("scope", true);
	} // openScopePopup()

	// confirm scope popup
	this.confirmScopePopup = function () {
		var e = popupLink;
		// set value. first input. remove root
		e.parentNode.getElementsByTagName("input")[0].value = foo.scopeListPanel.toString();
		// updateAttr
		this.updateAttr(e);
		manager.closePopup();
	} // confirmScopePopup()

	// open chart attributes popup
	this.openChartAttributesPopup = function (e) {
		popupLink = e;
		foo.chartAttributesListPanel.fromString(e.parentNode.getElementsByTagName("input")[0].value)
		manager.openPopup("chartattributes", true);
	} // openChartAttributesPopup()

	// confirm chart attributes popup
	this.confirmChartAttributesPopup = function () {
		var e = popupLink;
		// set value. first input. remove root
		e.parentNode.getElementsByTagName("input")[0].value = foo.chartAttributesListPanel.toString();
		// updateAttr
		this.updateAttr(e);
		manager.closePopup();
	} // confirmChartAttributesPopup()

	// open datalogger attributes popup
	this.openDataLoggerAttributesPopup = function (e) {
		popupLink = e;
		foo.dataLoggerAttributesListPanel.fromString(e.parentNode.getElementsByTagName("input")[0].value)
		manager.openPopup("dataloggerattributes", true);
	} // openDataLoggerAttributesPopup()

	// confirm datalogger attributes popup
	this.confirmDataLoggerAttributesPopup = function () {
		var e = popupLink;
		// set value. first input. remove root
		e.parentNode.getElementsByTagName("input")[0].value = foo.dataLoggerAttributesListPanel.toString();
		// updateAttr
		this.updateAttr(e);
		manager.closePopup();
	} // confirmDataLoggerAttributesPopup()

	// --------------------------------------------------------------------------------------------------------------------------
	// Update Attribute ---------------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	// update object attribute, given the field
	this.updateAttr = function (e,event) {
		// event target
		var evt = window.event || event;
		if (evt) var code = evt.keyCode || evt.charCode || evt.which;

		// return key, confirm: lose focus
		if (evt && evt.type == "keyup" && code == 13) {
			try { evt.preventDefault(); } catch(e) {}
			loseFocus();
			return;
		}

		// find parent
		var p = e;
		while (p.className.substr(0,4)!="attr") p = p.parentNode;

		// is it an add attribute?
		var addAttr = (p.className.indexOf("add")!=-1);

		// get attr
		var t = p.getAttribute("name")[0];
		var i = parseInt(p.getAttribute("name").substr(1));

		// field name
		var fn = e.getAttribute("name");

		var obj;
		switch(t) {
		case 'o': obj = activeObj; break;
		case 'p': obj = activePage; break;
		case 'm': obj = project; break;
		}
		if (!obj && !addAttr) return;
		switch(t) {
		case 'o': var a = attrPanelFields[i]; break;
		case 'p': var a = pagesPanel.editFields[i]; break;
		case 'm': var a = (addAttr)?projectPanel.addFields[i]:projectPanel.editFields[i]; break;
		}
		var id = a.link;

		// get snapshot before updating (for undo)
		if (!addAttr)
			var snapshot = obj.toJSON();

		// action: show only correct fields
		this.updateWatchAttr(a);

		// update
		switch (a.type) {
		// project
		case "projectsize":
			if (addAttr) break;

			if (!a.input["orientationenabled"].checked) {
				project.orientationMode = false;

				var w = parseInt(a.input["w"].value);
				if (!w) w = 50;
				if (w<1) w = 1;
				var h = parseInt(a.input["h"].value);
				if (!h) h = 50;
				if (h<1) h = 1;

				project.updateSize(w,h);
			} else {
				project.orientationMode = true;

				var wl = parseInt(a.input["wl"].value);
				if (!wl) wl = 50;
				if (wl<1) wl = 1;
				var hl = parseInt(a.input["hl"].value);
				if (!hl) hl = 50;
				if (hl<1) hl = 1;
				var wp = parseInt(a.input["wp"].value);
				if (!wp) wp = 50;
				if (wp<1) wp = 1;
				var hp = parseInt(a.input["hp"].value);
				if (!hp) hp = 50;
				if (hp<1) hp = 1;

				project.updateSize(wl,hl,wp,hp);
			}
			projectEditor.adjustLayout();
			break;
		case "scale":
			if (addAttr) break;
			project.scale = a.input["v"].value;
			break;
		case "projectskin":
			if (addAttr) break;
			var t = a.select["s"].value;
			if (t == project.skin) return; // nothing changed
			project.skin = t;
			// update timeout
			clearTimeout(skinCSSUpdateTimeout);
			skinCSSUpdateTimeout = setTimeout(updateSkinCSS,1000);
			break;
		case "style":
			if (addAttr) break;
			project.style = a.input["v"].value;
			// update timeout
			clearTimeout(skinCSSUpdateTimeout);
			skinCSSUpdateTimeout = setTimeout(updateSkinCSS,1000);
			break;
		case "uiset":
			if (addAttr) break;
			project.uiset = a.input["v"].value;
			break;
		case "deviceimage":
			if (addAttr) break;
			project.deviceImage = (a.select["s"].value == "");
			break;
		case "projectlan":
			if (addAttr) break;
			var t = a.select["s"].value;
			if (t == project.language) return; // nothing changed
			project.language = t;
			timestampChecker.start(); // restart, language has changed.. check custom language file
			break;
		case "header":
			if (addAttr) break;
			project.header = a.input["v"].value;
			break;
		case "projectlocked":
			if (addAttr) break;
			project.locked = a.input["v"].checked;
			break;
		case "projectkiosk":
			if (addAttr) break;
			var t = a.select["k"].value;
			project.kiosk = t;
			bgPageE.style.backgroundPosition = "0px "+(project.kiosk?"0px":"20px"); // move background
			project.updateSize();
			projectEditor.adjustLayout();
			break;
		case "projectbackground":
			if (addAttr) break;
			project.background = a.input["v"].value;
			bgPageE.style.backgroundImage = "url('/img/"+project.background+"')";
			break;
			break;
		case "cameralist":
			if (addAttr) break;
			project.cameraList = a.input["v"].value;
			break;
		case "cameraoverlay":
			if (addAttr) break;
			project.cameraOverlay = a.input["v"].value;
			break;
		case "cameragridlist":
			if (addAttr) break;
			project.cameraGridList = a.input["v"].value;
			break;
		case "projectscope":
			if (addAttr) break;
			project.scope = a.input["v"].value;
			break;

		// pages
		case "pagetype":
			var t = a.select["t"].value;
			if (t == obj.obj.id) return; // nothing changed
			obj.changeObjType(t);
			project.updateSize();
			project.sortPages();
			selectPage(obj);
			this.initPagesListPanel();
			this.checkWarnings(); // we've changed the object
			break;
		case "pagetitle":
			pagesPanel.title.innerHTML = "Pages: "+a.input["v"].value; // repeated, should probably create a function to refresh the title!!!
			// continue
		case "pageid":
			obj.attrValues[id] = a.input["v"].value;
			this.initPagesListPanel();
			break;
		case "pageorientation":
			var t = a.select["o"].value;
			obj.orientation = t;
			project.updateSize();
			project.sortPages();

			selectPage(obj); // redraws page also
			this.initPagesListPanel();
			break;
		case "popupsize":
			var w = parseInt(a.input["w"].value);
			if (!w || w<obj.obj.minWidth) w = obj.obj.minWidth;
			if (obj.obj.maxWidth && w>obj.obj.maxWidth)
				w = obj.obj.maxWidth;
			var h = parseInt(a.input["h"].value);
			if (!h || h<obj.obj.minHeight) h = obj.obj.minHeight;
			if (obj.obj.maxHeight && w>obj.obj.maxHeight)
				h = obj.obj.maxHeight;

			obj.width = w;
			obj.height= h;

			obj.redraw();
			this.adjustLayout();
			break;
		case "popuptype":
			obj.attrValues[2] = a.select["s"].value;
			break;
		case "locations":
			obj.locations = a.input["v"].value;
			break;
		case "pageprotected":
			obj.attrValues[2] = a.select["o"].value;
			break;
		case "altpage":
			var v = a.select["s"].value;
			if (v[v.length-1] != ":") {
				obj.attrValues[id] = v;
				a.div["i"].style.display = "none";
			} else {
				obj.attrValues[id] = a.input["l"].value;
				a.div["i"].style.display = "block";
			}
			this.initPagesEditPanel();
			break;
		case "gestures":
			obj.gestures = a.input["v"].value;
			break;
		case "scope":
			obj.scope = a.input["v"].value;
			break;

		// objs
		case "id":
			obj.id = a.input["v"].value;
			obj.redraw();
			break;
		case "pos":
			// switch?
			if (e.getAttribute("name") == "pxy" && e.checked)
				a.input["prc"].checked = false;
			if (e.getAttribute("name") == "prc" && e.checked)
				a.input["pxy"].checked = false;
			// mode
			a.div["xy"].style.display = (a.input["pxy"].checked)?"inline":"none";
			a.div["rc"].style.display = (a.input["prc"].checked)?"inline":"none";
			// get pos
			if (a.input["pxy"].checked) {
				obj.posMode = "xy";
				var x = parseInt(a.input["x"].value);
				var y = parseInt(a.input["y"].value);
				if (!x) x = 0;
				if (!y) y = 0;
				obj.x = x;
				obj.y = y;
			} else {
				obj.posMode = "rc";
				var r = parseInt(a.input["r"].value);
				var c = parseInt(a.input["c"].value);
				if (!r) r = 1;
				if (!c) c = 1;
				obj.r = r;
				obj.c = c;
			}
			obj.redraw();
			foo.updateSelectedFrame();
			break;
		case "xy":
		case "xyla":
			var n = e.getAttribute("name");
			var x,y,l,d;
			if (n == "l" || n == "a") {
				l = parseInt(a.input["l"].value);
				d = parseInt(a.input["a"].value);
				if (!l) l = 0;
				if (!d) d = 0;
				x = obj.attr0[0];
				y = obj.attr0[1];

				// rotate
				var radians = (Math.PI / 180) * d,
		        	cos = Math.cos(radians),
		        	sin = Math.sin(radians);
				/*
		        x = (cos * (x - cx)) + (sin * (y - cy)) + cx;
		        y = (cos * (y - cy)) - (sin * (x - cx)) + cy;
				*/

				x += Math.round(sin * l);
		        y += Math.round(cos * -l);

				a.input["x"].value = x;
				a.input["y"].value = y;
			} else {
				x = parseInt(a.input["x"].value);
				y = parseInt(a.input["y"].value);
				if (!x) x = 0;
				if (!y) y = 0;

				if (a.type == "xyla") {
					var dx = x - parseInt(activeObj.attr0[0]);
					var dy = parseInt(activeObj.attr0[1]) - y;
					l = Math.sqrt( dx*dx + dy*dy );
					// angle in degrees
					d = Math.atan2(dx, dy) * 180 / Math.PI;
					if (d<0) d += 360;
					a.input["l"].value = Math.round(l);
					a.input["a"].value = Math.round(d);
				}
			}
			obj.attrValues[id] = "x"+x+"y"+y;
			obj.redraw();
			foo.updateSelectedFrame();
			break;
		case "string":
		case "label":
		case "css":
		case "chartattributes":
		case "dataloggerattributes":
		case "cameraids":
			if (evt && evt.type == "keyup" && code == 13) {
				try { evt.preventDefault(); } catch(e) {}
				//insertAtCursor(a.input["v"], "<br>");
			}
			obj.attrValues[id] = a.input["v"].value;
			obj.redraw();
			break;
		case "img":
		case "video":
			obj.attrValues[id] = a.input["v"].value;
			obj.redraw();
			break;
		case "width":
			var w = parseInt(a.input["w"].value);
			if (!w) w = 50;
			if (obj.obj.maxWidth && w>obj.obj.maxWidth)
				w = obj.obj.maxWidth;
			obj.attrValues[id] = w;
			obj.width = w;
			obj.redraw();
			foo.updateSelectedFrame();

			if (obj.fixedRatio && parseInt(a.input["w"].value)) {
				obj.height = Math.round(obj.width/obj.fixedRatio);
				a.input["h"].value = Math.round(obj.width/obj.fixedRatio);
				obj.attrValues[id+1] = obj.width;
			}

			if (!a.input["h"])
				break; // do height as well if it's there
			id += 1; // next attrValue
		case "height":
			var h = parseInt(a.input["h"].value);
			if (!h) h = 50;
			if (obj.obj.maxHeight && h>obj.obj.maxHeight)
				h = obj.obj.maxHeight;
			obj.attrValues[id] = h;
			obj.height= h;

			if (obj.fixedRatio && fn == "h" && parseInt(a.input["h"].value)) {
				obj.width = Math.round(obj.height*obj.fixedRatio);
				a.input["w"].value = Math.round(obj.height*obj.fixedRatio);
				obj.attrValues[id-1] = obj.width;
			}

			obj.redraw();
			foo.updateSelectedFrame();
			break;
		case "link":
		case "device":
		case "containerid":
		case "altpage":
			var v = a.select["s"].value;
			if (v[v.length-1] != ":") {
				obj.attrValues[id] = v;
				a.div["i"].style.display = "none";
			} else {
				obj.attrValues[id] = a.input["l"].value;
				a.div["i"].style.display = "block";
			}
			obj.redraw();
			break;
		// grouped attributes, select fields
		case "select": case "color": case "camera": case "cameraid": case "temp": case "timer": case "music":
			obj.attrValues[id] = a.select["s"].value;
			obj.redraw();
			break;
		}

		if (obj && obj.obj) {
			this.updateWatchObjs();

			// optional attribute?
			if (obj.obj.attributes[id] && obj.obj.attributes[id].optional) {
				if (!obj.attrValues[id])
					obj.attrValues[id] = null;
				obj.redraw();
			}

			switch(t) {
			case 'o': if (obj.obj.isDescrAttr(a.type)) this.refreshObjsListPanel(); break;
			case 'p': if (obj.obj.isDescrAttr(a.type)) this.refreshPagesListPanel(); break;
			}
		}

		if (!addAttr) {
			// warning? remove it?
			if (obj.warnings && obj.warnings[id]) {
				this.checkAttributeWarning(obj, id);
			} else {
				this.checkAttributeWarningOnTimeout(obj, id);
			}

			// undo state. type, obj, previous snapshot
			addUndoState("attr_update",[obj],[snapshot]);
		}
	} // updateAttr()

	this.updateWatchAttr = function (a) {
		// watch field visibility
		if (activeObj && activeObj.obj.watch && a.title == "Action") {
			var v = a.select["s"].value;
			var i = activeObj.obj.id;
			var d = i == "_watch_shutter" ? 1 : 0; // shutter has mode, which shifts all fields down
			objsPanel.edit.childNodes[3+d].style.display = v == "user" ? "" : "none"; // name
			objsPanel.edit.childNodes[4+d].style.display = v == "user" && i != "_watch_slider" ? "" : "none"; // param
			objsPanel.edit.childNodes[5+d].style.display = v == "device" ? "" : "none"; // address
			objsPanel.edit.childNodes[6+d].style.display = v == "url" ? "" : "none"; // url
		}

	};

	// --------------------------------------------------------------------------------------------------------------------------
	// Project Panel Functions -----------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	// duplicate project
	this.cloneProject = function () {
		if (manager.cPopup.data.input["s"].checked)
			files.saveProject(project.name,foo.generateIndex());

		project.name = manager.cPopup.data.input["n"].value;
		project.timestamp = 0;
		foo.redrawPages();

		manager.closePopup();
		updateToolbarTitle();
		foo.selectTab("pages","edit");
		foo.refreshProjectEditPanel();
		foo.initProjectListPanel();

		manager.showNotice("project duplicated");
	} // cloneProject()

	// init project list panel
	this.initProjectListPanel = function () {
		// clear
		projectPanel.list.innerHTML = "";
		// update
		var name = "";
		for (var i=0; i<this.projects.length; i++) {
			var div = document.createElement("div");
			div.className = (project && this.projects[i] == project.name)?"pItem mItemButton selected":"pItem mItemButton";
			name = this.projects[i]; // name
			div.innerHTML = "<div class='label'>"+name+"</div><br style='clear:both'>"; // name
			browser.initButtonEvents(div,{onclick:"projectEditor.onProjectListSelect(event,"+i+")"});
			projectPanel.list.appendChild(div);
		}
	} // initProjectListPanel()

	// init project add panel
	this.initProjectAddPanel = function () {
		projectPanel.add.innerHTML = "";
		projectPanel.addFields = [];

		var d,e,t,a; // div name, element, type, attribute
		var attr = [{d:"string",t:"projectname",id:"projectname",title:"Name"},
		            {d:"projectskin",t:"projectskin",id:"skin",title:"Skin"},
		            {d:"projectlan",t:"projectlan",id:"lan",title:"Language"},
		            {d:"string",t:"header",id:"header",title:"Header"},
		            {d:"projectsize",t:"projectsize",id:"projectsize",title:"Size"},
		            {d:"addproject",t:"addproject",id:"addproject",title:"Create Project"}];

		// attributes
		for (var i=0; i<attr.length; i++) {
			// new element
			e = document.createElement('div');
			e.innerHTML = attrPanelFieldsSrc[attr[i].d];
			e.className = "attr"+((attr[i].d == "addproject")?"bt":"")+" add ";
			e.setAttribute('name','m'+i);
			browser.initEvents(e); // init buttons if any
			projectPanel.add.appendChild(e);

			// new attribute panel field. element, type, link, values
			a = new AttrField(e,attr[i].t,attr[i].id,attr[i].values,attr[i].labels,attr[i].colorSet,attr[i].title);
			projectPanel.addFields.push(a);
		}
	} // initProjectAddPanel()

	// refresh project add panel (values)
	this.refreshProjectAddPanel = function () {
		var t,v;
		for (var i=0; i<projectPanel.addFields.length; i++) {
			var a = projectPanel.addFields[i];
			switch (a.type) {
			case "projectskin":
				var o;
				var h = "";
				for (k=0; k<this.skins.length; k++) {
					// add
					h += "<option value='"+this.skins[k]+"'";
					h += ">"+this.skins[k]+"</option>";
				}
				a.select["s"].innerHTML = h;
				break;
			}
		}
	} // refreshProjectAddPanel()

	// init project edit panel
	this.initProjectEditPanel = function () {
		var o = project;
		project = null;
		projectPanel.edit.innerHTML = ""; // changing this fires the updateAttr, so we put activeObj to null
		project = o;

		if (!project) return;

		projectPanel.editFields = [];

		var d,e,t,a; // div name, element, type, attribute
		var attr = [];
		// d:div name, t:type, id:link
		attr.push({d:"projectskin",t:"projectskin",id:"skin",title:"Skin"});
		attr.push({d:"projectlan",t:"projectlan",id:"language",title:"Language"});
		attr.push({d:"string",t:"header",id:"header",title:"Header"});
		attr.push({d:"projectsize",t:"projectsize",id:"size",title:"Size"});
        attr.push({d:"deviceimage",t:"deviceimage",id:"deviceImage",title:"Device Image"});
		attr.push({d:"projectkiosk",t:"projectkiosk",id:"projectKiosk",title:"Kiosk"});
        attr.push({d:"scale",t:"scale",id:"scale",title:"Scale"});
		attr.push({d:"projectlocked",t:"projectlocked",id:"projectLocked",title:"Locked"});
		attr.push({d:"img",t:"projectbackground",id:"projectbackground",title:"Background"});
		attr.push({d:"cameralist",t:"cameralist",id:"cameraList",title:"Camera List"});
		attr.push({d:"cameraoverlay",t:"cameraoverlay",id:"cameraOverlay",title:"Camera Overlay"});
		attr.push({d:"cameragridlist",t:"cameragridlist",id:"cameraGridList",title:"Camera Grid Headers"});
        attr.push({d:"scope",t:"projectscope",id:"scope",title:"Scope List"});
        attr.push({d:"style",t:"style",id:"style",title:"Style"});
        attr.push({d:"uiset",t:"uiset",id:"uiset",title:"UISet"});
		attr.push({d:"title",t:"title",id:"",title:"Project Options"});
		attr.push({d:"delproject",t:"bt",id:"",title:""});
		attr.push({d:"cloneproject",t:"bt",id:"",title:""});

		// attributes
		for (var i=0; i<attr.length; i++) {
			// new element
			e = document.createElement('div');
			e.innerHTML = attrPanelFieldsSrc[attr[i].d];
			e.className = "attr"+((attr[i].t == "bt")?"bt":"")+" "+attr[i].d;
			e.setAttribute('name','m'+i);
			browser.initEvents(e); // init buttons if any
			projectPanel.edit.appendChild(e);

			// new attribute panel field
			a = new AttrField(e,attr[i].t,attr[i].id,attr[i].values,attr[i].labels,attr[i].colorSet,attr[i].title);
			projectPanel.editFields.push(a);
		}

		this.refreshProjectEditPanel();
	} // initProjectEditPanel()

	// refresh project edit panel (values)
	this.refreshProjectEditPanel = function () {
		if (!project) return;
		var t,v;
		for (var i=0; i<projectPanel.editFields.length; i++) {
			var a = projectPanel.editFields[i];
			switch (a.type) {
			case "projectskin":
				var o;
				var s = false;
				var h = "";
				for (k=0; k<this.skins.length; k++) {
					// add
					h += "<option value='"+this.skins[k]+"'";
					if (!s && this.skins[k] == project.skin) {
						h += " selected='selected'";
						s = true;
					}
					h += ">"+this.skins[k]+"</option>";
				}
				a.select["s"].innerHTML = h;
				break;
			case "projectlan":
				t = project.language;
				for (var k=0; k<a.select["s"].options.length; k++) {
					if (t == a.select["s"].options[k].value) {
						a.select["s"].selectedIndex = k;
						break;
					}
				}
				break;
			case "header":
				a.input["v"].value = (project.header)?project.header:"";
				break;
			case "projectlocked":
				a.input["v"].checked = (project.locked);
				break;
			case "projectkiosk":
				switch (project.kiosk) {
				case "": a.select["k"].selectedIndex = 0; break;
				case "nolock": a.select["k"].selectedIndex = 1; break;
				case "lock": a.select["k"].selectedIndex = 2; break;
				}
				break;
			case "projectbackground":
				a.input["v"].value = (project.background)?project.background:"";
				break;
			case "deviceimage":
				a.select["s"].selectedIndex = (project.deviceImage)?0:1;
				break;
			case "scale":
				a.input["v"].value = (project.scale)?project.scale:"";
				break;
			case "cameralist":
				a.input["v"].value = (project.cameraList)?project.cameraList:"";
				break;
			case "cameraoverlay":
				a.input["v"].value = (project.cameraOverlay)?project.cameraOverlay:"";
				break;
			case "cameragridlist":
				a.input["v"].value = (project.cameraGridList)?project.cameraGridList:"";
				break;
			case "projectsize":
				a.input["w"].value = project.width;
				a.input["h"].value = project.height;
				if (project.orientationMode) {
					a.input["orientationenabled"].checked = true;
					a.input["wl"].value = project.width;
					a.input["hl"].value = project.height;
					a.input["wp"].value = project.width2;
					a.input["hp"].value = project.height2;
				} else {
					a.input["orientationenabled"].checked = false;
				}
				this.setOrientationEnabled(a.input["orientationenabled"]);
				break;
			case "projectscope":
				a.input["v"].value = (project.scope)?project.scope:"";
				break;
			case "style":
				a.input["v"].value = (project.style)?project.style:"";
				break;
			case "uiset":
				a.input["v"].value = (project.uiset)?project.uiset:"";
				break;
			}
		}
	} // refreshProjectEditPanel()

	// --------------------------------------------------------------------------------------------------------------------------
	// Pages Panel Functions ----------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	// init pages panel
	this.initPagesListPanel = function () {
		// clear
		pagesPanel.list.innerHTML = "";
		// no project selected?
		if (!project) return;
		// update
		var name = "";
		for (var i=0; i<project.pages.length; i++) {
			var div = document.createElement("div");
			div.className = (project.pages[i]==activePage)?"pItem mItemButton selected":"pItem mItemButton";
			var id = project.pages[i].obj.id;
			if (id == "_watch_page") id = "watchpage";
			name = "<div class='labelS'>";
			name += ((id == "menu" || id == "overlay" || id == "watchpage")?id:project.pages[i].attrValues[0]); // name
			if ((id != "popup" && id != "watchpage") && project.orientationMode)
				name += " <span style='font-size:80%'>("+project.pages[i].orientation+")</span>";
			if (id == "page")
				name += "<br><span class='descr'>"+project.pages[i].attrValues[1]+"<span>";
			name += "</div><img class='icon' src='/manager/pic/icon"+id;
			if (id != "popup" && id != "watchpage")
				name += (project.orientationMode)?project.pages[i].orientation.charAt(0):"l";
			name += ".png'><br style='clear:both'>";
			div.innerHTML = name; // name
			browser.initButtonEvents(div,{onclick:"projectEditor.onPagesListSelect(event,"+i+")"});
			pagesPanel.list.appendChild(div);
		}
	} // initPagesListPanel()

	// init pages edit panel
	this.initPagesEditPanel = function () {
		var o = activePage;
		activePage = null;
		pagesPanel.edit.innerHTML = ""; // changing this fires the updateAttr, so we put activePage to null
		activePage = o;
		pagesPanel.editFields = [];

		if (!activePage) return;

		var d,e,t,a; // div name, element, type, attribute
		var laId = activePage.obj.id == "menu" ? 0 : 3; // id of the "altpage" attr
		var laLa = o.orientation == "landscape" ? "Portrait" : "Landscape"; // other orientation label
		var attr = [{d:"pagetype",t:"pagetype",id:"type",title:"Page Type"},
		            {d:"string",t:"pageid",id:0,title:"Id"},
		            {d:"string",t:"pagetitle",id:1,title:"Title"},
					{d:"pageorientation",t:"pageorientation",id:"orientation",title:"Orientation"},
					{d:"popupsize",t:"popupsize",id:"popupsize",title:"Size"},
					{d:"select",t:"popuptype",id:2,title:"Type"},
					{d:"string",t:"locations",id:"locations",title:"Locations"},
					{d:"pageprotected",t:"pageprotected",id:2,title:"Protected"},
					{d:"link",t:"altpage",id:laId,title:"Alternative "+laLa+" Page"},
					{d:"gestures",t:"gestures",id:"gestures",title:"Gestures"},
					{d:"scope",t:"scope",id:"scope",title:"Scope List"},
					{d:"title",t:"",id:"",title:"Page Options"},
					{d:"delpage",t:"bt",id:"delpage",title:""},
					{d:"clonepage",t:"bt",id:"clonepage",title:""},
					{d:"copypage",t:"bt",id:"copypage",title:""},
					{d:"cutpage",t:"bt",id:"cutpage",title:""}];

		if (activePage.obj.watch) {
			attr = [
				{d:"title",t:"",id:"",title:"Watch Page Options"},
				{d:"delpage",t:"bt",id:"delpage",title:""},
				{d:"copypage",t:"bt",id:"copypage",title:""},
				{d:"cutpage",t:"bt",id:"cutpage",title:""}
			];
		}

		// attributes
		for (var i=0; i<attr.length; i++) {
			// new element
			e = document.createElement('div');
			e.innerHTML = attrPanelFieldsSrc[attr[i].d];
			e.className = "attr"+((attr[i].t == "bt")?"bt":"")+" "+attr[i].d;
			e.setAttribute('name','p'+i);
			browser.initEvents(e); // init buttons if any
			pagesPanel.edit.appendChild(e);

			// new attribute panel field
			a = new AttrField(e,attr[i].t,attr[i].id,attr[i].values,attr[i].labels,attr[i].colorSet,attr[i].title);
			pagesPanel.editFields.push(a);
		}

		this.refreshPagesEditPanel();
	} // initPagesEditPanel()

	// init pages add panel
	this.initPagesAddPanel = function () {
		// clear
		pagesPanel.add.innerHTML = "";
		if (!project) return;
		var ptypes = [{type:"menu"},{type:"page"},{type:"popup"}];

		var op = false;
		var wp = false;

		for (var i=0; i<project.pages.length; i++) {
			if (project.pages[i].obj.id == "overlay") {
				op = true;
			}
			if (project.pages[i].obj.id == "_watch_page") {
				wp = true;
			}
		}

		if (!op) {
			ptypes.push({type:"overlay"});
		}
		if (!wp) {
			ptypes.push({type:"_watch_page",label:"watch page"});
		}

		// update
		var div;
		for (var i=0; i<ptypes.length; i++) {
			if (i>0) {
				div = document.createElement("div");
				div.className = "sep";
				pagesPanel.add.appendChild(div);
			}
			div = document.createElement("div");
			div.className = "pNew mItemButton";
			var type = ptypes[i].type;
			var label = ptypes[i].label ? ptypes[i].label : type;
			div.innerHTML = "<div class='labelS'>"+label+"<div class='icon'><img src='/manager/pic/iconadd.png'></div><br style='clear:both'></div>";
			browser.initButtonEvents(div,{onclick:"projectEditor.onPagesAddSelect(event,\""+type+"\")"});
			pagesPanel.add.appendChild(div);
		}
	} // initPagesAddPanel()

	// add a page. if silent, it won't add it to pages
	this.addPage = function (type,silent) {
		var npopup = 1,
			npage = 1,
			id = "",
			page = dictionary.getObjInstance(type);

		for (var i=0; i<project.pages.length; i++) {
			if (project.pages[i].obj.id == "page")
				npage++;
			else if (project.pages[i].obj.id == "popup")
				npopup++;
		}

		selectNone();

		if (!silent) {
			project.addPage(page);
		}

		switch(type) {
		case "menu":
			id = "menu";
			break;
		case "page":
			id = id?id:"page"+npage; // overlay?
			page.attrValues[0] = id;
			page.attrValues[1] = (id == "overlay")?"":"Page "+npage;
			break;
		case "popup":
			id = "popup"+npopup;
			page.attrValues[0] = id;
			page.attrValues[1] = "Popup "+npopup;
			break;
		case "overlay":
			id = "overlay";
			this.initPagesAddPanel(); // can't add another one
			break;
		case "_watch_page":
			id = "watchpage";
			page.width = 134 + 4*2; //4:margin
			page.height = 300;
			this.initPagesAddPanel(); // can't add another one
			break;
		}

		if (!silent)
			this.initPagesListPanel();

		return page;
	} // addPage

	// delete the active page
	this.delActivePage = function () {
		selectNone();
		// notice
		manager.showNotice("<b>"+activePage.obj.id+"</b> deleted");
		project.delPage(activePage);
		this.initPagesAddPanel(); // a single overlay or watch page can be added
		this.initPagesListPanel();
		selectPage(null);
		this.checkWarnings();
	} // delActivePage()

	// duplicate page
	this.cloneActivePage = function () {
		var npopup = 1;
		var npage = 1;
		for (var i=0; i<project.pages.length; i++) {
			if (project.pages[i].obj.id == "page")
				npage++;
			else if (project.pages[i].obj.id == "popup")
				npopup++;
		}

		selectNone();
		var p = activePage.cloneObj();

		if (activePage.obj.id != "menu" && activePage.obj.id != "overlay" &&
			activePage.obj.id != "watchpage") {
			p.attrValues[0] = manager.cPopup.data.input["n"].value;
			manager.closePopup();
		}

		p.redraw();
		project.pages.push(p);
		project.sortPages();

		foo.initPagesListPanel();
		selectPage(p);
		foo.selectTab("pages","list");
		foo.checkWarnings();
		addUndoState("page_new", p);

		manager.showNotice("page duplicated");
	} // cloneActivePage()

	// load copied page
	function loadCopiedPage() {
		if (localStorage && localStorage.copiedPage && dictionary) {
			copiedPage = [];
			var a = JSON.parse(localStorage.copiedPage);
			var p = dictionary.getObjInstance(a.obj);
			p.fromJSON(a);
			copiedPage = p;
		}
	}
	function saveCopiedPage() {
		if (localStorage) {
			var p = copiedPage.toJSON(true); // true:also children
			localStorage.copiedPage = JSON.stringify(p);
		}
	}

	// copy selected page
	this.copyPage = function () {
		if (!activePage) return;
		copiedPage = activePage.cloneObj();
		if (activePage.obj.watch) {
			activePage.redraw();
			this.updateWatchObjs();
		}
		saveCopiedPage();
		// notice
		manager.showNotice("<b>"+activePage.obj.id+"</b> copied");
	} // copyPage()

	// cut the active page
	this.cutActivePage = function () {
		if (!activePage) return;
		// notice
		manager.showNotice("<b>"+activePage.obj.id+"</b> cut");
		copiedPage = activePage.cloneObj();
		saveCopiedPage();
		addUndoState("page_del", activePage);
		selectNone();
		project.delPage(activePage);
		this.initPagesAddPanel(); // a single overlay or watch page can be added
		this.initPagesListPanel();
		selectPage(null);
		this.checkWarnings();
	} // cutActivePage()

	// past copied page
	this.pastePage = function () {
		loadCopiedPage(); // make sure
		if (!copiedPage) return;

		var oi = copiedPage;
		//copiedPage = oi.cloneObj(); // in case we want to paste it again

		project.pages.push(oi);
		project.sortPages();

		this.initPagesAddPanel(); // a single overlay or watch page can be added
		this.initPagesListPanel();
		selectPage(copiedPage);
		if (copiedPage.obj.watch) {
			this.updateWatchObjs();
		}
		this.selectTab("pages","list");

		this.checkObjectWarnings(oi);
		addUndoState("page_new", oi);

		// notice
		manager.showNotice("<b>"+oi.obj.id+"</b> pasted");
	}

	// select page
	function selectPage(page) {
		foo.closeAllContainers();
		selectNone();
		activePage = page;
		containerFrameE.style.display = "none"
		if (page) {
			activeContainer = activePage;
			activePage.redraw();
			var name;
			switch (activePage.obj.id) {
			case "menu":		name = "Menu"; break;
			case "overlay":		name = "Overlay"; break;
			case "_watch_page":	name = "Apple Watch"; break;
			default:			name = activePage.attrValues[1]; // name;
			}
			var id = activePage.obj.id;
			bgPageE.style.display = (id!="popup" && id!="_watch_page")?"block":"none";
			bgPopupE.style.display = (id=="popup")?"block":"none";
			bgWatchE.style.display = (id=="_watch_page")?"block":"none";
		} else {
			activeContainer = null;
			var name = "";
			bgPageE.style.display = "none";
			bgPopupE.style.display = "none";
			bgWatchE.style.display = "none";
		}
		pagesPanel.title.innerHTML = "Pages: "+name;
		updateToolbarTitle();
		foo.refreshPagesListPanel();
		foo.initPagesEditPanel();
		foo.initObjsListPanel();
		foo.initObjsAddPanel(); // watch has different objects
		foo.updatePanelIcons(); // obj must be disabled if no page or enabled
		foo.adjustLayout();
	} // selectPage()

	// refresh page attribute panel (values)
	this.refreshPagesEditPanel = function () {
		if (!activePage) return;
		var t,v,k,sv,st;
		for (var i=0; i<pagesPanel.editFields.length; i++) {
			var a = pagesPanel.editFields[i];
			sv = []; // used on select fields
			st = [];
			switch (a.type) {
			case "pagetype":
				t = activePage.obj.id;
				switch(t) {
				case "menu": a.select["t"].selectedIndex = 0; break;
				case "page": a.select["t"].selectedIndex = 1; break;
				case "popup": a.select["t"].selectedIndex = 2; break;
				case "overlay": a.select["t"].selectedIndex = 3; break;
				}
				if (t=="overlay") {
					for (var f=1; f<=9; f++)
						pagesPanel.editFields[f].e.style.display = "none";
					pagesPanel.editFields[3].e.style.display = (t=="popup" || !project.orientationMode)?"none":"block"; // orientation
				} else {
					pagesPanel.editFields[1].e.style.display = (t=="menu")?"none":"block"; // name
					pagesPanel.editFields[2].e.style.display = (t=="menu")?"none":"block"; // title
					pagesPanel.editFields[3].e.style.display = (t=="popup" || !project.orientationMode)?"none":"block"; // orientation
					pagesPanel.editFields[4].e.style.display = (t!="popup")?"none":"block"; // size
					pagesPanel.editFields[5].e.style.display = (t!="popup")?"none":"block"; // popup type
					pagesPanel.editFields[6].e.style.display = (t!="page")?"none":"block"; // location
					pagesPanel.editFields[7].e.style.display = (t!="page")?"none":"block"; // protected
					pagesPanel.editFields[8].e.style.display = (t!="page" || !project.orientationMode)?"none":"block"; // alt page
					pagesPanel.editFields[9].e.style.display = (t!="popup")?"block":"none"; // gestures
					pagesPanel.editFields[10].e.style.display = (t!="popup")?"block":"none"; // scope
				}
				break;
			case "pageorientation":
				t = activePage.orientation;
				switch(t) {
				case "landscape": a.select["o"].selectedIndex = 0; break;
				case "portrait": a.select["o"].selectedIndex = 1; break;
				}
				break;
			case "pageid":
			case "pagetitle":
				v = activePage.attrValues[a.link];
				if (v == null) v = "";
				a.input["v"].value = v;
				break;
			case "popuptype":
				st = sv = ["simple","modal"];
				break;
			case "popupsize":
				a.input["w"].value = activePage.width;
				a.input["h"].value = activePage.height;
				break;
			case "locations":
				a.input["v"].value = activePage.locations;
				break;
			case "pageprotected":
				v = activePage.attrValues[a.link];
				switch(v) {
				case "": a.select["o"].selectedIndex = 0; break;
				case "pin": a.select["o"].selectedIndex = 1; break;
				case "puk": a.select["o"].selectedIndex = 2; break;
				}
				break;
			case "altpage":
				sv.push("");
				st.push("");
				var pid = "";
				for (k=0; k<project.pages.length; k++) {
					if (project.pages[k].obj.id != "popup" &&
						project.pages[k].orientation != activePage.orientation) {
						if (project.pages[k].obj.id == "menu") {
							pid = "menu";
						} else {
							pid = project.pages[k].attrValues[0];
						}
						if (pid) { // watchpage has no id
							sv.push(pid);
							st.push(pid + " (" + project.pages[k].orientation + ")");
						}
					}
				}
				sv.push("Other:");
				st.push("Other:");
				break;
			case "gestures":
				// refresh gesturesListPanel
				var v = { // sorted by importance
					"swipeup":{values:[]},
					"swipedown":{values:[]},
					"swipeleft":{values:[]},
					"swiperight":{values:[]},
					"pinchin":{values:[]},
					"pinchout":{values:[]}
				};

				// pages
				for (k=0; k<project.pages.length; k++) {
					if (project.pages[k].obj.id == "menu")
						sv.push("page:menu");
					else
						sv.push("page:"+project.pages[k].attrValues[0]);
				}
				sv = sv.unique();
				sv.sort();
				sv.push("page:back");
				sv.push("page:forward");
				sv.push("page:logout");
				sv.splice(0,0,"off");
				sv.splice(1,0,"user");

				for (t in v)
					v[t].values = sv;

				foo.gesturesListPanel.setValues(v);

				a.input["v"].value = activePage.gestures;
				break;
			case "scope":
				a.input["v"].value = activePage.scope;
				break;
			}

			// select
			switch (a.type) {
			case "popuptype":
			case "altpage":
				var o;
				var f = false;
				var v = activePage.attrValues[a.link];
				// clear
				if (a.div["i"]) {
					a.div["i"].style.display = "none";
					a.input["l"].value = "";
				}

				var h = "";
				var s;
				for (k=0; k<sv.length; k++) {
					// add
					s = (sv[k] == v);
					if (v) { // link
						if (sv[k] == v) f = true;
						if (!f && k == sv.length-1) s = true;
					}
					h += "<option value='"+sv[k]+"'";
					if (s)
						h += " selected='selected'";
					h += ">"+st[k]+"</option>";
				}
				a.select["s"].innerHTML = h;
				if (a.div["i"] && !f && v) {
					a.div["i"].style.display = "block";
					a.input["l"].value = v;
				}
				break;
			}
		}
	} // refreshObjsEditPanel()

	// refresh page list panel (selected page)
	this.refreshPagesListPanel = function () {
		if (!project) return;
		selectedPageI = -1;
		// update
		for (var i=0; i<project.pages.length; i++) {
			browser.setButtonAttribute(pagesPanel.list.childNodes[i], "selected", project.pages[i]==activePage)
			if (project.pages[i]==activePage) selectedPageI = i;
		}
	} // refreshPagesEditPanel()

	// focus page list panel
	this.focusPagesListPanel = function () {
		if (!project) return;
		// update
		var h = 0;
		var div;
		for (var i=0; i<project.pages.length; i++) {
			div = pagesPanel.list.childNodes[i];
			if (project.pages[i]==activePage) {
				var y = Math.round(h - pagesPanel.list.offsetHeight/2 + div.offsetHeight/2);
				pagesPanel.list.scrollTop = y;
				return; // found
			}
			h += div.offsetHeight;
		}
	} // focusPagesListPanel()

	// --------------------------------------------------------------------------------------------------------------------------
	// Objs Panel Functions -----------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	// load attribute fields, get and store the html
	this.loadAttrFields = function () {
		var div = document.getElementById("pe_attributeFields");
		var divs = div.getElementsByTagName("div");
		for (var i=0; i<divs.length; i++)
			attrPanelFieldsSrc[divs[i].getAttribute("name")] = divs[i].innerHTML;
		div.innerHTML = ""; // remove them all
		div.parentNode.removeChild(div); // remove node
	} // loadAttrFields()

	// init editor object palette
	this.initObjsAddPanel = function () {
		// clear
		objsPanel.add.innerHTML = "";
		// update
		var div,id;
		var isWatchPage = (activePage && activePage.obj.watch);
		for (var i=0; i<dictionary.objs.length; i++) {
			id = dictionary.objs[i].id;
			if (isWatchPage) {
				if (!dictionary.objs[i].watch || id == "_watch_page")
					continue; // won't show up in the palette
				id = id.substr(7);
			} else {
				if (dictionary.objs[i].hidden)
					continue; // won't show up in the palette
				// can show?
				if (!document.getElementById("objslistshowall").checked && JSONConfig.hsycoconfig.webobjects) {
					var f = false;
					for (var k=0; k<JSONConfig.hsycoconfig.webobjects.length; k++) {
						if (id == JSONConfig.hsycoconfig.webobjects[k]) {
							f = true;
							break;
						}
					}
					if (!f) continue;
				}
			}
			if (i>0) {
				div = document.createElement("div");
				div.className = "sep";
				objsPanel.add.appendChild(div);
			}
			div = document.createElement("div");
			div.className = "pNew mItemButton";
			div.innerHTML = "<div class='label'>"+id+"<span class='icon'><img src='/manager/pic/iconadd.png'></span><br style='clear:both'></div>";
			browser.initButtonEvents(div,{onclick:"projectEditor.onObjsAddSelect(event,"+i+")"});
			objsPanel.add.appendChild(div);
		}
	} // initObjsAddPanel()

	// init obj edit panel
	this.initObjsEditPanel = function () {
		var o = activeObj;
		activeObj = null;
		objsPanel.edit.innerHTML = ""; // changing this fires the updateAttr, so we put activeObj to null
		activeObj = o;
		attrPanelFields = [];

		if (!selObjs.length) return;

		var e,t,a,d,title,v,l,cs; // element, type, attribute, description, title, value, labels, colorset
		var k = 0; // attribute index

		if (!selMode || selObjs.length == 1) {
			if (!activeObj) return;
			// id
			if (activeObj.obj.iId) {
				t = "id";
				d = "string";
				title = "ID";
				e = document.createElement('div');
				e.innerHTML = attrPanelFieldsSrc[d];
				e.className = "attr "+d;
				e.setAttribute('name','o'+k);
				objsPanel.edit.appendChild(e);

				// new attribute panel field
				a = new AttrField(e,t,"id",null,null,null,title);
				attrPanelFields.push(a);

				k++;
			}

			// attributes
			for (var i=0; i<activeObj.obj.attributes.length; i++) {
				t = d = activeObj.obj.attributes[i].type;
				v = activeObj.obj.attributes[i].values;
				l = activeObj.obj.attributes[i].labels;
				cs = activeObj.obj.attributes[i].colorSet;

				title = activeObj.obj.attributes[i].name;

				// check if next is height (size)
				if (t == "width" &&
					activeObj.obj.attributes.length>i+1 &&
					activeObj.obj.attributes[i+1].type == "height") {
					switch (activeObj.obj.id) {
					case "cameraimage":
					case "camerapanel":
					case "camera": d = "camerasize"; title = "Size"; break;
					case "buttonimage":
					case "selector":
					case "submitimage":
					case "userimage":
					case "video":
					case "imagelink":
					case "image": d = "imgsize"; title = "Size"; break;
					default: d = "size"; title = "Size";
					}
				}

				// new element, unless height and previous was size
				if (!e || t!="height" ||
					(e.className!="attr size" && e.className!="attr camerasize" && e.className!="attr imgsize")) {
					e = document.createElement('div');
					e.innerHTML = attrPanelFieldsSrc[d];
					e.className = "attr "+d;
					e.setAttribute('name','o'+k);
					browser.initEvents(e); // init buttons if any
					objsPanel.edit.appendChild(e);
				} else {
					title = null;
				}

				// new attribute panel field
				a = new AttrField(e,t,i,v,l,cs,title);
				attrPanelFields.push(a);

				k++;
			}
		}

		// object options (type title)
		t = "title";
		d = "title";
		e = document.createElement('div');
		e.innerHTML = attrPanelFieldsSrc[d];
		e.className = "attr "+d;
		e.setAttribute('name','o'+k);
		objsPanel.edit.appendChild(e);
		a = new AttrField(e,t,d,null,null,null,"Object Options");

		// open container?
		if (activeObj && activeObj.isContainer && !activeObj.isInclude && selObjs.length == 1) {
			t = "open";
			d = "openobj";
			e = document.createElement('div');
			e.innerHTML = attrPanelFieldsSrc[d];
			e.className = "attrbt "+d;
			e.setAttribute('name','o'+k);
			browser.initEvents(e); // init buttons if any
			objsPanel.edit.appendChild(e);
		}

		// del obj
		if (activeObj && !activeObj.isInclude) {
			t = "del";
			d = "delobj";
			e = document.createElement('div');
			e.innerHTML = attrPanelFieldsSrc[d];
			e.className = "attrbt "+d;
			e.setAttribute('name','o'+k);
			browser.initEvents(e); // init buttons if any
			objsPanel.edit.appendChild(e);
		}

		if (selObjs.length>1 || !activeObj.isInclude) {
			// clone obj
			t = "clone";
			d = "cloneobj";
			e = document.createElement('div');
			e.innerHTML = attrPanelFieldsSrc[d];
			e.className = "attrbt "+d;
			e.setAttribute('name','o'+k);
			browser.initEvents(e); // init buttons if any
			objsPanel.edit.appendChild(e);

			// copy obj
			t = "copy";
			d = "copyobj";
			e = document.createElement('div');
			e.innerHTML = attrPanelFieldsSrc[d];
			e.className = "attrbt "+d;
			e.setAttribute('name','o'+k);
			browser.initEvents(e); // init buttons if any
			objsPanel.edit.appendChild(e);

			// cut obj
			t = "cut";
			d = "cutobj";
			e = document.createElement('div');
			e.innerHTML = attrPanelFieldsSrc[d];
			e.className = "attrbt "+d;
			e.setAttribute('name','o'+k);
			browser.initEvents(e); // init buttons if any
			objsPanel.edit.appendChild(e);
		}

		this.refreshObjsEditPanel();
	} // initObjsEditPanel()

	// init objs list panel. recursive:container, n (level), path
	this.initObjsListPanel = function (c,l,p) {
		if (c == null) {
			// clear
			objsPanel.list.innerHTML = "";
			// no page? done
			if (!activePage) return;
			// update
			var c = activePage;
			var l = 0;
			var p = "";
		}

		var o,oid,ri;
		var w = activeContainer.obj.watch;
		for (var i=0; i<c.objs.length; i++) {
			ri = w ? i : c.objs.length-i-1;
			oid = p+ri;
			o = c.objs[ri];
			if (o == activeContainer || c == activeContainer) {
				var div = document.createElement("div");
				div.className = "pItem mItemButton"; // selected on refreshObjsListPanel
				browser.initButtonEvents(div,{onclick:"projectEditor.onObjsListSelect(event,\""+oid+"\")"});
				objsPanel.list.appendChild(div);
			}
			if (o.isContainer && !o.isInclude)
				this.initObjsListPanel(o,l+1,oid+".");
		}
		if (l == 0) // just once
			this.refreshObjsListPanel();
	} // initObjsListPanel()

	// refresh attribute panel (values) single attribute (type, ex: "pos")
	this.refreshObjsEditPanel = function (attr) {
		if (!activeObj) return;
		var t,v,k;
		for (var i=0; i<attrPanelFields.length; i++) {
			var a = attrPanelFields[i];
			// refresh a single attribute?
			if (attr && a.type != attr) continue;
			// fill select? array
			var sv,st,sf,sv2; // values, text, from:if -1 empty. values 2 (alternative values)
			sv = [];
			sv2 = [];
			st = [];
			switch (a.type) {
			case "color":
				// from the dictionary
				var colors = dictionary.colors[a.colorSet];
				for (k=0; k<colors.length; k++) {
					if (hscMode || !colors[k].hidden) {
						sv.push(colors[k].value);
						sv2.push(colors[k].alt);
						st.push(colors[k].name);
					}
				}
				break;
			case "link":
				sv.push("");
				for (k=0; k<project.pages.length; k++) {
					if (project.pages[k].obj.id == "menu")
						sv.push("menu");
					else
						sv.push(project.pages[k].attrValues[0]);
				}
				sv = sv.unique();
				sv.sort();
				sv.push("back");
				sv.push("forward");
				sv.push("logout");
				sv.push("URL:");
				st = sv;
				break;
			case "select":
				// new values?
				if (a.optional)
					sv.push("");
				for (k=0; k<a.values.length; k++) {
					sv.push(a.values[k]);
				}
				if (a.labels && a.labels.length) {
					if (a.optional)
						st.push("");
					for (k=0; k<a.labels.length; k++) {
						st.push(a.labels[k]);
					}
				} else {
					st = sv;
				}
				break;
			case "camera":
				sv.push("");
				st.push("");
				for (k=0; k<JSONConfig.hsycoconfig.cameraids.length; k++) {
					sv.push(JSONConfig.hsycoconfig.cameraids[k]);
					st.push(JSONConfig.hsycoconfig.cameraids[k])
				}
				for (k=0; k<JSONConfig.hsycoconfig.cameragrids.length; k++) {
					sv.push("grid"+(k+1));
					st.push("grid "+(k+1));
				}
				break;


			case "device":
				sv.push("");
				st.push("");
				var id,descr;
				for (var item in JSONTopo.hsycotopology.devices) { // devices
					descr = (JSONTopo.hsycotopology.devices[item].length>1)?JSONTopo.hsycotopology.devices[item][1]:'';
					sv.push(item);
					st.push(item+" "+descr);
				}
				sv.push("USER:");
				st.push("User defined:");
				break;


			case "music":
				sv.push("");
				st.push("");
				for (k=0; k<JSONConfig.hsycoconfig.musicids.length; k++) {
					sv.push(k);
					st.push(JSONConfig.hsycoconfig.musicids[k])
				}
				break;
			case "cameraid":
				sv.push("");
				var arr = project.getAllObjs();
				for (t=0; t<arr.length; t++) {
					if ((arr[t].obj.id == "camera" ||
						arr[t].obj.id == "camerapanel" ||
						arr[t].obj.id == "cameraimage") &&
						arr[t].id)
						sv.push(arr[t].id);
				}
				sv = sv.unique();
				sv.sort();
				st = sv;
				break;
			case "containerid":
				sv.push("");
				var arr = project.getAllObjs();
				for (t=0; t<arr.length; t++) {
					if (arr[t].obj.id == "container" && arr[t].id)
						sv.push(arr[t].id);
				}
				sv = sv.unique();
				sv.sort();
				sv.push("Other:");
				st = sv;
				break;
			case "temp":
				sv.push("");
				st.push("");
				var id,descr;
				for (var item in JSONTopo.hsycotopology.temp) {
					id = item.substr(1)?parseInt(item.substr(1)):'';
					descr = (JSONTopo.hsycotopology.temp[item].length>0)?JSONTopo.hsycotopology.temp[item][0]:'';
					sv.push(id);
					st.push(id+" "+descr);
				}
				break;
			case "timer":
				sv.push("");
				st.push("");
				var id,descr;
				for (var item in JSONState.hsycostate.timers) {
					id = item;
					descr = ""; //(JSONState.hsycostate.timers[item].length>0)?JSONState.hsycostate.timers[item][0]:'';
					sv.push(id);
					st.push(id+" "+descr);
				}
				break;
			case "include":
				for (k in project.includes) {
					sv.push(k);
				}
				st = sv;
				break;
			}

			// refresh fields
			switch (a.type) {
			case "id":
				a.input["v"].value = activeObj.id;
				break;
			case "pos":
				a.input["x"].value = activeObj.x;
				a.input["y"].value = activeObj.y;
				a.input["r"].value = activeObj.r;
				a.input["c"].value = activeObj.c;
				a.input["pxy"].checked = (activeObj.posMode == "xy")?"checked":"";
				a.input["prc"].checked = (activeObj.posMode == "rc")?"checked":"";
				a.div["xy"].style.display = (activeObj.posMode == "xy")?"inline":"none";
				a.div["rc"].style.display = (activeObj.posMode == "xy")?"none":"inline";
				break;
			case "xy":
			case "xyla":
				var p = activeObj.attrValues[a.link];
				p = p.trim().substr(1).split("y");
				var x = parseInt(p[0]);
				var y = parseInt(p[1]);
				a.input["x"].value = x;
				a.input["y"].value = y;
				if (a.type == "xyla") {
					var dx = x - parseInt(activeObj.attr0[0]);
					var dy = parseInt(activeObj.attr0[1]) - y;
					l = Math.sqrt( dx*dx + dy*dy );
					// angle in degrees
					d = Math.atan2(dx, dy) * 180 / Math.PI;
					if (d<0) d += 360;
					a.input["l"].value = Math.round(l);
					a.input["a"].value = Math.round(d);
				}
				break;
			case "string":
			case "label":
			case "pageid":
			case "img":
			case "video":
			case "css":
			case "chartattributes":
			case "dataloggerattributes":
			case "cameraids":
				v = activeObj.attrValues[a.link];
				if (v == null) {
					v = "";
				} else { // decode parenthesis
					v = v.replace(/\&\#40\;/g,'(');
					v = v.replace(/\&\#41\;/g,')');
				}
				a.input["v"].value = v;
				break;
			case "width":
			case "camerawidth":
				a.input["w"].value = activeObj.width;
				if (a.input["sizeratio"])
					a.input["sizeratio"].checked = (activeObj.fixedRatio != null);
				break;
			case "height":
			case "cameraheight":
				a.input["h"].value = activeObj.height;
				if (a.input["sizeratio"])
					a.input["sizeratio"].checked = (activeObj.fixedRatio != null);
				break;
			case "link":
			case "device":
			case "containerid":
				var o;
				var f = false;
				var v = activeObj.attrValues[a.link];
				// clear
				a.div["i"].style.display = "none";
				a.input["l"].value = "";

				var h = "";
				var s;
				for (k=0; k<sv.length; k++) {
					// add
					s = (sv[k] == v);
					if (v) { // link
						if (sv[k] == v) f = true;
						if (!f && k == sv.length-1) s = true;
					}
					h += "<option value='"+sv[k]+"'";
					if (s)
						h += " selected='selected'";
					h += ">"+st[k]+"</option>";
				}
				a.select["s"].innerHTML = h;
				if (!f && v) {
					a.div["i"].style.display = "block";
					a.input["l"].value = v;
				}
				break;
			// grouped attributes, select fields
			case "select": case "color": case "camera": case "cameraid":
			case "temp": case "timer": case "include": case "music":
				var o;
				var s = false;
				// clear
				var h = "";
				for (k=0; k<sv.length; k++) {
					// add
					h += "<option value='"+sv[k]+"'";
					if (!s && (sv[k] == activeObj.attrValues[a.link] || (sv2[k] && sv2[k] == activeObj.attrValues[a.link]))) {
						h += " selected='selected'";
						s = true;
					}
					h += ">"+st[k]+"</option>";
				}
				a.select["s"].innerHTML = h;
				break;
			}

			this.updateWatchAttr(a);
		}
	} // refreshObjsEditPanel()

	// refresh obj list panel (names, selected). recursive:container, l (level), n (cursor)
	this.refreshObjsListPanel = function () {
		// no page? done
		if (!activePage) return;
		// update
		prevSelObj = null; // will be set to current obj until nextSelObj is set
		nextSelObj = null; // will be set to selected obj until next is found

		var name,k,o,div;
		var n = 0;
		var c = activeContainer;
		var st = objsPanel.list.scrollTop;
		var ri;
		var w = activeContainer.obj.watch;
		for (var i=0; i<c.objs.length; i++) {
			ri = w ? i : c.objs.length-i-1;

			if (ri==c.objs.length) // special case
				o = c;
			else
				o = c.objs[ri];

			if (o == activePage) continue; // show only containers

			div = objsPanel.list.childNodes[n];
			if (!div) { // TODO:fix this
				//console.log(o.obj.id+" "+n+" "+objsPanel.list.childNodes.length);
				continue;
			}

			// next/prev
			if (activeObj) {
				if (nextSelObj) {
					if (nextSelObj == activeObj)
						nextSelObj = o;
				} else {
					if (o == activeObj)
						nextSelObj = o;
					else
						prevSelObj = o;
				}
			} else {
				if (!nextSelObj)
					nextSelObj = o;
				prevSelObj = o;
			}

			browser.setButtonAttribute(div, "selected", selObjs.indexOf(o) != -1)

			name = o.obj.id; // name
			if (o.obj.watch)
				name = name.substr(7);
			if (o.id)
				name += " <span class='descrR'>"+o.id+"<span>";
			else if (o.obj.dAttr!=null && o.attrValues[o.obj.dAttr]) {
				var lab = o.attrValues[o.obj.dAttr].replace(/<br>/g," ");
				name += " <span class='descrR'>"+lab+"<span>";
			}
			/*
			if (l>0) {
				var spacer = "";
				//for (k=0; k<l-1; k++) spacer += "<img src='/manager/pic/empty.png' width=25 height=15>";
				spacer += "<img src='/manager/pic/arrowi.png' width=25 height=15>";
				name = spacer + name;
			}
			*/
			if (o == c) {
				name = "<img src='/manager/pic/arrowu.png' width=15 height=25>" + name;
			} else if (c != activePage) {
				name = "<img src='/manager/pic/arrowi.png' width=25 height=15>" + name;
			}

			name = "<div class='label'>"+name+"</div><br style='clear:both'>";
			div.innerHTML = name;
			n++;
		}
		objsPanel.list.scrollTop = st;
	} // refreshObjsListPanel()

	// focus objs list
	this.focusObjsListPanel = function (c) {
		if (c == null) {
			// panel visible?
			if (objsPanel.list.style.display == "none") return;
			// no page? done
			if (!activePage) return;
			// no obj? done
			if (!activeObj) return;
			// update
			var c = activePage;
		}
		var e;
		for (var i=0; i<objsPanel.list.childNodes.length; i++) {
			e = objsPanel.list.childNodes[i];
			if (activeObj == c.objs[objsPanel.list.childNodes.length-i-1]) {
				if (e && e.offsetTop != null && e.parentNode.offsetTop != null)
					e.parentNode.scrollTop = e.offsetTop - e.parentNode.offsetTop;
				return;
			}
		}
		/*
		var k;
		for (var i=c.objs.length-1; i>=0; i--) {
			var div = objsPanel.list.childNodes[n];

			if (activeObj == c.objs[i]) {
				var y = Math.round(h - objsPanel.list.offsetHeight/2 + div.offsetHeight/2);
				objsPanel.list.scrollTop = y;
				return true; // found
			}

			h += div.offsetHeight;
			n++;
			if (c.objs[i].isContainer && !c.objs[i].isInclude)
				if (this.focusObjsListPanel(c.objs[i],n,h))
					return true;
		}
		*/
		return false;
	} // focusObjsListPanel()

	// --------------------------------------------------------------------------------------------------------------------------
	// Layout -------------------------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	// adjust project editor layout. viewport size
	this.adjustLayout = function () {
		if (!manager.viewportWidth || !manager.viewportHeight) return;

		var	vw = manager.viewportWidth;
		var	vh = manager.viewportHeight;

		bgE.style.display = (activePage == null)?"none":"inline";
		contentE.style.display = (activePage == null)?"none":"inline";
		helpersE.style.display = (activePage == null)?"none":"inline";

		this.adjustPanels();

		// tool bar size
		var tbW = 201; // left one
		var tbH = 36; // top one

		// editable area size
		var eW = vw - tbW;
		var eH = vh - tbH;

		toolbarE.style.left = (tbW-1)+"px"; // +1, attach it to the iconPanel
		toolbarE.style.width = (eW+1)+"px";

		document.getElementById("pe_warnings").style.maxHeight = (eH-70)+"px";
		document.getElementById("cameraValues").style.maxHeight = (eH-200)+"px";

		var b = 7;
		document.getElementById("pe_sourcePanel").style.left = (tbW+b)+"px";
		document.getElementById("pe_sourcePanel").style.top = (tbH+b)+"px";
		document.getElementById("pe_sourcePanel").style.width = (eW-b*2)+"px";
		document.getElementById("pe_sourcePanel").style.height = (eH-b*2)+"px";

		document.getElementById("pe_sourcePanelText").style.left = (10)+"px";
		document.getElementById("pe_sourcePanelText").style.top = (20)+"px";
		document.getElementById("pe_sourcePanelText").style.width = (eW-42)+"px";
		document.getElementById("pe_sourcePanelText").style.height = (eH-62)+"px";

		// no active page?
		if (!activePage) return;

		var border = 20; // canvas border

		// kiosk? for background classes, etc
		editorE.className = "hsc"+(project.kiosk?" kiosk":"");

		// page size
		var pw = activePage.width;
		var ph = activePage.height;
		var pm = [10,0,0,5]; // page margins
		var bgw;
		var bgh;
		if (activePage.obj.id == "popup") {
			pm = dictionary.margin.popup;
		} else if (activePage.obj.id == "_watch_page") {
			pm = [4,4,4,4];
		} else if (activePage.orientation=="portrait") {
			pm = dictionary.margin[project.kiosk?"kiosk":project.isPageCompact(project.width2,project.height2)?"compact":"standard"];
		} else {
			pm = dictionary.margin[project.kiosk?"kiosk":project.isPageCompact(project.width,project.height)?"compact":"standard"];
		}
		bgw = pw+pm[1]+pm[3];
		bgh = ph+pm[0]+pm[2];

		// container size
		var cow = activeContainer.width;
		var coh = activeContainer.height;
		// exceeds page limit?
		if (false && !activeContainer.isPage) {
			if (cow + activeContainer.ax > pw+border)
				cow = pw+border-activeContainer.ax;
			if (coh + activeContainer.ay > ph+border)
				coh = ph+border-activeContainer.ay;
		}

		editorE.style.left = tbW+"px";
		editorE.style.top = tbH+"px";
		editorE.style.width = eW+"px";
		editorE.style.height = eH+"px";

		bgPageE.style.width = bgw+"px";
		bgPageE.style.height = bgh+"px";

		var phE = document.getElementById("pageheader");
		var pfE = document.getElementById("pagefooter");
		phE.style.top = "0px";
		pfE.style.bottom = "0px";
		phE.style.display = (!project.kiosk)?"inline":"none";
		pfE.style.display = (!project.kiosk && project.isPageCompact(pw,ph))?"inline":"none";

		var p = bgPopupE.getElementsByTagName("div")[0];
		//p.style.display = "block";
		p.style.width = (pw+8)+"px";
		p.style.height = ph+"px";

		p = bgWatchE;
		//p.style.display = "block";
		p.style.width = (pw)+"px";
		p.style.height = ph+"px";

		contentE.style.overflow = (activePage.obj.id == "popup")?"visible":"hidden"; // overflow visible on popups

		contentE.style.width = bgw+"px";
		contentE.style.height = bgh+"px";

		helpersContentE.style.width = cow+"px";
		helpersContentE.style.height = coh+"px";

		xSnapE.style.height = (ph)+"px";
		xSnapE.style.top = "0px";
		ySnapE.style.width = pw+"px";

		if (vw > 0) {
			var left = Math.round((eW-bgw)/2);
			var top = Math.round((eH-bgh)/2);
			if (left < border) left = border;
			if (top < border) top = border;

			bgPageE.style.left = left+"px";
			bgPageE.style.top = top+"px";

			bgPopupE.style.left = left+"px";
			bgPopupE.style.top = top+"px";

			bgWatchE.style.left = left+"px";
			bgWatchE.style.top = top+"px";

			contentE.style.left = left+"px";
			contentE.style.top = top+"px";

			left += pm[3];
			top += pm[0];

			this.pageContentE.style.left = pm[3]+"px";
			this.pageContentE.style.top = pm[0]+"px";
			// for later use, on mouse/touch events
			this.pageContentE._left = pm[3];
			this.pageContentE._top = pm[0];

			var w = pw+left+border;
			var h = ph+top+border;
			w = (w>eW)?w:eW;
			h = (h>eH)?h:eH;
			helpersE.style.width =
			clickE.style.width = w+"px";
			helpersE.style.height =
			clickE.style.height = h+"px";

			if (browser.browser == "Explorer") {
				clickE.style.background = "url('/manager/pic/empty.png')";
			}

			if (activeContainer && !activeContainer.isPage) {
				left += activeContainer.ax;
				top += activeContainer.ay;
			}

			helpersContentE.style.left = left+"px";
			helpersContentE.style.top = top+"px";
		}
	} // adjustLayout()

	// adjust the panels
	this.adjustPanels = function () {
		if (!manager.viewportWidth || !manager.viewportHeight) return;

		var vw = manager.viewportWidth;
		var vh = manager.viewportHeight;
		var bh = 37; // buttons height
		var tp = 93;

		projectPanel.panel.style.top =
		pagesPanel.panel.style.top =
		objsPanel.panel.style.top = bh+"px";

		projectPanel.setHeight(vh-tp);
		pagesPanel.setHeight(vh-tp);
		objsPanel.setHeight(vh-tp);
	} // adjustPanels()

	// --------------------------------------------------------------------------------------------------------------------------
	// Events -------------------------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	// on project list select
	this.onProjectListSelect = function (event,i) {
		try {
			event.preventDefault();
		} catch(e) {}

		this.loadProject(this.projects[i]);
	} // onProjectListSelect()

	// on pages list select
	this.onPagesListSelect = function (event,i) {
		try {
			event.preventDefault();
		} catch(e) {}

		selectPage(project.pages[i]);
	} // onPagesListSelect()

	// on objs list select
	this.onObjsListSelect = function (event,i) {
		try {
			event.preventDefault();
		} catch(e) {}

		var ids = i.split(".");

		var c = activePage;
		var k = 0;
		var o = null;

		var cs = []; // containers to open

		for (k=0; k<ids.length; k++) {
			o = c.objs[ids[k]*1];
			if (k<ids.length-1) {
				cs.push(o);
				c = o;
			}
		}

		// current container selected? close it
		if (o == activeContainer) {
			// close containers
			this.closeAllContainers();
			for (k=0; k<cs.length; k++)
				this.openContainer(cs[k]);
		} else if (o) {
			if (o == activeObj && o.isContainer)
				this.openContainer(o);
		}
		selectObj(o);
	} // onObjsListSelect()

	// on objs add select
	this.onObjsAddSelect = function (event,i) {
		try {
			event.preventDefault();
		} catch(e) {}

		if (!activePage) return; // no page

		var oi = dictionary.objs[i].getInstance();

		if (activeContainer.isPage)
			this.pageContentE.appendChild(oi.div);
		else
			activeContainer.div.childNodes[2].appendChild(oi.div);

		if (oi.obj.id == "background") {
			activeContainer.addObj(oi,0);
			activeContainer.redraw();
		} else {
			activeContainer.addObj(oi);
			oi.redraw();
		}

		this.updateWatchObjs();
		this.initObjsListPanel();
		selectObj(oi);
		this.checkObjectWarnings(oi);
		addUndoState("obj_new", [oi]);
	} // onObjsAddSelect()

	// on page duplicate
	this.onPageDuplicate = function () {
		if (!activePage) return; // no page

		if (activePage.obj.id == "menu" || activePage.obj.id == "overlay") {
			this.cloneActivePage();
		} else {
			manager.openPopup('duplicatepage',true);
			focusElement(manager.cPopup.data.input["n"]);
		}
	} // onPageDuplicate()

	// on active page delete (button event)
	this.onActivePageDelete = function () {
		if (!activePage) return; // no page

		addUndoState("page_del", activePage);
		this.delActivePage();
	} // onActivePageDelete()

	// on project duplicate
	this.onProjectDuplicate = function () {
		manager.openPopup('duplicateproject',true);
		manager.cPopup.data.input["n"].value = project.name+"_copy";
		focusElement(manager.cPopup.data.input["n"]);
	} // onProjectDuplicate()

	// on pages add select
	this.onPagesAddSelect = function (event,type) {
		try {
			event.preventDefault();
		} catch(e) {}

		var page = this.addPage(type);
		selectPage(page);
		this.selectTab("pages", "edit");
		addUndoState("page_new", page);
	} // onObjsAddSelect()

	// panel open/close
	this.onPanelSelect = function (panel,event) {
		if (event) try {event.preventDefault()} catch(e) {}

		if (!project && panel != 'm') return; // no project
		if (!activePage && panel == 'o') return; // no page

		// deselect object
		if (panel != 'o')
			selectNone();

		projectPanel.show(panel == 'm');
		pagesPanel.show(panel == 'p');
		objsPanel.show(panel == 'o');

		switch (panel) { // copied from this.selectTab
		case "m": projectPanel.selectTab("list"); break;
		case "p": pagesPanel.selectTab(project.pages.length?"list":"add"); break;
		case "o": objsPanel.selectTab(activePage.objs.length?"list":"add"); break;
		}

		selectedPanel = panel;
		this.updatePanelIcons();
		this.adjustPanels();
	} // onPanelSelect()

	// update top left icons
	this.updatePanelIcons = function () {
		// TODO:save them
		var divs = document.getElementById("pe_iconPanel").getElementsByTagName("img");
		// projects
		divs[0].style.display = (selectedPanel == 'm')?"inline":"none";
		divs[1].style.display = (selectedPanel != 'm')?"inline":"none";
		// pages
		divs[2].style.display = (project && selectedPanel == 'p')?"inline":"none"; // on
		divs[3].style.display = (project && selectedPanel != 'p')?"inline":"none"; // selected
		divs[4].style.display = (!project)?"inline":"none"; // disabled
		// objs
		divs[5].style.display = (project && activePage && selectedPanel == 'o')?"inline":"none"; // on
		divs[6].style.display = (project && activePage && selectedPanel != 'o')?"inline":"none"; // selected
		divs[7].style.display = (!project || !activePage)?"inline":"none"; // disabled
	} // updatePanelIcons89

	this.onToolbarSelect = function (w) {
		if (w == 'project') {
			projectEditor.closeAllContainers();
			selectNone();
			projectEditor.onPanelSelect('p');
			projectEditor.selectTab("pages","list");
		} else if (w == 'page') {
			projectEditor.closeAllContainers();
			selectNone();
			projectEditor.onPanelSelect('o')
			projectEditor.selectTab("objs","list");
		} else if (w == 0) {
			projectEditor.onPanelSelect('o')
			projectEditor.selectTab("objs","edit");
		} else {
			// close n containers
			var c;
			for (var i=0; i<w; i++) {
				c = activeContainer;
				projectEditor.closeContainer();
			}
			selectObj(c);
			projectEditor.onPanelSelect('o')
			projectEditor.selectTab("objs","edit");
		}
	} // onToolbarSelect()

	// get frame button based on coords
	function getFrameBt(x,y) {
		var frameBt = "";
		var bw = 30;
		var bh = 30;
		var dw = 0;
		var dh = 0;

		var s = (selObjs.length == 1 && !selMode); // no buttons (just open/close container) when more objects are selected or in selMode

		if (activeObj) {
			var aox = (activeObj.x!=null)?activeObj.x:0;
			var aoy = (activeObj.y!=null)?activeObj.y:0;
			var aow = activeObj.width?activeObj.width:activePage.width;
			var aoh = activeObj.height?activeObj.height:activePage.height;

			var bx,by,bsx,bsy;
			dw = ((activeObj.obj.deltaWidth)?activeObj.obj.deltaWidth:0);
			dh = ((activeObj.obj.deltaHeight)?activeObj.obj.deltaHeight:0);
			// remove. top right
			if (!activeObj.isInclude) {
				bx = aox + aow + dw;
				by = aoy - bh;
				if (s &&
					x >= bx && x <= bx+bw &&
					y >= by && y <= by+bh) {
					frameBt = "x";
				}
			}
			// resize. bottom right
			if (s && activeObj.obj.minWidth != null) {
				bx = aox + aow + dw;
				by = aoy + aoh + dh;
				if (x >= bx && x <= bx+bw &&
					y >= by && y <= by+bh) {
					frameBt = "r";
				}
			}
			// move (line)
			else if (s && activeObj.endPoint != null) {
				bx = aox + activeObj.startPoint[0] -10;
				by = aoy + activeObj.startPoint[1] -10;
				if (x >= bx && x <= bx+bw &&
					y >= by && y <= by+bh) {
					frameBt = "sp";
				} else {
					bx = aox + activeObj.endPoint[0] -10;
					by = aoy + activeObj.endPoint[1] -10;
					if (x >= bx && x <= bx+bw &&
						y >= by && y <= by+bh) {
						frameBt = "ep";
					}
				}
			}
			// open. bottom left
			if (s && activeObj.obj.closedBy != null) {
				bx = aox - bw;
				by = aoy + aoh;
				if (x >= bx && x <= bx+bw &&
					y >= by && y <= by+bh) {
					frameBt = "o";
				}
			}
			// position. top left
			bx = aox - bw;
			by = aoy - bh;
			if (s && x >= bx && x <= bx+bw &&
				y >= by && y <= by+bh) {
				frameBt = "p";
			}
		}
		// close
		if (!frameBt && !activeContainer.isPage) {
			bx = -bw;
			by = activeContainer.height + dh;
			if (x >= bx && x <= bx+bw &&
				y >= by && y <= by+bh) {
				frameBt = "c";
			}
		}

		return frameBt;
	} // getFrameBt()

	// --------------------------------------------------------------------------------------------------------------------------
	// Events Handling ----------------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	function onTouchStart(event) {
		clickE.focus();
		if (event.touches.length == 1) { // one finger
			onMouseDown(event);
		}
	}

	function onTouchMove(event) {
		if (event.touches.length == 1) { // one finger
			try {
				event.preventDefault();
			} catch(e) {}
			onMouseMove(event);
		} else if (event.touches.length>1) {
			return; // default scrolling
		}
	}

	// element, this.name, this.parameter array
	function onTouchEnd(event) {
		if (event.touches.length == 0) { // no fingers
			onMouseUp(event);
		}
	}

	// mouse down event
	function onMouseDown(event) {
		// event target
		var evt = window.event || event;

		if (!browser.iDevice) try { evt.preventDefault(); } catch(e) {}

		if (!activePage) return;

		var p = browser.getMouseRelativePosition(event, contentE);
		var x = p.x - foo.pageContentE._left - activeContainer.ax;
		var y = p.y - foo.pageContentE._top - activeContainer.ay;
		x += editorE.scrollLeft;
		y += editorE.scrollTop;

		if (x == null || y == null) return;

		x = Math.round(x); // HACK: needed?
		y = Math.round(y);

		moving = false;
		resizing = false;
		selecting = false;
		movingPoint = false;

		downX = lastX = x;
		downY = lastY = y;

		// detect clicked frame button functions (close, resize..)
		var frameBt = getFrameBt(x,y);

		// frame bt?
		if (frameBt) {
			switch(frameBt) {
			case "x":
				foo.delSelObjs();
				skipClickUpEvent = true;
				break;
			case "r":
				resizing = true;
				var aox = (activeObj.x!=null)?activeObj.x:0;
				var aoy = (activeObj.y!=null)?activeObj.y:0;
				var aow = activeObj.width?activeObj.width:activePage.width;
				var aoh = activeObj.height?activeObj.height:activePage.height;
				downDx = aox-x + aow;
				downDy = aoy-y + aoh;
				break;
			case "sp":
			case "ep":
				movingPoint = frameBt;
				var aox = (activeObj.x!=null)?activeObj.x:0;
				var aoy = (activeObj.y!=null)?activeObj.y:0;
				var p = activeObj[movingPoint == "sp" ? "startPoint" : "endPoint"];
				var pox = p && p[0] ? p[0] : 0;
				var poy = p && p[1] ? p[1] : 0;
				downDx = pox-x+aox;
				downDy = poy-y+aoy;
				break;
			case "o":
				foo.openContainer(activeObj);
				downX = downY = null; // force a button lift
				skipClickUpEvent = true;
				break;
			case "c":
				foo.closeContainer();
				downX = downY = null; // force a button lift
				skipClickUpEvent = true;
				break;
			case "p":
				if (activeObj.posMode == "rc") {
					activeObj.posMode = "xy";
					activeObj.updateXY(); // no params: uses r,c
				} else {
					activeObj.posMode = "rc";
					activeObj.updateRowColumn(); // no params: uses x,y
					activeObj.updateXY(); // update x,y also, so we can use fast positioning
				}
				activeObj.updatePos();
				foo.updateSelectedFrame();
				foo.refreshObjsEditPanel("pos");
				skipClickUpEvent = true;
				break;
			}
		} else {
			// detect clicked object
			var m = 5; // margin
			cycleObjs = []; // objects under the selected area, used on mouseup
			for (var i=0; i<activeContainer.objs.length; i++) {
				var o = activeContainer.objs[i];
				if (o.width && o.height && o.visible) {
					var dw = ((o.obj.deltaWidth)?o.obj.deltaWidth:0);
					var dh = ((o.obj.deltaHeight)?o.obj.deltaHeight:0);
					if (x >= o.x-m && x <= o.x+o.width+dw+m &&
						y >= o.y-m && y <= o.y+o.height+dh+m)
						cycleObjs.push(o);
				}
			}

			if (cycleObjs.length == 0) {
				if (!selMode) { // in selMode, we don't deselect
					selectNone();
					if (activeContainer == activePage) {
						foo.onPanelSelect('p');
						foo.selectTab("pages","edit");
					}
				}
				//foo.initObjsEditPanel();
			} else if (selMode) {
				selectObj(cycleObjs.last()); // select now
				cycleObjs = []; // do nothing on mouseup
				draggedObj = null;
			} else {
				// check if in the current selection
				var inSel = false;
				for (var i=0; i<selObjs.length; i++) {
					if (cycleObjs.indexOf(selObjs[i])!=-1) {
						activeObj = selObjs[i]; // activeObj is the one under the click
						inSel = true;
						break;
					}
				}
				// not in the current selection?
				if (!inSel) {
					selectObj(cycleObjs.last()); // select now
					cycleObjs = []; // do nothing on mouseup
				}
				draggedObj = activeObj;
			}

			// update the frame
			foo.updateSelectedFrame();

			if (draggedObj) {
				downDx = draggedObj.x-x;
				downDy = draggedObj.y-y;
				var rc = dictionary.calcRowColumn(x, y, draggedObj.obj.grid);
				downDr = draggedObj.r-rc.r;
				downDc = draggedObj.c-rc.c;
			}
		}
	} // onMouseDown()

	// mouse move event
	function onMouseMove(event) {
		// event target
		var evt = window.event || event;
		if (!activeContainer) return; // no page selected?

		try { evt.preventDefault(); } catch(e) {}

		var p = browser.getMouseRelativePosition(event, contentE);
		var x = p.x - foo.pageContentE._left - activeContainer.ax;
		var y = p.y - foo.pageContentE._top - activeContainer.ay;
		x += editorE.scrollLeft;
		y += editorE.scrollTop;

		x = Math.round(x); // HACK: needed?
		y = Math.round(y);

		// frame buttons over
		var frameBt = getFrameBt(x,y);
		selectedRemoveBtE.className = "frameBt"+((frameBt == "x")?" over":"");
		selectedResizeBtE.className = "frameBt"+((frameBt == "r")?" over":"");
		selectedOpenBtE.className = "frameBt"+((frameBt == "o")?" over":"");
		containerFrameCloseBtE.className = "frameBt"+((frameBt == "c")?" over":"");
		selectedLabelE.className = "frameBt"+((frameBt == "p")?" over":"");
		selectedStartPointBtE.className = "pointBt"+((frameBt == "sp")?" over":"");
		selectedEndPointBtE.className = "pointBt"+((frameBt == "ep")?" over":"");
		if (!activePage) return;
		if (downX == null || downY == null) return;
		if (!draggedObj && !resizing && !selMode && !movingPoint) return;
		if (activeObj && activeObj.isInclude) return;

		lastX = x;
		lastY = y;

		// pixel tolerance (snap in place)
		var t = (browser.iDevice)?10:0;
		if (!moving && !selecting && !movingPoint) {
			if (Math.abs(downX-x)>t || Math.abs(downY-y)>t) {
				if (selMode) {// start selecting
					selecting = true;
					selectRectE.style.left = x+"px";
					selectRectE.style.top = y+"px";
					selectRectE.style.width = "0px";
					selectRectE.style.height = "0px";
					selectRectE.style.display = "inline";
				} else if (!activeObj || !activeObj.obj.watch) { // start dragging
					moving = true;
				}
			} else {
				return;
			}
		}

		// selecting
		if (selecting) {
			var sx,sy,sw,sh;
			if (downX<x) {
				sx = downX;
				sw = x-downX;
			} else {
				sx = x;
				sw = downX-x;
			}
			if (downY<y) {
				sy = downY;
				sh = y-downY;
			} else {
				sy = y;
				sh = downY-y;
			}
			// select rect
			selectRectE.style.left = sx+"px";
			selectRectE.style.top = sy+"px";
			selectRectE.style.width = sw+"px";
			selectRectE.style.height = sh+"px";
			// objects under the rect
			var under = [];
			for (var i=0; i<activeContainer.objs.length; i++) {
				var o = activeContainer.objs[i];
				var dw = ((o.obj.deltaWidth)?o.obj.deltaWidth:0);
				var dh = ((o.obj.deltaHeight)?o.obj.deltaHeight:0);
				if (o.width && o.height && o.visible) {
					if (!(o.x > sx+sw ||
						 o.x+o.width+dw < sx ||
						 o.y > sy+sh ||
						 o.y+o.height+dh < sy))
						under.push(o);
				}
			}
			selObjsAdd = under;
			foo.updateSelectedFrame();
			if (snapEnabled)
				updateSnapPositions();
		}

		// resizing
		else if (resizing) {
			var snapshot = activeObj.toJSON();

			var w = x - activeObj.x + downDx;
			var h = y - activeObj.y + downDy;
			activeObj.width = w;
			activeObj.height = h;

			if (activeObj.fixedRatio)
				activeObj.height = parseInt(activeObj.width/activeObj.fixedRatio);

			// snap
			else if (snapEnabled) {
				var snap = {};
				// temporarely add delta size
				if (activeObj.obj.deltaWidth)
					w += activeObj.obj.deltaWidth;
				if (activeObj.obj.deltaHeight)
					h += activeObj.obj.deltaHeight;
				// get new size
				if (activeObj.posMode == "rc") {
					var r = dictionary.calcRowColumn(activeObj.x + w, activeObj.y + h, activeObj.obj.grid);
					r = dictionary.calcXY(r.r, r.c, activeObj.obj.grid);
					var br = dictionary.calcXY(1,1,activeObj.obj.grid); // base
					if (Math.abs(activeObj.x + w - r.x - br.x)<5) {
						snap.x = r.x-br.x;
						w = r.x - br.x*2 - activeObj.x;
					}
					if (Math.abs(activeObj.y + h - r.y - br.y)<5) {
						snap.y = r.y-br.y;
						h = r.y - br.y*2 - activeObj.y;
					}
				} else {
					snap = foo.getSnap(activeObj.x+w, activeObj.y+h, 5);
					if (snap.x) w = snap.x - activeObj.x;
					if (snap.y) h = snap.y - activeObj.y;
				}
				// remove delta size
				if (activeObj.obj.deltaWidth)
					w -= activeObj.obj.deltaWidth;
				if (activeObj.obj.deltaHeight)
					h -= activeObj.obj.deltaHeight;
				// apply size
				if (snap.x) {
					activeObj.width = w;
					xSnapE.style.display = "inline";
					xSnapE.style.left = (snap.x-1)+"px";
				} else {
					xSnapE.style.display = "none";
				}
				if (snap.y) {
					activeObj.height = h;
					ySnapE.style.display = "inline";
					ySnapE.style.top = (snap.y-1)+"px";
				} else {
					ySnapE.style.display = "none";
				}
			}

			if (activeObj.obj.maxWidth) {
				if (activeObj.width > activeObj.obj.maxWidth) {
					activeObj.width = activeObj.obj.maxWidth;
					xSnapE.style.display = "none";
				}
				if (activeObj.height > activeObj.obj.maxHeight) {
					activeObj.height = activeObj.obj.maxHeight;
					ySnapE.style.display = "none";
				}
			}
			if (activeObj.obj.minWidth) {
				if (activeObj.width < activeObj.obj.minWidth) {
					activeObj.width = activeObj.obj.minWidth;
					xSnapE.style.display = "none";
				}
				if (activeObj.height < activeObj.obj.minHeight) {
					activeObj.height = activeObj.obj.minHeight;
					ySnapE.style.display = "none";
				}
			}

			activeObj.updateSizeAttributes();

			activeObj.redraw();
			foo.updateSelectedFrame();
			foo.refreshObjsEditPanel("width");
			foo.refreshObjsEditPanel("height");

			// undo state. type, objs, previous snapshots
			addUndoState("attr_update",[activeObj],[snapshot]);
		} // resizing

		// moving
		else if (moving) {
			// if moving when multi selected, switch all to xy
			if (selObjs.length>1) {
				for (var i=0; i<selObjs.length; i++) {
					if (selObjs[i].posMode == "rc") {
						selObjs[i].posMode = "xy";
						selObjs[i].updateXY(); // no params: uses r,c
					}
				}
			}

			// xy coords
			if (draggedObj.posMode == "xy") {
				x += downDx;
				y += downDy;
				// snap?
				if (snapEnabled) {
					// delta (now used only for line)
					var dx = 0;
					var dy = 0;
					if (draggedObj.obj.id == "line") {
						dx = draggedObj.startPoint[0];
						dy = draggedObj.startPoint[1];
						x += dx;
						y += dy;
					}
					// position snap, top left corner
					var snap = foo.getSnap(x,y,5);
					// try with endpoint
					if (draggedObj.obj.id == "line" && snap.x == null && snap.y == null) {
						x -= dx; // undo
						y -= dy;
						dx = draggedObj.endPoint[0];
						dy = draggedObj.endPoint[1];
						x += dx;
						y += dy;
						snap = foo.getSnap(x,y,5);
					}
					// position + size snap, bottom right corner
					if (snap.x == null) {
						if (draggedObj.obj.deltaWidth)
							x += draggedObj.obj.deltaWidth;
						var snapS = foo.getSnap(x + draggedObj.width,null,5);
						if (snapS.x != null) {
							x = snapS.x - draggedObj.width;
							snap.x = snapS.x;
						}
						if (draggedObj.obj.deltaWidth)
							x -= draggedObj.obj.deltaWidth;
					} else {
						x = snap.x;
					}
					if (snap.y == null) {
						if (draggedObj.obj.deltaHeight)
							y += draggedObj.obj.deltaHeight;
						var snapS = foo.getSnap(null,y + draggedObj.height,5);
						if (snapS.y != null) {
							y = snapS.y - draggedObj.height;
							snap.y = snapS.y;
						}
						if (draggedObj.obj.deltaHeight)
							y -= draggedObj.obj.deltaHeight;
					} else {
						y = snap.y;
					}
					// snaps?
					if (snap.x != null) {
						xSnapE.style.display = "inline";
						xSnapE.style.left = (snap.x-1)+"px";
						xSnapE.style.top = (-activeContainer.ay)+"px";
					} else {
						xSnapE.style.display = "none";
					}
					if (snap.y != null) {
						ySnapE.style.display = "inline";
						ySnapE.style.top = (snap.y-1)+"px";
						ySnapE.style.left = (-activeContainer.ax)+"px";
					} else {
						ySnapE.style.display = "none";
					}
					x -= dx;
					y -= dy;
				}

				// single
				if (selObjs.length == 1) {
					var snapshot = draggedObj.toJSON();
					draggedObj.setPosition(x,y);
					// row/column coords from x/y
					draggedObj.updateRowColumn();
					draggedObj.fixPos(); // checkPos and fix it if necessary
					draggedObj.updatePos(); // update position, redraw or set coordinates
					// undo state. type, objs, previous snapshots
					addUndoState("attr_update",[draggedObj],[snapshot]);
				} else { // multi, move all by delta
					var dx = x-draggedObj.x;
					var dy = y-draggedObj.y;
					var uo = []; // objects, for undo state
					var us = []; // snapshots, for undo state
					for (var i=0; i<selObjs.length; i++) {
						uo.push(selObjs[i]);
						us.push(selObjs[i].toJSON());
						selObjs[i].setPosition(selObjs[i].x + dx, selObjs[i].y + dy);
						// row/column coords from x/y
						selObjs[i].updateRowColumn();
						selObjs[i].fixPos(); // checkPos and fix it if necessary
						selObjs[i].updatePos(); // update position, redraw or set coordinates
					}
					// undo state. type, objs, previous snapshots
					addUndoState("attr_update",uo,us);
				}
			} else {
				var snapshot = draggedObj.toJSON();
				var cr = dictionary.calcRowColumn(x, y, draggedObj.obj.grid);
				draggedObj.r = cr.r + downDr;
				draggedObj.c = cr.c + downDc;

				// x/y from row/column
				draggedObj.updateXY();
				draggedObj.fixPos(); // checkPos and fix it if necessary
				draggedObj.updatePos(); // update position, redraw or set coordinates
				// undo state. type, obj, previous snapshot
				addUndoState("attr_update",[draggedObj],[snapshot]);
			}

			foo.updateSelectedFrame();
			foo.refreshObjsEditPanel("pos");
			if (draggedObj.obj.id == "line") {
				foo.refreshObjsEditPanel("xy");
				foo.refreshObjsEditPanel("xyla");
			}
		} // moving

		else if (movingPoint) {
			var _x = x + downDx;
			var _y = y + downDy;

			// snap?
			if (snapEnabled) {
				// position snap, top left corner
				var snap = foo.getSnap(_x,_y,5);
				// snaps?
				if (snap.x != null) {
					_x = snap.x;
					xSnapE.style.display = "inline";
					xSnapE.style.left = (snap.x-1)+"px";
					xSnapE.style.top = (-activeContainer.ay)+"px";
				} else {
					xSnapE.style.display = "none";
				}
				if (snap.y != null) {
					_y = snap.y;
					ySnapE.style.display = "inline";
					ySnapE.style.top = (snap.y-1)+"px";
					ySnapE.style.left = (-activeContainer.ax)+"px";
				} else {
					ySnapE.style.display = "none";
				}
			}

			activeObj.attrValues[movingPoint == "sp" ? 0 : 1] = "x"+_x+"y"+_y;
			activeObj[movingPoint == "sp" ? "startPoint" : "endPoint"] = [_x,_y];
			activeObj.reset();

			foo.refreshObjsEditPanel("xy");
			foo.refreshObjsEditPanel("xyla");
		}
	} // onMouseMove()

	// mouse up event
	function onMouseUp(event) {
		// event target
		var evt = window.event || event;

		if (!browser.iDevice) try { evt.preventDefault(); } catch(e) {}

		if (!activePage) return;

		downX = downY = null;

		// snap lines visible only when dragging
		xSnapE.style.display = "none";
		ySnapE.style.display = "none";

		if (skipClickUpEvent) { // clicked on a button
			skipClickUpEvent = false;
			return;
		}
		if (resizing) {
			resizing = false;
			return;
		}
		selectRectE.style.display = "none"; // could be visible even if selecting is false, when mouseup outside window
		if (selecting) {
			selecting = false;
			selObjs = getUnionSelObjs();
			if (selObjs.length)
				selectObj(activeObj?activeObj:selObjs[0],true); // reselect and update the panels, true:just refresh
			selObjsAdd = [];
			updateObjToolButtons();
			updateToolbarTitle();
			return;
		}
		// moving?
		if (moving) {
			moving = false;
			draggedObj = null;
			return;
		}
		// moving points?
		if (movingPoint) {
			movingPoint = false;
			return;
		}
		var x = lastX;
		var y = lastY;
		if (x == null || y == null) return;

		// if we get here, we clicked in the same spot: deselect or select next object
		if (cycleObjs.length && activeObj) {
			// cycle
			var i = cycleObjs.indexOf(activeObj);
			if (i!=-1) { // can it happen?
				activeObj = null;
				if (i>0) {
					selectObj(cycleObjs[i-1]); // pick the next one
					foo.selectTab("objs","edit");
					foo.focusObjsListPanel();
					draggedObj = activeObj;
				} else {
					selectNone();
					foo.onPanelSelect('p');
					foo.selectTab("pages","edit");
				}
			}
			// just one
			/*
			if (!activeObj || cycleObjs.length == 1) {
				if (selObjs.length == 1 && activeObj == cycleObjs.last())
					selectNone() // deselect all
				else
					selectObj(cycleObjs.last()); // select it
				if (selObjs.length) {
					foo.selectTab("objs","edit");
					foo.focusObjsListPanel();
				} else {
					foo.onPanelSelect('p');
					foo.selectTab("pages","edit");
				}
			}
			*/
		}
	} // onMouseUp()

	// key down
	this.onKeyDown = function (e, code, target) {
		// source > hsm. ctrl + shift + h
		if (e.ctrlKey && e.shiftKey && code == 72) {
			hscMode = !hscMode;
			document.getElementById("sourceButton").getElementsByTagName("span")[0].innerHTML = hscMode?"hsc":"source";
			manager.hideQuickAppsPanel(true); // quick apps panel opened on ctrl+shift, hide it (true: cancel switching)
			return false;
		}

		// shift, select mode? selMode: null, key, bt
		if (e.shiftKey && !selMode)
			foo.toggleSelMode("key");

		// enter
		if (manager.cPopup) {
			if (manager.cPopup.id == "choosefile") {
				fileManager.onKeyDown(e, code, target);
			} else {
				if (code == 13) { // return
				switch (manager.cPopup.id) {
					case "duplicatepage":
						if (focusedElement == manager.cPopup.data.input["n"])
							foo.cloneActivePage();
						break;
					case "duplicateproject":
						if (focusedElement == manager.cPopup.data.input["n"])
							foo.projectEditor.cloneProject();
						break;
					}
				}
				return; // popup open
			}
		}

		if (manager.cPopup) return; // no other keypress events while popups are open

		if (project && project.name && !manager.cPopup) {
			// ctrl/cmd s
			if (code == 83 && (e.ctrlKey || e.metaKey)) {
				browser.preventDefault(e);
				projectEditor.saveProject();
				return;
			}
			// ctrl c
			if (String.fromCharCode(code) == "C" && (e.ctrlKey || e.metaKey) && activeObj) {
				if ((browser.OS != "Mac" || e.metaKey) && focusedElement) { // ctrl+c on fields
					return;
				}
				browser.preventDefault(e);
				projectEditor.copySelObjs();
				return;
			}
			// ctrl x
			if (String.fromCharCode(code) == "X" && (e.ctrlKey || e.metaKey) && activeObj) {
				if ((browser.OS != "Mac" || e.metaKey) && focusedElement) { // ctrl+x on fields
					return;
				}
				browser.preventDefault(e);
				projectEditor.cutSelObjs();
				return;
			}
			// ctrl v
			if (String.fromCharCode(code) == "V" && (e.ctrlKey || e.metaKey)) {
				if ((browser.OS != "Mac" || e.metaKey) && focusedElement) { // ctrl+v on fields
					return;
				}
				browser.preventDefault(e);
				projectEditor.pasteObjs();
				return;
			}
			// ctrl z
			if (String.fromCharCode(code) == "Z" && (e.ctrlKey || e.metaKey)) {
				if ((browser.OS != "Mac" || e.metaKey) && focusedElement) { // ctrl+z on fields
					return;
				}
				browser.preventDefault(e);
				projectEditor.undo();
				return;
			}
		}

		// ctrl/cmd s
		if (code == 83 && (e.ctrlKey || e.metaKey)){
			browser.preventDefault(e);
			return; // no project, not allowed
		}

		if (selectedPanel == 'p') {
			if (pagesPanel.selectedPane == "list") {
				switch (code) {
				case 37: // left
				case 38: // up
					browser.preventDefault(e);
					if (selectedPageI>0) {
						selectPage(project.pages[selectedPageI-1]);
						projectEditor.focusPagesListPanel();
					}
					break;
				case 39: // right
				case 40: // down
					browser.preventDefault(e);
					if (selectedPageI<project.pages.length-1) {
						selectPage(project.pages[selectedPageI+1]);
						projectEditor.focusPagesListPanel();
					}
					break;

				case 65: // a
					browser.preventDefault(e);
					projectEditor.moveActivePage(1);
					projectEditor.focusPagesListPanel();
					break;
				case 90: // z
					browser.preventDefault(e);
					projectEditor.moveActivePage(-1);
					projectEditor.focusPagesListPanel();
					break;
				}
			}
		} else if (selectedPanel == 'o') {
			if (objsPanel.selectedPane == "list") {
				switch (code) {
				case 68: // d
					browser.preventDefault(e);
					if (activeObj) {
						projectEditor.delSelObjs();
					}
					break;
				case 37: // left
				case 38: // up
					browser.preventDefault(e);
					if (prevSelObj && prevSelObj!=activeObj) {
						var p = prevSelObj;
						if (p.parentObj != activeContainer) {
							projectEditor.closeAllContainers();
							// containers to open
							var oc = [];
							var o = p;
							while (!o.parentObj.isPage) {
								o = o.parentObj;
								oc.push(o);
							}
							for (var i=oc.length-1; i>=0; i--)
								projectEditor.openContainer(oc[i]);
						}
						selectObj(p);
						projectEditor.focusObjsListPanel();
					}
					break;
				case 39: // right
				case 40: // down
					browser.preventDefault(e);
					if (nextSelObj && nextSelObj!=activeObj) {
						var n = nextSelObj;
						if (n.parentObj != activeContainer) {
							projectEditor.closeAllContainers();
							// containers to open
							var oc = [];
							var o = n;
							while (!o.parentObj.isPage) {
								o = o.parentObj;
								oc.push(o);
							}
							for (var i=oc.length-1; i>=0; i--)
								projectEditor.openContainer(oc[i]);
						}
						selectObj(n);
						projectEditor.focusObjsListPanel();
					}
					break;

				case 65: // a
					browser.preventDefault(e);
					projectEditor.moveZ(1);
					break;
				case 90: // z
					browser.preventDefault(e);
					projectEditor.moveZ(-1);
					break;
				}
			} else if (objsPanel.selectedPane == "edit") {
				if (focusedElement) return; // field focused
				if (!activeObj) return;
				switch (code) {
				case 68: // d
					browser.preventDefault(e);
					projectEditor.delSelObjs();
					break;
				case 37: // left
					browser.preventDefault(e);
					moveSelObjs(4, e.shiftKey==1?10:1);
					break;
				case 38: // up
					browser.preventDefault(e);
					moveSelObjs(1, e.shiftKey==1?10:1);
					break;
				case 39: // right
					browser.preventDefault(e);
					moveSelObjs(2, e.shiftKey==1?10:1);
					break;
				case 40: // down
					browser.preventDefault(e);
					moveSelObjs(3, e.shiftKey==1?10:1);
					break;

				case 65: // a
					browser.preventDefault(e);
					projectEditor.moveZ(1);
					break;
				case 90: // z
					browser.preventDefault(e);
					projectEditor.moveZ(-1);
					break;
				}
			}
		}
	} // onKeyDown()

	// key up
	this.onKeyUp = function (e, code, target) {
		// shift, select mode? selMode: null, key, bt
		if (!e.shiftKey && selMode == "key")
			foo.toggleSelMode("");
	} // onKeyUp()

	init();
} // ProjectEditor()


// project editor panel
function ProjectEditorPanel(name) {
	this.name = name;

	this.panel = document.getElementById("pe_"+name+"Panel");

	var t = document.getElementById("pe_"+name+"PanelTitle");
	this.title = t.getElementsByTagName("div")[0];

	this.content = document.getElementById("pe_"+name+"PanelContents");

	var listBt = document.getElementById("pe_"+name+"PanelListBt");
	var editBt = document.getElementById("pe_"+name+"PanelEditBt");
	var addBt = document.getElementById("pe_"+name+"PanelAddBt");

	this.list = document.getElementById("pe_"+name+"PanelList");
	this.edit = document.getElementById("pe_"+name+"PanelEdit");
	this.add = document.getElementById("pe_"+name+"PanelAdd");

	this.listBts = document.getElementById("pe_"+name+"PanelListBts");
	this.editBts = document.getElementById("pe_"+name+"PanelEditBts");
	this.addBts = document.getElementById("pe_"+name+"PanelAddBts");

	this.addFields = []; // TODO: only project uses it
	this.editFields = [];

	this.isOpen = true;

	this.selectedPane = null;

	// show/hide. true/false
	this.show = function (s) {
		if (s == this.isOpen) return;
		this.isOpen = s;
		this.panel.style.display = s?"":"none";
	} // show()

	// set tabs height
	this.setHeight = function (h) {
		// list on pages and objs is shorter
		this.list.style.height = (this.listBts?h-30:h)+"px";
		this.edit.style.height = (this.editBts?h-30:h)+"px";
		this.add.style.height = (this.addBts?h-30:h)+"px";
	} // setHeight()

	// select tab
	this.selectTab = function (tab) {
		this.selectedPane = tab;
		this.list.style.display = (tab=="list")?"block":"none";
		this.edit.style.display = (tab=="edit")?"block":"none";
		this.add.style.display = (tab=="add")?"block":"none";
		browser.setButtonAttribute(listBt,"selected",(tab=="list"));
		browser.setButtonAttribute(editBt,"selected",(tab=="edit"));
		browser.setButtonAttribute(addBt,"selected",(tab=="add"));
		if (this.listBts)
			this.listBts.style.display = (tab=="list")?"block":"none";
		if (this.editBts)
			this.editBts.style.display = (tab=="edit")?"block":"none";
		if (this.addBts)
			this.addBts.style.display = (tab=="add")?"block":"none";
	} // selectTab()
} // ProjectEditorPanel()

//--------------------------------------------------------------------------------------------------------------------------
// List Panel --------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------

//list panel. list panel element, assigner (ex: =), separator (ex: ;) (used to compose and parse the string)
function ListPanel(e,assigner,separator) {
	var foo = this;

	var tseparator = separator?separator.trim():"";

	// div that will contain the list
	this.e = e;
	// this variable
	this.name = e.getAttribute("name");

	this.list = []; // list [{nameE:[], valueE:[]},..]
	this.values = {}; // possible values ["name":{type:"type", values:["value1","value2",..]},..]

	// save them so they can be used with prototype function stringToArray
	this.assigner = assigner;
	this.separator = separator;

	// two divs, attr and add
	for (var i=0; i<e.childNodes.length; i++) {
		if (e.childNodes[i].attributes)
		switch (e.childNodes[i].getAttribute("name")) {
			case "attr": this.attrE = e.childNodes[i].cloneNode(true); break;
			case "add": this.addE = e.childNodes[i].cloneNode(true); break;
		}
	}
	// clean
	this.e.innerHTML = "";
	this.e.appendChild(this.addE);

	// set values
	this.setValues = function (values) {
		this.values = values;
		this.valuesChanged = true;
		for (var i=0; i<this.list.length; i++) {
			this.updateValues(i,true);
		}
	} // setValues()

	this.updateValues = function (i,wipe) {
		var item = this.list[i];
		var o,k,t,a;
		// select
		if (assigner) { // no assigner? just a list, no select
			// names
			if (wipe) { // changed?
				item.selNameE.innerHTML = "<option value='' selected='true'>Select Attribute</option>"; // quickly remove
				a = []; // autocomplete
				for (k in this.values) {
					o = document.createElement('option');
					o.text =
					o.value = k;
					try {
						item.selNameE.add(o, null); // standards compliant; doesn't work in IE
					} catch(e) {
						item.selNameE.add(o, 0); // IE only
					}
					a.push(k);
				}
				browser.initAutocomplete(item.nameE, "list:"+a.join("|"));
				item.selNameE.parentNode.className = (a.length?"selectIcon":"selectIcon disabled");
			}
			// values
			if (item.lastName != item.nameE.value) { // changed?
				item.lastName = item.nameE.value;
				item.selValueE.innerHTML = "<option value='' selected='true'>Select Value</option>"; // quickly remove
				a = []; // autocomplete
				if (this.values[item.lastName] && this.values[item.lastName].values) {
					for (t=0; t<this.values[item.lastName].values.length; t++) {
						o = document.createElement('option');
						o.text =
						o.value = this.values[item.lastName].values[t];
						try {
							item.selValueE.add(o, null); // standards compliant; doesn't work in IE
						} catch(e) {
							item.selValueE.add(o, 0); // IE only
						}
						a.push(this.values[item.lastName].values[t]);
					} // for
				} // if
				browser.initAutocomplete(item.valueE, "list:"+a.join("|"));
				item.selValueE.parentNode.className = (a.length?"selectIcon":"selectIcon disabled");
			} // if
			this.checkValue(i);
		}
	} // updateValues()

	// init item
	this.initItem = function (item,i) {
		// init events
		if (assigner) { // no assigner? just a list
			item.selNameE.onchange = new Function("event",this.name+".onNameSelChange(event,this,"+i+")");
			item.selValueE.onchange = new Function("event",this.name+".onValueSelChange(event,this,"+i+")");
		}

		item.nameE.onkeydown = new Function("event",this.name+".onNameKeyDown(event,this,"+i+")");
		if (assigner) // no assigner? just a list
			item.valueE.onkeydown = new Function("event",this.name+".onValueKeyDown(event,this,"+i+")");

		item.nameE.onblur = new Function("event",this.name+".updateValues("+i+",false)");
		if (assigner) // no assigner? just a list
			item.valueE.onblur = new Function("event",this.name+".updateValues("+i+",false)");

		// add and setup
		browser.initButtonEvents(item.delBtE, {onclick:this.name+".del("+i+")"});
	} // initItem()

	// add to the list
	this.add = function () {
		var e = this.attrE.cloneNode(true);
		this.e.insertBefore(e, this.addE);

		// index
		var i = this.list.length;

		// list item
		var item = {e:e};
		var d = e.getElementsByTagName("input");
		item.nameE = d[0];
		if (assigner) { // no assigner? just a list
			item.valueE = d[1];
			d = e.getElementsByTagName("select");
			item.selNameE = d[0];
			item.selValueE = d[1];
		}
		d = e.getElementsByTagName("div");
		item.delBtE = d[0];


		item.lastName = null; // to check if changed
		item.lastValue = null; // to check if changed

		this.list.push(item);
		this.initItem(item,i);
		this.updateValues(i,true);

		focusElement(item.nameE);
	} // add()

	// del from list
	this.del = function (i) {
		this.e.removeChild(this.list[i].e);
		this.list.splice(i,1);
		if (i < this.list.length) { // wasn't last element
			for (var k=0; k<this.list.length; k++)
				this.initItem(this.list[k],k);
		}
	} // del()

	// clear all
	this.clear = function () {
		while (this.list.length)
			this.del(0);
	} // clear()

	this.onNameSelChange = function (event,e,i) {
		if (!e.value) return; // no value
		this.list[i].nameE.value = e.value;
		this.updateValues(i, false);
		e.selectedIndex = 0; // always reset
	} // onNameSelChange()

	this.onValueSelChange = function (event,e,i) {
		if (!e.value) return; // no value
		this.list[i].valueE.value = e.value;
		this.updateValues(i, false);
		e.selectedIndex = 0; // always reset
	} // onValueSelChange()

	this.onNameKeyDown = function (event,e,i) {
		// event
		var evt = window.event || event;
		var code = evt.keyCode || evt.charCode || evt.which;
		switch (code) {
		case 8: // backspace
			if (this.list[i].nameE.value == "") {
				try { evt.preventDefault(); } catch(e) {}
				if (i>0) {
					if (assigner)
						focusElement(this.list[i-1].valueE);
					else
						focusElement(this.list[i-1].nameE);
				}
				if (!assigner || this.list[i].valueE.value == "") // delete if empty
					this.del(i);
			}
			break;
		case 9: // tab
		case 13: // enter
			try { evt.preventDefault(); } catch(e) {}
			if (assigner) {
				if (!evt.shiftKey)
					focusElement(this.list[i].valueE);
				else if (i>0)
					focusElement(this.list[i-1].valueE); // previous
			} else {
				if (!evt.shiftKey) {
					if (i<this.list.length-1)
						focusElement(this.list[i+1].nameE);
					else
						this.add();
				} else if (i>0) {
					focusElement(this.list[i-1].nameE);
				}
			}
			break;
		case 27: // esc
			try { evt.preventDefault(); } catch(e) {}
			loseFocus();
			break;
		}
	} // onNameKeyDown()

	this.onValueKeyDown = function (event,e,i) {
		// event
		var evt = window.event || event;
		var code = evt.keyCode || evt.charCode || evt.which;

		switch (code) {
		case 8: // backspace
			if (this.list[i].valueE.value == "") {
				try { evt.preventDefault(); } catch(e) {}
				focusElement(this.list[i].nameE);
			}
			break;
		case 9: // tab
		case 13: // enter
			try { evt.preventDefault(); } catch(e) {}
			if (!evt.shiftKey) {
				if (i<this.list.length-1)
					focusElement(this.list[i+1].nameE);
				else
					this.add();
			} else {
				focusElement(this.list[i].nameE);
			}
			break;
		case 27: // esc
			try { evt.preventDefault(); } catch(e) {}
			loseFocus();
			break;
		}
	} // onValueKeyDown()

	// check value
	this.checkValue = function (i) {
		if (!this.values[this.list[i].lastName]) return;
		var v = this.list[i].valueE.value.trim();
		var t = this.values[this.list[i].lastName].type;
		switch(t) {
		case "cssSize":
		case "cssPosition":
			var n = v.replace( /[\D]/g , ""); // remove other characters
			if (n == "" && v != "auto") {
				v = n;
			} else if (v != "auto") {
				if (v.charAt(0) == "-" && t == "cssPosition")
					n = -n;
				if (v.indexOf("%")!=-1)
					v = n+"%";
				else if (v.indexOf("em")!=-1)
					v = n+"em";
				else
					v = n+"px";
			}
			break;
		case "cssColor":
			if (v.search(/[A-Fa-f0-9]{6}|[A-Fa-f0-9]{3}/) == 0)
				v = "#"+v;
			break;
		}
		this.list[i].valueE.value = v;
	} // checkValue()

	// update from string
	this.fromString = function (str) {
		this.clear();
		// parse
		var a = this.stringToArray(str);
		// add items
		for (var i=0; i<a.length; i++) {
			this.add();
			if (assigner) {
				this.list[i].nameE.value = a[i][0];
				this.list[i].valueE.value = a[i][1];
			} else {
				this.list[i].nameE.value = a[i];
			}
			this.updateValues(i, false);
		}
	} // fromString()

	// list to string
	this.toString = function () {
		var str = "";
		var arr = [];
		for (var i=0; i<this.list.length; i++) {
			if (!this.list[i].nameE.value.trim()) continue;
			this.checkValue(i); // check all values when getting string
			arr.push([
				this.list[i].nameE.value,
				this.list[i].valueE.value
			]);
		}

		return this.arrayToString(arr);
	} // toString()
} // ListPanel()

// array from string
// declare it on prototype, so we can use it for watchData
ListPanel.prototype.stringToArray = function (str,assigner,separator) {
	if (!assigner)
		assigner = this.assigner;
	if (!separator)
		separator = this.separator;

	var tseparator = separator?separator.trim():"";

	// parse
	str = str.trim();
	var a = []; // result
	if (str) {
		a = assigner?[["",""]]:[""]; // lines
		var cl = 0; // current line
		var cf = 0; // current field (0 name, 1 value)
		var escape = false;
		var c; // char
		for (var i=0; i<str.length; i++) {
			c = str[i];
			switch (c) {
			case "\\":
				escape = !escape;
				if (!escape) {
					if (assigner)
						a[cl][cf] += c; // second \, add it
					else
						a[cl] += c;
				}
				break;
			case assigner:
				if (!escape && assigner) {
					cf++; // next field
				} else {
					if (assigner)
						a[cl][cf] += c; // escaped, add it
					else
						a[cl] += c;
					escape = false;
				}
				break;
			case tseparator:
				if (!escape) {
					cf = 0; // back to name
					if (assigner) {
						a[cl][0] = a[cl][0].trim();
						a[cl][1] = a[cl][1].trim();
						if (a[cl][0] != "") {
							cl++; // next line
							a[cl] = ["",""];
						}
					} else {
						a[cl] = a[cl].trim();
						if (a[cl] != "") {
							cl++; // next line
							a[cl] = [""];
						}
					}
					break; // otherwise continue
				} else {
					if (assigner)
						a[cl][cf] += c; // escaped, add it
					else
						a[cl] += c;
					escape = false;
				}
				break;
			default:
				if (assigner)
					a[cl][cf] += c; // escaped, add it
				else
					a[cl] += c;
				escape = false;
			}
		}
		// correct last one
		if (assigner) {
			if (a[cl][0] == "") {
				a.pop();
			} else {
				a[cl][0] = a[cl][0].trim();
				a[cl][1] = a[cl][1].trim();
			}
		} else {
			if (a[cl] == "") {
				a.pop();
			} else {
				a[cl] = a[cl].trim();
			}
		}
	}
	// done
	return a;
}

ListPanel.prototype.arrayToString = function (arr,assigner,separator) {
	var tseparator;
	// add \ in front of \, assigner and separator
	function escape(str) {
		var c;
		var r = "";
		for (var i=0; i<str.length; i++) {
			c = str[i];
			if (c == "\\" || c == assigner || c == tseparator)
				r += "\\";
			r += c;
		}
		return r;
	}

	if (!assigner)
		assigner = this.assigner;
	if (!separator)
		separator = this.separator;

	tseparator = separator?separator.trim():"";

	var str = "";
	for (var i=0; i<arr.length; i++) {
		if (i) str += separator;

		if (assigner)
			str += escape(arr[i][0]) + assigner + escape(arr[i][1]);
		else
			str += escape(arr[i][0]);
	}
	return str;
}



//--------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
// FileManager -------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------

// file manager class
function FileManager() {
	var started = false; // if already started, will just switch
	this.open = false; // currently open. set by start, hide

	// upload progress
	var uploadProgressReq = new XMLReq();
	var uploadReq; // xmlHTTPRequest for upload

	// warnings? (events.txt)
	var warningsReq = new XMLReq();
	this.warnings = []; // warnings
	this.warningsInterval = 5000; // check every n ms
	this.warningsLimit = 100;

	this.rootPath = ""; // root folder. never changes?

	this.currentPath = ""; // path
	this.currentFile = ""; // current file, full path
	this.currentFolder = null; // contents of the current folder (array)
	this.folderTs = 0; // timestamp
	this.filesInFolder = 0; // number of files in folder, from data (currentFolder)

	this.filter = null; // reg exp

	this.selectedItem = -1; // currently selected item (or last selected item if multiple)
	this.selectedItems = []; // for multiple selection

	// multiple file selection
	var selMode; // null, key, bt

	// save copy, move data to resend on overwrite confirm
	var copyData = [];
	var moveData = [];

	this.dirsPanelWidth = 0; // width of the dir panel

	this.popupMode = false; // open in popup
	this.popupData = {
		currentPath : "", // path
		currentFile : "", // current file, full path
		currentFolder : null, // contents of the current folder (array)
		folderTs : 0, // folder timestamp
		filter : null, // view file filter
		replace : [], // replaces once file is chosen
		rootPath: "", // folder root (can't go up)
		defaultPath: "", // default root (start browsing from here)
		selectedItem : -1 // currently selected item
	}

	this.uploadCheckInterval = null; // interval to check the current upload

	this.editorOpen = false;
	this.editorFontSize = 12;
	this.editorScrollTop = null; // saved when hidden, restored on save
	this.editorChanged = false;
	this.editorTs = 0; // current opened file last modified timestamp

	this.logPreviewVisible = false; // is log visible?

	this.uploading = false; // upload panel will be visible
	this.uploadProgressVisible = false; // will be visible for a while after uploading is done
	var uploadData = {}; // upload data, filename, size
	this.uploadDoneTimeout = null; // timeout to close the panel when done
	var formDataSupport = (!!window.FormData); // support for xmlhttpreq upload method

	var selectOnRefresh; // item to select {path:..., name:...}

	this.e = document.getElementById("fileManager");

	var pathE = document.getElementById("fm_dirsPath");
	var pathPE = document.getElementById("fm_dirsPPath");

	var dirsHeaderE = document.getElementById("fm_dirsHeader");
	var dirsPanelE = document.getElementById("fm_dirsPanel");
	var dirsContentE = document.getElementById("fm_dirsContent");
	var dirsParentBtE = document.getElementById("fm_dirsParentBt");
	var dirsUploadBtE = document.getElementById("fm_dirsUploadBt");
	var dirsNewFileBtE = document.getElementById("fm_dirsNewFileBt");
	var dirsNewFolderBtE = document.getElementById("fm_dirsNewFolderBt");

	var dirsPHeaderE = document.getElementById("fm_dirsPHeader");
	var dirsPContentE = document.getElementById("fm_dirsPContent");
	var dirsPParentBtE = document.getElementById("fm_dirsPParentBt");
	var dirsPUploadBtE = document.getElementById("fm_dirsPUploadBt");
	var dirsPNewFolderBtE = document.getElementById("fm_dirsPNewFolderBt");

	var dirsPConfirmBtE = document.getElementById("fm_dirsPConfirmBt");

	var detailsContentE = document.getElementById("fm_detailsContent");
	var detailsPContentE = document.getElementById("fm_detailsPContent");

	var detailsPanelE = document.getElementById("fm_detailsPanel");
	var detailsPPanelE = document.getElementById("fm_detailsPPanel");

	var toolbarE = document.getElementById("fm_toolbar");

	var loadingE = document.getElementById("fm_dirsLoading");
	var loadingLabelE = document.getElementById("fm_dirsLoadingLabel");

	var loadingPE = document.getElementById("fm_dirsPLoading");

	var detailsSelE = document.getElementById("fm_detailsSel");
	var detailsSelNE = document.getElementById("fm_detailsSelN");
	var detailsTotE = document.getElementById("fm_detailsTot");
	var detailsNameE = document.getElementById("fm_detailsName");
	var detailsNameVE = document.getElementById("fm_detailsNameV");
	var detailsKindE = document.getElementById("fm_detailsKind");
	var detailsKindVE = document.getElementById("fm_detailsKindV");
	var detailsSizeE = document.getElementById("fm_detailsSizeV");

	var detailsPSelE = document.getElementById("fm_detailsPSel");
	var detailsPSelNE = document.getElementById("fm_detailsPSelN");
	var detailsPTotE = document.getElementById("fm_detailsPTot");
	var detailsPNameE = document.getElementById("fm_detailsPName");
	var detailsPNameVE = document.getElementById("fm_detailsPNameV");
	var detailsPKindE = document.getElementById("fm_detailsPKind");
	var detailsPKindVE = document.getElementById("fm_detailsPKindV");
	var detailsPSizeE = document.getElementById("fm_detailsPSizeV");

	var detailsDirIconE = document.getElementById("fm_detailsDirIcon");
	var detailsFileIconE = document.getElementById("fm_detailsFileIcon");
	var detailsFilesIconE = document.getElementById("fm_detailsFilesIcon");
	var detailsTextPreviewE = document.getElementById("fm_detailsTextPreview");
	var detailsFileIconOverE = document.getElementById("fm_detailsFileIconOver");
	var detailsImgPreviewE = document.getElementById("fm_detailsImgPreview");

	var detailsPDirIconE = document.getElementById("fm_detailsPDirIcon");
	var detailsPFileIconE = document.getElementById("fm_detailsPFileIcon");
	var detailsPFilesIconE = document.getElementById("fm_detailsPFilesIcon");
	var detailsPTextPreviewE = document.getElementById("fm_detailsPTextPreview");
	var detailsPFileIconOverE = document.getElementById("fm_detailsPFileIconOver");
	var detailsPImgPreviewE = document.getElementById("fm_detailsPImgPreview");

	var detailsBtOpenFolderE = document.getElementById("fm_detailsBtOpenFolder");
	var detailsBtEditE = document.getElementById("fm_detailsBtEdit");
	var detailsBtOpenVEE = document.getElementById("fm_detailsBtOpenVE");
	var detailsBtDeleteE = document.getElementById("fm_detailsBtDelete");
	var detailsBtRestartE = document.getElementById("fm_detailsBtRestart");
	var detailsBtMoveE = document.getElementById("fm_detailsBtMove");
	var detailsBtDuplicateE = document.getElementById("fm_detailsBtDuplicate");
	var detailsBtRenameE = document.getElementById("fm_detailsBtRename");
	var detailsBtDownloadE = document.getElementById("fm_detailsBtDownload");

	var uploadProgressPanelE = document.getElementById("fm_uploadProgressPanel");
	var uploadContentE = document.getElementById("fm_uploadContent");
	var uploadFileNameE = document.getElementById("fm_uploadFileName");
	var uploadBarE = document.getElementById("fm_uploadBar");
	var uploadProgressE = document.getElementById("fm_uploadProgress");
	var uploadBytesE = document.getElementById("fm_uploadBytes");
	var uploadFileFrameE =  document.getElementById("fm_uploadFileFrame");

	var uploadPFileNameE = document.getElementById("fm_uploadPFileName");
	var uploadPBarE = document.getElementById("fm_uploadPBar");
	var uploadPProgressE = document.getElementById("fm_uploadPProgress");
	var uploadPBytesE = document.getElementById("fm_uploadPBytes");

	var editorContentE = document.getElementById("fm_editorContent");
	var editorTitleE = document.getElementById("fm_editorTitle");
	var editorPanelE = document.getElementById("fm_editorPanel");
	var editorHeaderLabelE = document.getElementById("fm_editorHeaderLabel");
	var editorTextE = document.getElementById("fm_editorText");

	var editorLoadingE = document.getElementById("fm_editorLoading");

	var toolbarSaveBtE = document.getElementById("fm_toolbarSaveBt");

	var uploadFileFormE = document.getElementById("fm_uploadFileForm");
	var uploadFileInputE = document.getElementById("fm_uploadFileInput");

	// autocomplete
	this.codeAssistEnabled = true;
	this.aceEnabled = true;

	var self = this;

	// init
	function init() {
		self.aceEnabled = !browser.touchEventsSupported;
		if (self.aceEnabled) {
			self.editor = ace.edit("fm_editorText");
	        self.editor.setShowPrintMargin(false);
			self.editor.$blockScrolling = Infinity;
			self.editor.getSession().on('change', function(e) {
	            self.editorChanged = true;
	            updateEditorTitle();
	        });
			//self.editor.getSession().setUseWorker(false);
			self.toolTip = new TokenTooltip(self.editor);
		} else {
			var pe = document.getElementById("fm_editorText");
			var ta = document.createElement("textarea");
			var adiv = document.createElement("div");

			pe.appendChild(ta);

			ta.style.overflow = "scroll";
			ta.style.top = "0px";

			ta.style.width = "100%";
			ta.style.height = "100%";
			//
			ta.style.position = "absolute";
			ta.style.fontFamily = 'Monaco, "Lucida Console"';
			ta.style.fontSize = "12px";
			ta.style.lineHeight = "18px";
			ta.style.border = "none";
			ta.style.padding = "0";
			ta.style.mozTabSize =
			ta.style.oTabSize =
			ta.style.tabSize = "4";
			ta.style.WebkitOverflowScrolling = "touch";

			ta.addEventListener('input', function() {
				self.editorChanged = true;
	            updateEditorTitle();
  			}, false);

			self.editor = ta;
		}

		uploadProgressReq.onLoaded = onUploadProgressUpdate;
		uploadProgressReq.onAuthenticate = function (lock) {fileManager.onUploadProgressError(); showPin(lock);}; // showPin will stop apps
		uploadProgressReq.onNoAccess = function () {fileManager.onUploadProgressError(); manager.showErrorPopup("No access");};
		uploadProgressReq.onError = self.onUploadProgressError; // other errors, connection..

		warningsReq.retryOnErrorDelay = 3000; // retry on errors
		warningsReq.onLoaded = self.onWarningsUpdate;
		warningsReq.onAuthenticate = showPin; // showPin will stop apps
		warningsReq.onNoAccess = function () {manager.showErrorPopup("No access");};

		if (browser.iDevice) {
			dirsUploadBtE.style.display = "none";
			dirsPUploadBtE.style.display = "none";
		}

		selMode = "meh"; // force update
		self.toggleSelMode(""); // off by default

		// drag and drop?
		if ("draggable" in document.createElement('span')) {
			dirsContentE.ondragover = showDirsOver;
			dirsContentE.ondragend = showDirsOver;
			dirsContentE.ondragleave = showDirsLeave;
			dirsContentE.ondrop = onDirsContentDrop;

			dirsPContentE.ondragover = showDirsOver;
			dirsPContentE.ondragend = showDirsOver;
			dirsPContentE.ondragleave = showDirsLeave;
			dirsPContentE.ondrop = onDirsContentDrop;
		}

		updateToolbarPopupButtons();
	} // init()

	// start
	this.start = function () {
		manager.hideOtherApps("fm");

		this.e.style.display = "inline";

		this.adjustLayout();

		// loading popup?
		if (manager.cPopup && manager.cPopup.id == "loading")
			manager.closePopup();

		if (!started) {
			toolbarSaveBtE.style.display = "none";
			started = true;
			this.browseTo("");
		} else {
			this.browseTo(this.currentPath); // refresh

			// log preview
			if (this.logPreviewVisible)
				logViewer.startPreview(5);

			if (this.editorOpen) {
				timestampChecker.start();
				if (self.aceEnabled) {
					var sm = self.getSyntaxMode();
					if (sm == "events" || sm == "javascript")
						snippetDataManager.start();
				} else {
					if (this.editorScrollTop)
						this.editor.scrollTop = this.editorScrollTop;
					this.editorScrollTop = null;
				}
			}
		}

		this.focus();
		this.open = true;

		// 	timestampChecker started on browse
	} // start()

	// hide (switching to another app)
	this.hide = function () {
		timestampChecker.stop(); // pause

		this.e.style.display = "none";
		logViewer.stopPreview();

		manager.focus();

		// select mode? selMode: null, key, bt
		if (selMode == "key")
			self.toggleSelMode("");

		if (self.aceEnabled) {
			snippetDataManager.stop();
		} else {
			if (this.editorOpen) {
				this.editorScrollTop = this.editor.scrollTop;
			}
		}

		this.open = false;
	} // hide()

	// focus, restore key events
	this.focus = function () {
		if (window.focus) window.focus();
		manager.deselect();

		if (this.editorOpen && this.editor.focus) {
			this.editor.blur(); // refocus
			this.editor.focus();
		}
	} // focus()

	// adjust project editor layout. viewport size
	this.adjustLayout = function () {
		if (!manager.viewportWidth || !manager.viewportHeight) return;

		var	vw = manager.viewportWidth;
		var	vh = manager.viewportHeight;

		// tool bar size
		var tbW = 0; // left one
		var tbH = 36; // top one

		// editable area size
		var eW = vw - tbW;
		var eH = vh - tbH;

		toolbarE.style.left = (tbW-1)+"px"; // +1, attach it to the iconPanel
		toolbarE.style.width = (eW+1)+"px";

		// panels
		var bs = 1; // border size
		var pm = 5+bs; // panel margin: padding + border size
		var pd = 7; // panel distance from border
		var pw = Math.round((vw-pd*3-pm*4)/2); //;
		var ph = vh-tbH-pm*2-pd*2;
		if (pw<340) pw = 340;
		this.dirsPanelWidth = pw; // used in adjustFileNames

		document.getElementById("fm_warnings").style.maxHeight = (eH-70)+"px";

		// detail, upload, log panels
		var upH = 0;
		var lpH = 140; // log panel height
		var lpW = pw+pm*2; // = pw minus the panel margin
		var upH = 70; // upload panel height
		var dpH = ph;
		if (this.logPreviewVisible) 	dpH -= lpH+pd;
		var edH = dpH; // same as details, without the upload progress
		if (this.uploadProgressVisible) dpH -= upH+pm*2+pd;

		dirsPanelE.style.left = (pd)+"px";
		dirsPanelE.style.top = (tbH+pd)+"px";
		dirsPanelE.style.width = pw+"px";
		dirsPanelE.style.height = ph+"px";

		uploadProgressPanelE.style.left =
		detailsPanelE.style.left = (pd*2+pm*2+pw)+"px";
		detailsPanelE.style.top = (tbH+pd)+"px";

		pw = (vw-pd*3-pm*4) -pw; // fix it: since it's /2, pw could be 1 pixel wider

		uploadProgressPanelE.style.width =
		detailsPanelE.style.width = pw+"px";
		detailsPanelE.style.height = dpH+"px";

		uploadProgressPanelE.style.height = upH+"px";
		uploadProgressPanelE.style.top = (tbH+pd+pm*2+pd+dpH)+"px";

		dirsContentE.style.height = (vh-144-pm)+"px";
		loadingE.style.height = (vh-144-pm)+"px";

		loadingLabelE.style.left = Math.round((dirsContentE.offsetWidth-70)/2)+"px";

		uploadContentE.style.left = Math.round((pw-250)/2)+"px";
		detailsContentE.style.left = Math.round((pw-360)/2)+"px";

		// details content top, we move contents down max 30px from top
		var dfs = (detailsPanelE.offsetHeight - detailsContentE.offsetHeight)/2-30;
		dfs = Math.round(dfs<40?dfs:40);

		detailsContentE.style.top = dfs+"px";

		var eW = vw-pm*2-pd*2; // full content width

		editorPanelE.style.left = (pd)+"px";
		editorPanelE.style.top = (tbH+pd)+"px";
		editorPanelE.style.width = (eW)+"px";
		editorPanelE.style.height = (edH)+"px";

		editorTextE.style.width = (eW)+"px";
		editorTextE.style.height = (edH-30)+"px";

		editorLoadingE.style.left = Math.round((eW - 70)/2)+"px";

		// mini icons?
		browser.miniButton(dirsUploadBtE, pw<370);
		browser.miniButton(dirsNewFileBtE, pw<370);
		browser.miniButton(dirsNewFolderBtE, pw<370);

		// log preview / editor
		if (this.logPreviewVisible) {
			var lpT = tbH+pd+edH+pm*2+pd;
			logViewer.panelShape.y = lpT;
			if (!this.editorOpen) {
				logViewer.panelShape.x = detailsPanelE.offsetLeft;
				logViewer.panelShape.width = lpW;
				logViewer.panelShape.height = lpH;
			} else {
				logViewer.panelShape.x = editorPanelE.offsetLeft;
				logViewer.panelShape.width = (vw-pd*2);
				logViewer.panelShape.height = lpH;
			}
			logViewer.adjustLayout();
		}

		adjustFileNames();
		adjustHeader();
	} // adjustLayout()

	// update edit toolbar popup buttons
	function updateToolbarPopupButtons() {
		document.getElementById("selectButtonFm").style.display = self.editorOpen?"none":"";
		document.getElementById("downloadBackupButton").style.display = self.editorOpen?"none":"";
		document.getElementById("toggleCommentButton").style.display = self.editorOpen?"":"none";
		document.getElementById("codeAssistButton").style.display = self.editorOpen?"":"none";
		if (self.editorOpen) {
			browser.enableButton(document.getElementById("toggleCommentButton"),self.aceEnabled && self.getSyntaxMode());
			browser.enableButton(document.getElementById("codeAssistButton"),self.aceEnabled && self.getSyntaxMode());
			document.getElementById("editor_search_replace_bts").style.display = self.aceEnabled?"":"none";
		}
	}

	// toggle selection mode. mode:null (toggle "bt"/null), "key", "" (null)
	this.toggleSelMode = function (mode) {
		var v = selMode;
		if (mode)
			selMode = mode;
		else if (mode === "")
			selMode = null;
		else
			selMode = selMode?null:"bt"; // toggle
		// changed?
		/*
		if (v != selMode) {
			// button
			document.getElementById("selectButton").getElementsByTagName("img")[0].style.display = selMode?"inline":"none";
			document.getElementById("selectButton").getElementsByTagName("img")[1].style.display = selMode?"none":"inline";
		}
		*/
	} // toggleSelMode()


	// toggle comment, from button
	this.toggleComment = function () {
		fileManager.editorChanged = true;
		updateEditorTitle();

		if (!self.aceEnabled)
			return;

		var s = self.editor.session;
		var Range = ace.require("ace/range").Range;
		var sr = s.selection.lead.row;
		var er = s.selection.anchor.row;

		if (sr > er) {
			var t = sr;
			sr = er;
			er = t;
		}

		var comm = self.getSyntaxMode() == "javascript" ? "//" : "#";

		var comment = true;
		var line;
		// check if we need to comment or uncomment
		for (var i=sr; i<=er; i++) {
			line = s.getLine(i);
			if (line.substr(0,comm.length) == comm) {
				comment = false;
				break;
			}
		}

		// add or remove comment
		var commLine = false; // comment on line?
		for (var i=sr; i<=er; i++) {
			line = s.getLine(i);
			commLine = (line.substr(0,comm.length) == comm);
			if (comment && !commLine) {
				s.insert({row:i,column:0},comm);
			} else if (!comment && commLine) {
				s.remove(new Range(i, 0, i, comm.length));
			}
		}

		// fix selection
	};

	// enable/disable autocomplete
	this.setAutocomplete = function (e) {
		if (!self.aceEnabled)
			return;
		this.codeAssistEnabled = !this.codeAssistEnabled;
		document.getElementById("codeAssistButton").getElementsByTagName("img")[0].style.display = this.codeAssistEnabled?"inline":"none";
		document.getElementById("codeAssistButton").getElementsByTagName("img")[1].style.display = this.codeAssistEnabled?"none":"inline";

		this.editor.setOptions({
	        enableBasicAutocompletion: true,
	        enableSnippets: true,
	        enableLiveAutocompletion: this.codeAssistEnabled
	    });
	};

	// show / hide loading
	this.showLoading = function (show) {
		var lE = (this.popupMode)?loadingPE:loadingE;
		lE.style.display = show?"inline":"none";
		// bts are enabled only when folder is loaded

		var dirsUE = (this.popupMode)?dirsPUploadBtE:dirsUploadBtE;
		var dirsFoE = (this.popupMode)?dirsPNewFolderBtE:dirsNewFolderBtE;
		var dirsFiE = (this.popupMode)?null:dirsNewFileBtE;

		browser.enableButton(dirsUE, !show);
		browser.enableButton(dirsFoE, !show);
		if (dirsFiE) browser.enableButton(dirsFiE, !show);
	} // showLoading()

	// browse to folder
	this.browseTo = function (folder) {
		timestampChecker.stop(); // pause it, we resume when we receive: onList
		var o = this.popupMode?this.popupData:this;
		if (o.currentPath != folder) {
			o.currentPath = folder;
			o.currentFolder = null;
			this.selectItem(-1);
		}
		this.showFolderSel(); // remove highlighted in background
		this.showLoading(true);
		files.load("list",folder);
		this.updatePath();
	} // browseTo()

	// browse to parent folder
	this.parentFolder = function () {
		var o = this.popupMode?this.popupData:this;
		if (!o.currentPath) return;
		var a = o.currentPath.split("/");
		var n = a.pop();
        var p = a.join("/");
        selectOnRefresh = {path:p, name:n};
		this.browseTo(p);
	} // parentFolder()

	// show folder contents. data
	this.showFolder = function (data) {
		var o = this.popupMode?this.popupData:this;
		var dirsCE = (this.popupMode)?dirsPContentE:dirsContentE;
		var dirsPE = (this.popupMode)?dirsPParentBtE:dirsParentBtE;
		var dirsUE = (this.popupMode)?dirsPUploadBtE:dirsUploadBtE;
		var dirsFoE = (this.popupMode)?dirsPNewFolderBtE:dirsNewFolderBtE;
		var dirsFiE = (this.popupMode)?null:dirsNewFileBtE;

		var st = 0; // scroll top
		if (data) {
			o.currentFolder = data;
			o.folderTs = data[4];
			o.filesInFolder = data[2].length;
		} else { // if no data, we're just refreshing (show uploading file)
			data = o.currentFolder;
			st = dirsCE.scrollTop;
		}

		// enable/disable buttons
		browser.enableButton(dirsUE, data!=null);
		browser.enableButton(dirsFoE, data!=null);
		if (dirsFiE)
			browser.enableButton(dirsFiE, data!=null);

		if (!data) {
			dirsCE.innerHTML = '<div class="fileItem mLineButton">Path not found.</div>';
		} else {
			// add uploading file?
			var ufp = -1; // uploaded file position
			if (this.open && this.uploading && uploadData.name) {
				if (this.currentPath == uploadData.path) {
					for (var i=0; i<data[2].length; i++) {
						if (uploadData.name==data[2][i][0]) {
							ufp = i;
							data[2][i][2]='';
							data[2][i][3]='-';
							break;
						} else if (uploadData.name.toLowerCase()<data[2][i][0].toLowerCase()) {
							ufp = i;
							data[2].splice(i,0,[uploadData.name,'f','','-']);
							break;
						}
					}
				}
				uploadData.index = ufp; // used on selectItem
			}

			// filter, remove unwanted files
			if (o.filter) {
				var p = o.currentPath?o.currentPath+"/":"";
				for (var i=0; i<data[2].length; i++) {
					// test paths and files
					if ((data[2][i][1]=='d' && (!o.filter.path || !o.filter.path.test(p+data[2][i][0]))) || // test paths to show
						(data[2][i][1]=='f' && (!o.filter.file || !o.filter.file.test(p+data[2][i][0])))) { // test files that can be selected
						data[2].splice(i,1);
						i--;
					}
				}
			}

			// gen html
			dirsCE.innerHTML = "";
			var e,h;
			for (var i=0; i<data[2].length; i++) {
				// file or dir
				if (data[2][i][1]=='f') {
					var icon = this.canEdit(i)?"bticontextfile":"bticonfile";
					h  = '<div class="icon"><img src="/manager/pic/'+icon+'.png" onmousedown="return false;"></div>';
					h += '<div class="name"></div>'; // set on adjustFileNames
					if (!this.popupMode)
						h += '<div class="modified">'+data[2][i][3]+'</div>';
					h += '<div class="size">'+manager.formatFS(data[2][i][2])+'</div>';
				} else {
					h  = '<div class="icon"><img src="/manager/pic/bticonfolder.png" onmousedown="return false;"></div>';
					h += '<div class="name"></div>';  // set on adjustFileNames
					if (!this.popupMode)
						h += '<div class="modified">'+data[2][i][3]+'</div>';
					h += '<div class="size"></div>';
				}

				e = document.createElement('div');
				e.innerHTML = h;

				e.className = "fileItem mLineButton"+(ufp==i?" disabled":"")+(o.selectedItems.indexOf(i)!=-1?" selected":"");

				browser.initButtonEvents(e,{onclick:"fileManager.selectItem("+i+")"});

				dirsCE.appendChild(e);
			}

			adjustFileNames();
		}
		adjustHeader();

		dirsPE.style.display = (o.currentPath!=o.rootPath)?"inline":"none";

		dirsCE.scrollTop = st;

		this.showLoading(false);

		// selected? update details
		if (!this.popupMode && this.selectedItem)
			this.showDetails();

		// auto select after uploading?
		if (selectOnRefresh) {
			if (selectOnRefresh.path == o.currentPath) {
				for (var i=0; i<data[2].length; i++) {
					if (selectOnRefresh.name==data[2][i][0]) {
						this.selectItem(i); // just uploaded, popup mode. select it
						break;
					}
				}
			}
			selectOnRefresh = null; // done
		}
	} // showFolder()

	// show details
	this.showDetails = function () {
		var o = this.popupMode?this.popupData:this;

		var detailsCE = (this.popupMode)?detailsPContentE:detailsContentE;

		var detailsTPE = (this.popupMode)?detailsPTextPreviewE:detailsTextPreviewE;
		var detailsDIE = (this.popupMode)?detailsPDirIconE:detailsDirIconE;
		var detailsFIE = (this.popupMode)?detailsPFileIconE:detailsFileIconE;
		var detailsFsIE = (this.popupMode)?detailsPFilesIconE:detailsFilesIconE;
		var detailsFIOE = (this.popupMode)?detailsPFileIconOverE:detailsFileIconOverE;
		var detailsIPE = (this.popupMode)?detailsPImgPreviewE:detailsImgPreviewE;

		var detailsSNE = (this.popupMode)?detailsPSelNE:detailsSelNE;
		var detailsTE = (this.popupMode)?detailsPTotE:detailsTotE;
		var detailsNE = (this.popupMode)?detailsPNameE:detailsNameE;
		var detailsNVE = (this.popupMode)?detailsPNameVE:detailsNameVE;
		var detailsKE = (this.popupMode)?detailsPKindE:detailsKindE;
		var detailsKVE = (this.popupMode)?detailsPKindVE:detailsKindVE;
		var detailsSE = (this.popupMode)?detailsPSizeE:detailsSizeE;

		if (o.selectedItem == -1) {
			detailsTPE.innerHTML = "";
			detailsIPE.style.display = "none";
			detailsIPE.style.visibility = "hidden";
		} else {
			var multi = (o.selectedItems.length>1);
			var i = o.selectedItem;
			var n = o.currentFolder[2][i][0];
			var t = multi?"multi":o.currentFolder[2][i][1];
			var p = o.currentPath+(o.currentPath?"/":"")+n;
			var r = /^www\/([^\/]*\/)?img\/[^\.]*\.(gif|jpe?g|png)$/; // www/(1 folder/)?img(anything but .)(extensions)
			// calculate size
			var s = 0;
			for (k=0; k<o.selectedItems.length; k++)
				s += o.currentFolder[2][o.selectedItems[k]][2]; // size
			var isImg = (!multi && t=="f" && r.test(p) && s<300000);

			detailsDIE.style.display = (t=="d" && !isImg)?"inline":"none";
			detailsFIE.style.display = (t=="f" && !isImg)?"inline":"none";
			detailsFsIE.style.display = (multi)?"inline":"none";
			detailsTPE.style.display = (t=="f" && !isImg && this.canEdit(i))?"inline":"none";
			detailsFIOE.style.display = (t=="f" && !isImg)?"inline":"none";

			detailsIPE.style.display = (isImg)?"inline":"none";
			detailsIPE.style.visibility = "hidden";
			if (isImg)
				detailsIPE.src = "/x/files?gv*"+files.encodeFileName(o.currentFile);
			else
				detailsIPE.src = "/manager/pic/empty.png";

			// load preview?
			detailsTPE.innerHTML = ""; // reset text preview, if any
			if (t=="f" && this.canEdit(i)) {
				files.load("gettextpreview",p);
			}

			detailsSNE.innerHTML = o.selectedItems.length;
			detailsTE.innerHTML = o.filesInFolder; // should use a var instead!!!
			detailsNE.style.display = multi?"none":"block";
			detailsNVE.innerHTML = multi?"":o.currentFolder[2][i][0];
			detailsKE.style.display = multi?"none":"block";
			detailsKVE.innerHTML = multi?"":this.getFileKind(p,t);
			detailsSE.innerHTML = (t=="d")?"-":manager.formatFS(s);

			if (!this.popupMode) {
				// special files, can't be deleted, renamed or moved
				var special = false;
				if (o.currentPath == "") {
					for (k=0; k<o.selectedItems.length; k++) {
						n = o.currentFolder[2][o.selectedItems[k]][0]; // name
						if (n == "hsyco.jar" ||
							n == "hsyco.ini" ||
							n == "access.ini") {
							special = true;
							break;
						}
					}
				}

				// buttons
				detailsBtOpenFolderE.style.display = (t=="d")?"inline":"none";
				detailsBtEditE.style.display = (!multi && this.canEdit(i))?"inline":"none";
				detailsBtOpenVEE.style.display = (!multi && p.search(/www\/[^\/]+\/index.hsm/) != -1)?"inline":"none";
				detailsBtDeleteE.style.display = (special)?"none":"inline";
				detailsBtRestartE.style.display = (!multi && o.currentPath+o.currentFile == "hsyco.jar")?"inline":"none";
				detailsBtMoveE.style.display = (special)?"none":"inline";
				detailsBtDuplicateE.style.display = (!multi)?"inline":"none";
				detailsBtRenameE.style.display = (multi || special)?"none":"inline";
				detailsBtDownloadE.style.display = (!multi)?"inline":"none";
			}
		}
		detailsCE.style.visibility = (o.selectedItem >= 0)?"visible":"hidden";
	} // showDetails()

	// adjust file names
	function adjustFileNames() {
		var o = self.popupMode?self.popupData:self;
		var dirsCE = (self.popupMode)?dirsPContentE:dirsContentE;

		var data = o.currentFolder;
		var ic = '<img src="/manager/pic/miniiconopen.png" class="openIcon">'; // open icon
		var w = self.popupMode?440:self.dirsPanelWidth;
		for (var i=0; i<dirsCE.childNodes.length; i++) {
			var e = dirsCE.childNodes[i];
			var c = self.canOpen(i); // can open
			// length
			var n = data[2][i][0];
			var n1 = "";
			var n2 = "";
			e.childNodes[1].innerHTML = n+(c?ic:"");
			while (w-e.childNodes[1].offsetWidth<260) { // 260 is calculated: minimum
				if (!n1) {
					n1 = n.substr(0,Math.round(n.length/2));
					n2 = n.substr(n1.length);
				}
				n1 = n1.substr(0,n1.length-1);
				n2 = n2.substr(1);
				if (n1=="" || n2=="") break;
				e.childNodes[1].innerHTML = n1+"..."+n2+(c?ic:"");
			}
		}
	} // adjustFileNames()

	// adjust files header
	function adjustHeader() {
		var dirsCE = (this.popupMode)?dirsPContentE:dirsContentE;
		var s = (dirsCE.scrollHeight>dirsCE.clientHeight);
		var hE = self.popupMode?dirsPHeaderE:dirsHeaderE;
		hE.getElementsByTagName("DIV")[1].style.marginRight = s?browser.scrollBarSize+"px":"";
	}

	// show selected, set classes
	this.showFolderSel = function () {
		var o = this.popupMode?this.popupData:this;
		var dirsCE = (this.popupMode)?dirsPContentE:dirsContentE;

		var s,t;
		for (var i=0; i<dirsCE.childNodes.length; i++) {
			browser.setButtonAttribute(dirsCE.childNodes[i], "selected", (o.selectedItems.indexOf(i)!=-1));
			browser.setButtonAttribute(dirsCE.childNodes[i], "disabled", (this.uploading && uploadData.index == i));
		}
	} // showFolderSel()

	// refresh folder contents (from timestampChecker)
	this.refreshFolder = function (txt) {
		var f = eval(txt);

		var o = this.popupMode?this.popupData:this;
		var dirsCE = (this.popupMode)?dirsPContentE:dirsContentE;

		var st = 0;
		if (o.currentFolder) {
			st = dirsCE.scrollTop; // refreshing
			if (o.currentFolder.toString() == f.toString()) {
				return; // nothing to do here, it's the same
			}
		}

		// keep selection?
		var sf = []; // saved filenames
		var k,n;
		var r = false; // reselect if anything changed
		for (var i=0; i<o.selectedItems.length; i++) {
			k = o.selectedItems[i];
			n = o.currentFolder[2][k][0];
			sf.push(n); // save filename
			// changed?
			if (!r && (f[2].length <= k || f[2][k][0] != n))
				r = true; // need to reselect so...
		}

		if (r)
			this.selectItem(-1); // deselect all

		this.showFolder(f);

		// restore selection?
		if (r) {
			var ts = []; // to select indexes
			for (var i=0; i<f[2].length; i++) {
				if (sf.indexOf(f[2][i][0]) != -1)
					ts.push(i);
			}
			// same number of selected items?
			if (ts.length == sf.length) {
				var s = selMode;
				selMode = "key"; // force multi selection
				for (var i=0; i<ts.length; i++)
					this.selectItem(ts[i]);
				selMode = s;
			}
		}

		// restore scrolling
		dirsCE.scrollTop = st;
	} // refreshFolder()

	// update path
	this.updatePath = function () {
		var o = this.popupMode?this.popupData:this;
		a = o.currentPath.split("/");
		if (o.rootPath)
			a.splice(0,o.rootPath.split("/").length); // so we start looping from the rooth

		var txt = "";
		var fun = ""; // functions
		var path = o.rootPath;
		var dir = o.rootPath?o.rootPath:"HSYCO Server";

		fun = 'data-onclick="fileManager.browseTo(\''+path+'\')"';
		txt += " <span class='mTextButton "+((o.currentPath!=o.rootPath)?"checked":"selected")+"' "+fun+">"+dir+"</span>";

		if (o.currentPath) {
			for (var i=0; i<a.length; i++) {
				dir = a[i];
				path += (path?"/":"")+dir;
				fun = 'data-onclick="fileManager.browseTo(\''+path+'\')"';
				txt += "&nbsp;&raquo;&nbsp;<span class='mTextButton "+((i<a.length-1)?"checked":"selected")+"' "+fun+">"+dir+"</span>";
			}
		}

		if (!this.popupMode) {
			pathE.innerHTML = txt;
			browser.initEvents(pathE);
		} else {
			pathPE.innerHTML = txt;
			browser.initEvents(pathPE);
		}
	}; // updatePath()

	// null (this.currentFile) or directory, file name, path array, file extension
	function isEventsFile(d,n,ap,ext) {
		if (!d) {
			var p = self.currentFile;
			ap = p.split("/");
			n = ap.pop(); // remove file name
			var an = n.split(".");
			ext = an[an.length-1];
		}

		if (!d && n=="events.txt")
			return true;

		if (ap && ap.length==2 && ap[0]=="plugins" && n=="events.txt")
			return true;

		if (ap && ap.length==3 && ap[0]=="plugins" && ap[2] == "events" && ext=="txt")
			return true;

		if (ap && ap[0] == "events" && ext=="txt")
			return true;

		return false;
	}

	// get file kind
	this.getFileKind = function (p,t) {
		if (t=="d") return "Folder";

		var ap = p.split("/");
		var n = ap.pop(); // remove file name
		var d = ap.join("/");
		var an = n.split(".");
		var ext = an[an.length-1];

		if (isEventsFile(d,n,ap,ext))
			return "Events File";

		switch (ext) {
		case "txt": return "Plain Text";
		case "xml": return "XML Document";
		case "ini": return "Ini File";
		case "jar": return "Java JAR File";
		case "jpg": case "jpeg": case "gif":
		case "png": return "Image";
		case "avi": return "Video";
		case "log": return "Log File";
		case "css": return "CSS Stylesheet";
		case "hsc": return "HSC File";
		case "hsm": return "Project File";
		default:
			if (an[an.length-2] == "log")
				return "Log File";
			return "Document";
		}
	} // getFileKind()

	// can open. index on currentFolder
	this.canOpen = function (i) {
		if (this.popupMode) return true; // can select all the files that are shown
		var o = this;
		var n = o.currentFolder[2][i][0]; // name
		var t = o.currentFolder[2][i][1]; // type
		if (t=="d") return true; // can open folders
		return this.canEdit(i);
	} // canOpen()

	// can edit
	this.canEdit = function (i) {
		if (this.popupMode) return false; // can't edit if popup
		var n = this.currentFolder[2][i][0]; // name
		var t = this.currentFolder[2][i][1]; // type
		if (t=="d") return false; // can't edit folders
		var s = this.currentFolder[2][i][2]; // size
		var p = this.currentPath+(this.currentPath?"/":"")+n; // full path
		var a = n.split(".");
		var e = (a.length>1)?a.pop():""; // extension
		var ee = (a.length>1)?a.pop():""; // extension
		switch (e) {
		case "ini": case "hsc": case "hsm": case "sh":
		case "csv": case "js": case "log":
		case "java": case "htm": case "html": case "txt": case "xml": case "css":
			return true;
		}
		if (ee == "log") return true; // .log.1 ..
		return false;
	} // canEdit()

	// select item. if i is null, select again
	this.selectItem = function (i) {
		var o = this.popupMode?this.popupData:this;
		var multi = selMode && !this.popupMode; // multiple selection not enabled in popup
		var okb = false; // ok button enabled (only in popup)
		if (i==null) i = o.selectedItem;
		if (i>=0) {
			if (this.uploading && uploadData.index == i) return; // can't select, it's still uploading
			var n = o.currentFolder[2][i][0];
			var t = o.currentFolder[2][i][1];
			var p = o.currentPath+(o.currentPath?"/":"")+n;
			if (o.selectedItem != i || multi) { // not selected or selecting multiple files?
				if (multi) {
					var k = o.selectedItems.indexOf(i);
					// selecting?
					if (k == -1) {
						o.selectedItem = i;
						o.selectedItems.push(i);
					}
					// delesecting?
					else {
						o.selectedItems.splice(k,1);
						o.selectedItem = o.selectedItems.length?o.selectedItems.last():-1;
					}
				} else {
					o.selectedItem = i;
					o.selectedItems = [i];
					o.currentFile = p;
				}
				if (this.popupMode)
					okb = (o.selectedItems.length && t=="f") || (o.filter && o.filter.folder); // file or folder
				// update details
				this.showDetails();
			} else { // clicked again on the same "double click"
				o.selectedItems = [o.selectedItem]; // select just one
				if (t=="d") {
					this.browseTo(o.currentPath+(o.currentPath?"/":"")+n);
				} else if (this.popupMode) {
					this.confirmChooseFilePopup();
					return;
				} else if (this.canEdit(i)) {
					this.openEditor();
				}
			}
		} else {
			o.selectedItem = -1;
			o.selectedItems = [];
			if (this.popupMode) // choose folder is always on
				okb = (o.filter && o.filter.folder); // folder
		}
		if (o.selectedItem == -1) {
			o.currentFile = "";
			// will hide details
			this.showDetails();
		}
		// enable ok button for choose popup
		if (this.popupMode)
			browser.enableButton(dirsPConfirmBtE, okb);
		this.showFolderSel();
	} // selectItem()

	this.selectNext = function () {
		var o = this.popupMode?this.popupData:this;
		var dirsCE = (this.popupMode)?dirsPContentE:dirsContentE;

		var i = o.selectedItem+1;
		if (i >= dirsCE.childNodes.length) return;
		this.selectItem(i);
	} // selectNext()

	this.selectPrev = function () {
		var o = this.popupMode?this.popupData:this;

		var i = o.selectedItem-1;
		if (i < 0) return;
		this.selectItem(i);
	} // selectPrev()

	// toggle selection mode. mode:null (toggle "bt"/null), "key", "" (null)
	this.toggleSelMode = function (mode) {
		var v = selMode;
		if (mode)
			selMode = mode;
		else if (mode === "")
			selMode = null;
		else
			selMode = selMode?null:"bt"; // toggle
		// changed?
		if (v != selMode) {
			// button
			document.getElementById("selectButtonFm").getElementsByTagName("img")[0].style.display = selMode?"inline":"none";
			document.getElementById("selectButtonFm").getElementsByTagName("img")[1].style.display = selMode?"none":"inline";
		}
	} // toggleSelMode()

	// new folder
	this.newFolder = function () {
		var o = self.popupMode?self.popupData:self;
		var u = self.popupMode;
		var name = manager.cPopup.data.input["n"].value;
		if (!name) return; // nothing selected
		if (o.currentPath) name = o.currentPath+"/"+name;

		manager.closePopup(); // close new folder popup
		manager.showLoadingPopup();

		files.load("newfolder",name);
	} // newFolder()

	// delete items
	this.deleteItems = function () {
		var o = this.popupMode?this.popupData:this;
		manager.closePopup();
		manager.showLoadingPopup();

		// data, array of source pathnames
		delData = [];
		var k,n;
		for (var i=0; i<self.selectedItems.length; i++) {
			k = self.selectedItems[i];
			n = self.currentFolder[2][k][0];
			if (self.currentPath) n = self.currentPath+"/"+n; // add path
			delData.push(n); // save filename
		}
		files.load("deletefile",delData);
		this.selectItem(-1);
	} // deleteFile()

	// new file
	this.newFile = function () {
		var o = self.popupMode?self.popupData:self;
		var u = self.popupMode;
		var n = manager.cPopup.data.input["n"].value;

		if (!n) return; // nothing selected

		manager.closePopup(); // close new file popup

		self.currentFile = o.currentPath+(o.currentPath?"/":"")+n;
		self.openEditor();
	} // newFile()

	// rename file
	this.renameFile = function () {
		var o = self.popupMode?self.popupData:self;
		var n = manager.cPopup.data.input["n"].value;
		if (!n) return; // nothing selected
		var p = (o.currentPath)?o.currentPath+"/":"";

		manager.closePopup(); // close rename file popup

		selectOnRefresh = {path:o.currentPath, name:n};
		files.load("renamefile",[fileManager.currentFile,p+n]);
	} // renameFile()

	// open in project editor
	this.openInProjectEditor = function () {
		var o = this.popupMode?this.popupData:this;
		projectEditor.toLoad = o.currentPath.split("/").pop();
		manager.switchApp("pe");
	} // openInProjectEditor()

	// show preview
	this.updateTextPreview = function (text) {
		var o = this.popupMode?this.popupData:this;
		text = text.replace(/&/g, "&amp;").replace(/>/g, "&gt;").replace(/</g, "&lt;").replace(/"/g, "&quot;");
		text = "<pre><div class='title'>"+o.currentFile.split("/").pop()+"</div>"+text+"</pre>";
		detailsTextPreviewE.innerHTML = text;
	} // updateTextPreview()

	// download
	var fileDownload = {};
	this.downloadFile = function () {
		var o = this.popupMode?this.popupData:this;
		var ts = "."+(new Date()).getTime();
		var url = "/x/files?g"+ts+"*"+files.encodeFileName(o.currentFile);
		if (false && browser.touchEventsSupported && o.currentFolder[2][o.selectedItem][1] == "f") { // works only on safari mobile apparently
			fileDownload.name = o.currentFile.split("/").pop();

			var xmlhttp = new XMLHttpRequest();
			xmlhttp.onreadystatechange = function() {
			    if (xmlhttp.readyState == 4 && xmlhttp.status == 200) {
			        fileDownload.content = xmlhttp.responseText;
					manager.showNotice("Download ready: ",0);

					var blob = new Blob([fileDownload.content], {
						type: 'application/octet-stream;charset=utf-8;'
					});
					var objectURL = URL.createObjectURL(blob);

					var saveLink = document.createElement("a");
					saveLink.innerHTML = "<b>download now</b>";
					saveLink.onclick = self.mobileDownload;

					document.getElementById("notice").appendChild(saveLink);
			    }
			}
			xmlhttp.open("GET", url);
			xmlhttp.send();

			manager.showNotice("Download requested, please wait...");
		} else {
			if (browser.touchEventsSupported)
				window.open(url);
			else
				document.getElementById("downloadTarget").src = url;
			if (o.currentFolder[2][o.selectedItem][1] == "d")
				manager.showNotice("Download requested, please wait...");
		}
	}

	this.mobileDownload = function () {
		var reader = new FileReader();
		var blob = new Blob([fileDownload.content], {
			type: 'application/octet-stream;charset=utf-8;'
		});

		var w = window.open();
		reader.onload = function(e) {
			w.location.href = reader.result;
		}
		reader.readAsDataURL(blob);
	};

	// download backup
	this.downloadBackup = function () {
		var ts = "."+(new Date()).getTime();
		document.getElementById("downloadTarget").src = "/x/files?g"+ts+"*.";
		manager.showNotice("Backup requested, please wait...");
		manager.closeToolbarPopup();
	}

	// new folder popup
	this.openNewFolderPopup = function () {
		var u = this.popupMode;
		manager.openPopup("newfolder",true);
	} // openNewFolderPopup()

	// new file popup
	this.openNewFilePopup = function () {
		manager.openPopup("newfile",true);
	} // openNewFilePopup()

	// new folder popup
	this.openRenameFilePopup = function () {
		manager.openPopup("renamefile",true);
		manager.cPopup.data.input["n"].value = this.currentFolder[2][this.selectedItem][0];
	} // openNewFolderPopup()

	// copy items
	this.copyItems = function () {
		self.openChooseFilePopup(onChoosePathCopy,"folder");
	} // copyItems()

	// confirm choose path for copy popup
	function onChoosePathCopy(v) {
		moveData = null;
		// picked or confirmed?
		if (v != null) {
			// data, array of source pathnames
			copyData = [];
			var k,n;
			for (var i=0; i<self.selectedItems.length; i++) {
				k = self.selectedItems[i];
				n = self.currentFolder[2][k][0];
				if (self.currentPath) n = self.currentPath+"/"+n; // add path
				copyData.push(n); // save filename
			}
			// add destination direcory
			copyData.push(v);
			files.load("copyfiles",copyData);
		} else {
			files.load("copyfilesoverwrite",copyData);
		}
	} // onChoosePathCopy()

	// move items
	this.moveItems = function (confirm) {
		self.openChooseFilePopup(onChoosePathMove,"folder");
	} // moveItems()

	// confirm choose path for move popup
	function onChoosePathMove(v) {
		copyData = null;
		// picked or confirmed?
		if (v != null) {
			// data, array of source pathnames
			moveData = [];
			var k,n;
			for (var i=0; i<self.selectedItems.length; i++) {
				k = self.selectedItems[i];
				n = self.currentFolder[2][k][0];
				if (self.currentPath) n = self.currentPath+"/"+n; // add path
				moveData.push(n); // save filename
			}
			// add destination direcory
			moveData.push(v);
			files.load("movefiles",moveData);
		} else {
			files.load("movefilesoverwrite",moveData);
		}
	} // onChoosePathMove()

	// confirm overwrite on copy or move
	this.confirmOverwrite = function () {
		manager.closePopup();
		if (copyData)
			onChoosePathCopy();
		else
			onChoosePathMove();
	} // confirmOverwrite()

	// duplicate file
	this.duplicateFile = function () {
		var k = self.selectedItems[0];
		var n = self.currentFolder[2][k][0]; // file name
		var p = self.currentPath?self.currentPath+"/":""; // path
		var a = n.split(".");
		var c = this.canEdit(k);
		a[a.length>1 && c?a.length-2:0] += "_copy"; // add before recognized extension, or at the end
		var nn = a.join(".");
		selectOnRefresh = {path:p, name:nn};
		files.load("duplicatefile",[p+n,p+nn]);
	} // duplicateFile()

	// --------------------------------------------------------------------------------------------------------------------------
	// Editor -------------------------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	// open editor
	this.openEditor = function () {
		manager.closeToolbarPopup();
		manager.closePopup(); // do this first, because the editorrefresh popup will trigger tsCheckReq
		timestampChecker.stop(); // will restart after loaded, in updateEditor

		self.toggleSelMode(""); // reset sel mode, ignore shift

		var o = this.popupMode?this.popupData:this;
		this.editorOpen = true;
		this.editorChanged = false;

		dirsPanelE.style.display = "none";
		detailsPanelE.style.display = "none";
		editorPanelE.style.display = "inline";
		this.showEditorLoading(true);

		editorTitleE.style.display = "inline";
		updateEditorTitle();

		updateToolbarPopupButtons();

		files.load("reqfile",o.currentFile); // reqfile, we get the timestamp first

		this.adjustLayout();

		if (self.aceEnabled) {
			var sm = self.getSyntaxMode();
			if (sm == "events" || sm == "javascript")
			snippetDataManager.start();
		}
	} // openEditor()

	// update editor title
	function updateEditorTitle() {
		var o = self.popupMode?self.popupData:self;
		editorHeaderLabelE.innerHTML = (self.editorChanged?"* ":"")+o.currentFile;
	}

	// close editor. save? null to show popup, true or false
	this.closeEditor = function (save) {
		if (this.editorChanged && save == null) {
			manager.openPopup("closeeditor",true);
			return;
		}

		this.editorOpen = false;

		updateToolbarPopupButtons();

		if (save) { // editorOpen is false, so when we're done saving, we close again
			this.saveEditor();
			return;
		} else if (save == false) { // clicked on no, don't save
			manager.closePopup();
		}

		if (self.aceEnabled) {
			this.editor.setValue(""); // clear
	        this.editor.resize(true);
		} else {
			this.editor.scrollTop = 0;
			this.editor.value = "";
		}

		this.hideWarnings();

		this.editorChanged = false;

		editorTitleE.style.display = "none";
		dirsPanelE.style.display = "";
		detailsPanelE.style.display = "";
		editorPanelE.style.display = "none";
		toolbarSaveBtE.style.display = "none";

		selectOnRefresh = {path:this.currentPath, name:this.currentFile}; // so we auto select when refreshing
		this.browseTo(this.currentPath); // refresh

		this.adjustLayout();
		manager.closeToolbarPopup();

		if (self.aceEnabled)
			snippetDataManager.stop();
	} // closeEditor()

	// show editor loading
	this.showEditorLoading = function (show) {
		if (show) {
			editorTextE.style.display = "none";
			editorLoadingE.style.display = "inline";
		} else {
			toolbarSaveBtE.style.display = "inline";
			editorTextE.style.display = "inline";
			editorLoadingE.style.display = "none";
		}
	} // showEditorLoading()

	// update editor with contents
	this.updateEditor = function (text) {
		this.showEditorLoading(false);

		if (this.aceEnabled) {
			this.editor.session.setValue(text);
	        /*
	        this.editor.clearSelection();
	        this.editor.moveCursorTo(0,0);
	        */
	        this.editor.getSession().setScrollTop(0);
	        this.editor.session.getUndoManager().reset();
			this.editor.focus();
		} else {
			this.editor.value = text;
			this.editor.focus();
			this.editor.scrollTop = 0;
		}

		this.editorChanged = false;
        updateEditorTitle();

		// warning check
		if (isEventsFile()) {
			this.startWarningsCheck();
		}

		if (this.aceEnabled) {
			var mode = self.getSyntaxMode();
			// try ACE modes
			if (!mode) {
				var modelist = ace.require("ace/ext/modelist");
				mode = modelist.getModeForPath(self.currentFile).mode;
			} else {
				mode = "ace/mode/"+mode;
			}

			this.editor.session.setMode(mode);
			this.editor.session.setUseWorker(mode != "ace/mode/events");
			this.editor.session.setAnnotations([]);

			//
			this.editor.setOptions({
				enableBasicAutocompletion: true,
				enableSnippets: true,
				enableLiveAutocompletion: self.codeAssistEnabled
			});
		}

		timestampChecker.start(); // restart, stopped in open editor
	} // updateEditor()

	// save editor contents
	this.saveEditor = function () {
		this.editorChanged = false;
		var c = "";
		this.editor.blur();
		if (this.aceEnabled) {
			c = this.editor.getValue();
		} else {
			c = this.editor.value;
		}
		updateEditorTitle();
		timestampChecker.stop();
		manager.showSavingPopup();
		files.saveEditorFile(this.currentFile, c);
	} // saveEditor()

	// on editor saved event
	this.onEditorSaved = function (r) {
		if (r != "error") {
			// when there's an unrecoverable error on events.txt it renames the file to events_unsafe.txt, so the timestamp is 0:keep the old timestamp
			fileManager.editorTs = r*1; // timestamp refreshed
			manager.showNotice("<b>"+files.resID+"</b> saved");
			if (!fileManager.editorOpen) {
				fileManager.closeEditor(false); // saved already, don't save
				return;
			}
			// warning check
			if (isEventsFile()) {
				fileManager.startWarningsCheck();
			}
		} else {
			manager.showNotice("error saving <b>"+files.resID+"</b>");
			if (!fileManager.editorOpen) { // not saved.. restore?
				fileManager.editorOpen = true; // still open!
				manager.closePopup(); // close saving popup
			}
		}
		// restart check
		timestampChecker.start();
		// focus
		if (this.aceEnabled) {
			this.editor.blur();
			this.editor.focus();
		}
	} // onEditorSaved()

	// set edit font size
	this.setEditFontSize = function (a) {
		if (a) this.editorFontSize++; else this.editorFontSize--;

		if (this.aceEnabled) {
			editorTextE.style.fontSize = this.editorFontSize+"px";
			editorTextE.style.lineHeight = Math.round(this.editorFontSize + this.editorFontSize/2)+"px";
		} else {
			this.editor.style.fontSize = this.editorFontSize+"px";
			this.editor.style.lineHeight = Math.round(this.editorFontSize + this.editorFontSize/2)+"px";
		}
	} // setEditFontSize()

	// get syntax type, for highlighting
	this.getSyntaxMode = function () {
		var f = self.currentFile;
		var a = f.split(".")
		var ext = a.length>1 ? a.pop() :"";
		if (f == "systemtopo.txt" || f == "license.txt" || ext == "ini") {
			return "ini";
		} else if ((f.indexOf("events") == 0 && ext == "txt") || // any txt inside events/
				   (f.endsWith("events.txt"))) { // ends with events.txt
			return "events";
		} else if (ext == "js") {
			return "javascript";
		}
		return "";
	}

	// --------------------------------------------------------------------------------------------------------------------------
	// Upload -------------------------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	// upload bt > this.uploadFile > initUploadData(uploadFileInputE.files)
	//                                      |- > [open overwrite popup] > confirmUpload > sendUpload
	// drag & drop                 > initUploadData(e.dataTransfer.files)

	// open upload file popup
	this.openUploadPopup = function () {
		var o = this.popupMode?this.popupData:this;
 		var u = this.popupMode; // opening/closing will change it
		if (!this.uploading) {
			manager.openPopup("uploadfile", true);
		} else {
			manager.openPopup("uploadingfile", true);
		}
	} // openUploadPopup()

	// upload file (from upload popup)
	this.uploadFile = function () {
		var data;
		if (uploadFileInputE.files && formDataSupport) // input supports files and xmlhttpreq method available
			data = uploadFileInputE.files;

		initUpload(data);
	} //  uploadFile()

	// init upload. data (e.dataTransfer.files || uploadFileInputE.files || no data: form submit)
	function initUpload(data) {
		var o = self.popupMode?self.popupData:self;
		var timestamp = (new Date()).getTime()+"";
		var n, fs; // name, file size

		// reset uploadData with a new id, target path name
		uploadData = {id:timestamp.substr(5), files:[], path:o.currentPath};
		if (data) {
			uploadData.size = 0;
			uploadData.data = [];
			for (var i=0; i<data.length; i++) {
				uploadData.data.push(data[i]);
				n = data[i].name;
				fs = data[i].size;
				uploadData.files.push({name:n, size:fs});
				uploadData.size += fs;
			}
		} else { // old method
			n = uploadFileInputE.value;
			if (!n) return; // nothing chosen
			n = n.split("\\").pop(); // remove path
			uploadData.files = [{name:n, size:null}]; // single size won't be used
			uploadData.size = null; // don't know, will ask to the server
		}

		// file already exists?
		for (var i=0; i<uploadData.files.length; i++) {
			for (var k=0; k<o.currentFolder[2].length; k++) {
				if (uploadData.files[i].name == o.currentFolder[2][k][0]) {
					manager.openPopup("uploadoverwrite", true);
					return;
				}
			}
		}

		// no overwrite, confirm
		self.confirmUpload();
	} // initUpload

	// confirm upload (no overwrite or from overwrite popup)
	this.confirmUpload = function () {
		// new or old method
		if (uploadData.data) { // also drag
			if (!sendUpload()) {
				self.onUploadProgressError();
				return;
			}
		} else {
			uploadFileFormE.action = "/x/files?u*"+uploadData.id+"*"+files.encodeFileName(uploadData.path);
			uploadFileFormE.submit();
		}

		self.showUploadProgress(true);
		self.uploading = true;
		if (self.uploadDoneTimeout) {
			clearTimeout(self.uploadDoneTimeout);
			self.uploadDoneTimeout = null;
		}
		var r = "/x/files?cu*"+uploadData.id;
		if (!uploadData.size)
			r += "*s";
		uploadProgressReq.open(r);

		// popups
		if (manager.cPopup && manager.cPopup.id == "uploadoverwrite")
			manager.closePopup(); // close upload overwrite
		if (manager.cPopup && manager.cPopup.id == "uploadfile")
			manager.closePopup(); // close choose file
		if (self.popupMode)
			manager.openPopup("uploadingfile", false);
	} // confirmUpload()

	// send upload (via xmlhttreq post, new method)
	function sendUpload() {
	    if (!formDataSupport) return false; // not supported (shouldn't get here)
	    if (!uploadData.data) return false; // no data?

	    var formData = new FormData();
		for (var i = 0; i < uploadData.data.length; i++)
			formData.append("file", uploadData.data[i]);

	    // now post a new XHR request
	    uploadReq = new XMLHttpRequest();
	    uploadReq.open("POST", "/x/files?u*"+uploadData.id+"*"+files.encodeFileName(uploadData.path));
	    uploadReq.send(formData);

	    return true; // done
	} // sendUpload()

	// show upload progress
	this.showUploadProgress = function (show) {
		self.uploadProgressVisible = show;
		uploadProgressPanelE.style.display = show?"inline":"none";
		self.adjustLayout();
		// reset panel
		uploadFileNameE.innerHTML = "";
		uploadProgressE.innerHTML = "";
		uploadBytesE.innerHTML = ""
		uploadBarE.style.display = "none";
		// popup
		uploadPFileNameE.innerHTML = "&nbsp;";
		uploadPProgressE.innerHTML = "&nbsp;";
		uploadPBytesE.innerHTML = "&nbsp;";
		uploadPBarE.style.display = "none";
		// file name
		if (show) {
			var txt = "Uploading";
			if (uploadData.files.length>1)
				txt += " (1/"+uploadData.files.length+")";
			txt += ": "+uploadData.files[0].name;
			uploadFileNameE.innerHTML =
			uploadPFileNameE.innerHTML = txt;
		}
		// timeout
		if (!show && self.uploadDoneTimeout) {
			clearTimeout(self.uploadDoneTimeout);
			self.uploadDoneTimeout = null;
		}
	} // showUploadProgress()

	// upload progress update
	function onUploadProgressUpdate() {
		var a = this.getResponseText().split(" ");
		// do it just the first time
		if (self.uploading && a.length>1) { // not canceled and size
			uploadData.size = parseInt(a[1]);
			if (self.open && self.currentPath == uploadData.path) {
				if (self.popupMode) {
					self.popupMode = false;
					self.showFolder();
					self.popupMode = true;
				} else {
					self.showFolder();
				}
			}
		}
		var v = a[0];

		// error?
		if (v == "error") {
			// if progress has been set at least once, it's a valid error
			if (uploadData.progress != null) {
				self.onUploadProgressError();
				return;
			}
			// if it's error before a valid value, maybe the server hasn't started the upload yet
			if (!uploadData.errorCount)
				uploadData.errorCount = 1;
			else
				uploadData.errorCount++;
			// 10 errors, upload start didn't work
			if (uploadData.errorCount == 10) {
				self.onUploadProgressError();
				return;
			}
		} else {
			uploadData.progress = v;
		}

		if (v == "null") v = "0";
		var fs = uploadData.size; // total size
		if (v!="100") {
			if (!self.popupMode && self.currentPath == uploadData.path &&
				uploadData.index!=-1 &&
				dirsContentE.childNodes[uploadData.index]) {
				dirsContentE.childNodes[uploadData.index].childNodes[3].innerHTML =
					fs?manager.formatFS(Math.round(fs*v/100)):"";
			}
			if (self.uploading) { // not canceled?
				var r = "/x/files?cu*"+uploadData.id;
				if (!fs) r+="*s"; // check if received size, otherwise ask again
				uploadProgressReq.open(r,250);
			}
		} else if (self.uploading) { // not canceled?
			self.uploading = false;

			manager.showNotice("upload finished");
			self.uploadDoneTimeout = setTimeout(self.showUploadProgress,5000);

			if (!self.popupMode && self.open && self.currentPath == uploadData.path) {
				self.browseTo(uploadData.path);
			} else if (self.popupMode) {
				selectOnRefresh = {path:uploadData.path, name:uploadData.name}; // so we auto select when refreshing
				self.browseTo(uploadData.path); // popup mode, so we must be in the same dir
				// we update fileManager too
				if (self.currentPath == uploadData.path && self.open) {
					self.popupMode = false;
					self.browseTo(self.currentPath);
					self.popupMode = true; // restore
				}
			}

			uploadData.path = "";
			manager.closePopup();
		}
		// show progress
		if (v!="0" && v!="error") {
			uploadBarE.style.display = "";
			uploadPBarE.style.display = "";
			uploadBarE.style.width = Math.round(238*v/100)+"px";
			uploadPBarE.style.width = Math.round(174*v/100)+"px";
		}
		uploadProgressE.innerHTML =
		uploadPProgressE.innerHTML = (v!="error"?v+"%":"");
		var cs = (v!="error")?Math.round(fs*v/100):0; // current size of uploaded data
		uploadBytesE.innerHTML =
		uploadPBytesE.innerHTML = fs?(manager.formatFS(cs)+"/"+ manager.formatFS(fs)):"";
		// show file name if multiple
		if (v!="0" && uploadData.files.length>1) {
			// find out which one
			var t = 0; // current size
			for (var i=0; i<uploadData.files.length; i++) {
				t += uploadData.files[i].size;
				if (t>=cs) break;
			}
			// text
			var txt = "Uploading";
			txt += " ("+(i+1)+"/"+uploadData.files.length+")";
			txt += ": "+uploadData.files[i].name;
			uploadFileNameE.innerHTML =
			uploadPFileNameE.innerHTML = txt;
		}
	} // onUploadProgressUpdate()

	// upload progress error
	this.onUploadProgressError = function () {
		uploadProgressE.innerHTML =
		uploadPProgressE.innerHTML = "error";
		// abort upload if necessary
		if (uploadReq) {
			try {
				req.abort();
			} catch (err) {}
		}
		var fs = "file"+(uploadData.files.length>1?"s":""); // file string
		manager.showNotice("error uploading "+fs);
		self.uploadDoneTimeout = setTimeout(self.showUploadProgress,5000);

		if (!self.popupMode && self.open && self.currentPath == uploadData.path) {
			self.browseTo(uploadData.path);
		} else if (self.popupMode) {
			self.browseTo(uploadData.path); // popup mode, so we must be in the same dir
			// we update fileManager too
			if (self.currentPath == uploadData.path && self.open) {
				self.popupMode = false;
				self.browseTo(self.currentPath);
				self.popupMode = true; // restore
			}
		}

		uploadData.path = "";
		self.uploading = false;
		manager.closePopup();
	} // onUploadProgressError()

	// stop the upload
	this.cancelUpload = function () {
		uploadFileFrameE.src = "about:blank";
		this.uploading = false;
		uploadData.path = "";
		uploadData = {};
		uploadProgressReq.stop();
		this.showUploadProgress(false);
		if (!this.popupMode && this.currentPath == uploadData.path)
			this.browseTo(this.currentPath);
		manager.showNotice("upload canceled");
		manager.closePopup();
	}

	function onDirsContentDrop(e) {
		this.className = "fm_dirsContent";
		if (!e || !e.dataTransfer) return false;
		e.stopPropagation();
		e.preventDefault();
		initUpload(e.dataTransfer.files);
	}

	function showDirsOver(e) {
		try {
			e.stopPropagation();
		    e.preventDefault();
		    e.dataTransfer.dropEffect = "copy";
		} catch (err) {}

		this.className = "fm_dirsContent hover";
		return false;
	}

	function showDirsLeave() {
		this.className = "fm_dirsContent";
		return false;
	}

	// --------------------------------------------------------------------------------------------------------------------------
	// Warnings Check -----------------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	function reqWarnings(delay) {
		warningsReq.open("/x/geteventserrors."+(new Date()).getTime()+"?"+self.currentFile,delay);
	}

	// start warnings check
	this.startWarningsCheck = function () {
		if (isEventsFile()) {
			reqWarnings();
		} else {
			this.hideWarnings();
		}
	} // startWarningsCheck()

	// stop warnings check
	this.stopWarningsCheck = function () {
		warningsReq.stop();
	} // stopWarningsCheck()

	//
	this.onWarningsUpdate = function () {
		var r = JSON.parse(this.getResponseText());

		var lE = document.getElementById("fm_warningsLoading");

		if (r.timestamp != fileManager.editorTs) {
			reqWarnings(1000); // check again, with interval
			lE.style.display = "inline";
			return; // done
		}

		lE.style.display = "none";

		if (r && r.errors && r.errors.length) {
			// check if different
			var changed = false;
			for (var i=0; i<r.errors.length && i<fileManager.warningsLimit-1; i++) {
				if (!fileManager.warnings[i] ||
					(r.errors[i][0] != fileManager.warnings[i][0]) ||
					(r.errors[i][1] != fileManager.warnings[i][1])) {
					changed = true;
					break;
				}
			}
			if (!changed) return; // nothing to do

			fileManager.warnings = r.errors;

			var wE = document.getElementById("fm_warnings");
			var bE = document.getElementById("fm_toolbarWarningsBt");

			bE.style.display = "inline";
			bE.getElementsByTagName("span")[0].innerHTML = r.errors.length;

			wE.innerHTML = "";
			var html = "";
			var wt = ""; // error text
			var fun = ""; // functions
			var annotations = [];
			var l;
			for (var i=0; i<r.errors.length && i<fileManager.warningsLimit-1; i++) {
				l = parseInt(r.errors[i][0]);
				wt = decodeURIComponent(r.errors[i][1]).replace(/\+/g," ");
				annotations.push({row:l-1, column:0, text:wt,type:"error"});
				fun = 'data-onclick="fileManager.onWarningSelect('+l+')"';
				html += "<div class='mLineButton' "+fun+">"+wt+" (line <b>"+l+"</b>)</div>";
			}
			if (self.aceEnabled)
				self.editor.session.setAnnotations(annotations);
			wE.innerHTML = html;
			browser.initEvents(wE);
		} else {
			if (self.aceEnabled)
				self.editor.session.setAnnotations([]);
			fileManager.hideWarnings();
		}
	} // onWarningsUpdate()

	// hide warnings
	this.hideWarnings = function () {
		fileManager.warnings = []; // reset

		var wE = document.getElementById("fm_warnings");
		var bE = document.getElementById("fm_toolbarWarningsBt");

		bE.style.display = "none";
		manager.showToolbarPopup("fm_warnings",false);

		// contents
		wE.innerHTML = "";

		fileManager.stopWarningsCheck();
	} // hideWarnings()

	// warning select. line?
	this.onWarningSelect = function (l) {
		if (this.aceEnabled) {
			self.editor.gotoLine(l);
		} else {
			var text = this.editor.value.replace(/\s+$/g,"")
			var lines = text.split("\n").length;
			var lh = this.editor.clientHeight / lines;
			this.editor.scrollTop = (l - 1) * lh;
		}
	} // onWarningSelect()

	// --------------------------------------------------------------------------------------------------------------------------
	// Log Preview --------------------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	// show/hide log preview
	this.showLogPreview = function (show) {
		if (show == null) {
			show = !this.logPreviewVisible;
			manager.closeToolbarPopup();
		}
		if (show == this.logPreviewVisible) return;
		this.logPreviewVisible = !this.logPreviewVisible;

		if (show)
			logViewer.startPreview(5);
		else
			logViewer.stopPreview();

		this.adjustLayout();
	} // showLogPreview()

	// --------------------------------------------------------------------------------------------------------------------------
	// Choose File --------------------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	// open popup, function when file chosen, file filter (if f is null, don't refresh). type
	this.openChooseFilePopup = function (f,t) {
		this.popupMode = true;
		timestampChecker.stop(); // will be restarted by browse, and on close popup
		manager.openPopup("choosefile",true,function(){fileManager.popupMode = false; timestampChecker.start();});

		// if f is null, don't refresh: we're reopening after upload, or new folder
		if (f) {
			this.popupData.onChoose = f;

			switch(t) {
			case "img":
				manager.cPopup.contentE.getElementsByTagName("span")[0].innerHTML = "Choose File";

				this.popupData.rootPath = "www";
				this.popupData.defaultPath = (!this.popupData.currentPath)?"www/img":this.popupData.currentPath;

				// filter
				this.popupData.filter = {};
				var r = "^(www(/img(/.+)?"; // www, www/img
				if (projectEditor.open && project && project.name)
					r += "|/"+project.name+"|/"+project.name+"/img(/.+)?"; // www/[proj], www/[proj]/img
				r += ")?)$";
				this.popupData.filter.path = new RegExp(r);
				r = "^(www(/img/";
				if (projectEditor.open && project && project.name)
					r += "|/"+project.name+"/img/";
				r += ")).*\.(jpe?g|gif|png)$";
				this.popupData.filter.file = new RegExp(r);

				// replace once file is chosen
				this.popupData.replace = [];
				r = /(www\/([^\/]*\/)?img\/)/; // remove img folder
				this.popupData.replace.push({a:new RegExp(r),b:""});

				this.popupData.filter.folder = false; // select file, not folder

				break;
			case "video":
				manager.cPopup.contentE.getElementsByTagName("span")[0].innerHTML = "Choose File";

				this.popupData.rootPath = "www";
				this.popupData.defaultPath = (!this.popupData.currentPath)?"www/img":this.popupData.currentPath;

				this.popupData.filter = {};
				var r = "^(www(/img(/.+)?"; // www, www/img
				if (projectEditor.open && project && project.name)
					r += "|/"+project.name+"|/"+project.name+"/img(/.+)?"; // www/[proj], www/[proj]/img
				r += ")?)$";
				this.popupData.filter.path = new RegExp(r);
				r = "^(www(/img/";
				if (projectEditor.open && project && project.name)
					r += "|/"+project.name+"/img/";
				r += ")).*\.(mp4|webm|ogv)$";
				this.popupData.filter.file = new RegExp(r);

				// replace once file is chosen
				this.popupData.replace = [];
				r = /(www\/([^\/]*\/)?img\/)/; // remove img folder
				this.popupData.replace.push({a:r,b:""});
				r = /\.(mp4|webm|ogv)$/; // remove extension
				this.popupData.replace.push({a:r,b:""});

				this.popupData.filter.folder = false; // select file, not folder

				break;
			case "folder":
				manager.cPopup.contentE.getElementsByTagName("span")[0].innerHTML = "Choose Destination";

				this.popupData.rootPath = this.rootPath; // popup starts with same root as fm
				this.popupData.defaultPath = this.currentPath;

				// filter
				this.popupData.filter = {};
				var r = ".";
				this.popupData.filter.path = new RegExp(r);
				this.popupData.filter.file = null;

				// replace once file is chosen
				this.popupData.replace = [];

				this.popupData.filter.folder = true; // select folder

				break;
			}

			this.browseTo(this.popupData.defaultPath);
			this.selectItem(-1);

			dirsPUploadBtE.style.display = this.popupData.filter.folder?"none":"inline";
		}
		this.focus();
	} // openChooseFilePopup()

	// confirm choose file popup
	this.confirmChooseFilePopup = function () {
		var v = self.popupData.currentFile;
		if (!v && self.popupData.filter && self.popupData.filter.folder) // selecting a folder from within (nothing selected)?
			v = self.popupData.currentPath;
		// appy replace
		for (var i=0; i<self.popupData.replace.length; i++)
			v = v.replace(self.popupData.replace[i].a, self.popupData.replace[i].b);
		// external call
		self.popupData.onChoose(v);
		manager.closePopup();
	} // confirmChooseFilePopup()

	// --------------------------------------------------------------------------------------------------------------------------
	// Event handling -----------------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	// catch blank clicks to deselect
	this.onDirsClick = function (event,e) {
		// event target
		var evt = window.event || event;
		if (evt) evt.target = evt.target || evt.srcElement; // e.target not supported?
		if (evt && evt.target && evt.target == e) {
			var x = (evt.offsetX)?evt.offsetX:evt.layerX;
			if (x == null ||
				x<30 ||
				dirsPanelE.offsetWidth-x<30) return;
			this.selectItem(-1);
		}
	} // dirsClick()

	// on list, from files
	this.onList = function (f) {
		if (!this.editorOpen) // if editor is open, currentFile has to remain the same
			this.selectItem(-1);
		this.showFolder(f);
		timestampChecker.start(); // restart, we stop it on browse
	} // onList()

	// key down
	this.onKeyDown = function (e, code, target) {
		// shift, select mode? selMode: null, key, bt
		if (!self.editorOpen && e.shiftKey && !selMode)
			self.toggleSelMode("key");

		if (manager.cPopup && manager.cPopup.id != "choosefile") {
			// tab
			if (code == 9 && manager.cPopup.id == "saving") {
				browser.preventDefault(e);
				return;
			}
			// return
			if (code == 13) {
				switch (manager.cPopup.id) {
					case "newfolder":
						if (focusedElement == manager.cPopup.data.input["n"])
							fileManager.newFolder();
						break;
					case "newfile":
						if (focusedElement == manager.cPopup.data.input["n"])
							fileManager.newFile();
						break;
					case "renamefile":
						if (focusedElement == manager.cPopup.data.input["n"])
							fileManager.renameFile();
						break;
				}
			}
			return; // popup open
		}

		if (self.popupMode || !self.editorOpen) {
			switch (code) {
			case 38: // up
				browser.preventDefault(e);
				fileManager.selectPrev();
				break;
			case 40: // down
				browser.preventDefault(e);
				fileManager.selectNext();
				break;

			case 8: // backspace
			case 37: // left
				browser.preventDefault(e);
	            fileManager.parentFolder();
				break;

	        case 39: // right
				var o = fileManager.popupMode?fileManager.popupData:fileManager;
	            if (o.selectedItem == -1) {
	                fileManager.selectNext();
	                break;
	            }
			case 13: // enter
				browser.preventDefault(e);
				var o = fileManager.popupMode?fileManager.popupData:fileManager;
				if (o.selectedItem>=0)
					fileManager.selectItem(o.selectedItem);
				break;
			}
		} else if (fileManager.editorOpen) {
			if (self.aceEnabled)
				snippetDataManager.onInput();

			// ctrl/cmd s
			if (code == 83 && (e.ctrlKey || e.metaKey) && !manager.cPopup) {
				browser.preventDefault(e);
				fileManager.saveEditor();
				return;
			}
		}

		// ctrl/cmd s. no editor, not allowed
		if (code == 83 && (e.ctrlKey || e.metaKey)) {
			browser.preventDefault(e);
			return
		}

	} // onKeyDown()

	// key up
	this.onKeyUp = function (e, code, target) {
		// shift, select mode? selMode: null, key, bt
		if (!self.editorOpen && !e.shiftKey && selMode == "key")
			self.toggleSelMode("");
	} // onKeyUp()

	init();
} // FileManager Class



//--------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
// Status Browser ------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------

// Status Browser class
function StatusBrowser() {
	var started = false; // if already started, will just switch
	this.open = false; // currently open. set by start, hide

	var req = new XMLReq();
	var timeout; // repeat timeout
	// type of resource currently loading
	var resType = "";

	this.e = document.getElementById("statusBrowser");

	var toolbarE = document.getElementById("sb_toolbar");

	var sbPanelE = document.getElementById("sb_panel");
	var topPanelE = document.getElementById("sb_topPanel");
	var sbContainerE = document.getElementById("sb_container");

	var filterE = document.getElementById("sb_filter");
	var filterFieldE = document.getElementById("sb_filterField");

	var filters = {io:"", ui:"", vars:""}; // current filter strings
	var filterData = {io:[],ui:[],vars:[],io_h:false,ui_h:false,vars_h:false}; // array data from filter string
	var filterMode = {io:true, ui:true, vars:true}; // true:include, false:exclude
	var filterModeBtE = document.getElementById("sb_filterModeBt");
	var filterTimeoutId; // wait while typing filter

	var pauseBtE = document.getElementById("sb_pauseBt");

	var sessionDataBtE = document.getElementById("sb_sessionDataBt");

	var ioBtE = document.getElementById("sb_ioBt");
	var uiBtE = document.getElementById("sb_uiBt");
	var varsBtE = document.getElementById("sb_varsBt");

	var ioE = document.getElementById("sb_io");
	var uiE = document.getElementById("sb_ui");
	var varsE = document.getElementById("sb_vars");

	var selectedTab;

	// data to be displayed
	var data = {io:{}, ui:{}, vars:{}};

	// timestamps
	var ioLastReq = 0;
	var uiLastReq = 0;
	var varsLastReq = 0;

	var paused = false;

	var showSessionData = false;

	var self = this;

	// init
	function init() {
		req.onLoaded = onResourceLoaded;
		req.onAuthenticate = showPin;
		req.onNoAccess = function () {manager.showErrorPopup("No access");};
		req.onError = onResourceError; // it never fires???????????????????????????
		req.retryOnErrorDelay = 500;
	} // init()

	// start
	this.start = function () {
		manager.hideOtherApps("sb");

		this.e.style.display = "inline";

		// mode
		toolbarE.style.display = "inline";

		this.adjustLayout();

		if (!started) {
			started = true;
			this.selectTab("io");
		} else {
			startReq();
		}

		this.open = true;

		timestampChecker.start(); // no additional files to check here
	} // start()

	// hide (switching to another app)
	this.hide = function () {
		this.e.style.display = "none";
		stopReq();

		clearTimeout(filterTimeoutId);

		manager.focus();

		this.open = false;
	} // hide()

	// focus, restore key events
	this.focus = function () {
		if (window.focus) window.focus();
		manager.deselect();
	} // focus()

	// adjust project editor layout. viewport size
	this.adjustLayout = function () {
		if (!manager.viewportWidth || !manager.viewportHeight) return;

		var	vw = manager.viewportWidth;
		var	vh = manager.viewportHeight;

		// tool bar size
		var tbW = 0; // left one
		var tbH = 36; // top one

		// editable area size
		var eW = vw - tbW;
		var eH = vh - tbH;

		toolbarE.style.left = (tbW-1)+"px"; // +1, attach it to the iconPanel
		toolbarE.style.width = (eW+1)+"px";

		// panel
		var pd = 7; // panel distance from border
		var bs = 0; // border size. no border to improve aesthethics [first time I've ever used this word, might be wrong]
		var pl = pd; // panel left
		var pt = tbH+pd; // panel top
		var pw = vw-pd*2-bs*2; // full content width
		var ph = vh-tbH-pd*2-bs*2;

		var th = 19; // top bar
		var bh = 55; // bottom bar

		topPanelE.style.height = (th)+"px";

		sbContainerE.style.height = (ph-th-bh)+"px";

		sbPanelE.style.left = (pl)+"px";
		sbPanelE.style.top = (pt)+"px";
		sbPanelE.style.width = (pw)+"px";
		sbPanelE.style.height = (ph)+"px";

		browser.miniButton(pauseBtE, (pw<550));
		browser.miniButton(filterModeBtE, (pw<550));
		browser.miniButton(sessionDataBtE, (pw<550));

		var fw = (pw<450)?pw-200:250;
		filterFieldE.style.width = fw + "px";
		filterE.style.width = (fw-40) + "px"; // leave space for the x
	} // adjustLayout()

	// select tab
	this.selectTab = function (tab) {
		stopReq();

		selectedTab = tab;
		browser.setButtonAttribute(ioBtE,"selected",(tab=="io"));
		browser.setButtonAttribute(uiBtE,"selected",(tab=="ui"));
		browser.setButtonAttribute(varsBtE,"selected",(tab=="vars"));
		showFilter();

		ioE.style.display = (tab=="io")?"inline":"none";
		uiE.style.display = (tab=="ui")?"inline":"none";
		varsE.style.display = (tab=="vars")?"inline":"none";

		sessionDataBtE.style.display = (tab=="ui")?"inline":"none";

		// resume filter
		clearTimeout(filterTimeoutId);
		this.update(null,true);
		filterE.value = filters[selectedTab];
		filterE.blur();

		if (!paused)
			startReq();
	} // selectTab()

	// repeat
	this.repeat = function (ms) {
		timeout = setTimeout(doRepeat, ms);
	}

	function doRepeat() {
		self.load();
	}

	// load a file
	this.load = function () {
		if (timeout) {
			clearTimeout(timeout);
			timeout = null;
		}

		var url = "";
		switch (selectedTab) {
		case "io":
			var url = "/x/getio?"+ioLastReq;
			break;
		case "ui":
			var url = "/x/getstate?"+uiLastReq;
			if (showSessionData)
				url += ".latest.null.null."+(new Date()).getTime();
			break;
		case "vars":
			var url = "/x/getvars?"+varsLastReq;
			break;
		}

		resType = selectedTab;

	    req.open(url,10);
	} // load()

	// on resource loaded event
	function onResourceLoaded() {
		if (timeout) {
			clearTimeout(timeout);
			timeout = null;
		}

		//if (paused) return; // paused

    	var data = this.getResponseJSON();

	    switch(resType) {
	    case "io":
	    	if (data && data.timestamp) {
	    		ioLastReq = data.timestamp;
		    	self.update(data);
	    	}
	    	if (!paused)
	    		self.repeat(1000);
	    	break;
	    case "ui":
	    	if (data && data.hsycostate && data.hsycostate.timestamp) {
	    		uiLastReq = data.hsycostate.timestamp;
		    	self.update(data);
	    	}
	    	if (!paused)
	    		self.repeat(100);
	    	break;
	    case "vars":
	    	varsLastReq = (new Date()).getTime();
		    self.update(data);
	    	if (!paused)
	    		self.repeat(1000);
	    	break;
	    }
	} // onResourceLoaded()

	// on resource error
	function onResourceError() {
		if (timeout) {
			clearTimeout(timeout);
			timeout = null;
		}

    	// error
    	manager.clearNotice();
    	this.repeat(3000);
	} // onResourceError()

	// start reqests
	function startReq() {
		self.load();
	} // startReq()

	// update. force update?
	this.update = function (d, force) {
		var i;
		var k = 0; // used to alternate row colors
		var changed = force; // refresh only if something changed, or forced
		var html = "<table>"; // final html
		var ai = []; // indexes, to sort alphabetically
		var txt; // support
		var name,value,date;

		// local data object
		var lo = data[selectedTab];
		// update data object. {io:..., {vars:... , {hsycostate:{ui:...
		var uo = d?((selectedTab != "ui")?d[selectedTab]:(d.hsycostate?d.hsycostate.ui:null)):null;

		// changed?
		if (!changed && uo) {
			for (i in uo) {
				if (!lo[i] ||
					((selectedTab!="io" && lo[i] != uo[i]) ||
					 (selectedTab=="io" && !lo[i].same(uo[i])))) { // io has arrays
					if (selectedTab == "io")
						lo[i] = uo[i].clone();
					else
						lo[i] = uo[i];
					changed = true;
				}
			}
		}
		if (!changed) return;
		// rebuild indexes
		for (i in lo)
			ai.push(i);
		ai.sort();
		// add html
		for (i=0; i<ai.length; i++) {
			if (filterCheck(ai[i])) {
				name = decodeURIComponent(ai[i]);
				if (selectedTab == "io") {
					value = decodeURIComponent(lo[ai[i]][1]);
					date = decodeURIComponent(lo[ai[i]][0]);
				} else {
					value = decodeURIComponent(lo[ai[i]]);
				}
				value = value.replace(/\&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;"); // strip html
				// add
				html += "<tr class='"+selectedTab+" "+(++k%2?"a":"b")+"'>";
				html += "<td class='n'>"+name+"</td>";
				html += "<td class='v'>"+value+"</td>";
				if (selectedTab == "io")
					html += "<td class='d'>"+date+"</td>";
				html += "</tr>";
			}
		}
		html += "</table>"

		switch (selectedTab) {
		case "io":
			ioE.innerHTML = html;
			break;
		case "ui":
			uiE.innerHTML = html;
			break;
		case "vars":
			varsE.innerHTML = html;
			break;
		}
	} // updateLog()

	function stopReq() {
		if (timeout) {
			clearTimeout(timeout);
			timeout = null;
		}
		req.stop();
	} // stopReq()

	// check text line using filter. returns true/false
	function filterCheck(txt) {
		var t = decodeURIComponent(txt).toLowerCase();
		// __hsyco__ flag
		if (t.indexOf("__hsyco__") == 0 && !filterData[selectedTab+"_h"])
			return false;
		// no filter
		if (!filterData[selectedTab].length)
			return true;
		// or
		var f = false;
		for (var i=0; i<filterData[selectedTab].length; i++) {
			if (t.indexOf(filterData[selectedTab][i])!=-1) { // found
				f = true;
				break;
			}
		}
		if (!filterMode[selectedTab]) f = !f;
		return f;
	} // filterCheck()

	// update filter
	this.updateFilter = function (v) {
		if (v == null)
			v = filterE.value;
		else
			filterE.value = v;
		if (filters[selectedTab] != v) {
			filters[selectedTab] = v;
			// get filter data
			filterData[selectedTab] = v.trim().toLowerCase().split(" ");
			// __hsyco__ flag
			filterData[selectedTab+"_h"] = (filterData[selectedTab][0] == "__hsyco__");
			if (filterData[selectedTab+"_h"]) {
				filterData[selectedTab].splice(0,1);
			}
			// call update on small timeout
			clearTimeout(filterTimeoutId);
			filterTimeoutId = setTimeout(function(){self.update(null,true)},250);
		}
	} // updateFilter()

	// toggle pause. reset? (change just the buttons)
	this.togglePause = function (reset) {
		if (reset)
			paused = false;
		else
			paused = !paused;
		pauseBtE.getElementsByTagName("img")[0].src = paused?"/manager/pic/bticonpause.png":"/manager/pic/loaderg.gif";
		pauseBtE.getElementsByTagName("span")[0].innerHTML = paused?"resume":"pause";

		ioE.className =
		uiE.className =
		varsE.className = (paused)?"paused":"";

		if (!reset) {
			if (paused)
				stopReq();
			else
				startReq();
		}
	} // togglePause()

	// toggle session data
	this.toggleSessionData = function () {
		showSessionData = !showSessionData;
		data.ui = {};
		// force update
		uiLastReq = 0;
		sessionDataBtE.getElementsByTagName("img")[0].style.display = showSessionData?"inline":"none";
		sessionDataBtE.getElementsByTagName("img")[1].style.display = showSessionData?"none":"inline";
		if (!paused) {
			stopReq();
			startReq();
		}
	} // toggleSessionData()

	// toggle filter mode
	this.toggleFilter = function () {
		filterMode[selectedTab] = !filterMode[selectedTab];
		showFilter();
		filters[selectedTab] = ""; // force update
		this.updateFilter();
	} // toggleFilter()

	// show filter, called from toggleFilter and selectTab
	function showFilter() {
		filterModeBtE.getElementsByTagName("img")[0].src = "/manager/pic/bticonsearch"+(filterMode[selectedTab]?"":"o")+".png";
		filterModeBtE.getElementsByTagName("span")[0].innerHTML = filterMode[selectedTab]?"search:":"exclude:";
	} // showFilter()

	// on server restart
	this.onRestart = function () {
		if (!started) return;
		data = {io:{}, ui:{}, vars:{}}; // reset
		// force update
		ioLastReq = 0;
		uiLastReq = 0;
		varsLastReq = 0;
		this.update(null,true);
		self.load(); // force update now
	} // onRestart()

	init();
} // Status Browser Class



//--------------------------------------------------------------------------------------------------------------------------
// Animations --------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------

// Animations Class
function Animations() {
	var step = 50; // animation step msec

	var anims = {}; // animation data
	var cAnimation = 0; // current animation id

	var foo = this;

	// options: waitTime, fadeInTime, idleTime, fadeOutTime (msec time), fadeFrom, fadeTo (opacity), onFadeIn, onFadedIn, onFadeOut, onFadedOut (events)
	this.fadeAnimation = function(e, options) {
		if (!options) return; // ?
		cAnimation++;
		var a = options; // get all options and add
		a.e = e;
		a.type = "fade";
		a.id = cAnimation;
		a.timeout = null;
		a.s = 0; // status: 0 init (and wait), 1 fadeIn, 2 idle, 3 fadeOut
		a.c = 0; // current step. for status 1,3
		a.t = 0; // total steps for current status
		if (a.fadeFrom == null)
			a.fadeFrom = 0;
		if (a.fadeTo == null)
			a.fadeTo = 100;
		if (a.fadeFrom == a.fadeTo) { // shouldn't happen
			setOpacity(a.fadeFrom);
			return null;
		}
		// there's already a fade animation on this object?
		for (var i in anims) {
			if (anims[i] && anims[i].e == e) {
				if (anims[i].type == "fade")
					a.cv = anims[i].v; // save current value, so we fade from there
				this.removeAnimation(anims[i]);
			}
		}
		anims["a"+cAnimation] = a;
		onAnimationUpdate(a);
		return a;
	} // fadeInOut()

	// size animation
	this.sizeAnimation = function(e, f, time, w, h) {
		if (!options) return; // ?
		cAnimation++;
		var a = { e:e, type:"size", id:cAnimation, timeout:null, a:time, w:w, h:h, ow:e.offsetWidth, oh:e.offsetHeight };
		a.s = 0; // status: 0 init, 1 resizing
		a.t = 0; // current steps
		// there's already a size animation on this object?
		for (var i in anims) {
			if (anims[i] && anims[i].e == e) {
				this.removeAnimation(anims[i]);
			}
		}
		anims["a"+cAnimation] = a;
		onAnimationUpdate(a);
		return a;
	} // sizeAnimation()

	// remove animation
	this.removeAnimation = function(a) {
		// interval?
		if (a.timeout) {
			clearTimeout(a.timeout);
			a.timeout = null;
		}
		anims[a.id] = null;
		delete anims[a.id];
	} // removeAnimation()

	//
	function callAnimationUpdateOnTimeout(a,msec) {
		a.timeout = setTimeout(function(){onAnimationUpdate(a)},msec);
	} // callAnimationUpdateOnTimeout()

	//  on animation update
	function onAnimationUpdate(a) {
		//var a = anims["a"+id];
		if (!a) return; // error
		// interval?
		if (a.timeout) {
			clearTimeout(a.timeout);
			a.timeout = null;
		}
		// still there?
		if (!a.e) {
			foo.removeAnimation(a);
			return;
		}
		// animation
		switch (a.type) {
		case "fade":
			switch (a.s) {
			case 0: // init, wait
				a.s = 1;
				if (a.onFadeIn) // event
					a.onFadeIn();
				if (a.fadeInTime) { // fadeInTime
					a.t = Math.floor(a.fadeInTime/step); // total steps
					if (a.cv != null) {
						a.v = a.cv; // current value
						a.cv = null; // so we don't do it again on fadeOut
						a.c = Math.round(a.t*((a.v-a.fadeFrom)/(a.fadeTo-a.fadeFrom))); // calc current step, so we fade from there
					} else {
						a.v = a.fadeFrom; // current value
					}
					setOpacity(a.e,a.v);
					a.e.style.display = "inline";
					callAnimationUpdateOnTimeout(a,a.waitTime?a.waitTime:step);
					break;
				}
				// next state, don't break
			case 1: // fading in
				// done?
				if (!a.fadeInTime || a.c == a.t) {
					a.v = a.cv?a.cv:a.fadeTo; // current value
					setOpacity(a.e,a.v);
					a.s = 2;
					if (a.onFadedIn) // event
						a.onFadedIn();
					if (a.idleTime) {
						callAnimationUpdateOnTimeout(a,a.idleTime);
						break;
					} // else next state, don't break
				} else {
					a.c++;
					a.v = a.fadeFrom+((a.fadeTo-a.fadeFrom)*a.c/a.t); // current value
					setOpacity(a.e,a.v);
					callAnimationUpdateOnTimeout(a,step);
					break;
				}
			case 2: // idle
				if (!a.fadeOutTime) {
					foo.removeAnimation(a); // all done
					break;
				} else {
					a.s = 3;
					a.c = 0;
					a.t = Math.floor(a.fadeOutTime/step); // total steps
					if (a.cv != null) {
						a.v = a.cv; // current value
						a.c = Math.round(a.t*((a.fadeTo-a.v)/(a.fadeTo-a.fadeFrom))); // calc current step, so we fade from there
					}
					if (a.onFadeOut) // event
						a.onFadeOut();
					// next state, don't break
				}
			case 3: // fading out
				// done?
				if (a.c == a.t) {
					a.v = a.fadeFrom; // current value
					setOpacity(a.e,a.v);
					a.e.style.display = "none"; // optimize
					foo.removeAnimation(a); // all done
					if (a.onFadedOut) // event
						a.onFadedOut();
				} else {
					a.c++;
					a.v = a.fadeTo-((a.fadeTo-a.fadeFrom)*a.c/a.t); // current value
					setOpacity(a.e,a.v);
					callAnimationUpdateOnTimeout(a,step);
				}
				break;
			}
			break;
		case "size":
			switch (a.s) {
			case 0: // init
				a.s = 1;
				a.t = Math.floor(a.a/step); // total steps
			}

		}
	} // onAnimationUpdate()

	// set element opacity
	function setOpacity(obj,opacity) {
		//opacity = (opacity == 100)?99.999:opacity; // why?
		obj.style.filter = "alpha(opacity:"+opacity+")"; // IE/Win
		obj.style.KHTMLOpacity = opacity/100; // Safari<1.2, Konqueror
		obj.style.MozOpacity = opacity/100; // Older Mozilla and Firefox
		obj.style.opacity = opacity/100; // Safari 1.2, newer Firefox and Mozilla, CSS3
	} // setOpacity()

	//--------------------------------------------------------------------------------------------------------------------------------
	// Blinker -----------------------------------------------------------------------------------------------------------------------
	//--------------------------------------------------------------------------------------------------------------------------------

	var blinkInterval = null;
	var blinkE = []; // elements that blink
	var blinkC = 0; // counter 0->3

	this.getBlinks = function () {
		return blinkE;
	}

	// check if the element is not null and currently inside the DOM
	function isInDOMTree(node) {
		if (!node) return false;
		// find ultimate ancestor
		while(node.parentNode)
			node = node.parentNode;
		return !!(node.body);
	}

	// set blinking. mode: true|slow; fast; false;. r:reserved for interface objects, stopAll doesn't stop these
	this.setBlink = function (e,mode,r) {
		// already there?
		for (var i=0; i<blinkE.length; i++) {
			if (blinkE[i].e == e) {
				updateElementBlink(e,null);
				blinkE.splice(i,1);
				break;
			}
		}
		// add?
		if (mode && mode != "false") {
			blinkE.push({e:e, f:(mode == "fast"), r:r});
		}
		// start or clear
		if (blinkE.length && !blinkInterval) {
			blinkInterval = setInterval(updateBlink,250);
		} else if (!blinkE.length && blinkInterval) {
			clearInterval(blinkInterval);
			blinkInterval = null;
		}
	} // setBlink()

	// stop all
	this.stopAllBlink = function () {
		for (var i=0; i<blinkE.length; i++) {
			// stop all not reserved
			if (!blinkE[i].r) {
				updateElementBlink(blinkE[i].e,null); // null resets it
				blinkE.splice(i,1);
				i--;
			}
		}
		if (!blinkE.length && blinkInterval) {
			clearInterval(blinkInterval);
			blinkInterval = null;
		}
	} // stopAllBlink()

	// update blinking
	function updateBlink() {
		blinkC = blinkC.next(4);
		for (var i=0; i<blinkE.length; i++) {
			// not in DOM anymore?
			if (!isInDOMTree(blinkE[i].e)) {
				updateElementBlink(blinkE[i].e,null); // null resets it
				blinkE.splice(i,1);
				i--;
			}
			else if (blinkE[i].f)
				updateElementBlink(blinkE[i].e, (blinkC%2==0));
			else
				updateElementBlink(blinkE[i].e, (blinkC<2));
		}
		// if we removed stuff
		if (!blinkE.length && blinkInterval) {
			clearInterval(blinkInterval);
			blinkInterval = null;
		}
	} // updateBlink()

	// set blink on or off
	function updateElementBlink(e,b) {
		if (!e) return; // element no longer exists
		browser.setOpacity(e, (b==null)?null:(b?1:0.3));
		//if (browser.browser == "Safari" && !browser.iOS) // prevents weird artifacts on Safari
		//	e.style.webkitTransform = (b!=null)?"translateZ(0)":"";
	} // updateElementBlink()
} // Animation Class



//--------------------------------------------------------------------------------------------------------------------------
// Browser -----------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
function Browser() {
	// devices
	this.browser = "";
	this.version = "";
	this.OS = "";

	this.iPad = false;
	this.iOS = false;

	// browser
	this.iPhoneReload = false;
	this.buttonFeedbackEnabled = true;
	this.cameraStreamEnabled = false;
	this.cameraStreamFixedSize = false;
	this.touchEventsSupported = false;
	this.rgbaSupport = false;

	this.overEnabled = true; // mouse over effect enabled?

	this.skipButtonEvents = false; // won't fire any button events (ex. while we're dragging)

	this.scrollBarSize = 0; // browser's scrollbar size

	var dataBrowser = [{ str: navigator.userAgent, substr: "Chrome",  name: "Chrome" },
	                   { str: navigator.userAgent, substr: "CriOS",  name: "Chrome" }, // Chrome on iOS
	                   { str: navigator.userAgent, substr: "OmniWeb", ver: "OmniWeb/", name: "OmniWeb" },
	                   { str: navigator.vendor, substr: "Apple", name: "Safari", ver: "Version" },
	                   { prop: window.opera, name: "Opera"},
	                   { str: navigator.vendor, substr: "iCab", name: "iCab" },
	                   { str: navigator.vendor, substr: "KDE", name: "Konqueror" },
	                   { str: navigator.userAgent, substr: "Firefox", name: "Firefox" },
	                   { str: navigator.vendor, substr: "Camino", name: "Camino" },
	                   { str: navigator.userAgent, substr: "Netscape", name: "Netscape" }, // for newer Netscapes (6+)
	                   { str: navigator.userAgent, substr: "MSIE", name: "Explorer", ver: "MSIE" },
	                   { str: navigator.userAgent, substr: "Gecko", name: "Mozilla", ver: "rv" },
	                   { str: navigator.userAgent, substr: "Mozilla", name: "Netscape", ver: "Mozilla" }]; // for older Netscapes (4-)

	var dataOS = [{ str: navigator.platform, substr: "Win", name: "Windows" },
				  { str: navigator.platform, substr: "Mac", name: "Mac" },
				  { str: navigator.userAgent, substr: "iPhone", name: "iPhone/iPod" },
			      { str: navigator.userAgent, substr: "iPod", name: "iPod" },
			      { str: navigator.userAgent, substr: "iPad", name: "iPad" },
			   	  { str: navigator.userAgent, substr: "Android", name: "Android" },
			   	  { str: navigator.platform, substr: "Linux", name: "Linux" }];

	var versionSearchString = "";

	var self = this;

	var touched; // element touched (mousedown or touchstart)
	var touchStartX;
	var touchStartY;

	var lastButton; // last button clicked (mouseup or touchend), reset when touched changes

	// check performance, time code execution time
	var timingStart;
	var timingCheckpoint; // last checkpoint

	// scale delta, coordinates are shifted when scaled
	this.scaleDelta = 1;

	// possible button style attributes
	var buttonAttributes = {"disabled":0,
							"selected":1,
							"pressed":2,
							"checked":3,
							"mini":4,
							"error":5};

	this.retina = window.devicePixelRatio > 1;

	this.referrer = null; // hsyco referrer page url?

	this.vCompare = function (version, major, minor) {
		try {
			var sa = version.split(/[._ ]/);
			if (sa[0] > major) {
				return true;
			} else if (sa[0] == major && sa[1] >= minor) {
				return true;
			} else {
				return false;
			}
		} catch (err) {
			return false;
		}
	};

	function searchString(data) {
		for (var i=0;i<data.length;i++)	{
			var dataString = data[i].str;
			var dataProp = data[i].prop;
			versionSearchString = data[i].ver || data[i].name;
			if (dataString) {
				if (dataString.toLowerCase().indexOf(data[i].substr.toLowerCase()) != -1)
					return data[i].name;
			}
			else if (dataProp)
				return data[i].name;
		}
	}

	function searchVersion(dataString) {
		var index = dataString.indexOf(versionSearchString);
		if (index == -1) return;
		return parseFloat(dataString.substring(index+versionSearchString.length+1));
	}

	this.setCookie = function (name,value,mins) {
		var expires = "";
		if (mins) {
			var date = new Date();
			date.setTime(date.getTime()+(mins*60*1000));
			expires = "; expires="+date.toGMTString();
		}
		document.cookie = name+"="+value+expires+"; path=/";
	};

	this.getCookie = function (name) {
		var nameEQ = name + "=";
		var ca = document.cookie.split(';');
		for(var i=0;i < ca.length;i++) {
			var c = ca[i];
			while (c.charAt(0)==' ') c = c.substring(1,c.length);
			if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
		}
		return null;
	};

	this.delCookie = function (name) {
		this.setCookie(name,"",-1);
	};

	// get image size
	this.getImgSize = function (imgSrc) {
		var newImg = new Image();
		newImg.src = imgSrc;
		return {x:newImg.width, y:newImg.width};
	}; // getImgSize()

	// insert at cursor
	this.insertAtCursor = function (field, value) {
	  // IE support
	  if (document.selection) {
	    field.focus();
	    var sel = document.selection.createRange();
	    sel.text = value;
	  } // insertAtCursor()

	  // MOZILLA/NETSCAPE support
	  else if (field.selectionStart || field.selectionStart == '0') {
	    var startPos = field.selectionStart;
	    var endPos = field.selectionEnd;
	    field.value = field.value.substring(0, startPos) + value + field.value.substring(endPos, field.value.length);
	  } else {
	    field.value += value;
	  }
  }; // insertAtCursor()

	// get mouse relative position
	this.getMouseRelativePosition = function (evt,target) {
		var ep = this.getElementAbsolutePosition(target);
		var p = this.getMouseAbsolutePosition(evt,target);
		return {x:p.x-ep.x,y:p.y-ep.y};
	}; // getMouseRelativePosition()

	// get absolute mouse position, if touch, first touch. target if != evt.target
	this.getMouseAbsolutePosition = function (evt,target) {
		var x,y;
		if (this.touchEventsSupported && evt.touches && evt.touches[0]) {
			x = evt.touches[0].pageX;
			y = evt.touches[0].pageY;
		} else if (evt.pageX != null && evt.pageY != null) {
			x = evt.pageX;
			y = evt.pageY;
		} else {
			x = (evt.layerX != null)?evt.layerX:evt.offsetX;
			y = (evt.layerY != null)?evt.layerY:evt.offsetY;
			var c = target || evt.target || evt.srcElement;
			var p = this.getElementAbsolutePosition(c);
			x += p.x;
			y += p.y;
		}

		// scale?
		if (this.scaleDelta && this.scaleDelta != 1) {
			x *= this.scaleDelta;
			y *= this.scaleDelta;
		}

		return {x:x, y:y};
	}; // getMouseAbsolutePosition()

	// get element absolute position
	this.getElementAbsolutePosition = function (c) {
		var x = 0;
		var y = 0;
		while (c && c.offsetLeft != null && c.offsetTop != null) {
			x += c.offsetLeft;
			y += c.offsetTop;
			c = c.offsetParent || c.parentNode;
		}

		return {x:x, y:y};
	} // getElementAbsolutePosition()

	this.fixRGBA = function (c) {
		if (!this.rgbaSupport && c.indexOf("rgba")!=-1) {
			var a = c.replace("rgba(","").replace(")","").split(",");
			a.pop(); // a
			return "rgb("+a.join(",")+")";
		}
		return c;
	} // fixRGBA()

	// get currently selected text
	this.getSelectedText = function () {
		var selText = "";
		if (window.getSelection) {  // all browsers, except IE before version 9
			if (document.activeElement &&
				(document.activeElement.tagName.toLowerCase() == "textarea" ||
				document.activeElement.tagName.toLowerCase() == "input")) {
				var text = document.activeElement.value;
				selText = text.substring(document.activeElement.selectionStart, document.activeElement.selectionEnd);
			} else {
				var selRange = window.getSelection();
				selText = selRange.toString();
			}
		} else {
			if (document.selection.createRange) {       // Internet Explorer
				var range = document.selection.createRange();
				selText = range.text;
			}
		}
		return selText;
	} // getSelectedText()

	// set opacity. (null, 0-1)
	this.setOpacity = function (e,o) {
		// reset it?
		if (o == null || o == "") {
			if (self.browser == "Explorer")
				e.style.filter = ""; // IE
			else
				e.style.opacity = "";
		} else {
			if (browser.browser == "Explorer")
				e.style.filter = "progid:DXImageTransform.Microsoft.Alpha(opacity=" + Math.round(o*100) + ")"; // IE
			else
				e.style.opacity = o;
		}
	} // setOpacity()

	// prevent default event
	this.preventDefault = function (evt) {
	if (arguments.callee.caller.name && arguments.callee.caller.name.indexOf("Key")!=-1)
		if (evt.returnValue)
			evt.returnValue = false;
		if (evt.preventDefault)
			evt.preventDefault();
	}

	// get full dom path
	this.getDomPath = function (e) {
		var path = [];
		do {
		    path.unshift(e.nodeName + (e.className ? ' class="' + e.className + '"' : ''));
		} while ((e.nodeName.toLowerCase() != 'html') && (e = e.parentNode));
		return path.join(" > ");
	}

	// check performance
	this.startTiming = function (str) {
		timingStart = (new Date()).getTime();
		timingCheckpoint = timingStart;
		webLog("timing "+(str?str:""));
	}
	this.checkTiming = function (str) {
		var now = (new Date()).getTime();
		webLog("time"+(str?" ["+str+"]":"")+": "+(now - timingCheckpoint)+" (total:"+(now - timingStart)+")");
		timingCheckpoint = now;
	}

	//-------------------------------------------------------------------------------------------------------------------------
	// Events -----------------------------------------------------------------------------------------------------------------
	//-------------------------------------------------------------------------------------------------------------------------

	// we do it in two function. find a better way?
	function initImg(e) {
		if (browser.touchenabled) {
			if (!e.ontouchdown) e.ontouchdown = new Function("return false;");
		} else {
			if (!e.onmousedown) e.onmousedown = new Function("return false;");
		}
	}
	// init img, buttons, inputs, given a parent div
	this.initEvents = function (e) {
		var n = 0;
		var f;
		var x = /[mc].*?Button/;

		function initDiv(e) {
			if (e.className && x.test(e.className)) {
				// it's a button
				var foc = e.getAttribute("data-onclick"); // on click function
				var fod = e.getAttribute("data-ondown");
				var foov =  e.getAttribute("data-onover");
				var foou =  e.getAttribute("data-onout");
				// no events? don't init
				if (foc == null && fod == null && foov == null && foou == null) return;
				// init
				self.initButtonEvents(e, {onclick:foc, ondown:fod, onover:foov, onout:foou});
				n++;
			}
		}

		function initInput(e) {
			f = e.getAttribute("data-autocomplete"); // autocomplete values
			if (f!=null) { // any values?
				self.initAutocomplete(e, f);
			}
		}

		function initLabel(e) {
			e.onclick = function (){
				var pe = this.previousSibling;
				if (pe.nodeType == 3) pe = pe.previousSibling; // text node? try previous one
				pe.checked = !pe.checked;
				if (pe.onchange) pe.onchange();
			};
		}

		var d,i;
		// add onmousedown on images
		for (i = 0; (d = e.getElementsByTagName("img")[i]); i++) initImg(d);
		if (e.nodeName == "IMG") initImg(e);

		for (i = 0; (d = e.getElementsByTagName("div")[i]); i++) initDiv(d);
		if (e.nodeName == "DIV") initDiv(e);

		for (i = 0; (d = e.getElementsByTagName("span")[i]); i++) initDiv(d);
		if (e.nodeName == "SPAN") initDiv(e);

		for (i = 0; (d = e.getElementsByTagName("input")[i]); i++) initInput(d);
		if (e.nodeName == "DIV") initInput(e);

		for (i = 0; (d = e.getElementsByTagName("label")[i]); i++) initLabel(d);
		if (e.nodeName == "LABEL") initLabel(e);
	}; // initEvents()

	// mouse wheel event
	this.initMouseWheelEvent = function (e,f) {
		if (!browser.touchEventsSupported)
			window.addEvent(browser.browser == "Firefox"?"DOMMouseScroll":"mousewheel", e, f);
	};

	// show image on load
	this.showImageOnLoad = function (img) {
		function onImageLoad() {img.style.display = "";}
		function onImageError() {}
		img.onload =  onImageLoad;
		img.onabort = onImageError;
		img.onerror = onImageError;
		img.style.display = "none"; // hide it
	}; // showImageOnLoad()

	// ugly stuff. change it??
	// visible to all parents, so we can get the size
	this.changeDivVisibility = function (c) {
		var pd = [];
		while (c && c.style) { // container
			pd.push(c.style.display?c.style.display:null);
			c.style.display = "inline";
			c = c.parentNode;
		}
		return pd;
	};
	// restore visibility
	this.restoreDivVisibility = function (pd,c) {
		var t = 0;
		while (c && c.style) { // container
			c.style.display = pd[t]?pd[t]:"";
			t++;
			c = c.parentNode;
		}
	};

	//-------------------------------------------------------------------------------------------------------------------------
	// Buttons ----------------------------------------------------------------------------------------------------------------
	//-------------------------------------------------------------------------------------------------------------------------

	// button class:
	//  [...] [cm][...]Button [color]? [any button attribute] [state] [...]

	// init button events. f is an object containing all events, options?
	this.initButtonEvents = function (e,f) {
		if (f.onclick) // default action is on up
			f.onup = f.onclick;
		if (browser.touchEventsSupported) {
			e.ontouchstart = function (event) {if (!browser.skipButtonEvents) browser.onButtonEvent(event,this,'touchstart',f.ondown)};
			e.ontouchmove = function (event) {if (!browser.skipButtonEvents) browser.onButtonEvent(event,this,'touchmove',f.onmove,f.onout)};
			e.ontouchend = function (event) {if (!browser.skipButtonEvents) browser.onButtonEvent(event,this,'touchend',f.onup)};
		} else {
			e.onmouseover = function (event) {if (!browser.skipButtonEvents) browser.onButtonEvent(event,this,'mouseover',f.onover)};
			e.onmouseout = function (event) {if (!browser.skipButtonEvents) browser.onButtonEvent(event,this,'mouseout',f.onout)};
			if (f.onmove)
				e.onmousemove = function (event) {if (!browser.skipButtonEvents) browser.onButtonEvent(event,this,'mousemove',f.onmove)};
			e.onmousedown = function (event) {if (!browser.skipButtonEvents) browser.onButtonEvent(event,this,'mousedown',f.ondown)};
			e.onmouseup = function (event) {if (!browser.skipButtonEvents) browser.onButtonEvent(event,this,'mouseup',f.onup)};
		}
		initButtonData(e);
		// on lift? when button is lifted with liftButton() (ex. when scrolling)
		if (f.onlift)
			e.btData.onLift = f.onlift;
		// temporary (???) solution for divs that require drag for more than n pixels
		if (f.dontLiftOnMove)
			e.btData.dontLiftOnMove = true;
		var d;
		for (var i = 0; (d = e.getElementsByTagName("img")[i]); i++) initImg(d);
	}; // initButtonEvents()

	// clear button events
	this.clearButtonEvents = function (e) {
		if (browser.touchEventsSupported) {
			delete e.ontouchstart;
			delete e.ontouchmove;
			delete e.ontouchend;
			e.ontouchstart = null;
			e.ontouchmove = null;
			e.ontouchend = null;
		} else {
			delete e.onmouseover;
			delete e.onmouseout;
			delete e.onmousedown;
			delete e.onmouseup;
			e.onmouseover = null;
			e.onmouseout = null;
			e.onmousedown = null;
			e.onmouseup = null;
		}
	}; // clearButtonEvents()

	// set button color
	this.setButtonColor = function (e,c) {
		e.btData.color = c;
		updateButtonClass(e); // update class based on e.btData
	}; // setButtonColor()

	// enabled/disabled button
	this.enableButton = function (e,enable) {
		this.setButtonAttribute(e, "disabled", !enable);
	}; // enableButton()

	// select/deselect button
	this.selectButton = function (e,select) {
		this.setButtonAttribute(e, "selected", select);
	}; // selectButton()

	// set mini mode
	this.miniButton = function (e,mini) {
		this.setButtonAttribute(e, "mini", mini);
	}; // miniButton()

	// get button style attribute
	this.getButtonAttribute = function (e,attrName) {
		if (!e.btData) initButtonData(e); // can happen when events are assigned manually
		return e.btData.attrs[buttonAttributes[attrName]];
	}; // getButtonAttribute()

	// set button style attribute. name and value (true or false)
	this.setButtonAttribute = function (e,attrName,attrValue) {
		if (this.getButtonAttribute(e,attrName) != attrValue) {
			e.btData.attrs[buttonAttributes[attrName]] = attrValue;
			updateButtonClass(e); // update class based on e.btData
		}
	}; // setButtonAttribute()

	// used to press, lift button only graphically
	this.setButtonState = function (e,state) {
		e.btData.state = state;
		updateButtonClass(e);
	};

	// init button data from class
	function initButtonData(e) {
		var cs = e.className;
		var ss = "(.*\\s)?([mc][^\\s]*Button)(\\s("+buttonColorRegExp+"))?(\\s.*)?(\\sover|\\sdown)?"; // search string (button color regexp in include.js)
		var rx = new RegExp(ss);
		var matches = rx.exec(cs);

		// build data. pre, button class, attributes (binary string based on
		if (!matches || !matches[2]) // should this happen?
			var data = {pre:cs, bc:"", color:"", attrs:[], state:""};
		else
			var data = {pre:matches[1]?matches[1]:"",
						bc:matches[2],
						color:matches[4]?matches[4]:"", // r,g,b..
						attrs:[],
						state:matches[6]?matches[6].substr(1):""}; // ,over,down
		// attributes
		for (var a in buttonAttributes)
			data.attrs[buttonAttributes[a]] = (matches && matches[5])?matches[5].indexOf(" "+a)!=-1:false;

		// assign
		e.btData = data;
	}

	// update button class from its btData
	function updateButtonClass(e) {
		var d = e.btData;
		var c = d.pre+d.bc
		if (d.color)
			c += " "+d.color;
		for (var a in buttonAttributes)
			if (d.attrs[buttonAttributes[a]])
				c += " "+a;
		if (self.buttonFeedbackEnabled && d.state)
			c += " "+d.state;
		e.className = c;
	}

	function disableAndroidLongPress(evt,e) {
		if (browser.OS == "Android") {
			var d = e;
			while (d) {
				if (d.getAttribute && d.getAttribute("data-scrollmode")) return; // scrollable, don't disable the long press
				d = d.parentNode;
			}
			evt.preventDefault && evt.preventDefault();
			evt.stopPropagation && evt.stopPropagation();
			evt.cancelBubble = true;
			evt.returnValue = false;
		}
	}

	// generic button event. graphic feedback and function associated to the event. f can be a string or a function(event,e). of is an additional optional function (user on touchmove for onout). clt: cancel long touch on android devices when clicking on an image
	this.onButtonEvent = function (event,e,w,f,of) {
		if (!e) return; // error?
		// event
		var evt = window.event || event;

		// touchevents or not?
		if (w == "touchstart" || w == "touchend" || w == "touchmove") {
			if (!browser.touchEventsSupported) return false;
		} else {
			if (evt)
				this.preventDefault(evt);
			if (browser.touchEventsSupported) return false;
		}

		if (!e.btData) initButtonData(e); // can happen when events are assigned manually

		var swi = e.btData.attrs[buttonAttributes["switch"]]; // behave like a switch?
		var swip = swi?e.btData.attrs[buttonAttributes["pressed"]]:false; // switch pressed
		var nswip = swip; // new switch pressed value, to notice if it changes

		//webLog(" CHTULHU "+w); // uncomment to log all events

		var s = ""; // class to add, down/over (only if not disabled)
		if (!e.btData.attrs[buttonAttributes["disabled"]]) switch (w) {
		case "touchstart":
			// no multitouch
			if (touched && touched != e) {
				self.resetButton(touched);
			}
			touched = e;
			lastButton = null;
			touchStartX = evt.touches[0].clientX;
			touchStartY = evt.touches[0].clientY;
			s = "down";
			if (swi) nswip = !swip;
			disableAndroidLongPress(evt,e);
			break;
		case "touchmove":
			if (touched == e) {
				s = "down";
				if (!e.btData.dontLiftOnMove && // temporary (?) solution for divs that require drag for more than 40px
					(Math.abs(evt.touches[0].clientX - touchStartX) > 30 ||
					 Math.abs(evt.touches[0].clientY - touchStartY) > 30)) {
					  touched = null;
					  f = of; // execute optional function if any
				}
			}
			disableAndroidLongPress(evt,e);
			break;
		case "touchend":
			if (touched != e) {
				f = null; // won't execute the function
			} else {
				lastButton = touched; // store it
				this.preventDefault(evt);
			}
			touched = null;
			disableAndroidLongPress(evt,e);
			break;
		case "mouseover":
			if (touched) {
				if (touched == e)
					s = "down";
			} else if (self.overEnabled) s = "over"; // over only on manager
			break;
		case "mousemove":
			break;
		case "mouseout":
			// if we're still on the same div, do nothing
			var reltg;
			if (evt) // no evt if we're calling onButtonEvent from code (like Login, on keydown)
				reltg = (evt.relatedTarget) ? evt.relatedTarget : evt.toElement;
			if (reltg) {
				while (reltg && reltg != e && reltg.nodeName != 'BODY')
					reltg = reltg.parentNode;
				if (reltg == e) return;
			}
			touched = null;
			break;
		case "mousedown":
			touched = e;
			lastButton = null;
			s = "down";
			if (swi) nswip = !swip;
			break;
		case "mouseup":
			if (touched != e) {
				f = null; // won't execute the function
			} else {
				lastButton = touched; // store it
			}
			touched = null;
			if (self.overEnabled)
				s = "over"; // over only on manager
			break;
		}

		// update class based on e.btData
		if (s != e.btData.state || nswip != swip) {
			e.btData.state = s;
			if (swi)
				e.btData.attrs[buttonAttributes["pressed"]] = nswip;
			updateButtonClass(e);
		}

		// function
		if (f && f!="null" && !e.btData.attrs[buttonAttributes["disabled"]]) {
			// if f is a string, create a new function, otherwise just call it with (event,e)
			var func = (typeof(f) == "string")?new Function("event","e",f):f;
			func(event,e);
		}
		// don't prevent default to allow scrolling
		return false;
	}; // onButtonEvent()

	// lift pressed button. bt or currently pressed button if any
	this.liftButton = function (bt) {
		if (touched && (!bt || bt == touched)) {
			if (touched.btData.state) {
				touched.btData.state = "";
				updateButtonClass(touched);
			}
			// on lift event?
			if (touched.btData.onLift) {
				touched.btData.onLift();
			}
			touched = null;
			return true;
		}
		return false;
	}; // liftButton()

	// get touched button
	this.getTouchedButton = function () {
		return touched;
	}; // getTouchedButton()

	// reset button: lifts and clear state (over)
	this.resetButton = function (bt) {
		// bt is currently touched? otherwise reset the class
		if (!this.liftButton(bt)) {
			bt.btData.state = "";
			updateButtonClass(bt);
		}
	};

	// get last clicked button
	this.getLastButton = function () {
		return lastButton;
	} // getLastButton()

	// ----------------------------------------------------

	// init autocomplete
	this.initAutocomplete = function (e,v) {
		e.onkeyup = new Function("event","browser.onAutocomplete(event,this,'"+v+"')");
	} // initAutocomplete()

	// autocomplete
	this.onAutocomplete = function (event,e,v) {
		if (!e) return; // error?
		// event
		var evt = window.event || event;

		var a;
		if (v.startsWith("array:"))
			a = eval(v.substring(6));
		else if (v.startsWith("list:") >= 0 )
			a = v.substring( 5 ).split('|');

		if (evt.keyCode == 16) return;
		if (evt.keyCode == 8) return; // don't deal with delete

		var s = e.value.toLowerCase();
		if (!s) return;

		var k;
		for (var i=0; i<a.length; i++) {
			k = a[i].toLowerCase().indexOf(s, 0);
			if (k == 0 && a[i].length>s.length) {
				e.value = a[i];
				if (e.createTextRange) {
					hRange = e.createTextRange()
					hRange.findText(a[i].substr(s.length));
					hRange.select();
				} else {
					e.setSelectionRange(s.length, a[i].length);
				}
				return;
			}
		}

	} // onAutocomplete()

	//-------------------------------------------------------------------------------------------------------------------------
	// Init -------------------------------------------------------------------------------------------------------------------
	//-------------------------------------------------------------------------------------------------------------------------

	function init() {
		self.browser = searchString(dataBrowser) || "unknown";
		self.version = searchVersion(navigator.userAgent) || searchVersion(navigator.appVersion) || "unknown";
		self.OS = searchString(dataOS) || "unknown";

		self.iOS = (self.OS == "iPhone" || self.OS == "iPod" || self.OS == "iPad" || self.OS == "iPhone/iPod");
		self.iPad = (self.OS == "iPad");

		// check if client is iOS or iPod
		if (self.iOS && !self.iPad) { // check version only on ipod/iphone
			var i = navigator.userAgent.indexOf("iPhone OS ");
			self.iPhoneReload = !self.vCompare(navigator.userAgent.substring(i + 10), 3, 0);
		}

		// has touch events?
		self.touchEventsSupported = ('ontouchstart' in document.documentElement);
		if (unescape(location.search).indexOf("notouch") != -1)
			self.touchEventsSupported = false;

		// BTicino Touch device
		if (self.browser == "Safari" && self.OS == "Linux" && navigator.platform == "Linux armv7l")
			self.touchEventsSupported = false;

		// cookies?
		self.setCookie("test", "1", 1);
		self.cookiesEnabled = self.getCookie("test") == "1";
		self.delCookie("test");

		// button feedback
		if (unescape(location.search).indexOf("nobuttonfeedback") != -1)
			self.buttonFeedbackEnabled = false;

		// camera stream
		if ((self.browser == "Firefox" || self.browser == "Safari" || (self.browser == "Chrome" && !self.iOS)) &&
			unescape(location.search).indexOf("nocamstream") == -1)
			self.cameraStreamEnabled = true;

		// check rgba support
		var scriptElement = document.getElementsByTagName('script')[0];
		var prevColor = scriptElement.style.color;
		try {
			scriptElement.style.color = 'rgba(0, 0, 0, 0.5)';
		} catch(e) {}
		self.rgbaSupport = scriptElement.style.color != prevColor;
		scriptElement.style.color = prevColor;

		// scrollbar size
		var inner = document.createElement('p');
		inner.style.width = "100%";
		inner.style.height = "200px";

		var outer = document.createElement('div');
		outer.style.position = "absolute";
		outer.style.top = "0px";
		outer.style.left = "0px";
		outer.style.visibility = "hidden";
		outer.style.width = "200px";
		outer.style.height = "150px";
		outer.style.overflow = "hidden";
		outer.appendChild(inner);

		document.body.appendChild(outer);
		var w1 = inner.offsetWidth;
		outer.style.overflow = 'scroll';
		var w2 = inner.offsetWidth;
		if (w1 == w2) w2 = outer.clientWidth;

		document.body.removeChild(outer);

		self.scrollBarSize = (w1 - w2);

		// referrer is other hsyco menu?
		// remove url queries
		var docloc = (document.location+"").split("?")[0];
		var docref = (document.referrer+"").split("?")[0];
		// remove login page bit
		docref = docref.replace("/pin.","/").replace("/login.","/"); // old format
		docref = docref.replace(".login",""); // new format
		// not in an iframe and not the same project
		if (window.top.location == document.location && docloc != docref) {
			if (document.referrer) {
				document.cookie = "referrer=" + encodeURIComponent(docref) + "; max-age=946080000"; // 30 years
				self.referrer = docref;
			} else {
				document.cookie = "referrer=; expires=Thu, 01-Jan-70 00:00:01 GMT;";
				self.referrer = null;
			}
		} else {
			// referrer: search in cookies
			var p = document.cookie.indexOf("referrer=");
			if (p != -1) {
				var b = p+9;
				var e = document.cookie.indexOf(";", b);
				if (e == -1)
					e = document.cookie.length;
				self.referrer = decodeURIComponent(document.cookie.substring(b, e));
			}
		} // referrer
	} // init()

	init();
} // Browser()

var webLogReq;
var webLogStack;
function webLog(s) {
	function onLoaded() {
		if (webLogStack.length)
			webLogReq.open(webLogStack.splice(0,1),100);
	}

	if (!webLogReq) {
		webLogReq = new XMLReq();
		webLogReq.onLoaded = onLoaded;
		webLogReq.onError = onLoaded;
		webLogStack = [];
	}
	console.log(s);
	var url = "/x/weblog?" + (new Date()).getTime() + "." + encodeURIComponent(s);
	if (webLogReq.isReady())
		webLogReq.open(url);
	else
		webLogStack.push(url);
} // webLog()

// app features
if (window.parent) {
	window.hsycoApp = {};

	hsycoApp.receiveMessage = function (event) {
		// event.source, event.data is message body
		function splitStr(value, c) {
			var index = value.indexOf(c);
			return (index>-1?[value.substring(0, index), value.substring(index+1)]:[value,""]);
		}
		var evt = splitStr(event.data,":");

		switch (evt[0]) {
		case "lock":
			// key is null if already locked
			if (browser.getCookie("key")) {
				login.lock();
				if (client)
					client.stop();
			}
			break;
		case "pin":
			var vars = evt[1].split(",");
			login.pin(vars[0]);
			break;
		case "puk":
			var vars = evt[1].split(",");
			login.puk(vars[0],vars[1]);
			break;
		case "fixlinks":
			client.fixLinks();
			break;
		case "page":
			client.showPage(event.data); // page:<id>
			break;
		case "speech":
			client.sendCommand(urls.vrem,evt[1],"speech",{
				onCommandLoaded: function (res) {
					hsycoApp.sendMessage("speech",res);
				},
				onCommandError: function (res) {
					hsycoApp.sendMessage("speech","error");
				}
			});
			break;
		}
	};

	hsycoApp.sendMessage = function (msg,value) {
		msg += (value?":"+value:"")
		// old app method
		window.parent.postMessage(msg, "*");
		/*
		// new app method
		if (window.webkit && window.webkit.messageHandlers && window.webkit.messageHandlers.callbackHandler)
			window.webkit.messageHandlers.callbackHandler.postMessage(msg)
		*/
	};

	window.addEventListener("message", hsycoApp.receiveMessage, false);
}



//--------------------------------------------------------------------------------------------------------------------------
// XMLReq ------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------
function XMLReq() {
	var req = null; // request

	var status; // -1: aborted, 0: ready, 1:loading, 2:loaded

	var reqTimeout = null; // trigger timeout
	this.url = "";

	// custom event handlers
	this.onLoaded = null; // needed
	this.onStop = null; // when request is stopped. called with true if loading, false if reqTimeout
	this.onRetry = null; // before retrying on error
	this.onError = null; // any error not captured by custom error handlers
	this.onRequest = null; // when sending request

	// custom error handlers
	this.onConnectionError = null; // connection error
	this.onAuthenticate = null; // false if just logout, true if lock (so we reload)
	this.onNoAccess = null;

	this.maxWaitingTime = 0; // 0 nothing, msec to wait for an answer, else abort
	var waitTimeout = null; // abort after maxWaitingTime

	this.retryOnErrorDelay = 0; // retry delay msec (on any error), 0 does not retry
	this.maxRetries = 0; // max n of retries. after that, stops and fires onError event(s). if maxRetries is 0, custom onError event is never fired
	this.retries = 0; // current retry attempt

	var foo = this; // variable scope

	// errors
	this.ERROR_GENERAL = 0;
	this.ERROR_CONNECTION = 1;
	this.ERROR_MAXWAITTIME = 2;
	this.ERROR_LOGOUT = 3;
	this.ERROR_LOCK = 4;
	this.ERROR_NOACCESS = 5;

	this.init = function () {
		status = 0; // ready
		// init req
		if (window.XMLHttpRequest) {
			req = new XMLHttpRequest();
			req.onreadystatechange = onReadyStateChange;
			// branch for IE/Windows ActiveX version
		} else if (window.ActiveXObject) {
			req = new ActiveXObject("Microsoft.XMLHTTP");
			if (req) {
				req.onreadystatechange = onReadyStateChange;
			}
		}
	}

	// open url. url optional (no url:repeat). ms optional (ms:delay request)
	this.open = function (url, ms) {
		if (status == 1) // loading?
			foo.stop();
		status = 0; // ready
		if (url) { // no url? repeat last one stored
			foo.url = url;
			foo.retries = 0; // reset retries
		}
		if (reqTimeout) {
			clearTimeout(reqTimeout);
			reqTimeout = null;
		}
		if (waitTimeout) {
			clearTimeout(waitTimeout);
			waitTimeout = null;
		}
		if (ms) {
			reqTimeout = setTimeout(foo.open, ms);
			return;
		}
		if (!req) foo.init();
		status = 1; // loading
		if (foo.onRequest)
			foo.onRequest();
		try {
			req.open("GET", foo.url, true);
		} catch (err) {
			// If document is not fully active, throw an "InvalidStateError" exception and terminate the overall set of steps.
			// URL relative to base. If the algorithm returns an error, throw a "SyntaxError" exception and terminate these steps.
			onError(foo.ERROR_GENERAL);
			return;
		}
		req.send();

		// wait timeout
		if (foo.maxWaitingTime) {
			waitTimeout = setTimeout(onWaitTimeout, foo.maxWaitingTime);
		}
	}

	this.stop = function () {
		// on stop handler if loading, or about to load
		if (status == 1 || reqTimeout) {
			if (this.onStop)
				this.onStop(status == 1);
		}
		if (status == 1) { // loading
			status = -1; // stopped
			req.abort(); // will fire onReadyStateChange, status != 1, returns
			this.init(); // reinitialize req every time we abort
		}
		if (reqTimeout) {
			clearTimeout(reqTimeout);
			reqTimeout = null;
		}
		if (waitTimeout) {
			clearTimeout(waitTimeout);
			waitTimeout = null;
		}
		status = 0; // ready
	}

	// repeat. ms delay before repeating
	this.repeat = function (ms) {
		this.open(null, ms);
	}

	function onWaitTimeout() {
		if (waitTimeout) {
			clearTimeout(waitTimeout);
			waitTimeout = null;
		}
		status = -1; // aborted
		req.abort(); // will fire onReadyStateChange, status != 1, returns
		onError(foo.ERROR_MAXWAITTIME);
		foo.init(); // reinitialize req every time we abort
	}

	function onReadyStateChange() {
		// check readyState
		if (req.readyState == null) return; // does it ever happen?
		switch (req.readyState) {
		case 0: // unsent
		case 1: // open called, send not called
			//foo.open(); // retry?
			return;
		case 2: // headers received, still receiving
		case 3: // loading
			return; // not ready
		case 4: // done, completed or error
			// continue
		}

		if (waitTimeout) {
			clearTimeout(waitTimeout);
			waitTimeout = null;
		}

		// loading? (if aborted it's -1)
		if (status != 1) return;
		status = 2;

		// not "OK"
		if (req.status != 200) {
			onError(foo.ERROR_CONNECTION);
			return;
		}

		// get response text
		var res = "";
		try {
			res = req.responseText;
		} catch (err) {
			// If responseType is not the empty string or "text", throw an "InvalidStateError" exception.
			onError(foo.ERROR_GENERAL);
			return;
		}

		if (res.indexOf("authenticate") == 0 || res.indexOf("logout") == 0) {
			onError(foo.ERROR_LOGOUT);
			return;
		} else if (res.trim() == "lock") {
			onError(foo.ERROR_LOCK);
			return;
		} else if (res.trim() == "noaccess") {
			onError(foo.ERROR_NOACCESS);
			return;
		}

		if (foo.onLoaded) foo.onLoaded();
	}

	// on error. called for every error (but not on stop > abort)
	function onError(errCode) {
		// specific errors, if there's a custom handler it won't repeat automatically
		switch (errCode) {
		case foo.ERROR_CONNECTION:
			if (foo.onConnectionError) {
				foo.onConnectionError();
				return;
			}
			break;
		case foo.ERROR_LOGOUT:
			if (foo.onAuthenticate) {
				foo.onAuthenticate(false);
				return;
			}
			break;
		case foo.ERROR_LOCK:
			if (foo.onAuthenticate) {
				foo.onAuthenticate(true);
				return;
			}
			break;
		case foo.ERROR_NOACCESS:
			if (foo.onNoAccess) {
				foo.onNoAccess();
				return;
			}
			break;
		}
		// repeat?
		if (foo.retryOnErrorDelay) {
			if (!foo.maxRetries || foo.retries < foo.maxRetries) {
				foo.retries++;
				if (foo.onRetry) // before repeating, so we can change the retryOnErrorDelay
					foo.onRetry();
				if (foo.retryOnErrorDelay) {// could be changed by onRetry
					foo.repeat(foo.retryOnErrorDelay);
					return;
				}
			}
		}
		// no custom handlers, no (more) retries. generic error callback
		if (foo.onError)
			foo.onError(errCode);
	}

	// json getter
	this.getResponseJSON = function () {
		var res = this.getResponseText();
		if (res)
			return JSON.parse(res);
		else
			return null;
	}

	// text getter
	this.getResponseText = function () {
		var res = "";
		try {
			res = req.responseText;
			return res;
		} catch (err) { // If responseType is not the empty string or "text", throw an "InvalidStateError" exception.
			return null;
		}
	}

	// xml getter
	this.getResponseXML = function () {
		var res = "";
		try {
			res = req.responseXML;
			return res;
		} catch (err) { // If responseType is not the empty string or "document", throw an "InvalidStateError" exception.
			return null;
		}
	}

	// is loading?
	this.isReady = function () {
		return status != 1;
	}
} // XMLReq Class



//--------------------------------------------------------------------------------------------------------------------------
// Parser ------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------

// Parser class
function Parser() {
	// parse index
	this.parseProject = function () {
		project.selectDictionary(); // update project with dictionary data
		this.parseHSC(project.src);
	}; // parseProject()

	// parse include
	this.parseInclude = function (id,txt) {
		var c = this.parseHSC(txt, {include:true});

		project.includes[id] = [];
		for (var i=0; i<c.objs.length; i++)
			project.includes[id].push(c.objs[i]); // copy array
	}; // parseInclude()

	// parse hsc file. options: {include: return a container obj, object: return single object $(()) }
	this.parseHSC = function (txt,options) {
		if (!options) options = {}; // no options
		// build support structure
		var state = 0; // 0: outside, only obj allowed; 1: inside obj; 2: string; 3: # single line comment; 4: #{ multiline comment
		var objs = [];
		var obj;
		var cchar = 0;
		var cline = 1;
		var str = "";
		var errors = [];
		for (var i=0; i<txt.length; i++) {
			cchar++;
			var c = txt.charAt(i);
			switch (c) {
			case '(':
				if (state == 0) { // new obj
					obj = [];
					state = 1;
				} else if (state == 1) { // obj
					state = 2; // string
					if (obj[0] && obj[0][0]=="#")  // meta can include (
						str += c;
				} else if (state == 2) { // string
					errors.push("Unexpected (, line: "+cline+" character:"+cchar);
				} else { // comment
					str += c;
				}
				break;
			case ')':
				if (state == 0) { // error
					errors.push("Unexpected ), line: "+cline+" character:"+cchar);
				} else if (state == 1) { // obj
					obj.push(str.trim());
					str = "";
					objs.push(obj);
					state = 0;
				} else if (state == 2) { // string
					state = 1;
					if (obj[0] && obj[0][0]=="#") // meta can include )
						str += c;
				} else { // comment
					str += c;
				}
				break;
			case '#':
				if (state == 0) { // comment
					state = 3;
				} else {
					str += c;
				}
				break;
			case '{':
				if (state == 3) { // multiline comment
					state = 4;
				} else {
					str += c;
				}
				break;
			case '}':
				if (state == 4) { // multiline comment
					state = 3;
				} else {
					str += c;
				}
				break;
			case ' ':
				if (state == 1 && obj.length == 0 && str.trim()) { // first parameter
					obj.push(str.trim());
					str = "";
				} else if (state > 0) {
					str += c;
				}
				break;
			case ';':
				if (state == 1) {
					if (obj.length == 0 && str.trim()) { // first parameter, reads (object; par...)
						obj.push(str.trim());
						str = "";
					}
					obj.push(str.trim());
					str = "";
				} else if (state > 1) {
					str += c;
				}
				break;
			case '\r':
			case '\n':
				if (state == 3) { // comments end on line break
					state = 0;
					str = "";
				}
				cline++;
				cchar = 0;
				break;
			default:
				if (state>0) // ignore everything that isn't inside an object
					str += c;
			}
		} // for chars

		// build internal objects
		var cPage = null;
		var cPopup = null;
		var cContainer = (options.include)?dictionary.getObjInstance("container"):null; // include is a container
		var p; // support for searches
		var cObj = null;
		var name, id; // obj name, id
		for (i=0; i<objs.length; i++) {
			name = objs[i][0];
			id = null;
			if ((p = name.indexOf('!'))>0) {
				id = name.substr(p+1);
				name = name.substr(0,p);
			}

			switch (name) {
			// meta
			case "#skin":
				// TODO: these things can't be in an include
				// TODO: load skin dictionary!
				project.skin = objs[i][1];
				break;
			case "#language":
				project.language = objs[i][1];
				break;
			case "#include":
				// add
				cObj = dictionary.getObjInstance("#include");
				cObj.attrValues[0] = objs[i][1];
				if (cContainer)
					cContainer.addObj(cObj);
				else if (cPage)
					cPage.addObj(cObj);
				else if (cPopup)
					cPopup.addObj(cObj);

				// add to project, will be loaded if not already there
				project.addInclude(cObj);
				break;
			case "#size":
				// TODO: function that extracts size, pos from txt
				var s = objs[i][1].toUpperCase();
				var sa = s.split(/[ ,;X]+/);
				var width = parseInt(sa[0]);
				var height = parseInt(sa[1]);
				if (cPage) {
					cPage.width = width;
					cPage.height = height;
				} else if (cPopup) {
					cPopup.width = width;
					cPopup.height = height;
				} else {
					project.width = width;
					project.height = height;
				}
				if (objs[i][2]) {
					project.orientationMode = true;
					s = objs[i][2].toUpperCase();
					sa = s.split(/[ ,;X]+/);
					project.width2 = parseInt(sa[0]);;
					project.height2 = parseInt(sa[1]);
				}
				break;
			case "#gestures":
				if (cPage) {
					// it contains ; so join back
					objs[i].splice(0,1); // remove the first, won't be needing objs anymore
					cPage.gestures = objs[i].join("; "); // restore
				}
				break;
			case "#scope":
				if (cPage) {
					cPage.scope = objs[i][1];
				} else if (!cPopup) {
					project.scope = objs[i][1];
				}
				break;
			case "#deviceimage":
				if (objs[i][1] == "disable" || objs[i][1] == "off")
					project.deviceImage = false;
				break;
			case "#locked":
				if (objs[i][1] == "true" || objs[i][1] == "on")
					project.locked = true;
				break;
			case "#kiosk":
				project.kiosk = (objs[i].length>0)?objs[i][1]:"nolock";
				break;
			case "#cameralist":
			case "cameralist":
				project.cameraList = objs[i][1];
				break;
			case "#cameraoverlay":
			case "cameraoverlay":
				project.cameraOverlay = objs[i][1];
				break;
			case "#cameragridlist":
			case "cameragridlist":
				project.cameraGridList = objs[i][1];
				break;
			case "#scale":
				project.scale = objs[i][1];
				break;
			case "#style":
				// it contains ; so join back
				objs[i].splice(0,1); // remove the first, won't be needing objs anymore
				project.style = objs[i].join("; "); // restore
				break;
			case "#uiset":
				// it contains ; so join back
				objs[i].splice(0,1); // remove the first, won't be needing objs anymore
				project.uiset = objs[i].join("; "); // restore
		        project.uiset = project.uiset.replace(/\\"/g, '"'); // unescape quotes
				break;
			case "#location":
				if (cPage) {
					cPage.locations = objs[i][1];
				}
				break;
			case "header":
				project.header = objs[i][1];
				break;
			// special objects
			case "menu":
			case "menu#landscape":
			case "menu#portrait":
				cPage = dictionary.getObjInstance("menu");
				var t = name.split("#");
				if (t.length>1)	cPage.orientation = t[1];
				project.addPage(cPage);
				break;
			case "overlay":
			case "overlay#landscape":
			case "overlay#portrait":
				cPage = dictionary.getObjInstance("overlay");
				var t = name.split("#");
				if (t.length>1)	cPage.orientation = t[1];
				project.addPage(cPage);
				break;
			case "page":
			case "page#landscape":
			case "page#portrait":
				cPage = dictionary.getObjInstance("page");
				var t = name.split("#");
				if (t.length>1)	cPage.orientation = t[1];
				cPage.attrValues[0] = objs[i][1];
				cPage.attrValues[1] = objs[i][2];
				if (objs[i][3]) // protected
					cPage.attrValues[2] = objs[i][3];
				if (objs[i][4]) // alternative page
					cPage.attrValues[3] = objs[i][4];
				project.addPage(cPage);
				break;
			case "popup":
				cPopup = dictionary.getObjInstance("popup");
				project.addPage(cPopup);
				cPopup.attrValues[0] = objs[i][1];
				cPopup.attrValues[1] = objs[i][2];
				cPopup.attrValues[2] = objs[i][3];
				cPopup.width = cPopup.obj.width;
				cPopup.height = cPopup.obj.height;
				break;
			case "endofpage":
			case "endofmenu":
			case "endofoverlay":
				cPage = null;
				cPopup = null;
				cContainer = null;
				break;
			case "container":
				cObj = dictionary.getObjInstance("container");
				cObj.attrValues[0] = objs[i][1];
				cObj.attrValues[1] = objs[i][2];
				v = objs[i][1].toUpperCase();
				var p;
				if ((v.indexOf('X')==0) && (p=v.indexOf('Y'))>0) {
					cObj.posMode = "xy";
					cObj.x = parseInt(v.substr(1,p));
					cObj.y = parseInt(v.substr(p+1));
					cObj.updateRowColumn();
				} else if ((v.indexOf('R')==0) && (p=v.indexOf('C'))>0) {
					cObj.posMode = "rc"; // x,y will be calculated on redraw
					cObj.r = parseInt(v.substr(1,p));
					cObj.c = parseInt(v.substr(p+1));
				} else {
					cObj.posMode = "rc";
					cObj.r = parseInt(v.charAt(0));
					cObj.c = parseInt(v.charAt(1));
				}
				if (cContainer)
					cContainer.addObj(cObj);
				else if (cPage)
					cPage.addObj(cObj);
				else if (cPopup)
					cPopup.addObj(cObj);
				// add id
				if (id)	cObj.id = id;
				cContainer = cObj;
				break;
			case "endofcontainer":
				if (options.object) { // when parsing inner objects: $((..))
					cObj = dictionary.getObjInstance("endofcontainer");
				} else if (cContainer) { // no cContainer? it's an error
					if (cContainer.objs.length) {
						cContainer.width = 10;
						cContainer.height = 10;
					}
					cContainer.fitSize();
					cContainer.redraw();
					cContainer = cContainer.parentObj;
					if (cContainer.isPage)
						cContainer = null;
				}
				break;
			case "dmxrgb":
				name = "rgb"; // compatibility: dmxrgb becomes rgb
			// other objects
			default:
				cObj = dictionary.getObjInstance(name);
				if (cObj) {
					if (cContainer)
						cContainer.addObj(cObj);
					else if (cPage)
						cPage.addObj(cObj);
					else if (cPopup)
						cPopup.addObj(cObj);
					// attr values
					for (var k=0; k<cObj.obj.attributes.length; k++) {
						var v = (k+1<objs[i].length)?objs[i][k+1]:null;
						/*
						if (v) {
							v = v.replace(/\&\#40\;/g,'(');
							v = v.replace(/\&\#41\;/g,')');
						}
						*/
						cObj.attrValues[k] = v;
						if (v) // shouldn't happen TODO:error handling
						switch(cObj.obj.attributes[k].type) {
						case "pos":
							v = v.toUpperCase();
							var p;
							if ((v.indexOf('X')==0) && (p=v.indexOf('Y'))>0) {
								cObj.posMode = "xy";
								cObj.x = parseInt(v.substr(1,p));
								cObj.y = parseInt(v.substr(p+1));
								cObj.updateRowColumn();
							} else if ((v.indexOf('R')==0) && (p=v.indexOf('C'))>0) {
								cObj.posMode = "rc"; // x,y will be calculated on redraw
								cObj.r = parseInt(v.substr(1,p));
								cObj.c = parseInt(v.substr(p+1));
							} else {
								cObj.posMode = "rc";
								cObj.r = parseInt(v.charAt(0));
								cObj.c = parseInt(v.charAt(1));
								if (isNaN(cObj.r)) cObj.r = 1;
								if (isNaN(cObj.c)) cObj.c = 1;
							}
							break;
						case "width":
						case "camerawidth":
							cObj.width = parseInt(v);
							break;
						case "height":
						case "cameraheight":
							cObj.height = parseInt(v);
							break;
						}
					}
					// add id
					if (id)	cObj.id = id;
					// object outside container?
					if (!cObj.parentObj) {
						if (cObj.obj.id == "background") { // special case for project background
							project.background = cObj.attrValues[0];
						}
					} else {
						// draw the object (generate the inner html)
						cObj.redraw();
					}
				}
			}
		}

		if (options.include) {
			return cContainer;
		} else if (options.object) {
			return cObj;
		} else {
			project.sortPages();
			project.updateSize();
		}
	}; // parseHSC()

} // Parser()

//--------------------------------------------------------------------------------------------------------------------------
// Dictionary --------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------

function Dictionary(xml) {
	this.objs = []; // objects (all object kinds)

	// parse xml
	var root = xml.documentElement;
	var configRoot = root.getElementsByTagName("config")[0];
	var objRoot = root.getElementsByTagName("objects")[0];
	var objNodes = objRoot.getElementsByTagName("obj");

	// config
	this.skin = configRoot.getElementsByTagName("skin")[0].childNodes[0].nodeValue;
	try { this.size = configRoot.getElementsByTagName("size")[0].childNodes[0].nodeValue; } catch (e) { this.size = ""; }
	if (this.size) {
		this.size = this.size.split(","); // x,y
		if (project) {
			if (!project.width) project.width = parseInt(this.size[0]);
			if (!project.height) project.height = parseInt(this.size[1]);
		}
	}

	this.skin = configRoot.getElementsByTagName("skin")[0].childNodes[0].nodeValue;
	this.gridSizes = eval(configRoot.getElementsByTagName("grid")[0].childNodes[0].nodeValue);
	this.margin = {};

	this.colors = {};
	var setNodes = configRoot.getElementsByTagName("styles")[0].getElementsByTagName("set");
	var colorNodes,i,t,s,c;
	for (i=0; i<setNodes.length; i++) {
		s = setNodes[i].getAttribute("name");
		this.colors[s] = [];
		colorNodes = setNodes[i].getElementsByTagName("style");
		for (t=0; t<colorNodes.length; t++) {
			c = {};
			c.name = colorNodes[t].getAttribute("name");
			c.value = colorNodes[t].getAttribute("value");
			c.alt = colorNodes[t].getAttribute("alt");
			c.hidden = colorNodes[t].getAttribute("hidden");
			this.colors[s].push(c);
		}
	}

	var m,e;
	try {
		m = configRoot.getElementsByTagName("margin")[0].childNodes[0].nodeValue.split(",");
		this.margin.standard = [parseInt(m[0]),parseInt(m[1]),parseInt(m[2]),parseInt(m[3])];
	} catch (e) {
		this.margin.standard = [0,0,0,0];
	}
	try {
		m = configRoot.getElementsByTagName("margincompact")[0].childNodes[0].nodeValue.split(",");
		this.margin.compact = [parseInt(m[0]),parseInt(m[1]),parseInt(m[2]),parseInt(m[3])];
	} catch (e) {
		this.margin.compact = this.margin.standard;
	}
	try {
		m = configRoot.getElementsByTagName("marginkiosk")[0].childNodes[0].nodeValue.split(",");
		this.margin.kiosk = [parseInt(m[0]),parseInt(m[1]),parseInt(m[2]),parseInt(m[3])];
	} catch (e) {
		this.margin.kiosk = this.margin.standard;
	}
	try {
		m = configRoot.getElementsByTagName("marginpopup")[0].childNodes[0].nodeValue.split(",");
		this.margin.popup = [parseInt(m[0]),parseInt(m[1]),parseInt(m[2]),parseInt(m[3])];
	} catch (e) {
		this.margin.popup = [0,0,0,0];
	}
	this.bgStyle = configRoot.getElementsByTagName("bgstyle")[0].childNodes[0].nodeValue;

	// objects
	var a,v,src,def,size, minsize, maxsize, deltasize,n,obj,attr,k,t; // object properties
	for (var i=0; i<objNodes.length; i++)  {
		n = objNodes[i];
		try { src = n.getElementsByTagName("src")[0].childNodes[0].nodeValue; } catch (e) { src = ""; }
		try { def = n.getElementsByTagName("default")[0].childNodes[0].nodeValue; } catch (e) { def = ""; }
		try { size = n.getElementsByTagName("size")[0].childNodes[0].nodeValue; } catch (e) { size = ""; }
		try { minsize = n.getElementsByTagName("minsize")[0].childNodes[0].nodeValue; } catch (e) { minsize = ""; }
		try { maxsize = n.getElementsByTagName("maxsize")[0].childNodes[0].nodeValue; } catch (e) { maxsize = ""; }
		try { deltasize = n.getElementsByTagName("deltasize")[0].childNodes[0].nodeValue; } catch (e) { deltasize = ""; }

		a = n.attributes;
		v = {};
		for(var t=0; t<a.length; t++)
			v[a[t].name] = a[t].value;

		// new object
		obj = new Obj(v,src,def,size,minsize,maxsize,deltasize);
		this.objs.push(obj);

		attrs = n.getElementsByTagName("attr");
		for (t=0; t<attrs.length; t++) {
			a = attrs[t].attributes;
			v = {};
			for (k=0; k<a.length; k++)
				v[a[k].name] = a[k].value;
			obj.addAttr(v);
		}
	}

	// include obj
	var includeObj = new Obj({id:"#include", iId:false, grid:"1", hidden:false, closedby:"#include"},"<div></div>","","0,0");
	includeObj.addAttr({name:"File", type:"include"});
	includeObj.hidden = true;
	this.objs.push(includeObj);

	// get object instance, given the object id
	this.getObjInstance = function (id) {
		for (var i=0; i<this.objs.length; i++) {
			if (this.objs[i].id == id)
			return this.objs[i].getInstance();
		}
	}; // getObjInstance()

	// calculate row/column based on x/y
	this.calcRowColumn = function (x,y,grid) {
		return {c:Math.floor((x-this.gridSizes[grid-1][0])/this.gridSizes[grid-1][2])+1,
				r:Math.floor((y-this.gridSizes[grid-1][1])/this.gridSizes[grid-1][3])+1};
	}; // calcRowColumn()

	// calculate x/y based on row/column
	this.calcXY = function (r,c,grid) {
		return {x:(c-1)*this.gridSizes[grid-1][2]+this.gridSizes[grid-1][0],
				y:(r-1)*this.gridSizes[grid-1][3]+this.gridSizes[grid-1][1]};
	}; // calcXY()

	// get color regular expression to be used when changing a color class
	// all this stuff is elegant, but nearly useless, since it's used just to change color on button objects (light=blue, autom=gray)
	// use it (from the console) to get the string to paste in include.js
	this.getColorRegExp = function (colorSet) {
		var col = [];
		for (var i=0; i<this.colors[colorSet].length; i++) {
			col.push(this.colors[colorSet][i].value.replace(" ","\s"));
			if (this.colors[colorSet][i].alt)
				col.push(this.colors[colorSet][i].alt.replace(" ","\s"));
		}
		col = col.unique().sort(function(a, b){ return b.length - a.length; }); // ASC -> a - b; DESC -> b - a
		if (col[col.length-1]=="") col.pop();
		return col.join("|"); // glass|gr|g|b|y|r
	}; // getColorRegExp()
} // Dictionary()

//--------------------------------------------------------------------------------------------------------------------------
// Classes -----------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------

// Obj attribute class
function ObjAttr(v) {
	// name
	this.name = v["name"];
	// type
	this.type = v["type"];
	// values
	this.values = null;
	if (v["values"])
		this.values = v["values"].split(",");
	if (v["styleset"]) // styleset for color type attributes
		this.colorSet = v["styleset"];
	// labels
	this.labels = null;
	if (v["labels"])
		this.labels = v["labels"].split(",");
	// optional
	this.optional = (v["optional"] == "true");
	// can be empty?
	this.empty = (v["empty"] == "true");
} // ObjAttr Class

// Obj class. ui object with an id, source..
function Obj(v, src, def, size, minsize, maxsize, deltasize) {
	// id
	this.id = v["id"];
	// source
	this.source = src;
	// other parameters
	this.type = v["type"]?v["type"]:"std";
	this.iId = (v["iId"]?v["iId"]:null); // instance id, required optional or null
	this.grid = (v["grid"])?parseInt(v["grid"]):1; // grid (1,2,3..)
	this.hidden = (v["hidden"] == "true"); // not selectable from the palette
	this.closedBy = v["closedby"]; // container object closed by another object?
	this.def = (def!=null)?def.split(","):null; // default attribute values
	this.dAttr = null; // description attribute

	this.watch = this.id.substr(0,7) == "_watch_";
	this.fastPos = (src.search(/<div[^>]*\$@\d\.s[^>]*>/) == 0) || (this.watch); // looks for a style $@N.s on the first div: fast position mode

	if (size) {
		var s = size.split(",");
		this.width = parseInt(s[0]);
		this.height = parseInt(s[1]);

		if (minsize) {
			s = minsize.split(",");
	 		this.minWidth = parseInt(s[0]);
	 		this.minHeight = parseInt(s[1]);
		}

		if (maxsize) {
			s = maxsize.split(",");
	 		this.maxWidth = parseInt(s[0]);
	 		this.maxHeight = parseInt(s[1]);
		}

		if (deltasize) {
			s = deltasize.split(",");
	 		this.deltaWidth = parseInt(s[0]);
	 		this.deltaHeight = parseInt(s[1]);
		}
	}

	// container object, specify a size
	if (this.id == "container") {
		this.width = 100;
		this.height = 100;
		this.minWidth = 10;
		this.minHeight = 10;
	}

	// attributes
	this.attributes = [];

	// is description attribute? TODO:move elsewhere?
	this.isDescrAttr = function (v) {
		return (v == "id" ||
				v == "label" ||
				v == "img" ||
				v == "device" ||
				v == "scene" ||
				v == "camera" ||
				v == "timer" ||
				v == "security" ||
				v == "music" ||
				v == "temp")
	}

	// add an attribute
	this.addAttr = function (v) {
		this.attributes.push(new ObjAttr(v));
		// description attribute
		if (this.isDescrAttr(v["type"]))
			this.dAttr = this.attributes.length-1;
	}

	// get instance of this object
	this.getInstance = function () {
		var o = new ObjInstance(this);
		if (this.def)
			for (var i=0; i<this.def.length; i++)
				o.attrValues[i] = this.def[i];
		return o;
	}
} // Obj Class

// Obj instance class.  obj (from dictionary), optional parentObj if contained
function ObjInstance(obj) {
	// reference obj
	this.obj = obj;
	// parent obj. set later
	this.parentObj = null;
	// attribute values
	this.attrValues = [];
	// warnings if any. set by projectEditor.checkObjectWarnings
	this.warnings = null;
	// div
	this.div = document.createElement("div");
	this.div.className = "objectNode";
	// size
	if (obj.width != null)	this.width = obj.width;
	if (obj.height != null)	this.height = obj.height;
	// visibility
	this.visible = true;
	// id
	if (obj.iId)
		this.id = "";

	var borderStyle = "none"; // show border? save it so we update it when fast updating position

	// position
	for (var i=0; i<obj.attributes.length; i++) {
		if (obj.attributes[i].type == "pos") {
			// position mode
			this.posMode = "rc";
			// coordinates
			this.x = 0;
			this.y = 0;
			this.r = 1;
			this.c = 1;
			break;
		}
	}

	// change type
	this.changeObjType = function (id) {
		if (this.obj.id == id) return // nothing changed

		// conversion. TODO: shouldn't call projectEditor?
		if (this.isPage) {
			// work around, so code is not copied
			var p = projectEditor.addPage(id,true);
			this.obj = p.obj;
			var prop = ["width","height","gestures","locations","scope",
						"orientation","attrValues"];
			for (var i=0; i<prop.length; i++) {
				this[prop[i]] = p[prop[i]];
			}
		} else {
			for (var i=0; i<dictionary.objs.length; i++) {
				if (dictionary.objs[i].id == id) {
					this.obj = dictionary.objs[i];
					break;
				}
			}
		}
	} // changeObjType()

	// clone obj
	this.cloneObj = function (parent) {
		var o = this.obj.getInstance();
		for (var i=0; i<this.attrValues.length; i++) {
			o.attrValues[i] = this.attrValues[i];
			if (this.obj.attributes[i] && this.obj.attributes[i].type == "pos") {
				o.x = this.x;
				o.y = this.y;
				o.r = this.r;
				o.c = this.c;
			}
		}
		o.id = this.id;
		o.width = this.width;
		o.height = this.height;
		o.visible = true;
		o.posMode = this.posMode;
		o.parentObj = parent;

		if (this.orientation)
			o.orientation = this.orientation;

		if (this.gestures)
			o.gestures = this.gestures;

		if (this.scope)
			o.scope = this.scope;

		if (this.fixedRatio)
			o.fixedRatio = this.fixedRatio;

		if (this.isContainer) {
			for (i=0; i<this.objs.length; i++) {
				o.addObj(this.objs[i].cloneObj(this));
			}
		}

		o.redraw();
		return o;
	} // cloneObj()

	// to JSON. recursive? save all children
	this.toJSON = function (recursive) {
		var o = {};
		o.type = this.obj.id;
		o.attrValues = [];
		for (var i=0; i<this.attrValues.length; i++) {
			o.attrValues[i] = this.attrValues[i];
			if (this.obj.attributes[i] && this.obj.attributes[i].type == "pos") {
				o.x = this.x;
				o.y = this.y;
				o.r = this.r;
				o.c = this.c;
			}
		}
		o.id = this.id;
		o.width = this.width;
		o.height = this.height;
		o.visible = true;
		o.posMode = this.posMode;

		if (this.orientation)
			o.orientation = this.orientation;

		if (this.gestures)
			o.gestures = this.gestures;

		if (this.scope)
			o.scope = this.scope;

		if (this.fixedRatio)
			o.fixedRatio = this.fixedRatio;

		if (this.isContainer && recursive) {
			o.objs = [];
			for (i=0; i<this.objs.length; i++) {
				o.objs.push(this.objs[i].toJSON(recursive));
			}
		}
		return o;
	} // toJSON()

	// from JSON. JSON o, redraw all? returns all the attribute ids that changed
	this.fromJSON = function (o,redraw) {
		var c = []; // what changed. indexes of the attributes

		if (this.isPage) {
			if (o.type != this.obj.id) {
				this.changeObjType(o.type);
				c.push(0);
			}
			for (var i=0; i<o.attrValues.length; i++) {
				if (this.attrValues[i] != o.attrValues[i]) {
					c.push(i+1);
					this.attrValues[i] = o.attrValues[i];
				}
			}
			if (o.orientation != this.orientation) {
				this.orientation = o.orientation;
				c.push(3);
			}
			// popup size? just check, will be set later
			if (this.width != o.width || this.height != o.height)
				c.push(4);
			if (o.locations != this.locations) {
				this.locations = o.locations;
				c.push(5);
			}
			if (o.gestures != this.gestures) {
				this.gestures = o.gestures;
				c.push(7); // test this
			}
			if (o.scope != this.scope) {
				this.scope = o.scope;
				c.push(8); // test this
			}
		} else {
			if (this.obj.iId) {
				if (this.id != o.id) {
					c.push(0);
					this.id = o.id;
				}
			}
			for (var i=0; i<o.attrValues.length; i++) {
				if (this.attrValues[i] != o.attrValues[i]) {
					c.push(this.obj.iId?i+1:i);
					this.attrValues[i] = o.attrValues[i];
				}
				// fixedRatio
				if (this.obj.attributes[i].type == "width" && o.fixedRatio != this.fixedRatio) {
					this.fixedRatio = o.fixedRatio;
					c.push(this.obj.iId?i+1:i);
				}
			}
			if (this.posMode) {
				if (this.posMode != o.posMode) {
					c.push("posMode");
					this.posMode = o.posMode;
				}
				this.x = o.x;
				this.y = o.y;
				this.r = o.r;
				this.c = o.c;
			}
		}
		// container?
		if (o.objs) {
			this.objs = [];
			var oo;
			for (i=0; i<o.objs.length; i++) {
				oo = dictionary.getObjInstance(o.objs[i].type);
				oo.parentObj = this;
				oo.fromJSON(o.objs[i],redraw);
				this.objs.push(oo);
			}
		}
		// size
		if (this.width != null)
			this.width = o.width;
		if (this.height != null)
			this.height = o.height;

		this.redraw();
		return c.unique();
	} // fromJSON()

	this.setPosition = function (x,y) {
		this.px = this.x;
		this.py = this.y;
		this.x = x;
		this.y = y;
	};

	// set x/y position
	this.updatePos = function () {
		//this.checkPos(); // check limits
		// line special case
		if (this.obj.id == "line") {
			var dx = this.x-this.px;
			var dy = this.y-this.py;
			this.attr0[0] += dx;
			this.attr0[1] += dy;
			this.attr1[0] += dx;
			this.attr1[1] += dy;
			this.attrValues[0] = "x"+this.attr0.join("y");
			this.attrValues[1] = "x"+this.attr1.join("y");
			this.redraw();
			return;
		}
		// not optimized?
		if (!this.obj.fastPos) {
			this.redraw();
			return;
		}
		// update attributes
	 	for (var i=0; i<this.obj.attributes.length; i++) {
	 		if (this.obj.attributes[i].type == "pos") {
		 		this.attrValues[i] = (this.posMode == "xy")?("x"+this.x+"y"+this.y):("r"+this.r+"c"+this.c);
	 			break;
	 		}
	 	}
		var d = this.div.childNodes[this.isContainer?2:0]; // container has two divs before (shadow, bg)
		if (d) {
			d.style.left = this.x + "px";
			d.style.top = this.y + "px";
		}
		if (borderStyle != "none") // update border if any
			this.showBorder();
	} // setPosition()

	// calculate row/column based on x/y
	this.updateRowColumn = function (x,y) {
		if (x == null) x = this.x;
		if (y == null) y = this.y;
		var p = dictionary.calcRowColumn(x,y,this.obj.grid);
		this.c = p.c;
		this.r = p.r;
	} // updateRowColumn()

	// calculate x/y based on row/column
	this.updateXY = function (r,c) {
		if (r == null) r = this.r;
		if (c == null) c = this.c;
		var p = dictionary.calcXY(r,c,this.obj.grid);
		this.x = p.x;
		this.y = p.y;
	} // updateXY()

	// check position limits (can't be outside the page). return new coordinates
	this.checkPos = function () {
		var res = {x:null,y:null,r:null,c:null};
		var l = 10; // limit
		var page = this.parentObj;
		while (page && page.parentObj) page = page.parentObj;
		if (!page) return; // can it even happen?
		var popupOffset = (page.obj.id == "popup")?10:0;
		var ox = (this.parentObj.isContainer)?this.parentObj.ax:0;
		var oy = (this.parentObj.isContainer)?this.parentObj.ay:0;
		// limits
		var cl = l-this.width;
		var cr = page.width-ox-l;
		var ct = l-this.height-popupOffset;
		var cb = page.height-oy-l-popupOffset;
		if (this.x < cl) {
			res.x = cl;
		} else if (this.x > cr) {
			res.x = cr;
		}
		if (this.y < ct) {
			res.y = ct;
		} else if (this.y > cb) {
			res.y = cb;
		}
		// row/column
		if (this.c<1) res.c = 1;
		if (this.r<1) res.r = 1;
		if (this.parentObj && this.parentObj.isPage) {
			var m = dictionary.calcRowColumn(this.parentObj.width,this.parentObj.height,this.obj.grid);
			if (this.r>m.r) res.r = m.r;
			if (this.c>m.c) res.c = m.c;
		}
		return (res.x!=null || res.y!=null || res.r!=null || res.c!=null)?res:null;
	} // checkPos()

	// fix position based on checkPos res
	this.fixPos = function (p) {
		if (!p) p = this.checkPos();
		if (p) // restore
			for (var i in p)
				if (p[i]!=null)
					this[i] = p[i];
	} // fixPos()

	// update size attributes based on height/width
	this.updateSizeAttributes = function () {
		for (var i=0; i<this.obj.attributes.length; i++) {
			if (this.obj.attributes[i].type == "width")
				this.attrValues[i] = this.width;
			else if (this.obj.attributes[i].type == "height")
				this.attrValues[i] = this.height;
		}
	} // updateSizeAttributes()

	// get attribute {i,attr def,value} by name
	this.getAttrByName = function (name) {
		name = name.toLowerCase();
		for (var i=0; i<this.obj.attributes.length; i++) {
			if (this.obj.attributes[i].name.toLowerCase() == name) {
				return {i:i, attr:this.obj.attributes[i], value:this.attrValues[i]};
			}
		}
		return null;
	};

	// get source with parameters applied. options, like parseHSC
	this.getHTMLSrc = function (options) {
		if (!options) options = {}; // default
	 	var src = this.obj.source;

		// replace id
		if (this.id) {
	 		src = src.replace("$?",this.id);
		} else {
	 		src = src.replace("$?",'');
		}

		// optional parameters, remove the other block
		var r; // reg exp
	 	for (var i=0; i<this.obj.attributes.length; i++) {
	 		var n = (i<9)?i+1:String.fromCharCode(56+i); // 65 = A
	 		var v = null;
	 		if (i<this.attrValues.length) {
	 			v = this.attrValues[i];
/*
				v = v.replace(/\&\#40\;/g,'(');
				v = v.replace(/\&\#41\;/g,')');
*/
	 		}
			// regexp
			if (src.indexOf("$("+n+"=~")!=-1) {
				r = new RegExp("\\$\\((!)?"+n+"=~([^\\)]*)\\)(.*?)\\$\\(\\)");
				var match;
				while (match = r.exec(src)) {
					var r2 = new RegExp(match[2]);
					if ((r2.test(v) && match[1]!="!")||(!r2.test(v) && match[1]=="!")) {
						src = src.replace(r,"$3"); // using $1 to get $ :(
					} else {
						src = src.replace(r,"");
					}
					r.lastIndex = 0; // reset since the string changed
				}
			}
	 		// if value
 			if (v) {
 				// remove $(!n)...$()
 				if (src.indexOf("$(!"+n+")")!=-1) {
	 				r = new RegExp("\\$\\(!"+n+"\\)(.*?)\\$\\(\\)","g")
	 				src = src.replace(r,"");
 				}
 				// replace $(n)...$() with ...
 				if (src.indexOf("$("+n+")")!=-1) {
	 				r = new RegExp("\\$\\("+n+"\\)(.*?)\\$\\(\\)","g");
	 				src = src.replace(r,"$1");
 				}
 			} else {
 				// remove $(n)...$()
 				if (src.indexOf("$("+n+")")!=-1) {
	 				r = new RegExp("\\$\\("+n+"[^\\)]*\\)(.*?)\\$\\(\\)","g")
	 				src = src.replace(r,"");
 				}
 				// replace $(!n)..$() width ...
 				if (src.indexOf("$(!"+n+")")!=-1) {
 					r = new RegExp("\\$\\(!"+n+"]*\\)(.*?)\\$\\(\\)","g");
 					src = src.replace(r,"$1");
 				}
 			}
	 	}

	 	// parameters' value
	 	for (var i=0; i<this.obj.attributes.length; i++) {
	 		var n = (i<9)?i+1:String.fromCharCode(56+i); // 65 = A
	 		var v = "";
	 		if (i<this.attrValues.length)
	 			v = this.attrValues[i];
	 		switch(this.obj.attributes[i].type) {
	 		case "pos":
	 			if (this.posMode == "xy") {
		 			this.attrValues[i] = "x"+this.x+"y"+this.y;
			 		src = src.replace("$@"+n+".c","");
			 		src = src.replace("$@"+n+".s","left:"+this.x+"px; top:"+this.y+"px;");
	 			} else if (this.posMode == "rc") {
		 			this.attrValues[i] = "r"+this.r+"c"+this.c;
			 		src = src.replace("$@"+n+".c"," r"+this.r+" c"+this.c);
			 		src = src.replace("$@"+n+".s","");
	 			}
	 			break;
	 		case "width":
	 		case "camerawidth":
	 			r = new RegExp("\\$"+n,"g");
	 			src = src.replace(r,this.width);
	 			break;
	 		case "height":
	 		case "cameraheight":
	 			r = new RegExp("\\$"+n,"g");
	 			src = src.replace(r,this.height);
	 			break;
	 		default:
	 			r = new RegExp("\\$"+n,"g");
	 			src = src.replace(r,v);
	 			break;
	 		}
	 	}

		// path
		src = src.replace(/\$__path;/g,project.name);

	 	// inner objects?
	 	var p1 = 0;
	 	var p2 = 0;
	 	var s,e,h;
	 	var scp = -1; // skip container position
	 	var cc = 0; // hidden containers counter
	 	while ((p1 = src.indexOf("$((",p1))!=-1) {
	 		p2 = src.indexOf("))",p1+1);
	 		if (src.charAt(p2+2)==")") p2++; // in case $((obj (meh)))
	 		s = src.substr(p1+2,p2-p1-1); // (obj ...)
	 		e = parser.parseHSC(s,{object:true}); // objInstance
	 		if (e.obj.id == "container") { // detect an hidden container, skip content
	 			if (scp==-1 && e.attrValues[1] == "hidden") scp = p1; // when true, skip html of all inner content
	 			if (scp!=-1) cc++;
	 		}
	 		if (scp==-1) {
	 			h = e.getHTMLSrc({object:true}); // html source
	 			src = src.substr(0,p1) + h + src.substr(p2+2); // rebuild source
	 		} else {
	 			p1 = p2;
	 		}
	 		if (e.obj.id == "endofcontainer" && scp!=-1) {
	 			cc--;
	 			if (!cc) {
	 				src = src.substr(0,scp) + src.substr(p2+2); // remove hidden container and content
	 				p1 -= p2+2-scp;
	 				scp = -1; // done skipping
	 			}
	 		}
	 	}

	 	if (manager) {
			// custom text
			src = src.replace(/\$([_a-z][a-z0-9]+);/g, function(s,m1){ var r=project.customLan[m1]; return r?r:""; } );

	 		// remove remaining variables (strings...)
	 		//src = src.replace(/\$[^;^\s^"]+;/g,"");

		 	// remove events
		 	src = src.replace(/on[a-zA-Z]+="[^"]*"/,"");

		 	// remove scripts
		 	src = src.replace(/<script .*?<\/script>/,"");

		 	if (!options.object) {
			 	// container? add shadow/over
			 	if (this.obj.id == "container") {
			 		src = "<div class='containerShadow'></div><div class='containerBg' style='background:"+dictionary.bgStyle+"'></div>"+
			 				src+"</div><div class='containerOver'></div>";
			 	} else if (this.obj.id == "chart") {
			 		src += "<div class='chartOver'></div>";
			 	} else if (this.obj.id == "securitylog" || this.obj.id == "securitydisplay") {
			 		src += "<div class='securityLogOver'></div>";
			 	} else if (this.isInclude) {
			 		src += "<div class='includeOver'></div>";
			 	} else if (this.closeObj) { // close obj
			 		src += this.closeObj.getHTMLSrc();
			 	}
		 	}
	 	}
	 	return src;
	} // getHTMLSrc()

	// get HSM source with parameters applied. source or hsm? n for tabs
	this.getHSMSrc = function (hsm,n) {
		if (!n)
			n = 0;
		var tab = "";
		for (var k=0; k<n; k++) tab += '\t';

		var src = tab;

		if (hsm && (this.obj.id == "page" || this.obj.id =="menu" || this.obj.id =="popup" || this.obj.id == "overlay")) {
			src += '### Quick Guide:\n';
			src += '# - the object\'s coordinates must start at 0,0. if there\'s a background panel, its position should be x0y0\n';
			src += '# - no need for a nested container, just imagine the page as the object\'s container\n';
			src += '# - containers with hidden visibility (visible attribute) won\'t be visible when placing the final object in the Project Editor\n';
			src += '# - replace 1 in $@1.c and $@1.s with correct position attribute\n';
			src += '#    ex.: if the position is the second attribute (not counting the id): $@1.c > $@2.c, $@1.s > $@2.s\n';
			src += '# - replace the other attributes\n';
			src += '#    ex.: if the first attribute is the server name and xxx is the placeholder: xxx.label > $1.label\n';
			src += '# - fix all the images\' paths and move the files to [skin]/pic/[object\'s name]\n';
			src += '#    ex.: knxbrowser-on.png > /blue/pic/knxbrowser/knxbrowser-on.png\n';
			src += '# - no need for empty pngs! when src is empty, it will automatically be replaced with an empty image\n';
			src += '# - remove these comments and you\'re done\n';
			src += '###\n';
			src += '<div class="g1$@1.c" style="$@1.s;" data-type="container">\n';
		} else if (hsm && (this.obj.id == "endofpage" || this.obj.id == "endofmenu" || this.obj.id == "endofoverlay")) {
			src += '</div>\n';
		} else {
			if (hsm) src += '$(';
			src +='('+this.obj.id;
			if (this.orientation && this.obj.id != "popup") // can be popup, when converting from a page
				src += '#'+this.orientation;
			if (this.obj.iId && this.id)
				src += '!'+this.id;

			var v;
			for (var k=0; k<this.obj.attributes.length; k++) {
				if (this.obj.attributes[k].optional &&
					(this.attrValues.length<=k || this.attrValues[k] == null)) {
					v = "";
					var done = true;
					// check next
					for (var t=k+1; t<this.attrValues.length; t++) {
						if (this.attrValues[t]!=null) {
							done = false;
						}
					}
					if (done) break;
				} else {
					v = this.attrValues[k];
				}

				if (k != 0)
					src += ';'

				if (v) {
					v = ''+v;
					v = v.replace(/\(/g,'&#40;');
					v = v.replace(/\)/g,'&#41;');
					if (v.indexOf(';') >= 0)
						v = '('+v+')';
					src += ' '+v;
				} else if (k == 0) {
					src += ' '; // otherwise we'd have (object; ..)
				}
			}
			if (hsm) src += ')';
			src += ")\n";

			// additional options
			if (this.obj.id == "popup") {
				if (this.width && this.height)
					src += "(#size "+this.width+"x"+this.height+")\n";
			} else {
				if (this.obj.id == "page" && this.locations)
					src += "(#location "+this.locations+")\n";
				if (this.gestures)
					src += "(#gestures "+this.gestures+")\n";
				if (this.scope)
					src += "(#scope "+this.scope+")\n";
			}
		}

		if (this.isContainer && !this.isInclude) {
			var sp = false; // space?
			var id = "";
			for (var i=0; i<this.objs.length; i++) {
				id = this.objs[i].obj.id;
				if (i>0 && (id == "container" || sp)) // add space before container
					src += "\n";
				src += this.objs[i].getHSMSrc(hsm,n+1);
				sp = (id == "container"); // add space after container
			}
		}

		if (this.closeObj)
			src += this.closeObj.getHSMSrc(hsm,n);

	 	return src;
	} // getHSMSrc()

	// reset inner HTML
	this.redraw = function () {
		// position
		if (this.posMode == "rc" && this.c && this.r) {
			this.updateXY(this.r,this.c);
		}

		// include? get children
		if (this.isInclude) {
			var c = [];
			if (project.includes[this.attrValues[0]]) // loaded?
				for (var i=0; i<project.includes[this.attrValues[0]].length; i++)
					c.push(project.includes[this.attrValues[0]][i].div.cloneNode(true));
		}
		// container? save children
		else if (this.isContainer) {
			var c = [];
	 		for (var i=0; i<this.objs.length; i++)
	 			if (this.objs[i].div.className == "objectNode")
	 				c.push(this.objs[i].div);
		}

		this.div.innerHTML = this.getHTMLSrc();
		var p = (this.isPage)?(manager?projectEditor.pageContentE:client.pageContentE):null; // manager or client?
		if (p) {
			while (p.childNodes.length)
				p.removeChild(p.childNodes[0]);
		}

		// container? readd children
		if (this.isContainer) {
	 		for (i=0; i<c.length; i++) {
	 			if (this.isPage)
	 	 			p.appendChild(c[i]);
	 			else
	 				this.div.childNodes[this.isInclude?0:2].appendChild(c[i]);
	 		}
	 		if (manager && !this.isPage && this.parentObj) // only on manager
	 			this.showBorder(this == projectEditor.getActiveContainer() ? "open" :
	 							this.isInclude || this.parentObj.isPage ||
	 							this.parentObj == projectEditor.getActiveContainer() ? "visible" : "none");
		} else if (manager && (this.obj.id == "chart" || this.obj.id == "securitylog" || this.obj.id == "securitydisplay")) {
			this.showBorder(true);
		}

		// apply scripts if necessary
		this.reset();
	} // redraw()

	// apply scripts if necessary
	this.reset = function () {
		// TODO: this way it's too messy. every object should have a reset method taken from the client code
		// set button state
		function setState(e,dtype,type,state,value) {
			var state = "unknown";
			var templateName = project.skin;

			// this part is copied from client
			function setColor(e,color,colorset) {
				var c = e.className; // current class
				var r = new RegExp("([mc][^B]*Button)(\s("+dictionary.getColorRegExp(colorset)+"))?");
				c = c.replace(r,"$1 "+color); // can't begin with B: mB...Button
				e.className = c;
			}

			var icon = true;
			var bar = false;
			var img = "";
			var unknown = state=="unknown";
			var bw = 0;
			var pre = "/pic/bticon"+(dtype=="buttonicon"?"big":"");
			switch (type) {
				case "HSHUT":
					if (state == "unknown") state = "offdown";
					img = "/"+templateName+pre+"-hshut-"+state+".png";
					break;
				case "VSHUT":
					if (state == "unknown") state = "offdown";
					img = "/"+templateName+pre+"-vshut-"+state+".png";
					break;
				case "STD":
					if (state == "unknown") state = "off";
					img = "/"+templateName+pre+"-"+state+".png";
					break;
				case "LOCK":
					if (state == "unknown") state = "off";
					img = "/"+templateName+pre+"-lock-"+state+".png";
					break;
				case "ONOFF":
					if (state == "unknown") state = "off";
					img = "/"+templateName+pre+"-"+state+".png";
					icon = false;
					break;
				case "SCENE-EMER":
				case "SCENE":
					if (obj.id!="buttonicon") // buttonicon have custom colors <----- modified this.type --> obj.id
						setColor(e.childNodes[0],(type=="SCENE-EMER")?"alert":"scene","button"); // <----- modified from client code this.e --> e.childNodes[0]
					if (state == "unknown") state = "off";
					img = "/"+templateName+pre+"-scene-"+state+".png";
					break;
				case "DIMMER":
				case "LIGHT":
					if (state == "unknown") {
						state = "off";
						value = 0;
					}
					if (obj.id!="buttonicon") // buttonicon have custom colors <----- modified this.type --> obj.id
						setColor(e.childNodes[0],"light","button"); // <----- modified from client code this.e --> e.childNodes[0]
					bar = true;
					bw = value+"%";
					img = "/"+templateName+pre+"-light-"+state+".png";
					break;
			}
			var divs = e.getElementsByTagName("div");
			for (var k=0; k<divs.length; k++) {
				switch (divs[k].getAttribute("name")) {
				case "label":
					divs[k].style.display = (type=="ONOFF")?"none":"";
					break;
				case "onoff":
					divs[k].style.display = (type=="ONOFF")?"":"none";
					divs[k].innerHTML = state.toUpperCase();
					break;
				case "icon":
					divs[k].style.display = icon?"inline":"none";
					divs[k].getElementsByTagName("img")[0].src = img;
					break;
				case "unknown":
					divs[k].style.display = unknown?"inline":"none";
					break;
				case "bar":
					divs[k].style.display = bar?"inline":"none";
					break;
				case "barerror":
					break;
				case "baron":
					break;
				}
			}
		} // setState()

		switch (this.obj.id) {
		case "button":
		case "buttonicon":
			var item = this.attrValues[0];
			try {
				var type = JSONTopo.hsycotopology.devices[item][3];
			} catch (e) {
				var type = "LIGHT";
			}
			setState(this.div,this.obj.id,type,"unk");
			break;
		case "3button":
			var img1 = this.div.getElementsByTagName("img")[0];
			var img2 = this.div.getElementsByTagName("img")[2];
			var item = this.attrValues[0];
			try {
				var type = JSONTopo.hsycotopology.devices[item][3];
			} catch (e) {
				var type = "VSHUT";
			}
			var t = (type == "HSHUT") ? "hshut" : "vshut";
			img1.src = "/"+project.skin+"/pic/bticonbig-"+t+"-up.png";
			img2.src = "/"+project.skin+"/pic/bticonbig-"+t+"-down.png";
			break;
		case "buttonimage":
			var img = this.div.getElementsByTagName("img")[0];
			img.src = "/"+project.name+"/img/"+this.attrValues[4]; break;
			break;
		case "text":
			// no text?
			if (this.attrValues[1] == "") {
				this.div.childNodes[0].innerHTML = (this.id)?"!"+this.id:"text";
				this.div.childNodes[0].style.whiteSpace = "nowrap";
			}
			// go on
		case "input":
		case "date":
		case "time":
		case "keypad":
		case "select":
			var d = this.div.childNodes[0];
			if (manager) { // TODO: size needed for client too?
				var s = manager.getDivSize(d);
				if (s.w != this.width || s.h != this.height) {
					this.width = s.w;
					this.height = s.h;
					// only on manager
					if (manager && projectEditor.getActiveObj() == this)
						projectEditor.updateSelectedFrame();
				}
			}
			break;
		case "line":
			if (manager) { // TODO: what the?
				this.posMode = "xy";

				var sp = this.attrValues[0];
				sp = sp.trim().substr(1).split("y");
				sp = [parseInt(sp[0]), parseInt(sp[1])];
				this.startPoint = sp;
				this.attr0 = [sp[0],sp[1]]; // save it to move it

				var ep = this.attrValues[1];
				ep = ep.trim().substr(1).split("y");
				ep = [parseInt(ep[0]), parseInt(ep[1])];
				this.endPoint = ep
				this.attr1 = [ep[0],ep[1]]; // save it to move it

				var strokeColor = this.attrValues[2];
				var strokeWidth = this.attrValues[3];
				var lineCap = this.attrValues[4];
				var lineDash = this.attrValues[5];

				if (!strokeColor)
					strokeColor = "white";
				strokeWidth = parseInt(strokeWidth);
				if (!strokeWidth)
					strokeWidth = 1;
				if (!lineCap)
					lineCap = "butt";

				this.x = Math.min(sp[0], ep[0]);
				this.x -= strokeWidth;

				this.y = Math.min(sp[1], ep[1]);
				this.y -= strokeWidth;

				this.width = Math.max(sp[0], ep[0], 50) - this.x + strokeWidth;
				this.height = Math.max(sp[1], ep[1], 50) -  this.y + strokeWidth;

				sp[0] -= this.x;
				sp[1] -= this.y;
				ep[0] -= this.x;
				ep[1] -= this.y;

				var svg = "<svg style='left:"+this.x+"px; top:"+this.y+"px; width:"+this.width+"px; height:"+this.height+"px'>";
				svg += '<path d="M '+sp[0]+','+sp[1]+' L '+ep[0]+','+ep[1]+'"';
				svg += ' stroke="'+strokeColor.replace(/"/g,'\"')+'"';
				svg += ' stroke-width="'+strokeWidth+'"';
				svg += ' stroke-linecap="'+lineCap.replace(/"/g,'\"')+'"';
				if (lineDash)
					svg += ' stroke-dasharray="'+lineDash.replace(/"/g,'\"')+'"';
				svg += '/></svg>';

				this.div.childNodes[0].innerHTML = svg;
				projectEditor.updateSelectedFrame();
			}
			break;
		case "camera":
		case "cameraimage":
		case "camerapanel":
			// components
			var divs = this.div.getElementsByTagName("div");
			var c = {};
			for (var t=0; t<divs.length; t++) {
				var name = divs[t].getAttribute("name");
				c[name] = divs[t];
			}

			c.cameraimage.innerHTML = ""; // clean image
			c.cameraimage.style.backgroundColor = "black";
			c.cameraimage.style.width = this.width+"px";
			c.cameraimage.style.height = this.height+"px";
			if (c.cameraoverlay)
				c.cameraoverlay.innerHTML = ""; // clean overlay

			if (this.obj.id != "camerapanel") break;

			var bs = 6;  // camera frame side border size
			var bt = 40; // camera frame top border size
			var bb = 44; // camera frame bottom border size
			var cs = 10; // controls top space
			var bd = 8;  // button distance
			var bw = 40; // button width

			// frame
			var cpw = this.width+bs*2;
			var cph = this.height+bt+bb; // 65: border top + border bottom,

			c.panel.style.width  = cpw+"px";
			c.panel.style.height = cph+"px";

			// camera controls
			var cct = this.height + bt + cs;
			c.cameracontrols.style.top = cct+"px";
			c.cameracontrols.style.width = this.width+"px";
			c.btmotions.style.left = (this.width-bw)+"px";
			c.btmotions.style.top = (-this.height-bt-4)+"px";
			c.btptz.style.left = (this.width-bw)+"px";
			c.btplayback.style.left = (this.width/2 - bw/2)+"px";

			if (!parseInt(this.attrValues[0]) || parseInt(this.attrValues[0])>=0)
				c.btgrid.style.display = "none";

			c.btplay.style.display = "none";
			c.btpause.style.display = "none";
			c.btrew.style.display = "none";
			c.btfwd.style.display = "none";
			c.btsave.style.display = "none";
			c.btback.style.display = "none";
			c.display.style.display = "none";
			break;
		case "selectpanel":
		case "userlist":
			var i = (this.obj.id == "selectpanel")?6:8;
			var h = this.attrValues[i]?this.attrValues[i]:"";
			var divs = this.div.getElementsByTagName("div");
			for (var t=0; t<divs.length; t++) {
				var name = divs[t].getAttribute("name");
				if (name == "content") {
					divs[t].innerHTML = h;
					break;
				}
			}

			break;
		case "image":
		case "imagelink":
			var imgAttr = this.getAttrByName("image");
			var value = imgAttr ? imgAttr.value : "";
			var templateName = project.skin;
			var config = {path:project.name};
			var emptyPicURL = "/"+templateName+"/pic/empty.png";
			var e = this.div.childNodes[0];
			var imgC = e.getElementsByTagName("div")[0];
			var resAttr = this.getAttrByName("resize");
			var resize = resAttr ? resAttr.value : "";

			// user on uiset values
			function replaceSkin(value) {
				return value.replace(/\$skin\$/g,templateName);
			}

			// from image.js
			if (value == "") {
				value = emptyPicURL;
			}
			else if(value.indexOf("http://") == 0 ||
					value.indexOf("https://") == 0 ||
					value.indexOf("/"+templateName+"/pic/")==0 ||
					value.indexOf("/$skin$/pic/")==0) {
				value = replaceSkin(value);
			}
			else if (e.getAttribute("data-imgpath")=="pic") {
				value = "/"+templateName+"/pic/"+value;
			}
			else if (value.indexOf("/x/draw.png?")==-1) {
				value = "/"+config.path+"/img/"+value;
			}

			imgC.className = "obj_image_c "+resize;
			imgC.style.backgroundImage = "url('"+value+"')";
			break;
		}
	} // reset()

	// --------------------------------------------------------------------------------------------------------------------------
	// Container ----------------------------------------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------

	if (obj.closedBy) {
		this.isContainer = true;
		// objects
		this.objs = [];

		// absolute coordinates (relative to the page), set by openContainer
		this.ax = 0;
		this.ay = 0;

		// include?
		this.isInclude = (obj.id == "#include");
		if (this.isInclude) this.posMode = "xy"; // change pos mode

		if (obj.id == "menu" || obj.id == "page" || obj.id == "popup" || obj.id == "overlay" || obj.id == "_watch_page") {
			// is page? (for quick check)
			this.isPage = true;
			// orientation if menu or page and orientationMode (there's at least one page in portrait)
			if (obj.id != "popup") {
				this.orientation = (project.orientationMode)?"landscape":null;
				this.gestures = ""; // also gestures
				this.scope = ""; // also gestures
			}
			// locations
			if (obj.id == "page")
				this.locations = "";
		}

		// closeObj
		if (!this.isInclude)
			this.closeObj = dictionary.getObjInstance(obj.closedBy);

		// add object. obj, pos (order, used in undo)
		this.addObj = function (obj,pos) {
			if (pos==null)
				this.objs.push(obj);
			else
				this.objs.splice(pos,0,obj);
			obj.parentObj = this;
		} // addObj()

		// remove object
		this.removeObj = function (obj) {
			for (var i=0; i<this.objs.length; i++) {
				if (this.objs[i] == obj) {
					obj.parentObj = null;
					this.objs.splice(i,1)
					return;
				}
			}
		} // removeObj()

		// move object d=1 up d=2 top d=-1 down d=-2 bottom. return true if moved or false
		this.moveObj = function (obj,d) {
			for (var i=0; i<this.objs.length; i++) {
				if (this.objs[i]==obj)
					break;
				else if (i == this.objs.length-1)
					return false; // not found
			}

			switch (d) {
			case 1:
				if (i+1>=this.objs.length) return false; // already the last
				this.objs.splice(i,1);
				this.objs.splice(i+1,0,obj);
				break;
			case 2:
				if (i+1>=this.objs.length) return false; // already the last
				this.objs.splice(i,1);
				this.objs.push(obj);
				break;
			case -1:
				if (i-1<0) return false; // already the first
				this.objs.splice(i,1);
				this.objs.splice(i-1,0,obj);
				break;
			case -2:
				if (i-1<0) return false; // already the first
				this.objs.splice(i,1);
				this.objs.splice(0,0,obj);
				break;
			}

			return true;
		} // moveObj()

		// get content size
		this.getContentSize = function () {
			var mw = 0;
			var mh = 0;
			var mx = 0;
			var my = 0;
			var h,w,o;
			var objs = this.isInclude?project.includes[this.attrValues[0]]:this.objs;
			for (var i=0; i<objs.length; i++) {
				o = objs[i];
				w = o.x + o.width;
				h = o.y + o.height;
				if (o.obj.deltaWidth)  w += o.obj.deltaWidth;
				if (o.obj.deltaHeight) h += o.obj.deltaHeight;

				if (mw < w) mw = w;
				if (mh < h)	mh = h;

				if (!mx || mx > o.x) mx = o.x;
				if (!my || my > o.y) my = o.y;
			}
			return {w:mw, h:mh, x:mx, y:my};
		} // getContentSize()

		// fit to content. modify pos also?
		this.fitSize = function (pos) {
			// get size based on content
			var s = this.getContentSize();

			// reset container position, size
			if (this.width < s.w || this.height < s.h) {
				if (this.width < s.w)
					this.width = s.w;
				if (this.height < s.h)
					this.height = s.h;
				if (pos) {
					this.x = s.x;
					this.y = s.y;
					this.width -= s.x;
					this.height -= s.y;
				}
				this.redraw();
			}
		} // fitSize()

		// reset page size
		this.resetPageSize = function () {
			if (this.obj.id == "popup") {
				this.width = this.obj.width-dictionary.margin.popup[1]-dictionary.margin.popup[3];
				this.height = this.obj.height-dictionary.margin.popup[0]-dictionary.margin.popup[2];
			} else {
				if (this.orientation=="portrait") {
					var c = project.kiosk?"kiosk":project.isPageCompact(project.width2,project.height2)?"compact":"standard";
					this.width = project.width2-dictionary.margin[c][1]-dictionary.margin[c][3];
					this.height = project.height2-dictionary.margin[c][0]-dictionary.margin[c][2];
				} else { // default
					var c = project.kiosk?"kiosk":project.isPageCompact(project.width,project.height)?"compact":"standard";
					this.width = project.width-dictionary.margin[c][1]-dictionary.margin[c][3];
					this.height = project.height-dictionary.margin[c][0]-dictionary.margin[c][2];
				}
				if (this.width<0) this.width = 0;
				if (this.height<0) this.height = 0;
			}
		} // resetPageSize()
	} // if container

	// show border (containers and includes). visible, selected, open, none
	this.showBorder = function (style) {
		if (style) borderStyle = style;
		var sdiv = null;
		var bgdiv = null;
		if (this.isContainer && !this.isInclude) {
			sdiv = this.div.childNodes[0];
			bgdiv = this.div.childNodes[1];
		}
		var odiv =  this.div.childNodes[this.div.childNodes.length-1];

		// shadow
		if (sdiv) {
			if (borderStyle == "open") {
				sdiv.style.display = "inline";
				var w = this.parentObj.width;
				var h = this.parentObj.height;
				if (this.parentObj.obj.id == "popup") h -= 15; // ugly bug fix
				sdiv.style.width = w+"px";
				sdiv.style.height = h+"px";
			} else {
				sdiv.style.display = "none";
			}
		}

		// background
		if (bgdiv) {
			if (borderStyle == "open") {
				bgdiv.style.display = "inline";
				bgdiv.style.left = this.x +"px";
				bgdiv.style.top = this.y +"px";
				bgdiv.style.width = this.width +"px";
				bgdiv.style.height = this.height +"px";
			} else {
				bgdiv.style.display = "none";
			}
		}

		// over
		if (borderStyle == "none") {
			odiv.style.display = "none";
		} else {
			if (this.isContainer)
				odiv.className = (this.isInclude?"include":"container")+"Over"+((borderStyle == "selected")?"Open":"");
			odiv.style.display = "inline";
			odiv.style.left = this.x +"px";
			odiv.style.top = this.y +"px";
			odiv.style.width = (this.width-2) +"px"; // minus the border size
			odiv.style.height = (this.height-2) +"px";
		}
	} // showBorder()

} // ObjInstance Class

// attribute field. element, type, link, values, labels, colorset, title
function AttrField(e,t,l,v,lb,cs,title) {
	// element
	this.e = e;

	// type
	this.type = t;

	// values
	this.values = v;

	// labels
	this.labels = lb;

	// colorset
	this.colorSet = cs;

	// object attribute link (index of attrValues, id, pagetype..)
	this.link = l;

	// title
	this.title = title;

	// divs for quick access by name
	this.div = [];
	this.input = [];
	this.select = [];

	// get divs
	var divs,i;
	divs = e.getElementsByTagName("div");
	for (i=0; i<divs.length; i++)
		this.div[divs[i].getAttribute("name")] = divs[i];
	divs = e.getElementsByTagName("input");
	for (i=0; i<divs.length; i++) {
		var n = divs[i].getAttribute("name");
		var k = "";
		while (this.input[n+k]) k += "x"; // for radio buttons m,mx,mxx,mxxx..
		this.input[n+k] = divs[i];
	}
	divs = e.getElementsByTagName("select");
	for (i=0; i<divs.length; i++) this.select[divs[i].getAttribute("name")] = divs[i];

	// set title
	if (title && this.div["t"])
		this.div["t"].innerHTML = title;
} // AttrField Class

// project class
function Project() {
	// default values
	this.name = "new";
	this.timestamp = 0; // last modified timestamp

	this.skin = "blue";
	this.language = "en";
	this.header = "HSYCO";

	this.customLan = {};
	this.customLanTimestamp = 0; // last modified custom language file (<project>/text_<lan>.txt)

	this.src = "";

	this.orientationMode = false; // if true, page and menu objs will be #landscape,#portrait

	this.width = 890;
	this.height = 640;

	this.width2 = null; // only available when orientationMode is true
	this.height2 = null;

	if (dictionary && dictionary.size) { // done by Dictionary() too
		this.width = parseInt(dictionary.size[0]);
		this.height = parseInt(dictionary.size[1]);
	}

	this.locked = false; // if locked, won't send commands
	this.kiosk = ""; // kiosk mode. "","nolock","lock"
	this.scale = null;
	this.uiset = null; // initial uiset
	this.style = null; // project style
	this.background = "";

	this.warnings = null;

	this.cameraList = "";
	this.cameraGridList = "";
	this.cameraOverlay = "";

	this.pages = []; // array of pages (objInstance) for quick reference

	this.includes = {}; // include containers
	this.includesNeeded = []; // list of needed includes, to load

	this.deviceImage = true; // default

	this.status = "loading"; // loading (default when creating a project), new (when creating a new project), ready (set on onProjectLoaded)

	// updates with current dictionary data
	this.selectDictionary = function () {
		if (dictionary.size) {
			if (!this.width) this.width = parseInt(dictionary.size[0]);
			if (!this.height) this.height = parseInt(dictionary.size[1]);
		}
	} // selectDictionary()

	// add page and set size. obj, pos (order, used in undo)
	this.addPage = function (page,pos) {
		if (pos==null)
			this.pages.push(page);
		else
			this.pages.splice(pos,0,page);
		page.resetPageSize();
	} // addPage()

	// delete page
	this.delPage = function (page) {
		for (var i=0; i<this.pages.length; i++) {
			if (this.pages[i] == page) {
				this.pages.splice(i,1);
				return; // done
			}
		}
	} // delPage()

	// sort function for pages.sort
	this.pagesSortFunc = function (a,b) {
		// menu is always on top
		if (a.obj.id == "menu" && b.obj.id != "menu")
			return -1;
		if (a.obj.id != "menu" && b.obj.id == "menu")
			return 1;
		// watch is always on bottom of overlay
		if (a.obj.id == "_watch_page" && b.obj.id == "overlay")
			return 1;
		if (a.obj.id != "overlay" && b.obj.id == "_watch_page")
			return -1;
		// overlay is always on bottom
		if (a.obj.id == "overlay" && b.obj.id != "overlay")
			return 1;
		if (a.obj.id != "overlay" && b.obj.id == "overlay")
			return -1;
		// watch is always on bottom
		if (a.obj.id == "_watch_page" && b.obj.id != "_watch_page")
			return 1;
		if (a.obj.id != "_watch_page" && b.obj.id == "_watch_page")
			return -1;
		// both the same, check name
		if (a.attrValues[0] > b.attrValues[0])
			return 1;
		if (a.attrValues[0] < b.attrValues[0])
			return -1;
		if (this.orientationMode) {
			if (a.orientation == "vertical" && b.orientation == "horizontal")
				return 1;
			if (a.orientation == "horizontal" && b.orientation == "vertical")
				return -1;
		}
		return 0;
	} // pagesSortFunc()

	// sort pages alphabetically
	this.sortPages = function () {
		this.pages.sort(this.pagesSortFunc);
	} // sortPages()

	// is compact?
	this.isPageCompact = function (w,h) {
		return (w<=500);
	} // isPageCompact()

	// update project, pages sizes, sets page orientation
	this.updateSize = function (w,h,w2,h2) {
		if (w != null) this.width = w;
		if (h != null) this.height = h;
		if (w2 != null) this.width2 = w2;
		if (h2 != null) this.height2 = h2;

		for (var i=0; i<this.pages.length; i++) {
			// reset orientation
			if (this.pages[i].obj.id != "popup") {
				if (this.pages[i].orientation != "portrait" || !this.orientationMode) {
					if (this.orientationMode)
						this.pages[i].orientation = "landscape"; // default
					else
						this.pages[i].orientation = null;
				} else {
					this.pages[i].orientation = "portrait";
				}
				// reset size
				this.pages[i].resetPageSize();
			}
		}
	} // updateSize()

	// add include. object (to redraw)
	this.addInclude = function (obj) {
		// already loaded?
		if (this.includes[obj.attrValues[0]]) {
			obj.redraw(); // redraw now
			return;
		}

		for (var i=0; i<this.includesNeeded.length; i++) {
			if (this.includesNeeded[i].file == obj.attrValues[0]) { // already to be loaded?
				this.includesNeeded[i].objs.push(obj);
				return;
			}
		}

		project.includesNeeded.push({file:obj.attrValues[0], objs:[obj]});

		return true;
	} // addInclude()

	// redraw all objects
	this.redraw = function () {
		for (var i=0; i<this.pages.length; i++) {
			for (var k=0; k<this.pages[i].objs.length; k++) {
				this.pages[i].objs[k].redraw();
			}
		}
	} // reset all

	// reset all objects
	this.reset = function () {
		for (var i=0; i<this.pages.length; i++) {
			for (var k=0; k<this.pages[i].objs.length; k++) {
				this.pages[i].objs[k].reset();
			}
		}
	} // reset all

	// get all objects in the project. parent object
	this.getAllObjs = function (p) {
		var a = [];
		var r;
		var i;
		// no parent, all pages
		if (!p) {
			for (i=0; i<project.pages.length; i++) {
				r = this.getAllObjs(project.pages[i]);
				if (r) a = a.concat(r);
			}
		} else {
			a.push(p);
			if (p.objs && p.objs.length) {
				for (i=0; i<p.objs.length; i++) {
					r = this.getAllObjs(p.objs[i]);
					if (r) a = a.concat(r);
				}
			}
		}
		return a;
	} // getAllObjs()



	// to JSON
	this.toJSON = function () {
		var s = { language: this.language,
				  header: this.header,
				  orientationMode: this.orientationMode,
				  width: this.width,
				  height: this.height,
				  deviceImage: this.deviceImage,
				  scale: this.scale,
				  style: this.style,
				  uiset: this.uiset,
				  cameraList: this.cameraList,
				  cameraGridList: this.cameraGridList,
				  cameraOverlay: this.cameraOverlay };
		return s;
	} // toJSON()

	// from JSON. return all the attribute ids that changed
	this.fromJSON = function (o) {
		var c = []; // what changed. indexes of the attributes
		var k = 0;
		for (var i in s) {
			if (this[i]!=s[i]) {
				c.push((k<2)?k:(k<5)?2:k-2);
				this[i] = s[i];
			}
			k++;
		}
		return c.unique();
	} // fromJSON()

} // Project Class



//--------------------------------------------------------------------------------------------------------------------------
// Login -------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------

// Login class. parent object, to restore key events
function Login(parent) {
	this.onLogin = null; // on login successful event

	var req = new XMLReq();
	var check = new XMLReq(); // "already logged in" check

	var reqMode = ""; // ,pin,puk

	var loginLabelE = document.getElementById("l_loginLabel");
	var loginCodeE = document.getElementById("l_loginCode");
	var loginKeypadE = document.getElementById("l_loginKeypad");

	var loginBtsE = {
		"1":document.getElementById("l_login1Bt"),
		"2":document.getElementById("l_login2Bt"),
		"3":document.getElementById("l_login3Bt"),
		"4":document.getElementById("l_login4Bt"),
		"5":document.getElementById("l_login5Bt"),
		"6":document.getElementById("l_login6Bt"),
		"7":document.getElementById("l_login7Bt"),
		"8":document.getElementById("l_login8Bt"),
		"9":document.getElementById("l_login9Bt"),
		"0":document.getElementById("l_login0Bt"),
		"c":document.getElementById("l_loginCBt"),
		"ok":document.getElementById("l_loginOkBt")
	};

	// current code
	var code = "";
	var codeLength = 0; // current code length

	var pin = "";
	var puk = "";

	var mode;
	var smode; // start mode. mode can change (if pin is wrong, mode switches to puk)

	var pukReplies = 0; // how many times the server has answered "puk"
	var maxPukReplies = 3; // max replies before refreshing the page

	var self = this;

	// init
	function init() {
		req.retryOnErrorDelay = 250;
		req.maxRetries = 3;
		req.maxWaitingTime = 20000;
		req.onLoaded = onLoaded;
		req.onError = onError;
		req.onRetry = onRepeat;
		req.onAuthenticate = onAuth;

		check.onLoaded = onCheckLoaded;
		check.onRetry = onCheckRetry;
	} // init()

	// start
	this.start = function () {
		initCodeArea();
		getMode();
		askPin();

		req.stop();
		reqMode = "";

		check.retryOnErrorDelay = 100; // initial delay
		check.open("/x/getstate?-1."+(new Date()).getTime());

		document.onkeydown = onKeyDown;
		document.onkeyup = onKeyUp;
	}; // start()

	this.stop = function () {
		// hide stuff
		check.stop();
	};

	// get mode
	function getMode() {
		// no cookie? there's an error. reload on C
		if (!browser.cookiesEnabled || !document.cookie) {
			mode = 0;
		} else {
			var c = browser.getCookie("key");
			if (c && c.charAt(0) == 'U')
				smode = mode = "puk"; // requires puk also
			else
				smode = mode = "pin"; // just pin
		}
	} // getMode()

	// ask pin
	function askPin(silent) {
		loginLabelE.innerHTML = textD.enterpin;

		pin = "";
		puk = "";

		code = "";
		codeLength = 5;

		// force back to pin, so we try again only with pin
		if (smode == "pin")
			mode = "pin";

		showCode();
		enable(true);

		if (!silent && window.hsycoApp) {
			setTimeout(function(){
				hsycoApp.sendMessage("pin");
			},100);
		}
	} // askPin()

	// ask puk
	function askPuk(silent) {
		loginLabelE.innerHTML = textD.enterpuk;

		puk = "";

		code = "";
		codeLength = 14;

		mode = "puk"; // force mode to require puk

		showCode();
		enable(true);

		if (!silent && window.hsycoApp) {
			setTimeout(function(){
				hsycoApp.sendMessage("puk");
			},100);
		}
	} // askPuk()

	// init code area (to speed things up on iOS7
	var pinCodeE, pukCodeE;
	function initCodeArea() {
		var str = "";
		var str2 = "";
		var tw = loginCodeE.offsetWidth; // total width
		var cw = 0; // container width
		var nw = 16; // number cell width
		var nb = 1; // number cell border
		var x = 0; // cursor
		var s = 0; // space
		var i;
		var l = code.length; // current code length
		// pin
		for (i=0; i<5; i++) {
			s = i?15:0;
			x += s; // spacer
			str += "<div class='cell' style='float:left; width:"+nw+"px;"+(i?" margin-left:"+s+"px":"")+"'>&nbsp;</div>"
			x += nw+nb*2; // num width
		}
		str = "<div style='margin-left:"+Math.round((tw-x)/2)+"px;'>"+str+"</div>";

		// puk
		x = 0; // cursor
		for (i=0; i<14; i++) {
			s = (i==5 || i==9)?12:(i)?2:0; // spacer
			x += s;
			str2 += "<div class='cell' style='float:left; width:"+nw+"px;"+(i?" margin-left:"+s+"px":"")+"'>&nbsp;</div>"
			x += nw+nb*2; // num width
		}
		str2 = "<div style='margin-left:"+Math.round((tw-x)/2)+"px;'>"+str2+"</div>";

		loginCodeE.innerHTML = str+str2;
		pinCodeE = loginCodeE.childNodes[0];
		pukCodeE = loginCodeE.childNodes[1];
	} // initCodeArea()

	// show code
	function showCode() {
		var str = "";
		var i;
		var l = code.length; // current code length

		pinCodeE.style.display = !pin?"block":"none";
		pukCodeE.style.display = pin?"block":"none";

		if (!pin) {
			for (i=0; i<5; i++) {
				str = (l>i?"&#9679;":"&nbsp;"); // value
				pinCodeE.childNodes[i].innerHTML = str;
			}
		} else {
			for (i=0; i<14; i++) {
				str = (l>i?"&#9679;":"&nbsp;"); // value
				pukCodeE.childNodes[i].innerHTML = str;
			}
		}
	} // showCode()

	// enable (disabled when sending)
	function enable(enable) {
		for (var i in loginBtsE)
			browser.enableButton(loginBtsE[i], i=="c"?true:i!="ok"?enable:false); // c is always enabled, ok is always disabled when toggling
	} // enable

	// confirm
	function confirm() {
		if (pin == "") {
			pin = code;
			code = "";
			// ask for puk?
			if (mode == "puk") {
				askPuk();
				return;
			}
		} else if (!puk) {
			puk = code;
			code = "";
		}
		// send
		enable(false);
		loginLabelE.innerHTML = textD.waitforauth;
		reqMode = mode;
		if (mode == "puk") {
			req.open("/x/auth?*" + pin + "*" + puk + "*." + (new Date()).getTime());
		} else {
			req.open("/x/auth?*" + pin + "*." + (new Date()).getTime());
		}
	} // confirm

	// external login
	this.pin = function (_pin) {
		if (!_pin || _pin.length < 5)
			return;
		askPin(true); // if it was asking puk, silent: don't send app message
		code = _pin;
		showCode();
		confirm();
	}
	this.puk = function (_pin,_puk) {
		if (!_puk || _puk.length < 14)
			return;
		if (_pin  && _pin.length < 5)
			pin = _pin;
		askPuk(true); // if it was asking just pin, silent: don't send app message
		code = _puk;
		showCode();
		confirm();
	}
	this.lock = function () {
		browser.delCookie("key"); // delete key cookie
		req.open("/x/logout?reset." + (new Date()).getTime());
	}

	// goto login page
	this.gotoLoginPage = function () {
		var url = window.location.href;
		var ourl = url;
		if (url.indexOf("/pin.") != -1) { // old format
			url = url.replace("/pin.", "/login.")
		} else { // new format
			var u = url.split("?");
			if (u[0].indexOf(".login")==-1)
				u[0] += ".login";
			url = u.join("?");
		}
		if (url != ourl)
			window.location.replace(url);
		else
			window.location.reload(true); // reload
	}

	// on loaded
	function onLoaded() {
		reqMode = "";

		if (req.getResponseText().indexOf("puk") == 0) {
			pukReplies++;
			if (pukReplies >= maxPukReplies)
				self.gotoLoginPage(); // reload
			else
				askPuk();
		} else if (req.getResponseText().indexOf("authorized") == 0) {
			check.stop(); // stop the check
			pukReplies = 0; // reset
			if (parent) {
				document.onkeydown = parent.onKeyDown;
				document.onkeyup = parent.onKeyUp;
			}

			if (window.hsycoApp)
				hsycoApp.sendMessage("login", pin+","+puk);

			self.onLogin();
		} else if (req.getResponseText().indexOf("error") == 0) {
			self.gotoLoginPage(); // force login page

			if (window.hsycoApp)
				hsycoApp.sendMessage("loginerror", pin+","+puk);
		}
	} // onLoaded

	// on error
	function onError() {
		console.log("Login error");
		self.start(); // reset
	} // onError

	// on auth
	function onAuth(lock) {
		if (!lock)
			onError();
		else
			self.gotoLoginPage();
	}

	function onRepeat() {
		console.log("Login timeout "+req.retries);
		var span = loginLabelE.getElementsByTagName("SPAN");

		var txt = "(error "+req.retries+")";

		if (span && span[0]) {
			span[0].innerHTML = txt;
		} else {
			loginLabelE.innerHTML += "<span style='font-size:90%; padding-left: 10px;'>"+txt+"</span>";
		}
	}

	// on check loaded
	function onCheckLoaded() {
		if (parent) {
			document.onkeydown = parent.onKeyDown;
			document.onkeyup = parent.onKeyUp;
		}
		self.onLogin();
	} // onCheckLoaded

	// on check retry, increase time
	function onCheckRetry() {
		var d = check.retries*100;
		check.retryOnErrorDelay = d<2000?d:2000; // max 2 sec
		check.url = "/x/getstate?-1."+(new Date()).getTime(); // refresh url, new timestamp
	}

	/* no press/release if we need to hide it from others
	function pressButton(key) {
		browser.onButtonEvent(null,loginBtsE[key],"mouseover");
	}
	function releaseButton(key) {
		browser.onButtonEvent(null,loginBtsE[key],"mouseout");
	}
	 */

	// key down
	function onKeyDown(e) {
		if (!e) var e = window.event;
		// code
		var code;
		if (e.keyCode) code = e.keyCode;
		else if (e.which) code = e.which;
		// target
		var t;
		if (e.target) t = e.target;
		else if (e.srcElement) t = e.srcElement;
		if (t.nodeType == 3) // defeat Safari bug
			t = t.parentNode;

		if (e.metaKey) return true; // cmd-0...

		if (code == 8 || code == 32) { // BS, SPACE
			self.onButton("c");
			//pressButton("c");
			filter = true;
		} else if (code == 13 || code == 35 || code == 42) { // ENTER, #, *
			self.onButton("k");
			//pressButton("k");
			filter = true;
		} else if (code >= 48 && code <= 57) {
			self.onButton(String.fromCharCode(code));
			//pressButton(String.fromCharCode(code));
			filter = true;
		} else if (code >= 96 && code <= 105) {
			self.onButton(String.fromCharCode(code - 48));
			//pressButton(String.fromCharCode(code - 48));
			filter = true;
		} else if (code == 77) {
			self.onButton("0");
			//pressButton("0");
			browser.onButtonEvent(null,loginBtsE["0"],"mousedown");
			filter = true;
		} else if (code == 74) {
			self.onButton("1");
			//pressButton("1");
			browser.onButtonEvent(null,loginBtsE["1"],"mousedown");
			filter = true;
		} else if (code == 75) {
			self.onButton("2");
			//pressButton("2");
			browser.onButtonEvent(null,loginBtsE["0"],"mousedown");
			filter = true;
		} else if (code == 76) {
			self.onButton("3");
			//pressButton("3");
			filter = true;
		} else if (code == 85) {
			self.onButton("4");
			//pressButton("4");
			filter = true;
		} else if (code == 73) {
			self.onButton("5");
			//pressButton("5");
			filter = true;
		} else if (code == 79) {
			self.onButton("6");
			//pressButton("6");
			filter = true;
		} else {
			filter = false;
		}

		if (filter) {
			if (e.returnValue)
				e.returnValue = false;
			if (e.preventDefault)
				e.preventDefault();
			return false;
		}
	} // onKeyDown()

	// key up
	function onKeyUp(e) {
		if (!e) var e = window.event;
		// code
		var code;
		if (e.keyCode) code = e.keyCode;
		else if (e.which) code = e.which;
	} // onKeyUp()

	// on button event
	this.onButton = function (key) {
		switch (key) {
		case "c":
			if (code) { // delete one
				code = code.substr(0,code.length-1);
				browser.enableButton(loginBtsE.ok, code.length==codeLength);
				showCode();
			} else if (reqMode) { // abort request
				reqMode = "";
				req.stop();
				if (mode == "puk") {
					askPuk();
				} else {
					askPin();
				}
			} else if (mode == "puk") {
				askPin(); // back to ask pin
			}
			break;
		case "k":
			if (code.length == codeLength)
				confirm();
			break;
		default:
			if (reqMode == "" && code.length<codeLength) {
				code += key;
				browser.enableButton(loginBtsE.ok, code.length==codeLength);
				showCode();
			}
			break;
		}
	} // onButton()

	init();
} // Login Class
